SystemOrganization addCategory: #'Cormas-UI'!
SystemOrganization addCategory: 'Cormas-UI-Core'!
SystemOrganization addCategory: 'Cormas-UI-PoV'!
SystemOrganization addCategory: 'Cormas-UI-Project'!
SystemOrganization addCategory: 'Cormas-UI-VW-Compatibility'!

PFProjectBase subclass: #CMProjectModel
	instanceVariableNames: 'cormasModel cormasModelClass codeGenerator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Project'!

!CMProjectModel commentStamp: 'HernanMoralesDurand 9/26/2017 16:58' prior: 0!
Implements behavior of VW's Cormas class

For the Responsibility part: Three sentences about my main responsibilities - what I do, what I know.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.


    Implementation Points!

!CMProjectModel class methodsFor: 'instance creation' stamp: 'HernanMoralesDurand 9/26/2017 16:58'!
for: aCormasModel
	" Answer a new instance of the receiver configured for aCormasModel "
	
	^ self new initializeForModel: aCormasModel ! !

!CMProjectModel methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/22/2017 19:30'!
codeGenerator
	" Answer a code generator binding a reference to the receiver model "

	^ codeGenerator
		ifNil: [ codeGenerator := CGStCormas for: self ]
! !

!CMProjectModel methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/1/2017 20:59'!
codeGenerator: anObject
	codeGenerator := anObject! !

!CMProjectModel methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/26/2017 16:56'!
cormasModel
	^ cormasModel! !

!CMProjectModel methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/2/2017 00:30'!
cormasModel: aCormasModel
	" Set the receiver's model to be aCormasModel "

	cormasModel := aCormasModel! !

!CMProjectModel methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/15/2017 18:48'!
cormasModelAuthors: aString 
	" See comment in CMProjectManager>>cormasModelAuthors: "
	
	self codeGenerator 
		generateMethod: aString 
		selector: #authors 
		inClass: self cormasModelClass class.
! !

!CMProjectModel methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/26/2017 16:56'!
cormasModelClass
	^ cormasModelClass! !

!CMProjectModel methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/2/2017 00:15'!
cormasModelClass: aClass
	" Set the receiver's model class to be aClass "

	cormasModelClass := aClass! !

!CMProjectModel methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/15/2017 19:04'!
cormasModelCreationDate: aString 

	self codeGenerator
		generateMethod: aString 
		selector: #creationDate 
		inClass: self cormasModelClass class.

! !

!CMProjectModel methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/15/2017 18:56'!
cormasModelEmails: aString 
	" See comment in CMProjectManager>>cormasModelEmails: "

	self codeGenerator 
		generateMethod: aString 
		selector: #emails 
		inClass: self cormasModelClass class.
! !

!CMProjectModel methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/9/2017 22:58'!
cormasModelName
	" Answer a <String> with the receiver's model name "

	^ self cormasModelClass cormasModelName! !

!CMProjectModel methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/15/2017 18:57'!
cormasModelText: aString 
	" See comment in CMProjectManager>>cormasModelText: "

	self codeGenerator 
		generateMethod: aString 
		selector: #comments 
		inClass: self cormasModelClass class.
! !

!CMProjectModel methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/15/2017 18:55'!
cormasModelVersion: aString 

	self codeGenerator
		generateMethod: aString 
		selector: #version 
		inClass: self cormasModelClass class! !

!CMProjectModel methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/16/2017 14:35'!
createClassModelNamed: modelName
	" Generate a new class named modelName. Answer the new generated <Class> "
	
	| validClassName |
	
	validClassName := self validateCormasModelName: modelName.
	self codeGenerator 
		targetClassCategory: validClassName , 'Category';
		targetClass: validClassName;
		generateClassNamed: validClassName 
		superclass: CormasModel.
	self codeGenerator generateMethods.
	^ Smalltalk at: validClassName asSymbol! !

!CMProjectModel methodsFor: 'testing' stamp: 'HernanMoralesDurand 10/1/2017 18:01'!
hasCormasModelClass
	" Answer <true> if receiver has configured a Cormas model "
	
	^ self cormasModelClass notNil! !

!CMProjectModel methodsFor: 'initialize - release' stamp: 'HernanMoralesDurand 12/28/2017 01:11'!
initializeForModel: aCormasModel
	" Private - Set up the cormas model for the receiver "

	self initializeNamed: 'Unnamed'.
	self cormasModel: aCormasModel.
	self cormasModelClass: aCormasModel class.! !

!CMProjectModel methodsFor: 'initialize - release' stamp: 'HernanMoralesDurand 1/9/2018 02:35'!
initializeForModel: aCormasModel named: aString
	" Private - Set up the cormas model for the receiver "

	self initializeNamed: aString.
	self cormasModel: aCormasModel.
	self cormasModelClass: aCormasModel class.! !

!CMProjectModel methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/26/2017 17:23'!
projectName
	" Answer a <String> with the receiver's model name "

	^ self cormasModelName! !

!CMProjectModel methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/1/2017 23:37'!
validateCormasModelName: modelName
	" Answer a <String> with modelName as valid Smalltalk class name "

	| validClassName |
	
	(validClassName := self codeGenerator validateClassName: modelName) ~= modelName
		ifTrue: [ self alertMessage: self translator tModifiedModelName  ].
	^ validClassName! !

!CormasModel class methodsFor: '*Cormas-UI' stamp: 'HernanMoralesDurand 9/26/2017 17:11'!
cormasModelName

	^ self asString! !

Object subclass: #CMIcons
	instanceVariableNames: ''
	classVariableNames: 'icons'
	poolDictionaries: ''
	category: 'Cormas-UI-Core'!

!CMIcons commentStamp: 'HernanMoralesDurand 11/25/2017 19:51' prior: 0!
Provide icons for CORMAS project.

Updating this class:

IconFactory 	
	syncDirectory: 'c:\MySmalltalkProjects\CORMAS\CORMAS_Pharo6_GitHub\icons\' 
	intoClass: CMIcons

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.


    Implementation Points!

!CMIcons class methodsFor: 'accessing - icons' stamp: 'HernanMoralesDurand 11/25/2017 19:50'!
defineScenarioIcon
	"Private - Generated method"
	^ self icons
		at: #defineScenarioIcon
		ifAbsentPut: [ Form
				fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self defineScenarioIconContents readStream) ]! !

!CMIcons class methodsFor: 'private - contents' stamp: 'HernanMoralesDurand 11/25/2017 19:50'!
defineScenarioIconContents
	"Private - Method generated with the content of the file File @ c:\MySmalltalkProjects\CORMAS\CORMAS_Pharo6_GitHub\icons\defineScenario.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAACUAAAAjCAIAAACcpVRJAAAACXBIWXMAAA7EAAAOxAGVKw4b
AAADZUlEQVRIie2XTW/cRBjH/894bI/tfU3YzaIoNNFWpQFxpaQUOPElKjgg8SW48DWQEBL3
XpAq9YA4VLxUiooEIkUpGylhQ1Ul7LJOst6XsR3PcNh2syjJ2gslUhH/kyWP5zf/55nn8QwN
h30AQrj499Xa22UXgJnU/7znm8dTR/z6+Wf+N3ctzyVixBiIni6SH8t+7eb7letvM5Z13em8
lQ8+PPzxe9ELXNviuYJhWjyf57bFvXzj5weqUM4OQ8Z4xu+8G4BFUiZhmMSRiqIkimT3UBPJ
fAGA1jojL90fAO/+ehfoEp+LQgCGaREQyFCt1B3HAUBEGXkp/pJeL/74o+qwzy0nJur2ByoK
434vCaOjXte48ooQIiNppBR/9Okn7MDPWXbNsh8NiGktI+kAkhnHceLU67ZtPzNe+NWX/MEP
yBVMzsuWNeRmmxgNezySx4yp5cvFYnEUz2fD41/cAggAATbnL5j2fr7QOjww/BY0saurswYT
KfnrtAFAawAGkS6Vgldfk9euR44TS+m9fHXWYCLT/hztPa0fX1mtLy8DOJybY1LmCgXXnfkv
lsrT0Jo8T85XzEuXarUaANu2wzB0PW9WWBrPzSGXh+sBGBRL5XJZCGFZlhBCKTVTW8nGgwae
5o9zLoRt20QkhNBaZ6/xSU1fIwFP8uf0e3958bdgqbwTWZ0/TN8/r08qpaJeD3H8j3ljAJHz
3dcqCE4jtdYqCKxsLXsaL8nlQXSCDAJ257Zu/KKHQz1SHCvfR6fDiWDbMM3xt4PBYGbeb2tv
Qesn9ed68DwYHFsNfe9b3F/Hxk/Y2aZuF0kCIkxkNEmSra2tM+ectj8v33yv3W7NHx3AOVXX
SQKlTqxrPX5WSjUajfNaXUr+dl5f88vzOJ2bibxOOpNSbmxsRFFUrVbPnHCaPynltbW1e0lS
a+6sBN2zB42cEQHY399vNptCiKWlpfNa3TTeKCZv3rixznm703kpOKqNrdBJaWqlfm+3H/t+
fzCoVqsLCwuO45wXT8p4f9jc3Ox0OrLfnwM8xizOtWnGjA209qU0TbNYLFYqlcXFxSmTtPZ2
s/JG2t7eDoJASpkkCQDDMIQQQohSqTRq5dPV2tvNdF4aq16vzzT+tP7r5/kLvz+sP9x7Y/XF
R82HFwCzbfdP0Jdp7VuU8wkAAAAASUVORK5CYII='! !

!CMIcons class methodsFor: 'accessing - icons' stamp: 'HernanMoralesDurand 1/24/2018 18:42'!
doesNotUnderstand: aMessage
	" Redirect message to the answer an icon provided by the system "
	
	^ aMessage selector asIcon

! !

!CMIcons class methodsFor: 'accessing - icons' stamp: 'HernanMoralesDurand 11/25/2017 19:50'!
exec1StepIcon
	"Private - Generated method"
	^ self icons
		at: #exec1StepIcon
		ifAbsentPut: [ Form
				fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self exec1StepIconContents readStream) ]! !

!CMIcons class methodsFor: 'private - contents' stamp: 'HernanMoralesDurand 11/25/2017 19:50'!
exec1StepIconContents
	"Private - Method generated with the content of the file File @ c:\MySmalltalkProjects\CORMAS\CORMAS_Pharo6_GitHub\icons\exec1Step.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAACUAAAAjCAIAAACcpVRJAAAACXBIWXMAAA7EAAAOxAGVKw4b
AAADeklEQVRIie3W32scVRQH8HPm7kxmdhIzc4fd2Uk29keo3aTapVRsRUTog6I+6B8gCL70
TUWwguBPSh8EQRGKKL4IvgoW+6Ai+m6xkqQ0atomJmazbbKdZHdndmZn7vFhtstSaybGTVHp
eRqGe+9nzvcMw+B3P84dnXAymQHY+apdW0LfbwKAqmZvg3e1siDdBqa37nh3vP+eF7ru+ePP
1c6dI6Id94QQ9coyglj8+PTsyTe8xcU+qrfwwjD0PQ8A9dBj85d/fvu1+U8+ihqNnfIAII7i
5EKF2GIQnv9h5sTzK1+dFXG8I163iJAhDDGWU7W1s2dmTrzkTk/9k3hT308BAIiYkSR7cMhE
Wvjwg1/eOeVXKttTUzxEJAIiAkQgyGpakXPNrc2++epvn30a+V4/PVkIIgQARAAAgk5DhjG8
Z3w8mpmefvmF6vffkhA3bSSi2PdFEPz5zMwmXluSFCREIAIgwoQFIIKMohScAo+tlS+/WP3m
6+Izz95VmkgWkBCzp97yLs1Jg/r4i68M7d3b3ZjSHwAQIREgIiB2B4YIQIIANE0fL03a3Fw4
/d7c++8GtZoQYunM5/785ckjD+66e/evJ19vuW7vpNO/Z4hARACEiEmi1LnfeWozlx/bV6pf
mHIvXgiCoH7lCjdM7/dF2liXVLW5utrrbZYnQKcrCQEIKBlmAiIAERAErdbKpbmG58GjT4pd
e4IgwPLhtamf2gprxkSaHul6GIaqqqZ7shCEyQIERESEnkEIilcry2vXqt7+yeBA2crnFU0D
ABwZCY495l6cEoLEE08RoizLW+qvLUly532hpBtIhom44V6vVqvhaNF7/GnNtp1cjnNumiYA
xHHcuu/g9eKYqqqFQsEwDMbYVvMEupEnACAAYijE8tJSqGXXHz6GI6OO4wwPDzuO091hWRZj
zLZtRVGy2aymab3npeSJGXaDgiiK3WbTj6KNg4fEPRPcNG3b7pW6ZRiGYRi3PDMtTyJEEELU
g6AR1P19+1sHyjrnSVB/degmldIfZFhL0EbYDm3HO3T/gF0Y5Tyfz3PO/66U7rUlqcmykabW
Dx+h4li3p5tG0h9PCLGuaI1yOS7dyznP5XK6rm8jwC15suOIB442irtV09z2qLbqybI8oOvZ
hx4ZlKRSqdQXZjOPMWZZlmVZ/ZWS+nf8f/5/vD8A6LR8GZzlmI8AAAAASUVORK5CYII='! !

!CMIcons class methodsFor: 'GT-InspectorExtensions' stamp: 'HernanMoralesDurand 9/15/2017 00:21'!
gtInspectorIconsIn: composite
	<gtInspectorPresentationOrder: 0>
	<script: 'self inspect'>
	composite table
		title: 'Icons';
		display: [ (self class selectorsInCategory: 'accessing - icons') sorted
				collect: [ :each | each -> (self perform: each) ] ];
		column: 'Icon' evaluated: #value width: 50;
		column: 'Selector' evaluated: #key! !

!CMIcons class methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/15/2017 00:21'!
icons
	^ icons ifNil: [ icons := Dictionary new ]! !

!CMIcons class methodsFor: 'testing' stamp: 'HernanMoralesDurand 4/5/2018 11:50'!
isMetacelloConfig

	^ false! !

!CMIcons class methodsFor: 'accessing - icons' stamp: 'HernanMoralesDurand 12/11/2017 21:06'!
replay1StoredStepDisabledIcon
	"Private - Generated method"
	^ self icons
		at: #replay1StoredStepDisabledIcon
		ifAbsentPut: [ Form
				fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self replay1StoredStepDisabledIconContents readStream) ]! !

!CMIcons class methodsFor: 'private - contents' stamp: 'HernanMoralesDurand 12/11/2017 21:06'!
replay1StoredStepDisabledIconContents
	"Private - Method generated with the content of the file File @ c:\MySmalltalkProjects\CORMAS\CORMAS_Pharo6_GitHub\icons\replay1StoredStepDisabled.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAACUAAAAjCAIAAACcpVRJAAAACXBIWXMAAA7EAAAOxAGVKw4b
AAACLUlEQVRIie3WQYujMBQH8MQafVgU46W2h1IvpUu/wH77/QYLc2thDxWWtlbcBlttNET3
EJDi2O224wzsMv/TIxh/vCQG8bfvP75+Geu6id4/v+Kf+HLJEEIA1gd4h12ofQBznU/vP/Wq
qqrrundP7xzlnEsphRC2bQ8Ggx697v4456pI0zTLsh4b7faklKqo65pzHkVRnue9qN2eEEII
0dQIIcZYFEWc8zeqN88LIaRVcM73+71S+/eaNI0qOM/z7XabJMlzjd73mv6alGUZx/F6vWaM
Pap2fw9/k6qqNpuNbduTyQQAMMZqPM/zMAwNwwiCQNPa/TzvqZxOp9VqRSn1fR8AOOcvLy/n
87mqKiHEfD5vkQ/sX1O0UhRFkiSMMYSQlLIoCjXOGCvLsrXgN73WMWnSzL9+UXMHcc7V2mqa
ptpt1vmO9/qYqJFmPsaYc348HqWUtm0DgIIBQNd1QojjOKbZ/k25v3+d6ymljOMYIaR2znEc
y7IQQgAwnU5d10UIua5rGMbDHiFESaooy5IxlmUZpdTzvNlsdv0wAACA53m33vbY+WSMMcYA
IAgCSiml9KHp3V5zWV8nTdMkSYQQvu+7ruu6rtqwHjwVtYYY46IowjC8XC6U0tFo5DjOcDh8
QrrjEUKKotjtdofDwXEc3/dbW9WnRwhRF4dpmuPxeLFYvF266WGMMcZJkvi+36P0J8+yrOVy
2a+k0nG/YIyfO3tPeu+aT+/f9n4DW40aAwDjCQQAAAAASUVORK5CYII='! !

!CMIcons class methodsFor: 'accessing - icons' stamp: 'HernanMoralesDurand 11/25/2017 19:50'!
replay1StoredStepIcon
	"Private - Generated method"
	^ self icons
		at: #replay1StoredStepIcon
		ifAbsentPut: [ Form
				fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self replay1StoredStepIconContents readStream) ]! !

!CMIcons class methodsFor: 'private - contents' stamp: 'HernanMoralesDurand 11/25/2017 19:50'!
replay1StoredStepIconContents
	"Private - Method generated with the content of the file File @ c:\MySmalltalkProjects\CORMAS\CORMAS_Pharo6_GitHub\icons\replay1StoredStep.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAACUAAAAjCAIAAACcpVRJAAAACXBIWXMAAA7EAAAOxAGVKw4b
AAADP0lEQVRIie2X32/TVhTHz7Ed24mTOI4TJ07aEJoGURpUEBLbNPY4bQ/8XXvYJPayFyQ0
bRoIXoAX0IZAlD2U8bsgppGioYm2LC3tmqaN08Q/7uHBAaoq4KZhPPU8Xdvn3I++53yvroyT
D/7+dMwUBAn+/1hZmseNDQsAZDnyEXgva8+5j4DZHLu8Xd7gPObR9YuPGitNx3Y/LE/o+ba+
vPbXvdkn9+cqRwuffTWGiCGxd2a/0VufZbU4RJ5FZh4s/PjN1erD+Q8ltDfPdR0AQERkksBF
/vh15twPv8//szw4NcAvBCBwobCksrZ06ae7v529v1a3BqEG+ZOIABBRkuVkwlit2adPTN6Z
fOrY7s6oAS5ARCAfCoAYi6tRVX32aOnJndljxw+UxnP9+ii4nwCAgP4jIwgJgmGYqXRu6vLM
+ZNTi3MrfQkN0gfgK/TXHAIQAZCiRGLx0Zbz8sKp23vHUl8cPyi+FsoY+/nba3JE3n8kf/jz
0pYGBOkjIgJExNdaAREAiQiREtFcZaJi1fGX7yanp54Rkes5Z76/ERLCWSN/60q1Or31IAX5
BRERyHcNAOsyyf9CBDzPF4p7Kocqf96cu3v9aaNuWet21sx5HphZszo963pOHzy/f/786K3q
LszPWKgtPn74OJbmsyXFYR1i3vzzF8u1ldpCLZoMtdvtzRsGzI+IAMG3S3d+b5WD1Wy++HeO
472hCSFlyrwISDjxZbp6s15fW1ezUmE8LopiH7zu5Ih8z7DuuUDH7iwsLrVall7k9WFZ07Tx
AxW/ZL3ZYMc6HctTdUWNa4qi9Kev20/s6mOMLf+31FitJ/L83oqkpzVd14vFop/v2O5oqRyL
qq5ny2JU1ZQtG27jvEO3nwRgWdbaej2scSOfyKquGIZRGN6z2fH+emg4964NtzU/InJcp7XR
EEKUP8jFUlI2mx0tld8Ath/B+oio4zRtZ0MfEdIFKZlMpnQjkzF2AAvgEQAju9NuJ3J8oSzH
4lHTNPO5oUHu3ndWegwIW2EVh8tSIh3VNC2TycSi8QEv+t7FYliIxPnUCBdPi5lMpjy6D3bU
ve3yBF488rUJACndeI/ZdhC7/yu7vH7iFX9pU74N5rEHAAAAAElFTkSuQmCC'! !

!CMIcons class methodsFor: 'accessing - icons' stamp: 'HernanMoralesDurand 11/25/2017 19:50'!
replayAStoredSimIcon
	"Private - Generated method"
	^ self icons
		at: #replayAStoredSimIcon
		ifAbsentPut: [ Form
				fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self replayAStoredSimIconContents readStream) ]! !

!CMIcons class methodsFor: 'private - contents' stamp: 'HernanMoralesDurand 11/25/2017 19:50'!
replayAStoredSimIconContents
	"Private - Method generated with the content of the file File @ c:\MySmalltalkProjects\CORMAS\CORMAS_Pharo6_GitHub\icons\replayAStoredSim.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAACUAAAAjCAIAAACcpVRJAAAACXBIWXMAAA7EAAAOxAGVKw4b
AAADkElEQVRIie2Xz28bRRTHv292x147WdZeJ0CapJWbpBWoErkgIXHnxIU/gP+REzd+SIgK
cqhUaKjUljqmLU5Daq2dtXd3fj0O219q4l8l5IB42sNod+Z93nf2zZsZyrIRgCCo49+3o15X
XADmdfufd77mz+xhjJ3hwvfOk/fj1/u3b3Y8QUwkBBFICEB4IDjrPv/y483t1fPktW+s3Pm5
66NeD5dkxQ+Cii/9oF71fPFHp3NykgIL8Gb/v8tXL7V3I4MsSzOtTJEr5xgMa9x4NA5jOT8M
8+gDUJjMCsXWk6oCwJOGKM/zcfT+wlVihj5j7N4391DUgsg6VnmRGWWtMaow6eiktVFZW19b
iDdD3/1fev3DLJDLcUs/s301oEJ5UvnWunE63txeDDab1/n12JNCSgmKineKYZGbPFNFhWGi
leq169cW5U2bz++/2gcDDIIIglqzGVdjJlmMs6HlPN6oLgo7m/dygR8/SRlctj3Pq9dq4aqI
2gWEzrP8sy8+fQvexPnc+/YeAKudX/EAgOGFxdbmFWbuhcnw0L0FbBrvWS8FwMymsAD8KsJW
ZXd3F8Ad/zezpc6ZV6SGyhYRAPZ0CQNw46MPMUddPdMm5ou1jgEiAjMAv/JmZAuV6VejJn1g
doDHzCAQQJbOGLw4cqI+ueRZxQAIxIxixIu6npdXRh2u+AC0tloZENjRrR8eGmNPP/+UV9p7
l2ug55qscgDSvtrfe3y6pzH2+M+T5K9RmuTZSOnClHF0Op00yd8UM4lXD2vRpUF6RAAYrLUF
MB6oW98dLDWCpWXp+cJZ51hIiaD+otYwg0gI8eDBfSnlciOYV1+z2Vzdqvo1R0QEKuuMVhbg
YqyGSZEmhSpsmb1GGaDsIgB0uwfj8bjZbJ52O5HXaDTiuNnacuy7Mkufz57mlzrKZAKIAa2s
1RZw3e5Bt/uo1VxpNBqn3U7bH9rttrXWucPRUwdXe/GajXYAfFnWOQKYQARorQ8e/54Mkq32
1c0rG2f6nLEfbW9vM/MT0VNDQyoEXi04o62seKVUY9Vx0j9OjqIonAKbzQOws7Pj+363+0jr
p1ZXHQXWVpmqLIRORw5ac3YySqrV2vr6WqvViuN4ijea877S7/cHg8FgMEiSoXPGWgtACOF5
MorCKIqkV2lGK6cT8nU76nXnOi8BiON4euBz2n/9/nDh95Wf7vY++WDt7u2bFwBrvbv+N6rE
zPN7BOzPAAAAAElFTkSuQmCC'! !

!CMIcons class methodsFor: 'accessing - icons' stamp: 'HernanMoralesDurand 12/11/2017 21:06'!
replaySimBackwardDisabledIcon
	"Private - Generated method"
	^ self icons
		at: #replaySimBackwardDisabledIcon
		ifAbsentPut: [ Form
				fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self replaySimBackwardDisabledIconContents readStream) ]! !

!CMIcons class methodsFor: 'private - contents' stamp: 'HernanMoralesDurand 12/11/2017 21:06'!
replaySimBackwardDisabledIconContents
	"Private - Method generated with the content of the file File @ c:\MySmalltalkProjects\CORMAS\CORMAS_Pharo6_GitHub\icons\replaySimBackwardDisabled.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAACUAAAAjCAIAAACcpVRJAAAACXBIWXMAAA7EAAAOxAGVKw4b
AAACsElEQVRIie2WwW7jIBBAAQeDban40kRtD00vvfX/f6FS/yCn9tTUVghOtck4CNjDrBzX
TuKk0karVec0xgxvZpgB6GbzazQS5FIyIoSMRtHFeOxipB/eD+/f54063957QgillFKKIyGE
EEJ75HQJIQCA915KGUXRF14IwRjz/PxMKZ1Op4+Pj4wx59zLy4v3Pk3Tp6cntDmRVNc1AOCn
tVYpRSnd5dN7v9lsMAgA2G63qIQQCCHOuUY/JaaqqtbrNY5wzp1zaLuLz1qLK1JKAcA5RwjZ
brfee0qptdZaOwhzzn1+fgIA57yd/8b2y/613ccZCGsScDysqqqaDB2Sbr30Z2PEx0nr9doY
Y62N4/g8Xn/1I/ZYFFpr3Oy2ILvRD/L2LroX6Zwry9IYwznv1y3nvK03hTrM2yuLxaIsS9QH
+7Id39nni/d+Pp8XRdHvjXZMh8a7vMHSwK2q67qu62awP/NQ83R5feO2B5RSzrkQIo7j5XKp
tW5POKVBz84nYyxJktvb24eHB8bY+/v7crlELzs10ujH6nOw/yilUso4jqWUV1dXRVFord/e
3sbjsVJq0N1v1idjTErJOU+SJM9zrXVRFKvVajwep2mKMQnx55l5rB8GT5O2RFEkpcSIlVJl
Wc5ms+vr65ubGyHE3qWG83kc305vlmVKqY+Pj9lsNplMJpNJf/6oY4xKp5MGryFMb7OpZVku
Fgut9d3dXZ7nB+slTdM8zwEgyzLMfhRFSZJUVZVlGWMDxcwYE0I0mzqfz19fX5VS0+l0F9Jm
80vKlBDivQeA1WqFt7mUUkoJAMYY51wURXmeSymPI5t84OVujDHGEELu7++VUoyxHQ+ReHxw
zhljlFK0xL9CiLOeMLgaAABA4+sX3t8Q730IAb0n3+6/06Wz6//7e/fSvN8RO59T9mboZQAA
AABJRU5ErkJggg=='! !

!CMIcons class methodsFor: 'accessing - icons' stamp: 'HernanMoralesDurand 11/25/2017 19:50'!
replaySimBackwardIcon
	"Private - Generated method"
	^ self icons
		at: #replaySimBackwardIcon
		ifAbsentPut: [ Form
				fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self replaySimBackwardIconContents readStream) ]! !

!CMIcons class methodsFor: 'private - contents' stamp: 'HernanMoralesDurand 11/25/2017 19:50'!
replaySimBackwardIconContents
	"Private - Method generated with the content of the file File @ c:\MySmalltalkProjects\CORMAS\CORMAS_Pharo6_GitHub\icons\replaySimBackward.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAACUAAAAjCAIAAACcpVRJAAAACXBIWXMAAA7EAAAOxAGVKw4b
AAADyElEQVRIie1Xz28bVRCeZ6+dtbP2PhO7BOOkKUpQJVCBgBAHOAJ/Af8B/wUCISFx4V4B
h0rtkRNSoRJCIJVbpAY1ggtKCKhxGsetnRC72ey++dHDOuv1xj9SqTISYuTD2/Hs+943883z
WBmDMEVTIjJNvNQ0wf7He+pmJZ4RaVy0lT7nvol9LCuNSJaVnrY+k/yelsX5heTCRSr6OnSF
i6GP41OdMMtKRx8A+O76Ws8fjwCAa5//mLJS6OOHH78f+r/85HvbsQHgvQ9eXVy58EQsv7l6
+2HdV2LNXbSSeKGtXH5Rl9zdnb1ut6O1tqz0TC77xpuvA0Cnc3R+pPVftu78vG1bjpUWMkSI
w/GImFiY2fM8rTUAMAOiAIB5dHxOsKsf3dR6Ppct+L4feiJVJvEYiQwKcxQKAuHphCbUj4i/
/uzWM+78XLlKxACQzWRPPD8eM4QfGiLqN4mAoCEAGN96N6+vHTWpVr1kAjLGKFBKgW8CAACl
AEbxIyZiZk4cYhQeIv1xt772w2Zt4aIuITMLSHhKEMhmsiccCPV3S95nhISBGUidAAYGAxPH
CBedw0dffXrrwTYvXXoBAAAUACilTt8LGUjkGcIPmRCJYieSYZccIt344qeFxaVXVl9jFgJz
Ctd/TSk4e3Wd1QubAON4SiCsX2S3v/2t0+Irq6toEAMUkR4BARXxUhBKUsWKB2fzycTMzDyg
FyKiWIYvv/Xs7r1d4weqn70eIIuAAqWUisgqABmNZ5CCAIUHCAUBBgHGYvyX3i3c79zdWP81
PLuIqNPiiYCIhKoJQn3GbJg+kQZ+MwSoN1NlQkettgAAtt2YcVt//rVhGT3/XLUnSxko4uT+
Y2JCRhzQS7wdI8habWFra7NVaj1otjd/P6zMVe2ZnOpn8Xz9B4oxMBQXpAj2+GUTscvLK1rr
UqmkS83Ddn37DtQWl8b3XxLP92gma9FgvzMxjLByuTJrF1zXbTabVvb+cete++90qViBZP+N
vF/oxPOFB/Lp+8myxy3n2DlnfnZ2Vmu9v7+fn2s93NzHY3smk5vcf0ScAsVxwQjQaH6ROU7B
cQrFYlFr7TiNw4PO3kY3LcVE/yXxis8LoZ/JWJlMT42VpZx34qUgrSu5iaiuq11Xa60bjYar
D/5pdXfWJQ35kXgvv33B87x8Pm/bdui58k714OBAKVUszU7EC61crpTLlXp9p+22LXvPayEf
97TWm8/CYQ3OzDkTPeOt2+202+2joyPbtpeXV/rzYDQ/PdFQdH5UAHCcwr8wf/7X/z9MG+8x
GStQUmP6FUgAAAAASUVORK5CYII='! !

!CMIcons class methodsFor: 'accessing - icons' stamp: 'HernanMoralesDurand 12/11/2017 21:06'!
replayStoredSimDisabledIcon
	"Private - Generated method"
	^ self icons
		at: #replayStoredSimDisabledIcon
		ifAbsentPut: [ Form
				fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self replayStoredSimDisabledIconContents readStream) ]! !

!CMIcons class methodsFor: 'private - contents' stamp: 'HernanMoralesDurand 12/11/2017 21:06'!
replayStoredSimDisabledIconContents
	"Private - Method generated with the content of the file File @ c:\MySmalltalkProjects\CORMAS\CORMAS_Pharo6_GitHub\icons\replayStoredSimDisabled.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAACUAAAAjCAIAAACcpVRJAAAACXBIWXMAAA7EAAAOxAGVKw4b
AAACeElEQVRIie2WTW+jMBCGxybEDlUCbYREe4p6af9A1f//D3ruoaLSNsGJRB2qojFe8B4s
eQnkc6vNYbfviY+xn3mHGYBo/RPOpXz1YzAYeGfjAQA9J+yb9837Cs8Y87d5A3eEiHVdU0o5
54SQc/B831dKKaU454yxk6hPT09lWVJKHx4ePM9rmub5+TlNU2PM4+Pj1dWVDftdT0R0gLIs
1+s1Ih5Z4c/Pz6ZpAMAY8/HxAQBVVSGivVsUxRZ/HSEiIjLGJpOJ5x1452mtq6oCgKZpLLiu
a8sjhNR17SJ39qfv+wCglBJCSCn3G7WMNlhrba8YY9zxPn/tICllWZZhGAZB8MVW2jkP1p9T
VVWr1Wo+n+9/qJ1VANDJj+6515dSKk1TIYTrhY7aVbHqJHfavNsAKWWaplmW9QP+3F87U7dL
OyDP88Vi4Tqlv2qrhwP9uUuIWFUVIcR24/E66n3dyVpKmee57/uMsU5aB+u5MQ9t7516aq2N
Me/v7+v1OgiC29vb2WyGiJRuZHywnjvnzzLcaVmWy+XS9/2bm5v7+3t7kXPeX7Vrwy28rfOg
lMqyTCkVx/F0Op1MJnu26/vbx+vIGJNlmRAiSZLr6+soijjnfU9tnebPiRAihBBCcM7v7u4u
Ly8558PhsPO0+jrNnxvnt7c3AEiSJI7ji4uLY0h2+XA4dKf2mBDSNr3B01q/vLwURRFFUZIk
4/GYc37wYwQA9q9AShmGoS04YywMw6IoOOdBEGzhMcbSNKWUzmazKIqiKDqIcbL5xXHseZ7l
EUKm0+loNKKUjsdjF0ncfCCilNJ2xJEFPFXLxSs5wz9Zm/df/e/+g7xfTKFX1x7LBeIAAAAA
SUVORK5CYII='! !

!CMIcons class methodsFor: 'accessing - icons' stamp: 'HernanMoralesDurand 11/25/2017 19:50'!
replayStoredSimIcon
	"Private - Generated method"
	^ self icons
		at: #replayStoredSimIcon
		ifAbsentPut: [ Form
				fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self replayStoredSimIconContents readStream) ]! !

!CMIcons class methodsFor: 'private - contents' stamp: 'HernanMoralesDurand 11/25/2017 19:50'!
replayStoredSimIconContents
	"Private - Method generated with the content of the file File @ c:\MySmalltalkProjects\CORMAS\CORMAS_Pharo6_GitHub\icons\replayStoredSim.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAACUAAAAjCAIAAACcpVRJAAAACXBIWXMAAA7EAAAOxAGVKw4b
AAAEDklEQVRIie2Xy28bVRTGvzMPe1w/64kfiePETiMSSNK0yqJLUNmw4PEHoP4LLMqCBRJb
RCSWEUJCAlUsEC8hhFg0URFCVGVBhQJqEaJqRRMpJVES1Y4fM/fcw2Ic2+MmIWwiFjkr++re
+zvfd869M0O+r3CCQSJykjzjJGGnvFPefwyr++vDd5aV77945dLwuHsSPN9T7br51Qe3xqZy
z748l0jFjr/LnZ8frnx2O56KmSZdef150zIALL35jROPtPbar159LuMmg5k9P0XktcUXTMTX
79WuLd74aeWuUqwUH4f356/rT81MzszPNmrter0RrMrmszPzs7mC++CPv7sz++onsvTGdSKy
DeeMk1q9ufbR28v3724cB+l5PsS0rQgIjUYjGCTAtiJCRncEA/0igAAEEJnxWCbqpL/78rcv
3v/xX3laa9asfAVAKbWfv1a+EtGsexmHeASCiABEJBDHjg4NFb2G/d5b3y5/fru51w4c7iru
l65ZmHUoewGzFoHo3hU9cB6EiCCACIEEMIjSyUS5PP7oQfPa4sovN+93SUqxZZm9zVmz4tDd
r4UVSyiHg/wML4GADMPM5/Pj1XN3bq1//O6NtXubT+pjZuWp/vUiojwlOgS0+v9Qp3gBWwgw
CAIBQESRaLQyMVGv1a5/uuoWE5dfmUtmz3QTVYp9X/Un7Pvs+0qHn3eD94vIfgGJJDwOCBFS
6dT5+fNRI/HJ0g/ff73akSiAiA5LAaC1HrBsgEcgIgJEICBAC4xAb9BEAiKQgajjGIaxtVFr
Nbyut8rv2Nutq/JZ6xAv5GfgYaBP0DNCpAMD0Gy21n5/6OvW6Eyk8rQbXEMCaBbV92oS6Fa+
Ej6yfiIC2lcKGAGfAIA1P1rf2N3eyoyaxZJVHHGnpqa7GSlmzwu9ComI5w3WL8Tr1C2YCxFA
S3AosbuzvbW1mchR9VI0k00VCoVqtdq/UjMrn/s311qUz3Ikr9svPX2tZmP38bYdQ/mCHU2Y
5bHS9PQ0ngitMdAvIqK1Ppon1OkOEojPqraz46nW0DkjnY/k8u7s7FzfGQ8FK1YI+6lFeepo
HgX1E9HtdrPZamTKRrnqZN3MwsLCgZjO1gAzexI6fyLi+QrG4f0iEBAp7XneXixpTVyMnnWT
uVxufLxyBCwIrTTA6BMvItpjskPTBvpTWPZsG+VnrFjaLo+V0qlsLu8e5mE3Ehl786/HjDZY
DLNzXtvtFtCGL+ls79Hd4zGzgipOWmeHnVzedbP54ZFC7+SGbudeBOOTF9140VdKpVJJg0wA
lmUuvDRUr+8lEvF0zjmAd+HySJvrsbhTLBYrlcrAvodJDMYLhUIsFtNa25aTy7tBEqVSiZlN
0xwdLfcsPP1+OOX9j3n/AB/xMtWzEZ9LAAAAAElFTkSuQmCC'! !

!CMIcons class methodsFor: 'accessing - reset' stamp: 'HernanMoralesDurand 9/15/2017 00:21'!
resetIcons
	<script>
	^ icons := nil! !

!CMIcons class methodsFor: 'accessing - icons' stamp: 'HernanMoralesDurand 12/11/2017 21:06'!
run1StepBackwardDisabledIcon
	"Private - Generated method"
	^ self icons
		at: #run1StepBackwardDisabledIcon
		ifAbsentPut: [ Form
				fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self run1StepBackwardDisabledIconContents readStream) ]! !

!CMIcons class methodsFor: 'private - contents' stamp: 'HernanMoralesDurand 12/11/2017 21:06'!
run1StepBackwardDisabledIconContents
	"Private - Method generated with the content of the file File @ c:\MySmalltalkProjects\CORMAS\CORMAS_Pharo6_GitHub\icons\run1StepBackwardDisabled.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAACUAAAAjCAIAAACcpVRJAAAACXBIWXMAAA7EAAAOxAGVKw4b
AAACV0lEQVRIie2W346iMBjF2zLQD8gIaPDPJHM7yb7Bvv2+wWbuZ03cuFGEjC0XBAqx3Ysv
IUQdR0ecbDZzLogWw6/nnLZCf/z89f3b7O6Ok9trm/2hZVkQQgC8T+Cl69/sEzBdffG+eP8C
zxhzdPyud5LWWimltQYAy7JuyDPGlGWplKKU4ojnee1nVD95GmOqqkqSpCzLdrCu68NUr/Vn
jFFKCSGMMZTSuq455+hJa334+6t4u90uTVOlFCHEcZz2ekIf5wkhpJR79byri3nGmDzPhRBo
CwAIIbZtX8XTWq/Xa8bYbDbrkpRSSZJIKduSUE3TYJLY32U8rfXz83OWZbZt53n+9PTEGNvt
dsvlUkp5evoX94cmttstfpVS1nVNCFksFl1be7Wdn+eR/aeUcl0XH+o4TlVVhBAAcBwHOyMH
x1XTNB/nEUJ830crCCaEcM4ZY0VRFEVB3vZX1/XpFbufJ6UUACaTCS68OI4BgHMeRREA3N/f
Z1kmhHBdNwzDrr92/+HGP5eHVqIoCoKAUkopRaOYJwB4npfneZIkSZKEYYjTOl9HePh0bKg7
U8YYAIzH48FgEATBZrMRQlRV1aV+ZD+01KODlmV5nmdZFkb6+vq6Wq2Gw2Ecx7i+Lvb3rrrx
DgaDNE2FEC8vL9PpNI7j/nkojNe2bdd1gyAQQuDRM51Ou0upNx7KsiwAiKIIqVmWzefz0Wj0
+Ph4tJEe/t8xXs45APi+H4ahlHKz2Tw8PNyE16ViqWEY4vsLY/vnSc/vS1gq7vpDWP+8lvrm
rVvwTuh/5/0FtIoIuC7S8nYAAAAASUVORK5CYII='! !

!CMIcons class methodsFor: 'accessing - icons' stamp: 'HernanMoralesDurand 11/25/2017 19:50'!
run1StepBackwardIcon
	"Private - Generated method"
	^ self icons
		at: #run1StepBackwardIcon
		ifAbsentPut: [ Form
				fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self run1StepBackwardIconContents readStream) ]! !

!CMIcons class methodsFor: 'private - contents' stamp: 'HernanMoralesDurand 11/25/2017 19:50'!
run1StepBackwardIconContents
	"Private - Method generated with the content of the file File @ c:\MySmalltalkProjects\CORMAS\CORMAS_Pharo6_GitHub\icons\run1StepBackward.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAACUAAAAjCAIAAACcpVRJAAAACXBIWXMAAA7EAAAOxAGVKw4b
AAADQUlEQVRIie2XT28TRxTA37N3tf//22S8ioQpUlQHisShqKd+DL5EP0kP/QK9VRVXhFq1
9EDbIEoroRZUgwnISbFbIzu7XttZO7G9O7vTw4YoCsYJVpID8I7zZvXb38y8t7P468ONzyol
jhPg9KPnt3A83gEAUZTPgOe1m7kzwByMD7wPvDcEpQmlyRnxppPotx9raZIeQnInTkpT9uRB
8/7tGjB0iPbJtQtH8LI34rj8ArDWpv/zzb8noxhjAfJ0d3d8aMJsvwVgYW937bvqyxdBHiQE
ARAZUBrHx+K9VUQRfXDnWfWPpiSqqmTTKI2TaZZiKTuad3w5SpN6tXXvh5rAy45NGGNxRBHn
PbK4X7sZrN2q7gypZSwJghBNaUIpABw2Oj7v4MGhNNn33gnHa98/+W8jKDrnrGWFxkmaJIDA
GADAXL038ChNOv/2f//pad8bXv/ic6uo7VP/ult/dG/TKRRXVlbSFGgUAwBki4iAiGyu4Ix6
pzTZDkY3v76vys4Scb/96pdBMASA+uOX33x5Z7Pa/fjSKimV8vkD28xYto6MsfmCs/2eV1uW
YyHjBIHTTb1R75yH9PaNPy9dvaxrWhwnNKZ7GEQAYIDw6py89XpSGgsK9IN+GufTNB2OQkHO
TaaTC1ec57WnxF1eIsX9yZhRXyki4PzzMrt/2iXZXVW2w+44Ci9+qkl6HnNsuaJ8dE0aTraq
jx5v93oAAIiMMUBEBEDcU5sLnOEniqIkSeVVU7WBE7FQsHVdt207S8m6P9ja9TfaftcvFgnP
83uGjAEAA7ZI/RFCeJ4vFIYAYBiGZVnZICHEMAxP92QrCFpR60VTUTRdsxARjtq5eTwAcBzH
cZzXx13XdV230WiYZtcq9b36qNUKDdMURYXB0fWwYH8pl8vlcnl9fV3V+n1v5G0Ou14oy1oO
+UXq4ZhRqVQ6nU5gBKrV7bfHW/UQEg4Zf1o8ACCEiKKoKIphDNRC4DemvUbM5QRgs5v+CXyP
TNM0TXMwGBiGoeu+7W57/0Rhh+Es5IndJzKqruue5qlGb+DvtGuxU1JPi5eF4ziSJFmWFZiB
ez4yCod/S07+viTLsizLhJCZ2Xfovvte8v4HgLdn1doyx+wAAAAASUVORK5CYII='! !

!CMIcons class methodsFor: 'accessing - icons' stamp: 'HernanMoralesDurand 11/25/2017 19:50'!
runAllSimIcon
	"Private - Generated method"
	^ self icons
		at: #runAllSimIcon
		ifAbsentPut: [ Form
				fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self runAllSimIconContents readStream) ]! !

!CMIcons class methodsFor: 'private - contents' stamp: 'HernanMoralesDurand 11/25/2017 19:50'!
runAllSimIconContents
	"Private - Method generated with the content of the file File @ c:\MySmalltalkProjects\CORMAS\CORMAS_Pharo6_GitHub\icons\runAllSim.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAACUAAAAjCAIAAACcpVRJAAAACXBIWXMAAA7EAAAOxAGVKw4b
AAAECElEQVRIie2Xy28bVRTGz5mx49px7NhOMnYSUrsUGlpSkgYhhLrIDrFng4AFEis2bUFU
FWLBQ1SIPwAWoaoQaxYskCoBO4TEYxNoVAitFKpCIYmTOHE8nrn3no/F+DVOHBWJZoFyV/ad
O+fnc77vnBmzUpoOcDGAg+RZBwk75P2/eH65LMbcV16oH366eA6uKp2/kCwes2z7fvAinV/g
6Vhl7dYH7yWnZiaefzGWyd57oLVvv/l9/qNoZpBj8VPvvm9FIt7qyvU3Xo8OJFVla/bKp8Gx
UD0BioIyysfiwuKlV//4/DNR/j3y1n/8/ujUYydOn1Hra1YkQkTrN26k886J02cyY+OtYyGe
wIDIYiQgQ7a1+eW166+dL//w3f6iBlf9uk8EImJqCOS6tUZ8blN2+RMAmJls5lxfNBPlPz/5
+NfLb+/cvt2LGigNo6G1BWntG61JxIKQtG/s5jEzkQSfCBSL9o2mBxNbld8uv7V8dV5vb++T
KETDhKY/SGA0pG3Jbh6ImBkgAoiZALKsZKJ/YmyMby79fPHc3Wtf9EpUtBGlwlsiSgG98wvq
2civlTSRZdtDuVyxdLzy9VeLly5sLCx0UUEEY4xSoeeNwCjVmV+oHwIMM5iJgEaKRCAwQMx9
fX3FY6Xq9vadKx+ujE9MvPBSzHEokBAQpcSrE3UARcSrYx/9iAhgBGUN6hlsMlNzNCTT6cnp
2UHgl3feXL4635oMAETCSQc76K0fU7OWACiQMDBRI/nGKeZo7IhlW+5ff7uu24iutfgh/QAR
X5G0TdtdTwDMQMAIXNO8QI0ik1d3795ccrVxn5pLT8/E4/EOXng+CMT399WPuOGXIFlm4gaL
iMWYldU7G+Vy9eQpPTmVHR7OZlszD8Yo43td+Rnf69Svm8dM1PZLwzXMBObNjc3V8qo/frT2
zNnEyMgDjlMqlTpiE2kt7JNpZwMR8X2SttV35xe0RFMqZmKuufX1tVV/IF2Ze9rO50fz+XQ6
XSgU9rivQ6rWDqh3PdHhDiLSWpdrriuyPfMEHnwoNzjoOE4qlerv798NE626/Ekion2yoj15
ge2ZCZAtras7tdrkSe/R6cFcLpfLFYvF3eUQY4KWEG00NHH7wQlAez5i7Z09/EnMLmhLiRp1
ajOPxx2nMDyczWYzmcxuGDXnNRFBaYimWKIdzQh8j6Kx3jyLN+2ETiYqs09ahbFCD6n2oDoj
1VtLVTvS6jZ7aMTzfS96hDqaJMRjrbbsaHV2Vh5+JJvJ9JJqzxU5O7d2fFJrPTAw0PwFTv3l
V3Z2djojhHnPPlcFxZLJfD6/p1S9Vr1edxwnHo+LSKv9gwjGGLvjVSj0vrS8vExEqVSqo4v/
43X4f+WQ92/WP219ONyBCw7CAAAAAElFTkSuQmCC'! !

!CMIcons class methodsFor: 'accessing - icons' stamp: 'HernanMoralesDurand 11/25/2017 19:50'!
smallCormasLogoIcon
	"Private - Generated method"
	^ self icons
		at: #smallCormasLogoIcon
		ifAbsentPut: [ Form
				fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallCormasLogoIconContents readStream) ]! !

!CMIcons class methodsFor: 'private - contents' stamp: 'HernanMoralesDurand 9/15/2017 00:21'!
smallCormasLogoIconContents
	"Private - Method generated with the content of the file File @ c:\MySmalltalkProjects\CORMAS\CORMAS_Pharo6_GitHub\icons\smallCormasLogo.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAACXBIWXMAAAsTAAALEwEAmpwY
AAACVElEQVQokW1SS08TYRS93/2mTKelA33wbEVag4ihqKAujJpoohs1JhqWLkzcGWNc6daV
8Se4k+hODFGDuIDozoQgwYokdQoUrYUW+p5SmOl81wVgi/Hs7sk5Oecmh8F+sBaFDfqg0UaG
xRJlEcmARfsE9QdePchuBIHXSPFomlbL9Rqppj7bwYZDqFdhbAV/lYXERMBBa5v/VOB7coYP
wswusacR80sK9arP7XIgrzp5NbcFdaV2E7CnCdyy7Xuhspjr7+y6fuSkLNnSvm3tXOWru5ye
iovJ30BUl9DbLJ9o8X3MhJKOJ8qVQ2uu9pT96IpqL4FwU+p8kxlspJkNIMK/z3cWsCXLHyoX
uQF386P3sqOiSl1RWXu7EEgSDPlwOAQAuwa0qK2IN1nYz9WXxuwPI71objyvTPtRPZxUY89m
bJuCXQ4wr30vYbnUYLJWQ9lm1lg5ssO9qXwzmTjjCFXWdDGRAM4g7EEAwAMuMkVuKZNTzVWr
aFjmjqFimWlLV7wKAFAsDwDMKUnYrbLHQ+xVPPp+IXLJ1+vsHsXbmsgAURA9Lsn+KZCCKFCb
AgC0vsWpZOCFTsnvMsaXY/FEoUMEmafH8nZw1XDB54HMlBFLJ7L8Th/JKF5oHAhYs0zHPVg0
t6PZaCo5Xpz/wDStfytxSswFS5GJeX4taA16YDJJs+sSAIh3K/x0K93qkfu8YrHAvLJtoD3W
wOdQz48smLkKBp0Y16uvl2rjY34n3g9Dm1LbQKwoRqL0UwcAkDmTkMrm/rXaEI95od0BgkAr
CK0A/8MfsroIJBuY++QAAAAASUVORK5CYII='! !

Object subclass: #CMMigrator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Project'!

!CMMigrator class methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/27/2018 15:35'!
migrateToGitHub

| migration cmRefs | 

" Collect all the Cormas method references "
cmRefs := (RPackageOrganizer default packages
	select: [ : p | p packageName beginsWith: 'Cormas' ]
	thenCollect: [ : p | p methodReferences ]) flattened.

" Get all the current author names for Cormas packages "
(cmRefs
	select: [ : p | p author notNil and: [ p author notEmpty ]]
	thenCollect: [ : p | p author ]) asSet sorted.
 "#('Autogenerated' 'BrunoBonte' 'EtienneD' 'HernanMoralesDurand' 'JigyasaGrover' 'NickPapoulias' 'NicolasBecu' 'PierBo' 'SergeStinckwich' 'nbecu')"

" Inspect and fix all the invalid method author names "
cmRefs 
	select: [ : p | (p author notNil and: [ p author notEmpty ]) and: [ p author match: 'Autogenerated' ] ].

migration := GitMigration on: 'hernanmd/cormas-md'. 
migration cacheAllVersions. 
migration authors: { 
	'BrunoBonte' 			-> #('Your_Name' '<@gmail.com>') .
	'EtienneD' 				-> #('Your_Name' '<@gmail.com>') .
	'JigyasaGrover' 		-> #('Your_Name' '<@gmail.com>') .
	'NickPapoulias' 		-> #('Your_Name' '<@gmail.com>') .
	'PierBo' 					-> #('Your_Name' '<[hidden email]>') .
	'SergeStinckwich' 		-> #('Your_Name' '<Serge.Stinckwich@gmail.com>') .
	'nbecu' 					-> #('Your_Name' '<[hidden email]>') .
	'NicolasBecu' 			-> #('Your_Name' '<@gmail.com>') .
	'HernanMoralesDurand' -> #('Hernan Morales Durand' '<hernan.morales@gmail.com>') .	
	}. 
migration
	fastImportCodeToDirectory: 'repository' 
	initialCommit: '....' " copy/paste the id from the git log command in step 2)" 
	to: 'import.txt' ! !

Object subclass: #SelectionInList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-VW-Compatibility'!

!SelectionInList class methodsFor: 'instance creation' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
with: aCollection

	^ TickDialogWindow
		itemsList: aCollection 
		itemsHeaderName: String empty 
		title: 'CORMAS'! !

!SelectionInList methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
selectionIndexHolder! !

!SelectionInList methodsFor: 'initialize - release' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
with: aCollection

	self selectionList: (TickDialogWindow
		itemsList: aCollection 
		itemsHeaderName: String empty 
		title: 'CORMAS')! !

ComposableModel subclass: #CMSpecObject
	instanceVariableNames: 'projectManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Core'!

CMSpecObject subclass: #CMManipulationSetter
	instanceVariableNames: 'cormasModel classAttribValue_List selectedRow methodsForManip_List entity entityChoices applyToSubclasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Core'!

!CMManipulationSetter commentStamp: 'HernanMoralesDurand 4/4/2018 18:13' prior: 0!
CMManipulationSetter example.

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.


    Implementation Points!

!CMManipulationSetter class methodsFor: 'interface specs' stamp: 'HernanMoralesDurand 12/12/2017 07:32'!
labelControl
	
	^'Use for
control' asText asComposedText	"^('Employee
Number' asText emphasizeAllWith: (Array with: #bold with: #color->ColorValue red)) asComposedText"! !

!CMManipulationSetter class methodsFor: 'interface specs' stamp: 'HernanMoralesDurand 12/12/2017 07:32'!
labelInit
	
	^'Use for
init' asText asComposedText	"^('Employee
Number' asText emphasizeAllWith: (Array with: #bold with: #color->ColorValue red)) asComposedText"! !

!CMManipulationSetter class methodsFor: 'interface specs' stamp: 'HernanMoralesDurand 12/12/2017 07:32'!
labelTesting
	
	^'Use for
testing' asText asComposedText	"^('Employee
Number' asText emphasizeAllWith: (Array with: #bold with: #color->ColorValue red)) asComposedText"! !

!CMManipulationSetter class methodsFor: 'interface specs' stamp: 'HernanMoralesDurand 12/12/2017 07:32'!
windowSpec
	"Tools.UIPainter new openOnClass: self andSelector: #windowSpec"
	
	<resource: #canvas>
	^#(FullSpec 
		#window: #(WindowSpec 
			#properties: #(PropertyListDictionary #sizeType #specifiedSize #positionType #positionSystemDefault #openType #advanced) 
			#label: 'Manipulation Methods Setter' 
			#min: #(Point 427 371) 
			#max: #(Point 2200 2200) 
			#bounds: #(Rectangle 840 525 1267 896) 
			#flags: 8 
			#colors: #(LookPreferences 
				#setBackgroundColor: #(ColorValue 6655 8191 5119))) 
		#component: #(SpecCollection 
			#collection: #(#(DataSetSpec 
				#properties: #(PropertyListDictionary #showVerticalLines true #allowColumnReordering true #showLineNumbers true #allowColumnResizing true #rowLabelsAsButtons false #showHorizontalLines true) 
				#layout: #(LayoutFrame 0 0 65 0 0 1.0 0 1.00563) 
				#name: #Dataset1 
				#model: #methodsForManip_List 
				#columns: #(#(DataSetColumnSpec 
					#properties: #(PropertyListDictionary #labelFromApplication false #allowSorting false #allowResizing false) 
					#label: ' N¬∞' 
					#labelIsImage: false 
					#width: 30 
					#rendererType: #rowSelector 
					#editorType: #rowSelector 
					#noScroll: false) #(DataSetColumnSpec 
					#properties: #(PropertyListDictionary #labelFromApplication false #allowSorting true #allowResizing true) 
					#model: #'selectedRow methodAsString' 
					#label: 'Method' 
					#labelIsImage: false 
					#width: 160 
					#rendererType: #Text 
					#editorType: #Label 
					#noScroll: true) #(DataSetColumnSpec 
					#properties: #(PropertyListDictionary #labelFromApplication true #allowSorting true #allowResizing true) 
					#model: #'selectedRow isInit' 
					#label: #labelInit 
					#labelIsImage: true 
					#width: 70 
					#rendererType: #CheckBox 
					#editorType: #CheckBox 
					#noScroll: false) #(DataSetColumnSpec 
					#properties: #(PropertyListDictionary #labelFromApplication true #allowSorting true #allowResizing true) 
					#model: #'selectedRow isControl' 
					#label: #labelControl 
					#labelIsImage: true 
					#width: 70 
					#rendererType: #CheckBox 
					#editorType: #CheckBox 
					#noScroll: false) #(DataSetColumnSpec 
					#properties: #(PropertyListDictionary #labelFromApplication true #allowSorting true #allowResizing true) 
					#model: #'selectedRow isTesting' 
					#label: #labelTesting 
					#labelIsImage: true 
					#width: 70 
					#rendererType: #CheckBox 
					#editorType: #CheckBox 
					#noScroll: false)) 
				#labelsAsButtons: true) #(ActionButtonSpec 
				#layout: #(Rectangle 309 35 384 58) 
				#name: #applyClose 
				#model: #finalize 
				#label: 'Apply - Close' 
				#defaultable: true) #(ActionButtonSpec 
				#layout: #(Rectangle 241 35 296 58) 
				#name: #Apply 
				#model: #saveValues 
				#label: 'Apply' 
				#defaultable: true) #(ActionButtonSpec 
				#layout: #(Rectangle 140 35 228 58) 
				#name: #SetDefaultValues 
				#model: #setDefaultValues 
				#label: 'Default settings' 
				#defaultable: true) #(ComboBoxSpec 
				#layout: #(Rectangle 246 5 384 27) 
				#name: #ComboBox1 
				#model: #entity 
				#comboList: #entityChoices) #(LabelSpec 
				#layout: #(Point 9 3) 
				#name: #Label1 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 7679 8191 7167)) 
				#label: 'Set manipulation methods of Entity' 
				#style: #systemDefault) #(CheckBoxSpec 
				#layout: #(Point 15 35) 
				#name: #applyToSubclasses 
				#flags: 16 
				#model: #applyToSubclasses) #(LabelSpec 
				#layout: #(Point 34 28) 
				#name: #labelapplyToSubclasses1 
				#flags: 16 
				#label: 'Apply to') #(LabelSpec 
				#layout: #(Point 34 41) 
				#name: #labelapplyToSubclasses2 
				#flags: 16 
				#label: 'subclasses'))))! !

!CMManipulationSetter methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/12/2017 07:32'!
applyToSubclasses
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^applyToSubclasses isNil
		ifTrue: [applyToSubclasses := false asValue]
		ifFalse: [applyToSubclasses]! !

!CMManipulationSetter methodsFor: 'initialize-release' stamp: 'HernanMoralesDurand 12/12/2017 07:32'!
changeEntity
	
	| aList aMS |
	"collect all methods by using the setDefaultValues method, put them in the dataset, and then set back all the settings to false"
	self setDefaultValues.
	aList := self methodsForManip_List list copy.
	aList
		do:
			[:i | 
			i isInit: false.
			i isControl: false.
			i isTesting: false].	"read user defined preferences. If the preferences exists, set default value to fasle and then overwrite the preferences in the dataset"
	(self entityClass class selectors includes: #methodsForInit_UserDefined)
		ifTrue:
			[self entityClass methodsForInit_UserDefined
				do:
					[:m | 
					aMS := aList
						detect: [:i | i methodName = m asString]
						ifNone: [nil].
					aMS ifNotNil: [aMS isInit: true]]].
	(self entityClass class selectors includes: #methodsForControl_UserDefined)
		ifTrue:
			[self entityClass methodsForControl_UserDefined
				do:
					[:m | 
					aMS := aList
						detect: [:i | i methodName = m asString]
						ifNone: [nil].
					aMS ifNotNil: [aMS isControl: true]]].
	(self entityClass class selectors includes: #methodsForTesting_UserDefined)
		ifTrue:
			[self entityClass methodsForTesting_UserDefined
				do:
					[:m | 
					aMS := aList
						detect: [:i | i methodName = m asString]
						ifNone: [nil].
					aMS ifNotNil: [aMS isTesting: true]]].
	self methodsForManip_List list: aList.
	self entityClass subclasses isEmpty
		ifFalse:
			[self applyToSubclasses value: true.
			(self builder componentAt: #applyToSubclasses) isVisible: true.
			(self builder componentAt: #labelapplyToSubclasses1) isVisible: true.
			(self builder componentAt: #labelapplyToSubclasses2) isVisible: true]
		ifTrue:
			[self applyToSubclasses value: false.
			(self builder componentAt: #applyToSubclasses) isVisible: false.
			(self builder componentAt: #labelapplyToSubclasses1) isVisible: false.
			(self builder componentAt: #labelapplyToSubclasses2) isVisible: false]! !

!CMManipulationSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/12/2017 07:32'!
cormasModel
	
	^cormasModel! !

!CMManipulationSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/12/2017 07:32'!
cormasModel: anObject
	
	cormasModel := anObject! !

!CMManipulationSetter methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/12/2017 07:34'!
defaultValuesForClass: aClass category: aSymbol
	
	| aList i cat |
	aList := OrderedCollection new.
	cat := aSymbol asString.
	cat
		at: 1
		put: cat first asUppercase.
	(aClass perform: ('methodsFor' , cat) asSymbol)
		do: [ : m | i := CMClassManipulationMethod new.
			i
				targetClass: aClass;
				methodName: m;
				isInit: cat = 'Init';
				isControl: cat = 'Control';
				isTesting: cat = 'Testing'.
			aList add: i ].
	^ aList! !

!CMManipulationSetter methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/12/2017 07:35'!
entity
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^ entity isNil
		ifTrue: [ entity := String new asValueHolder ]
		ifFalse: [ entity ]! !

!CMManipulationSetter methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/12/2017 07:35'!
entityChoices
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^ entityChoices isNil
		ifTrue: [ entityChoices := OrderedCollection new asValueHolder ]
		ifFalse: [ entityChoices]! !

!CMManipulationSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/12/2017 07:35'!
entityClass
	
	^ self entity value class! !

!CMManipulationSetter methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/12/2017 07:32'!
finalize
	
	self saveValues.
	self closeAndUnschedule! !

!CMManipulationSetter methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/12/2017 07:32'!
methodsForManip_List
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^methodsForManip_List isNil
		ifTrue:
			[methodsForManip_List := SelectionInListSortAware new.
			methodsForManip_List selectionIndexHolder
				compute: [:v | self selectedRow value: methodsForManip_List selection].
			methodsForManip_List]
		ifFalse: [methodsForManip_List]! !

!CMManipulationSetter methodsFor: 'initialize-release' stamp: 'HernanMoralesDurand 12/12/2017 07:32'!
openOn: aModel
	
	| win |
	cormasModel := aModel.
	self prepareTable.
	win := (self allButOpenInterface: #windowSpec) window.
	win open.
	entity value: entityChoices value first! !

!CMManipulationSetter methodsFor: 'initialize-release' stamp: 'HernanMoralesDurand 12/12/2017 07:36'!
prepareTable
	
	| modelClasses |
	modelClasses := OrderedCollection new.
	modelClasses addAll: (cormasModel spatialClasses collect: #name).
	modelClasses addAll: (cormasModel socialClasses collect: #name).
	modelClasses addAll: (cormasModel passiveObjectClasses collect: #name).
	entityChoices := (OrderedCollection withAll: modelClasses) asValueHolder.
	self entity onChangeSend: #changeEntity to: self.	"self setDefaultValues."
	self initialize! !

!CMManipulationSetter methodsFor: 'initialize-release' stamp: 'HernanMoralesDurand 12/12/2017 07:32'!
requestForWindowClose
	
	cormasModel := nil.
	^super requestForWindowClose! !

!CMManipulationSetter methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/12/2017 07:32'!
saveValues
	
	| methodsName |
	"collect user define Init methods for a class"
	methodsName := (self methodsForManip_List list
		select: [:i | i isInit = true]) collect: [:i | i methodName].
	self
		write: methodsName
		inMethod: #methodsForInit_UserDefined
		inClass: self entityClass.
	self applyToSubclasses value
		ifTrue:
			[self entityClass subclasses
				do:
					[:c | self write: methodsName inMethod: #methodsForInit_UserDefined inClass: c]].	"collect user define Control methods for a self entityClasslass"
	methodsName := (self methodsForManip_List list
		select: [:i | i isControl = true]) collect: [:i | i methodName].
	self
		write: methodsName
		inMethod: #methodsForControl_UserDefined
		inClass: self entityClass.
	self applyToSubclasses value
		ifTrue:
			[self entityClass subclasses
				do:
					[:c | self write: methodsName inMethod: #methodsForControl_UserDefined inClass: c]].	"collect user define Testing methods for a self entityClasslass"
	methodsName := (self methodsForManip_List list
		select: [:i | i isTesting = true]) collect: [:i | i methodName].
	self
		write: methodsName
		inMethod: #methodsForTesting_UserDefined
		inClass: self entityClass.
	self applyToSubclasses value
		ifTrue:
			[self entityClass subclasses
				do:
					[:c | self write: methodsName inMethod: #methodsForTesting_UserDefined inClass: c]]! !

!CMManipulationSetter methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/12/2017 07:37'!
selectedRow
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^ selectedRow isNil
		ifTrue: [ selectedRow := nil asValueHolder ]
		ifFalse: [ selectedRow ]! !

!CMManipulationSetter methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/12/2017 07:32'!
selectedRowClassNameAsStringLabelPressed
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined."
	
	| ascSortBlock dscSortBlock sortBlock |
	ascSortBlock := [:x :y | x classNameAsString displayString <= y classNameAsString displayString].
	dscSortBlock := [:x :y | x classNameAsString displayString >= y classNameAsString displayString].
	sortBlock := self methodsForManip_List sortAspect ==
			#selectedRowClassNameAsString
		ifTrue:
			[self methodsForManip_List sortDirection == #asc
				ifTrue:
					[self methodsForManip_List sortDirection: #dsc.
					ascSortBlock]
				ifFalse:
					[self methodsForManip_List sortDirection: #asc.
					dscSortBlock]]
		ifFalse:
			[self methodsForManip_List sortAspect: #selectedRowClassNameAsString.
			self methodsForManip_List sortDirection: #dsc.
			ascSortBlock].
	self methodsForManip_List
		refreshList:
			(SortedCollection
				withAll: self methodsForManip_List list
				sortBlock: sortBlock) asList! !

!CMManipulationSetter methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/12/2017 07:32'!
selectedRowIsControlLabelPressed
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined."
	
	| ascSortBlock dscSortBlock sortBlock |
	ascSortBlock := [:x :y | x isControl displayString <= y isControl displayString].
	dscSortBlock := [:x :y | x isControl displayString >= y isControl displayString].
	sortBlock := self methodsForManip_List sortAspect == #selectedRowIsControl
		ifTrue:
			[self methodsForManip_List sortDirection == #asc
				ifTrue:
					[self methodsForManip_List sortDirection: #dsc.
					ascSortBlock]
				ifFalse:
					[self methodsForManip_List sortDirection: #asc.
					dscSortBlock]]
		ifFalse:
			[self methodsForManip_List sortAspect: #selectedRowIsControl.
			self methodsForManip_List sortDirection: #dsc.
			ascSortBlock].
	self methodsForManip_List
		refreshList:
			(SortedCollection
				withAll: self methodsForManip_List list
				sortBlock: sortBlock) asList! !

!CMManipulationSetter methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/12/2017 07:32'!
selectedRowIsInitLabelPressed
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined."
	
	| ascSortBlock dscSortBlock sortBlock |
	ascSortBlock := [:x :y | x isInit displayString <= y isInit displayString].
	dscSortBlock := [:x :y | x isInit displayString >= y isInit displayString].
	sortBlock := self methodsForManip_List sortAspect == #selectedRowIsInit
		ifTrue:
			[self methodsForManip_List sortDirection == #asc
				ifTrue:
					[self methodsForManip_List sortDirection: #dsc.
					ascSortBlock]
				ifFalse:
					[self methodsForManip_List sortDirection: #asc.
					dscSortBlock]]
		ifFalse:
			[self methodsForManip_List sortAspect: #selectedRowIsInit.
			self methodsForManip_List sortDirection: #dsc.
			ascSortBlock].
	self methodsForManip_List
		refreshList:
			(SortedCollection
				withAll: self methodsForManip_List list
				sortBlock: sortBlock) asList! !

!CMManipulationSetter methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/12/2017 07:32'!
selectedRowIsTestingLabelPressed
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined."
	
	| ascSortBlock dscSortBlock sortBlock |
	ascSortBlock := [:x :y | x isTesting displayString <= y isTesting displayString].
	dscSortBlock := [:x :y | x isTesting displayString >= y isTesting displayString].
	sortBlock := self methodsForManip_List sortAspect == #selectedRowIsTesting
		ifTrue:
			[self methodsForManip_List sortDirection == #asc
				ifTrue:
					[self methodsForManip_List sortDirection: #dsc.
					ascSortBlock]
				ifFalse:
					[self methodsForManip_List sortDirection: #asc.
					dscSortBlock]]
		ifFalse:
			[self methodsForManip_List sortAspect: #selectedRowIsTesting.
			self methodsForManip_List sortDirection: #dsc.
			ascSortBlock].
	self methodsForManip_List
		refreshList:
			(SortedCollection
				withAll: self methodsForManip_List list
				sortBlock: sortBlock) asList! !

!CMManipulationSetter methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/12/2017 07:32'!
selectedRowMethodAsStringLabelPressed
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined."
	
	| ascSortBlock dscSortBlock sortBlock |
	ascSortBlock := [:x :y | x methodAsString displayString <= y methodAsString displayString].
	dscSortBlock := [:x :y | x methodAsString displayString >= y methodAsString displayString].
	sortBlock := self methodsForManip_List sortAspect ==
			#selectedRowMethodAsString
		ifTrue:
			[self methodsForManip_List sortDirection == #asc
				ifTrue:
					[self methodsForManip_List sortDirection: #dsc.
					ascSortBlock]
				ifFalse:
					[self methodsForManip_List sortDirection: #asc.
					dscSortBlock]]
		ifFalse:
			[self methodsForManip_List sortAspect: #selectedRowMethodAsString.
			self methodsForManip_List sortDirection: #dsc.
			ascSortBlock].
	self methodsForManip_List
		refreshList:
			(SortedCollection
				withAll: self methodsForManip_List list
				sortBlock: sortBlock) asList! !

!CMManipulationSetter methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/12/2017 07:37'!
setDefaultValues
	
	| aList |
	aList := OrderedCollection new.
	aList
		addAll:
			(self
				defaultValuesForClass: self entityClass
				category: #init).
	aList
		addAll:
			(self
				defaultValuesForClass: self entityClass
				category: #control).
	aList
		addAll:
			(self
				defaultValuesForClass: self entityClass
				category: #testing).
	self methodsForManip_List list: aList! !

!CMManipulationSetter methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/12/2017 07:32'!
setDefaultValuesAndApply
	
	self setDefaultValues.
	self saveValues! !

!CMManipulationSetter methodsFor: 'write in class' stamp: 'HernanMoralesDurand 12/12/2017 07:38'!
write: stringArray inMethod: selector inClass: aClass
	
	| class s |
	class := aClass class.
	s := WriteStream on: String new.
	s
		nextPutAll: selector;
		cr.
	s
		tab;
		crtab;
		nextPutAll: '^#('.
	stringArray do: [:mn | s 
		nextPut: $#;
		nextPutAll: mn;
		space ].
	s nextPutAll: ')'.
	class
		compile: s contents
		classified: #manipulation! !

CMSpecObject subclass: #CMSpaceInterfaceConfig
	instanceVariableNames: 'entitiesList observedEntitiesList manipEntitiesList createEntitiesList spaceInterface configName manipMethods manipMethodsList entitySelected entitiesToAddList methodsToAddList attributes attributesList povMethods povMethodsList infoMethods infoMethodsList probeMethods probeMethodsList defaultPov defaultInfo canBeMoved moveEntityCheckBox manipWholePop manipWholePopCheckBox canChangeValues canChangeValuesCheckBox delimiterSize trackLengthValue trackedAgents defaultTool isManipulateForTabletEnabled isUndoRedoEnabled isSingleDefaultPovShown isSingleDefaultInfoShown siMenuFormat'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Core'!

CMSpaceInterfaceConfig class
	instanceVariableNames: 'winAddEntities_title winAddMethods_title'!

CMSpaceInterfaceConfig class
	instanceVariableNames: 'winAddEntities_title winAddMethods_title'!

!CMSpaceInterfaceConfig class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
apply
	
	^ToolbarIconLibrary visualFor: #modificationApply! !

!CMSpaceInterfaceConfig class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
attributesMenu
	"Tools.MenuEditor new openOnClass: self andSelector: #manipEntityMenu"
	
	<resource: #menu>
	^#(Menu #(#(MenuItem 
		#rawLabel: 'remove' 
		#value: #removeAttribute)) #(1) nil) decodeAsLiteralArray! !

!CMSpaceInterfaceConfig class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
createEntityMenu
	"Tools.MenuEditor new openOnClass: self andSelector: #createEntityMenu"
	
	<resource: #menu>
	^#(Menu #(#(MenuItem 
		#rawLabel: 'remove' 
		#value: #removeCreateEntity)) #(1) nil) decodeAsLiteralArray! !

!CMSpaceInterfaceConfig class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
displayOptionsMenu
	"Tools.MenuEditor new openOnClass: self andSelector: #displayOptionsMenu"
	
	<resource: #menu>
	^#(Menu #(#(MenuItem 
		#rawLabel: 'Delimitors size' 
		#submenu: #(Menu #(#(MenuItem 
			#rawLabel: '0 pixel' 
			#nameKey: #pixel0 
			#value: #pixel0 
			#indication: true 
			#indicationSelector: #delimiterSize) #(MenuItem 
			#rawLabel: '1 pixel' 
			#nameKey: #pixel1 
			#value: #pixel1 
			#indication: true 
			#indicationSelector: #delimiterSize) #(MenuItem 
			#rawLabel: '2 pixels' 
			#nameKey: #pixel2 
			#value: #pixel2 
			#indication: true 
			#indicationSelector: #delimiterSize) #(MenuItem 
			#rawLabel: '3 pixels' 
			#nameKey: #pixel3 
			#value: #pixel3 
			#indication: true 
			#indicationSelector: #delimiterSize)) #(4) nil)) #(MenuItem 
		#rawLabel: 'Track agents' 
		#nameKey: #trackAgents 
		#indication: false) #(MenuItem 
		#rawLabel: 'Set track length' 
		#value: #setTrackLength) #(MenuItem 
		#rawLabel: 'Default interface tool' 
		#submenu: #(Menu #(#(MenuItem 
			#rawLabel: 'Inspect' 
			#nameKey: #toolInspect 
			#value: #toolInspect 
			#indication: true 
			#indicationSelector: #defaultTool) #(MenuItem 
			#rawLabel: 'Manipulate' 
			#nameKey: #toolManipulate 
			#value: #toolManipulate 
			#indication: true 
			#indicationSelector: #defaultTool) #(MenuItem 
			#rawLabel: 'Create' 
			#nameKey: #toolCreate 
			#value: #toolCreate 
			#indication: true 
			#indicationSelector: #defaultTool) #(MenuItem 
			#rawLabel: 'Zoom' 
			#nameKey: #toolZoom 
			#value: #toolZoom 
			#indication: true 
			#indicationSelector: #defaultTool)) #(4) nil) 
		#helpText: 'Default tool used when clicking entities in the space interface') #(MenuItem 
		#rawLabel: 'Enable touchpad mode' 
		#nameKey: #toggleTouchpadMode 
		#value: #toggleTouchpadMode 
		#indication: false) #(MenuItem 
		#rawLabel: 'Enable Undo/Redo' 
		#nameKey: #toggleUndoRedo 
		#value: #toggleUndoRedo 
		#indication: true) #(MenuItem 
		#rawLabel: 'Space interface menu bar' 
		#submenu: #(Menu #(#(MenuItem 
			#rawLabel: 'full menu' 
			#nameKey: #siMenuFull 
			#value: #siMenuFull_apply 
			#indication: true 
			#indicationSelector: #siMenuFormat) #(MenuItem 
			#rawLabel: 'pov, info, track, Habitus' 
			#nameKey: #siMenuLimitedWithHabitus 
			#value: #siMenuLimitedWithHabitus_apply 
			#indication: false 
			#indicationSelector: #siMenuFormat) #(MenuItem 
			#rawLabel: 'pov, info, track' 
			#nameKey: #siMenuLimited 
			#value: #siMenuLimited_apply 
			#indication: false 
			#indicationSelector: #siMenuFormat) #(MenuItem 
			#rawLabel: 'pov, info, Habitus' 
			#nameKey: #siMenuLimited2WithHabitus 
			#value: #siMenuLimited2WithHabitus_apply) #(MenuItem 
			#rawLabel: 'pov, info' 
			#nameKey: #siMenuLimited2 
			#value: #siMenuLimited2_apply) #(MenuItem 
			#rawLabel: 'none' 
			#nameKey: #siMenuNone 
			#value: #siMenuNone_apply)) #(6) nil)) #(MenuItem 
		#rawLabel: 'Show single default pov in menu' 
		#nameKey: #toggleShowSingleDefaultPov 
		#value: #toggleShowSingleDefaultPov 
		#indication: true) #(MenuItem 
		#rawLabel: 'Show single default info in menu' 
		#nameKey: #toggleShowSingleDefaultInfo 
		#value: #toggleShowSingleDefaultInfo 
		#indication: true)) #(9) nil) decodeAsLiteralArray! !

!CMSpaceInterfaceConfig class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
infoMethodsMenu
	"Tools.MenuEditor new openOnClass: self andSelector: #infoMethodsMenu"
	
	<resource: #menu>
	^#(Menu #(#(MenuItem 
		#rawLabel: 'remove' 
		#value: #removeInfoMethod) #(MenuItem 
		#rawLabel: 'set as default' 
		#value: #setSelectionAsDefaultInfo) #(MenuItem 
		#rawLabel: 'no default info' 
		#value: #cancelDefaultInfo)) #(2 1) nil) decodeAsLiteralArray! !

!CMSpaceInterfaceConfig class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
load
	
	^ToolbarIconLibrary visualFor: #fileOpen! !

!CMSpaceInterfaceConfig class methodsFor: 'save-load' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
loadSIconfig: aConfigSpec in: aSIConfig ofModel: aModel
	
	| stream line aL data collec aClass configElement |
	aSIConfig manipMethods: Dictionary new.
	aSIConfig defaultPov: nil.
	aSIConfig defaultInfo: nil.
	stream := aConfigSpec readStream.
	[stream atEnd]
		whileFalse:
			[line := Cormas splitLine: stream sep: $*.
			configElement := (line first
				copyFrom: 1
				to: line first size - 1) asSymbol.
			configElement = #configName
				ifTrue: [aSIConfig configName value: line last].
			(#(#observedEntitiesList #manipEntitiesList #createEntitiesList)
				refersToLiteral: configElement)
				ifTrue:
					[aL := List new.
					(Cormas
						splitLine: line last readStream
						sep: $,)
						do:
							[:i | 
							aClass := (Cormas stringAsObjectType: i) class.
							aClass ifNotNil: [aL add: aClass]].
					(aSIConfig perform: configElement) setList: aL selecting: ''].
			(#(#manipMethods #povMethods #attributes #infoMethods #probeMethods)
				refersToLiteral: configElement)
				ifTrue:
					[data := (Cormas
						splitLine: line last readStream
						sep: $,) asOrderedCollection.
					aClass := (Cormas stringAsObjectType: data removeFirst) class.
					aClass
						ifNotNil:
							[(aSIConfig perform: configElement)
								at: aClass
								put: (data collect: [:m | m asSymbol])]].
			(#(#canBeMoved #manipWholePop #canChangeValues) refersToLiteral:
					configElement)
				ifTrue:
					[data := (Cormas
						splitLine: line last readStream
						sep: $,) asOrderedCollection.
					aClass := (Cormas stringAsObjectType: data removeFirst) class.
					aClass
						ifNotNil:
							[(aSIConfig perform: configElement)
								at: aClass
								put: (Cormas stringAsObjectType: data first)]].
			(#(#defaultPov #defaultInfo) refersToLiteral: configElement)
				ifTrue:
					[data := (Cormas
						splitLine: line last readStream
						sep: $,) asOrderedCollection.
					aClass := (Cormas stringAsObjectType: data removeFirst) class.
					aClass
						ifNotNil:
							[(aSIConfig perform: configElement)
								at: aClass
								put: data first asSymbol]].
			configElement = #delimiterSize
				ifTrue:
					[data := (Cormas
						splitLine: line last readStream
						sep: $,) asOrderedCollection.
					data removeFirst.
					aSIConfig perform: data first asSymbol].
			configElement = #defaultTool
				ifTrue:
					[data := (Cormas
						splitLine: line last readStream
						sep: $,) asOrderedCollection.
					aSIConfig perform: data first asSymbol].
			configElement = #siMenuFormat
				ifTrue:
					[data := (Cormas
						splitLine: line last readStream
						sep: $,) asOrderedCollection.
					aSIConfig perform: data first asSymbol].
			configElement = #isUndoRedoEnabled
				ifTrue:
					[data := (Cormas
						splitLine: line last readStream
						sep: $,) asOrderedCollection first.
					aSIConfig isUndoRedoEnabled: (Cormas stringAsObjectType: data)].
			configElement = #isManipulateForTabletEnabled
				ifTrue:
					[data := (Cormas
						splitLine: line last readStream
						sep: $,) asOrderedCollection first.
					aSIConfig
						isManipulateForTabletEnabled: (Cormas stringAsObjectType: data)].
			configElement = #isSingleDefaultPovShown
				ifTrue:
					[data := (Cormas
						splitLine: line last readStream
						sep: $,) asOrderedCollection first.
					aSIConfig isSingleDefaultPovShown: (Cormas stringAsObjectType: data)].
			configElement = #isSingleDefaultInfoShown
				ifTrue:
					[data := (Cormas
						splitLine: line last readStream
						sep: $,) asOrderedCollection first.
					aSIConfig isSingleDefaultInfoShown: (Cormas stringAsObjectType: data)].
			configElement = #trackLengthValue
				ifTrue:
					[data := (Cormas
						splitLine: line last readStream
						sep: $,) asOrderedCollection.
					data removeFirst.
					aSIConfig
						applyTrackLengthValue: (Cormas stringAsObjectType: data first)].
			configElement = #trackedAgents
				ifTrue:
					[collec := Set new.
					line size = 1
						ifFalse:
							[(Cormas
								splitLine: line last readStream
								sep: $,)
								do: [:i | collec add: (Cormas stringAsObjectType: i) asSymbol]].
					aSIConfig trackedAgents: collec]].
	stream close! !

!CMSpaceInterfaceConfig class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
manipEntityMenu
	"Tools.MenuEditor new openOnClass: self andSelector: #manipEntityMenu"
	
	<resource: #menu>
	^#(Menu #(#(MenuItem 
		#rawLabel: 'remove' 
		#value: #removeManipEntity)) #(1) nil) decodeAsLiteralArray! !

!CMSpaceInterfaceConfig class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
manipMethodsMenu
	"Tools.MenuEditor new openOnClass: self andSelector: #manipEntityMenu"
	
	<resource: #menu>
	^#(Menu #(#(MenuItem 
		#rawLabel: 'remove' 
		#value: #removeManipMethod)) #(1) nil) decodeAsLiteralArray! !

!CMSpaceInterfaceConfig class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
minusIcon
	
	^OpaqueImage
		figure: self removeEntityIconImage
		shape: self removeEntityIconMask! !

!CMSpaceInterfaceConfig class methodsFor: 'instance creation' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
newFor: aSI
	
	| x |
	x := super new.
	x spaceInterface: aSI.
	x prepareSettings.
	^x! !

!CMSpaceInterfaceConfig class methodsFor: 'instance creation' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
newFor: aSI withConfig: aConfigName
	
	| x |
	x := super new.
	x spaceInterface: aSI.
	x prepareSettings.
	x configName value: aConfigName.
	x spaceInterface configName value: aConfigName.
	self
		loadSIconfig:
			(x spaceInterface cormasModelClass
				perform: ('SIconfig_' , aConfigName) asSymbol)
		in: x
		ofModel: aSI cormasModel.
	^x! !

!CMSpaceInterfaceConfig class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
observedEntityMenu
	"Tools.MenuEditor new openOnClass: self andSelector: #observedEntityMenu"
	
	<resource: #menu>
	^#(Menu #(#(MenuItem 
		#rawLabel: 'remove' 
		#value: #removeObservedEntity)) #(1) nil) decodeAsLiteralArray! !

!CMSpaceInterfaceConfig class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
plusIcon
	
	^SpaceInterface createEntityIcon! !

!CMSpaceInterfaceConfig class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
povMethodsMenu
	"Tools.MenuEditor new openOnClass: self andSelector: #povMethodsMenu"
	
	<resource: #menu>
	^#(Menu #(#(MenuItem 
		#rawLabel: 'remove' 
		#value: #removePovMethod) #(MenuItem 
		#rawLabel: 'set as default' 
		#value: #setSelectionAsDefaultPov) #(MenuItem 
		#rawLabel: 'no default pov' 
		#value: #cancelDefaultPov)) #(2 1) nil) decodeAsLiteralArray! !

!CMSpaceInterfaceConfig class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
probeMethodsMenu
	"Tools.MenuEditor new openOnClass: self andSelector: #manipEntityMenu"
	
	<resource: #menu>
	^#(Menu #(#(MenuItem 
		#rawLabel: 'remove' 
		#value: #removeProbeMethod)) #(1) nil) decodeAsLiteralArray! !

!CMSpaceInterfaceConfig class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
question
	
	^ToolbarIconLibrary visualFor: #unknownWidget! !

!CMSpaceInterfaceConfig class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
removeEntityIconImage
	"Tools.UIMaskEditor new openOnClass: self andSelector: #removeEntityIconMask"
	
	<resource: #image>
	^CachedImage
		on:
			(Image
				extent: 24 @ 14
				depth: 2
				bitsPerPixel: 2
				palette:
					(MappedPalette
						withColors:
							(#(#(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(0 0 0)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 8191 8191)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1541 1541 1541)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(513 513 513)))
								collect:
									[:each | 
									(each at: 1) value
										perform: (each at: 2)
										withArguments: (each at: 3)]))
				usingBits:
					#[85 85 85 85 85 85 0 0 85 85 85 85 85 85 0 0 85 85 85 85 85 85 0 0 85 85 85 85 85 85 0 0 85 85 85 85 85 85 0 0 85 96 0 0 37 85 0 0 85 69 85 85 69 85 0 0 85 69 85 85 69 85 0 0 85 69 85 85 69 85 0 0 85 112 0 0 53 85 0 0 85 85 85 85 85 85 0 0 85 85 85 85 85 85 0 0 85 85 85 85 85 85 0 0 85 85 85 85 85 85 0 0])! !

!CMSpaceInterfaceConfig class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
removeEntityIconMask
	"Tools.UIMaskEditor new openOnClass: self andSelector: #removeEntityIconMask"
	
	<resource: #image>
	^CachedImage
		on:
			(Image
				extent: 24 @ 14
				depth: 1
				bitsPerPixel: 1
				palette: CoveragePalette monoMaskPalette
				usingBits:
					#[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 7 255 192 0 7 255 192 0 7 255 192 0 7 255 192 0 7 255 192 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0])! !

!CMSpaceInterfaceConfig class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
save
	
	^ToolbarIconLibrary visualFor: #fileSave! !

!CMSpaceInterfaceConfig class methodsFor: 'save-load' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
saveSIconfig: aConfig intoClass: modedelClass name: aName
	
	| selector aString |
	aString := 'configName:*' , aName ,
			'
observedEntitiesList:*'.
	aConfig observedEntitiesList list
		do: [:e | aString := aString , e name printString , ','].
	aString := aString ,
			'
manipEntitiesList:*'.
	aConfig manipEntitiesList list
		do: [:e | aString := aString , e name printString , ','].
	aString := aString ,
			'
createEntitiesList:*'.
	aConfig createEntitiesList list
		do: [:e | aString := aString , e name printString , ','].
	aConfig manipMethods keys
		do:
			[:aClass | 
			aString := aString ,
					'
manipMethods:*' , aClass name asString.
			(aConfig manipMethods at: aClass)
				do: [:aM | aString := aString , ',' , aM asString]].
	aConfig povMethods keys
		do:
			[:aClass | 
			aString := aString ,
					'
povMethods:*' , aClass name asString.
			(aConfig povMethods at: aClass)
				do: [:aM | aString := aString , ',' , aM asString]].
	aConfig attributes keys
		do:
			[:aClass | 
			aString := aString ,
					'
attributes:*' , aClass name asString.
			(aConfig attributes at: aClass)
				do: [:aM | aString := aString , ',' , aM asString]].
	aConfig infoMethods keys
		do:
			[:aClass | 
			aString := aString ,
					'
infoMethods:*' , aClass name asString.
			(aConfig infoMethods at: aClass)
				do: [:aM | aString := aString , ',' , aM asString]].
	aConfig probeMethods keys
		do:
			[:aClass | 
			aString := aString ,
					'
probeMethods:*' , aClass name asString.
			(aConfig probeMethods at: aClass)
				do: [:aM | aString := aString , ',' , aM asString]].
	aConfig canBeMoved keys
		do:
			[:aClass | 
			(aConfig canBeMovedFor: aClass)
				ifNotNil:
					[aString := aString ,
							'
canBeMoved:*' , aClass name asString , ','
						, (aConfig canBeMovedFor: aClass) asString]].
	aConfig manipWholePop keys
		do:
			[:aClass | 
			(aConfig manipWholePopFor: aClass)
				ifNotNil:
					[aString := aString ,
							'
manipWholePop:*' , aClass name asString , ','
						, (aConfig manipWholePopFor: aClass) asString]].
	aConfig canChangeValues keys
		do:
			[:aClass | 
			(aConfig canChangeValuesFor: aClass)
				ifNotNil:
					[aString := aString ,
							'
canChangeValues:*' , aClass name asString , ','
						, (aConfig canChangeValuesFor: aClass) asString]].
	aConfig defaultPov keys
		do:
			[:aClass | 
			(aConfig defaultPovFor: aClass)
				ifNotNil:
					[aString := aString ,
							'
defaultPov:*' , aClass name asString , ','
						, (aConfig defaultPovFor: aClass) asString]].
	aConfig defaultInfo keys
		do:
			[:aClass | 
			(aConfig defaultInfoFor: aClass)
				ifNotNil:
					[aString := aString ,
							'
defaultInfo:*' , aClass name asString , ','
						, (aConfig defaultInfoFor: aClass) asString]].
	aString := aString ,
			'
delimiterSize:*' , 'ESE,' , aConfig delimiterSize value asString ,
			'
defaultTool:*' , aConfig defaultTool value asString ,
			'
siMenuFormat:*' , aConfig siMenuFormat value asString ,
			'
isUndoRedoEnabled:*' , aConfig isUndoRedoEnabled asString ,
			'
isManipulateForTabletEnabled:*'
		, aConfig isManipulateForTabletEnabled asString ,
			'
isSingleDefaultPovShown:*' , aConfig isSingleDefaultPovShown asString ,
			'
isSingleDefaultInfoShown:*' , aConfig isSingleDefaultInfoShown asString ,
			'
trackLengthValue:*' , 'All,' , aConfig trackLengthValue asString ,
			'
trackedAgents:*'.
	aConfig trackedAgents do: [:e | aString := aString , e asString , ','].
	selector := 'SIconfig_' , aName.
	modedelClass class
		compile:
			(selector ,
					'\"Returns an array containing the settings of the Spatial Interface configuration named '
				, aName , '"\^''' , aString , '''\') withCRs
		classified: 'SI_config'
		notifying: nil! !

!CMSpaceInterfaceConfig class methodsFor: 'interface specs' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
winAddEntities
	"Tools.UIPainter new openOnClass: self andSelector: #winAddEntities"
	
	<resource: #canvas>
	^#(FullSpec 
		#window: #(WindowSpec 
			#properties: #(PropertyListDictionary #labelFromApplication true) 
			#label: #winAddEntities_title 
			#min: #(Point 224 166) 
			#max: #(Point 350 500) 
			#bounds: #(Rectangle 720 450 944 703) 
			#isEventDriven: true) 
		#component: #(SpecCollection 
			#collection: #(#(SequenceViewSpec 
				#layout: #(Rectangle 9 33 218 209) 
				#model: #entitiesToAddList 
				#multipleSelections: true 
				#useModifierKeys: true 
				#selectionType: #highlight) #(ActionButtonSpec 
				#layout: #(Rectangle 36 218 96 244) 
				#model: #accept 
				#label: #(UserMessage 
					#key: #ok 
					#defaultString: 'Ok') 
				#defaultable: true) #(LabelSpec 
				#layout: #(Point 42 8) 
				#label: #(UserMessage 
					#key: #attributesToBeSaved 
					#defaultString: 'Select entities to add')) #(ActionButtonSpec 
				#layout: #(Rectangle 112 218 172 244) 
				#model: #cancel 
				#label: #(UserMessage 
					#key: #cancel 
					#defaultString: 'Cancel') 
				#defaultable: true))))! !

!CMSpaceInterfaceConfig class methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
winAddEntities_title
	
	^winAddEntities_title ifNil: [winAddEntities_title := 'Entities']! !

!CMSpaceInterfaceConfig class methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
winAddEntities_title: anObject
	
	winAddEntities_title := anObject! !

!CMSpaceInterfaceConfig class methodsFor: 'interface specs' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
winAddMethods
	"Tools.UIPainter new openOnClass: self andSelector: #winAddMethods"
	
	<resource: #canvas>
	^#(FullSpec 
		#window: #(WindowSpec 
			#properties: #(PropertyListDictionary #labelFromApplication true) 
			#label: #winAddMethods_title 
			#min: #(Point 224 166) 
			#max: #(Point 350 500) 
			#bounds: #(Rectangle 720 450 944 703) 
			#isEventDriven: true) 
		#component: #(SpecCollection 
			#collection: #(#(SequenceViewSpec 
				#layout: #(Rectangle 9 33 218 209) 
				#model: #methodsToAddList 
				#multipleSelections: true 
				#useModifierKeys: true 
				#selectionType: #highlight) #(ActionButtonSpec 
				#layout: #(Rectangle 36 218 96 244) 
				#model: #accept 
				#label: #(UserMessage 
					#key: #ok 
					#defaultString: 'Ok') 
				#defaultable: true) #(LabelSpec 
				#layout: #(Point 3 9) 
				#label: #(UserMessage 
					#key: #attributesToBeSaved 
					#defaultString: 'Select available methods for')) #(ActionButtonSpec 
				#layout: #(Rectangle 112 218 172 244) 
				#model: #cancel 
				#label: #(UserMessage 
					#key: #cancel 
					#defaultString: 'Cancel') 
				#defaultable: true) #(InputFieldSpec 
				#layout: #(Rectangle 135 8 220 31) 
				#name: #InputField1 
				#flags: 0 
				#model: #entitySelected 
				#tabable: false 
				#isReadOnly: true))))! !

!CMSpaceInterfaceConfig class methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
winAddMethods_title
	
	^winAddMethods_title ifNil: [winAddMethods_title := 'Methods']! !

!CMSpaceInterfaceConfig class methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
winAddMethods_title: anObject
	
	winAddMethods_title := anObject! !

!CMSpaceInterfaceConfig class methodsFor: 'interface specs' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
windowSpec
	"Tools.UIPainter new openOnClass: self andSelector: #windowSpec"
	
	<resource: #canvas>
	^#(FullSpec 
		#window: #(WindowSpec 
			#label: 'Configure Habitus for view: ' 
			#min: #(Point 502 464) 
			#max: #(Point 502 464) 
			#bounds: #(Rectangle 800 406 1302 870) 
			#colors: #(LookPreferences 
				#setBackgroundColor: #(ColorValue 7757 7757 7757))) 
		#component: #(SpecCollection 
			#collection: #(#(TextEditorSpec 
				#layout: #(Rectangle 388 0 475 22) 
				#name: #TextEditor1 
				#flags: 4 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 7700 7700 7700)) 
				#tabable: false 
				#menu: #displayOptionsMenu 
				#tabRequiresControl: false 
				#isWrapped: false) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 6 0 30 23) 
				#name: #ActionButton4 
				#flags: 0 
				#model: #loadConfig 
				#helpText: 'Load existing configuration' 
				#label: #load 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(DividerSpec 
				#layout: #(Rectangle 35 0 39 23) 
				#name: #Divider1 
				#orientation: #vertical) #(DividerSpec 
				#layout: #(LayoutFrame 0 0 23 0 0 1.0 27 0) 
				#name: #Divider2) #(LabelSpec 
				#layout: #(LayoutFrame 44 0 2 0 116 0 24 0) 
				#name: #Label3 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #blue)) 
				#label: 'Habitus name') #(InputFieldSpec 
				#layout: #(LayoutFrame 118 0 1 0 218 0 22 0) 
				#name: #InputField1 
				#model: #configName 
				#helpText: 'Name it ''default'', to have this configuration loaded when a space window is open for the first time') #(LabelSpec 
				#layout: #(Rectangle 12 26 157 47) 
				#name: #Label5 
				#label: 'Entities that can be observed') #(LabelSpec 
				#layout: #(Rectangle 10 247 168 268) 
				#name: #Label4 
				#label: 'Entities that can be manipulated') #(SequenceViewSpec 
				#layout: #(Rectangle 10 269 165 434) 
				#name: #List6 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 7167 7167 8191)) 
				#model: #manipEntitiesList 
				#tabable: false 
				#menu: #manipEntityMenu 
				#multipleSelections: false 
				#selectionType: #highlight 
				#autoSelect: false) #(LabelSpec 
				#layout: #(Rectangle 340 247 477 268) 
				#name: #Label1 
				#label: 'Entities that can be created') #(SequenceViewSpec 
				#layout: #(Rectangle 339 269 494 434) 
				#name: #List1 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 7044 7044 7044)) 
				#model: #createEntitiesList 
				#tabable: false 
				#menu: #createEntityMenu 
				#multipleSelections: false 
				#selectionType: #highlight 
				#autoSelect: false) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 34 437 59 460) 
				#name: #addManip 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 7167 7167 8191)) 
				#model: #addManipEntities 
				#label: #plusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 61 437 86 460) 
				#name: #removeManip 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 7167 7167 8191)) 
				#model: #removeManipEntity 
				#label: #minusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 367 437 392 460) 
				#name: #ActionButton2 
				#model: #addCreateEntities 
				#label: #plusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 394 437 419 460) 
				#name: #ActionButton3 
				#model: #removeCreateEntity 
				#label: #minusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(SequenceViewSpec 
				#layout: #(Rectangle 10 48 165 214) 
				#name: #List5 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 7167 7167 8191)) 
				#model: #observedEntitiesList 
				#tabable: false 
				#menu: #observedEntityMenu 
				#multipleSelections: false 
				#selectionType: #highlight 
				#autoSelect: false) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 33 217 58 240) 
				#name: #ActionButton5 
				#model: #addObservedEntities 
				#label: #plusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 60 217 85 240) 
				#name: #ActionButton6 
				#model: #removeObservedEntity 
				#label: #minusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(SequenceViewSpec 
				#layout: #(Rectangle 170 320 333 434) 
				#name: #List2 
				#model: #manipMethodsList 
				#menu: #manipMethodsMenu 
				#multipleSelections: true 
				#useModifierKeys: true 
				#selectionType: #highlight) #(CheckBoxSpec 
				#layout: #(Point 179 272) 
				#name: #moveEntityCheckBox 
				#model: #moveEntityCheckBox 
				#callbacksSpec: #(UIEventCallbackSubSpec 
					#valueChangeSelector: #setMoveEntity 
					#requestFocusInSelector: #manipChekboxValidation) 
				#label: 'can be moved?') #(LabelSpec 
				#layout: #(Point 173 302) 
				#name: #Label2 
				#label: 'authorized methods') #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 212 439 231 458) 
				#name: #ActionButton7 
				#model: #addManipMethods 
				#label: #plusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 233 439 251 458) 
				#name: #ActionButton8 
				#model: #removeManipMethod 
				#label: #minusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(LabelSpec 
				#layout: #(Point 171 30) 
				#name: #Label6 
				#label: 'authorized pov') #(LabelSpec 
				#layout: #(Point 171 130) 
				#name: #Label7 
				#label: 'authorized attributes') #(SequenceViewSpec 
				#layout: #(Rectangle 170 47 324 112) 
				#name: #List3 
				#model: #povMethodsList 
				#menu: #povMethodsMenu 
				#multipleSelections: true 
				#useModifierKeys: true 
				#selectionType: #highlight) #(SequenceViewSpec 
				#layout: #(Rectangle 170 147 324 214) 
				#name: #List4 
				#model: #attributesList 
				#menu: #attributesMenu 
				#multipleSelections: true 
				#useModifierKeys: true 
				#selectionType: #highlight) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 225 216 243 235) 
				#name: #ActionButton9 
				#model: #removeAttribute 
				#label: #minusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 204 216 223 235) 
				#name: #ActionButton10 
				#model: #addAttribute 
				#label: #plusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 225 114 243 133) 
				#name: #ActionButton11 
				#model: #removePovMethod 
				#label: #minusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 204 114 223 133) 
				#name: #ActionButton12 
				#model: #addPovMethods 
				#label: #plusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(LabelSpec 
				#layout: #(Point 330 30) 
				#name: #Label8 
				#label: 'authorized info') #(LabelSpec 
				#layout: #(Point 330 130) 
				#name: #Label9 
				#label: 'authorized probes') #(SequenceViewSpec 
				#layout: #(Rectangle 329 47 483 112) 
				#name: #List7 
				#model: #infoMethodsList 
				#menu: #infoMethodsMenu 
				#multipleSelections: true 
				#useModifierKeys: true 
				#selectionType: #highlight) #(SequenceViewSpec 
				#layout: #(Rectangle 329 147 483 214) 
				#name: #List8 
				#model: #probeMethodsList 
				#menu: #probeMethodsMenu 
				#multipleSelections: true 
				#useModifierKeys: true 
				#selectionType: #highlight) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 384 216 402 235) 
				#name: #ActionButton13 
				#model: #removeProbeMethod 
				#label: #minusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 363 216 382 235) 
				#name: #ActionButton14 
				#model: #addProbeMethods 
				#label: #plusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 384 114 402 133) 
				#name: #ActionButton15 
				#model: #removeInfoMethod 
				#label: #minusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 363 114 382 133) 
				#name: #ActionButton16 
				#model: #addInfoMethods 
				#label: #plusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 223 0 247 23) 
				#name: #ActionButton17 
				#flags: 0 
				#model: #saveConfig 
				#helpText: 'Save the Habitus with a specific name to reuse later' 
				#label: #save 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 258 0 282 23) 
				#name: #ActionButton1 
				#flags: 0 
				#model: #applyCurrentSettings 
				#helpText: 'Apply current Habitus settings to the associated space interface' 
				#label: #apply 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(DividerSpec 
				#layout: #(Rectangle 251 0 255 23) 
				#name: #Divider3 
				#orientation: #vertical) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 478 0 502 23) 
				#name: #ActionButton18 
				#flags: 0 
				#model: #explainHabitus 
				#helpText: 'What is Habitus' 
				#label: #question 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(CheckBoxSpec 
				#layout: #(Point 179 258) 
				#name: #manipWholePopCheckBox 
				#model: #manipWholePopCheckBox 
				#callbacksSpec: #(UIEventCallbackSubSpec 
					#valueChangeSelector: #setManipWholePop 
					#requestFocusInSelector: #manipChekboxValidation) 
				#label: 'can manipulate whole pop?') #(CheckBoxSpec 
				#layout: #(Point 179 286) 
				#name: #canChangeValuesCheckBox 
				#model: #canChangeValuesCheckBox 
				#callbacksSpec: #(UIEventCallbackSubSpec 
					#valueChangeSelector: #setChangeValues 
					#requestFocusInSelector: #manipChekboxValidation) 
				#label: 'can change values?') #(LabelSpec 
				#layout: #(Point 395 0) 
				#name: #Label11 
				#label: 'Display options'))))! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 16:09'!
addAttribute
	| anEntity aList |
	anEntity := self observedEntitiesList selection.
	anEntity
		ifNil: [ self alertMessage: self translator tMustSelectEntity.
			^ nil ].
	self entitySelected value: anEntity name asString.
	aList := ((OrderedCollection
		withAll: (DefaultAttributesSetter attributsFromClass: anEntity))
		- (self attributesFor: anEntity)) asList.
	aList isEmpty
		ifTrue: [ ^ self alertMessage: 'No more attributes can be added to this list' ].
	methodsToAddList := self multiSelectionList with: aList sorted.
	self class winAddMethods_title: self translator tAttributes.
	(self openDialogInterface: #winAddMethods)
		ifFalse: [ ^ nil ].
	aList := self attributesList list copy.
	aList
		addAll: (methodsToAddList selections collect: [ :s | s asString ]).
	aList sort: [ :x :y | x < y ].
	self attributesList setList: aList selecting: Array new.
	self attributes
		at: self observedEntitiesList selection
		put: self attributesList list! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
addCreateEntities
	
	self addEntitiesListName: #createEntitiesList! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 16:12'!
addEntitiesListName: aListName
	| aList |
	aList := self entitiesList copy.
	aList removeAll: (self perform: aListName) list.
	aList isEmpty
		ifTrue: [ ^ self alertMessage: self translator tNoMoreEntities ].
	entitiesToAddList := self multiSelectionList with: aList.
	aListName = #createEntitiesList
		ifTrue: [ self class winAddEntities_title: self translator tEntitiesToCreate ].
	aListName = #manipEntitiesList
		ifTrue: [ self class winAddEntities_title: self translator tManipulationEntities ].
	aListName = #observedEntitiesList
		ifTrue: [ self class winAddEntities_title: self translator tObservedEntities ].
	(self openDialogInterface: #winAddEntities)
		ifFalse: [ ^ nil ].
	(self perform: aListName) list addAll: entitiesToAddList selections.
	(self perform: aListName) list sort: [ :x :y | x name < y name ].
	(self perform: aListName) selection: entitiesToAddList selections first.
	aListName = #manipEntitiesList
		ifTrue: [ entitiesToAddList selections
				do: [ :aClass | 
					self canBeMoved at: aClass put: true.
					self manipWholePop at: aClass put: true.
					self canChangeValues at: aClass put: true ] ]! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 16:54'!
addInfoMethods
	| anEntity aList |
	anEntity := self observedEntitiesList selection.
	anEntity
		ifNil: [ self alertMessage: self translator tMustSelectEntity.
			^ nil ].
	self entitySelected value: anEntity name asString.
	aList := anEntity availableInfo asList.
	(aList includes: #nil)
		ifTrue: [ aList remove: #nil ].
	aList removeAll: self infoMethodsList_WithoutDefaultSign list.
	aList isEmpty
		ifTrue: [ ^ self alertMessage: self translator tNoMoreInfo ].
	methodsToAddList := self multiSelectionList with: aList.
	self class winAddMethods_title: 'Info Methods'.
	(self openDialogInterface: #winAddMethods)
		ifFalse: [ ^ nil ].
	aList := self infoMethodsList list copy.
	aList addAll: methodsToAddList selections.
	aList sort: [ :x :y | x < y ].
	self infoMethodsList setList: aList selecting: Array new.
	self infoMethods
		at: self observedEntitiesList selection
		put: self infoMethodsList_WithoutDefaultSign list.
	self spaceInterface initMenuInfo! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
addManipEntities
	
	self addEntitiesListName: #manipEntitiesList.
	self displayMethodsAndOptionsForManipEntity! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
addManipMethods
	
	| anEntity aList |
	(anEntity := self manipEntitiesList selection) 
		ifNil: [
			self alertMessage: self translator tSelectEntity.
			^ nil].
	self entitySelected value: anEntity name asString.
	aList := anEntity methodsForControl asOrderedCollection.
	aList removeAll: self manipMethodsList list.
	aList isEmpty
		ifTrue: [ ^ self alertMessage: self translator tNoMoreMethods ].
	methodsToAddList := self multiSelectionList with: aList.
	(self openDialogInterface: #winAddMethods) ifFalse: [^nil].
	aList := self manipMethodsList list copy.
	aList addAll: methodsToAddList selections.
	aList sort: [:x :y | x < y].
	self manipMethodsList
		setList: aList
		selecting: Array new.
	self manipMethods
		at: self manipEntitiesList selection
		put: self manipMethodsList list! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
addObservedEntities
	
	| old new test |
	old := self observedEntitiesList list copy.
	self addEntitiesListName: #observedEntitiesList.
	new := self observedEntitiesList list.
	test := false.
	old size = new size
		ifTrue: [ 
			1
				to: old size
				do: [:i | (old at: i) ~= (new at: i) ifTrue: [test := true]]]
		ifFalse: [test := true].
	test
		ifTrue:
			[(self spaceInterface)
				initMenuPov;
				initMenuInfo;
				initMenuTrack]! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
addPovMethods
	
	| anEntity aList |
	(anEntity := self observedEntitiesList selection) 
		ifNil: [ 
			self alertMessage: self translator tSelectEntity.
			^ nil].
	self entitySelected value: anEntity name asString.
	aList := anEntity availablePov asOrderedCollection.
	(aList includes: #nil) ifTrue: [aList remove: #nil].
	aList removeAll: self povMethodsList_WithoutDefaultSign list.
	aList isEmpty
		ifTrue: [ ^ self alertMessage: self translator tNoMorPoV ].
	methodsToAddList := self multiSelectionList with: aList.
	self class winAddMethods_title: self translator tPoVMethods.
	(self openDialogInterface: #winAddMethods) ifFalse: [^nil].
	aList := self povMethodsList list copy.
	aList addAll: methodsToAddList selections.
	aList sort: [:x :y | x < y].
	self povMethodsList
		setList: aList
		selecting: Array new.
	self povMethods
		at: self observedEntitiesList selection
		put: self povMethodsList_WithoutDefaultSign list.
	self spaceInterface initMenuPov! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 15:20'!
addProbeMethods
	| anEntity aList |
	anEntity := self observedEntitiesList selection.
	anEntity
		ifNil: [ self alertMessage: 'An entity must be selected'.
			^ nil ].
	self entitySelected value: anEntity name asString.
	aList := anEntity probes asList.
	aList removeAll: self probeMethodsList list.
	aList isEmpty
		ifTrue: [ ^ self alertMessage: 'No more probe can be added to this list' ].
	methodsToAddList := self multiSelectionList with: aList.
	self class winAddMethods_title: 'Probe Methods'.
	(self openDialogInterface: #winAddMethods)
		ifFalse: [ ^ nil ].
	aList := self probeMethodsList list copy.
	aList addAll: methodsToAddList selections.
	self probeMethodsList setList: aList selecting: Array new.
	self probeMethods
		at: self observedEntitiesList selection
		put: self probeMethodsList list! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
applyCurrentSettings
	
	self spaceInterface initMenuPov.
	self spaceInterface initMenuInfo.
	self applyDefaultPovs.
	self applyDefaultInfos.
	self perform: self delimiterSize value! !

!CMSpaceInterfaceConfig methodsFor: 'overwrite spaceInterface' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
applyDefaultInfos
	
	| cellClass CSCs occupantClassses dicoInfo |
	(self spaceInterface infoMethodDico select: [:v | v ~= #nil])
		keysDo:
			[:aClass | 
			self spaceInterface
				changeInfo: #nil
				ofEntity: aClass class].
	dicoInfo := self defaultInfo copy select: [:v | v isNil not].
	cellClass := self spaceInterface cormasModelClass cellClass.
	CSCs := self spaceInterface cormasModelClass compoundSpatialClasses.
	occupantClassses := self spaceInterface cormasModelClass occupantClasses.
	(self defaultInfoFor: cellClass) isNil not
		ifTrue:
			[self spaceInterface
				changeInfo: ((self defaultInfoFor: cellClass) ifNil: [#nil])
				ofEntity: cellClass.	"ifNotNil:[]"
			dicoInfo
				keysAndValuesDo:
					[:aClass :defInfo | 
					((CSCs includes: aClass) and: [defInfo = #delimitors])
						ifTrue: [self spaceInterface changeInfo: defInfo ofEntity: aClass]].
			dicoInfo
				keysAndValuesDo:
					[:aClass :defInfo | 
					(occupantClassses includes: aClass)
						ifTrue: [self spaceInterface changeInfo: defInfo ofEntity: aClass]]]
		ifFalse:
			[dicoInfo
				keysAndValuesDo:
					[:aClass :defInfo | 
					((CSCs includes: aClass) and: [defInfo isNil not])
						ifTrue: [self spaceInterface changeInfo: defInfo ofEntity: aClass]].
			dicoInfo
				keysAndValuesDo:
					[:aClass :defInfo | 
					(occupantClassses includes: aClass)
						ifTrue: [self spaceInterface changeInfo: defInfo ofEntity: aClass]]]! !

!CMSpaceInterfaceConfig methodsFor: 'overwrite spaceInterface' stamp: 'HernanMoralesDurand 12/16/2017 15:30'!
applyDefaultPovs
	| dicoPov cellClass cSCs occupantClassses |
	(self spaceInterface povMethodDico select: [ :v | v ~= #nil ])
		keysDo:
			[ :aClass | self spaceInterface changePov: #nil ofEntity: aClass class ].
	dicoPov := self defaultPov copy reject: [ :v | v isNil ].
	cellClass := self spaceInterface cormasModelClass cellClass.
	cSCs := self spaceInterface cormasModelClass compoundSpatialClasses.
	occupantClassses := self spaceInterface cormasModelClass
		occupantClasses.
	(self defaultPovFor: cellClass) isNil not
		ifTrue: [ self spaceInterface
				changePov: ((self defaultPovFor: cellClass) ifNil: [ #nil ])
				ofEntity: cellClass.
			dicoPov
				keysAndValuesDo: [ :aClass :defPov | 
					((cSCs includes: aClass) and: [ defPov = #delimitors ])
						ifTrue: [ self spaceInterface changePov: defPov ofEntity: aClass ] ].
			dicoPov
				keysAndValuesDo: [ :aClass :defPov | 
					(occupantClassses includes: aClass)
						ifTrue: [ self spaceInterface changePov: defPov ofEntity: aClass ] ] ]
		ifFalse: [ dicoPov
				keysAndValuesDo: [ :aClass :defPov | 
					((cSCs includes: aClass)
						and: [ defPov isNil not and: [ defPov ~= #delimitors ] ])
						ifTrue: [ self spaceInterface changePov: defPov ofEntity: aClass ] ].
			dicoPov
				keysAndValuesDo: [ :aClass :defPov | 
					((cSCs includes: aClass) and: [ defPov = #delimitors ])
						ifTrue: [ self spaceInterface changePov: defPov ofEntity: aClass ] ].
			dicoPov
				keysAndValuesDo: [ :aClass :defPov | 
					(occupantClassses includes: aClass)
						ifTrue: [ self spaceInterface changePov: defPov ofEntity: aClass ] ] ]! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
applyTrackLengthValue: value
	
	| aClass |
	value = 'nil' ifTrue: [^nil].
	TrackFigure maxSize: value.
	self spaceInterface trackedFigureTypes
		do:
			[:symbol | 
			aClass := symbol class.
			(self spaceInterface drawing entityFiguresAt: aClass)
				do:
					[:fig | 
					(fig dependents select: [:tf | tf isKindOf: TrackFigure])
						do:
							[:track | 
							track testAndRemoveOrigine.
							track invalidate]]]! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
attributes
	
	^attributes ifNil: [attributes := Dictionary new]! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
attributes: anObject
	
	attributes := anObject! !

!CMSpaceInterfaceConfig methodsFor: 'access methods' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
attributesFor: aClass
	
	(self attributes keys includes: aClass)
		ifFalse:
			[self attributes
				at: aClass
				put: (DefaultAttributesSetter attributsFromClass: aClass) sorted].
	^self attributes at: aClass! !

!CMSpaceInterfaceConfig methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/16/2017 14:58'!
attributesList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^attributesList isNil
		ifTrue: [attributesList := self multiSelectionList new]
		ifFalse: [attributesList]! !

!CMSpaceInterfaceConfig methodsFor: 'overwrite spaceInterface' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
buildManipulationMenu: aMenuBuilder forEntity: aClass
	" Add to the menu the set of methods defined into 'methodsForManipulation' method. 
	The key will appear as the menu item. The selected method will be executed by the agent if the item is selected."
	
	(self manipMethodsFor: aClass)
		do: [:aSymbol | aMenuBuilder add: aSymbol asString -> aSymbol].
	^aMenuBuilder! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
canBeMoved
	
	^canBeMoved ifNil: [canBeMoved := Dictionary new]! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
canBeMoved: anObject
	
	canBeMoved := anObject! !

!CMSpaceInterfaceConfig methodsFor: 'access methods' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
canBeMovedFor: aClass
	
	(self canBeMoved keys includes: aClass)
		ifFalse:
			[self canBeMoved
				at: aClass
				put: aClass isSituatedClass].
	^self canBeMoved at: aClass! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
canChangeValues
	
	^canChangeValues ifNil: [canChangeValues := Dictionary new]! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
canChangeValues: anObject
	
	canChangeValues := anObject! !

!CMSpaceInterfaceConfig methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
canChangeValuesCheckBox
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^canChangeValuesCheckBox isNil
		ifTrue: [canChangeValuesCheckBox := false asValue]
		ifFalse: [canChangeValuesCheckBox]! !

!CMSpaceInterfaceConfig methodsFor: 'access methods' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
canChangeValuesFor: aClass
	
	(self canChangeValues keys includes: aClass)
		ifFalse: [self canChangeValues at: aClass put: true].
	^self canChangeValues at: aClass! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
cancelDefaultInfo
	
	self infoMethodsList
		setList: self infoMethodsList_WithoutDefaultSign copy
		selecting: Array new.
	self defaultInfo
		at: self observedEntitiesList selection
		put: nil.
	self displayMethodsForObservedEntity! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
cancelDefaultPov
	
	self povMethodsList
		setList: self povMethodsList_WithoutDefaultSign copy
		selecting: Array new.
	self defaultPov
		at: self observedEntitiesList selection
		put: nil.
	self displayMethodsForObservedEntity! !

!CMSpaceInterfaceConfig methodsFor: 'debuging' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
checkClassAndMethodsExist
	
	self checkHabitusList: #observedEntitiesList existsIn: #entitiesList
		dialogConfirmTypeName: 'observed entities'.
	self checkHabitusList: #manipEntitiesList existsIn: #entitiesList
		dialogConfirmTypeName: 'manipulated entities'.
	self checkHabitusList: #createEntitiesList existsIn: #entitiesList
		dialogConfirmTypeName: 'created entities'.
	self checkMethods: #povMethods exists_dialogConfirmTypeName: 'pov methods'.
	self checkMethods: #manipMethods exists_dialogConfirmTypeName:
			'manip methods'.
	self checkMethods: #attributes exists_dialogConfirmTypeName: 'attributes'.
	self checkMethods: #infoMethods exists_dialogConfirmTypeName:
			'info methods'.
	self checkMethods: #probeMethods exists_dialogConfirmTypeName: 'probes'.
	self checkDefaultValue: #defaultPov exists_dialogConfirmTypeName:
			'default pov'.
	self checkDefaultValue: #defaultInfo exists_dialogConfirmTypeName:
			'default info'! !

!CMSpaceInterfaceConfig methodsFor: 'debuging' stamp: 'HernanMoralesDurand 12/16/2017 15:31'!
checkDefaultValue: methodsList exists_dialogConfirmTypeName: defaultListName
	| defValue |
	(self perform: methodsList)
		keysDo: [ :aClass | 
			defValue := (self perform: methodsList) at: aClass.
			defValue
				ifNil: [ (self perform: methodsList) removeKey: aClass ]
				ifNotNil: [ (aClass allInstanceSelectors includes: defValue)
						ifFalse: [ (self
								confirm: (self confirmRemove: defValue list: aClass class: defaultListName))
								ifTrue: [ (self perform: methodsList) remove: aClass ] ] ] ]! !

!CMSpaceInterfaceConfig methodsFor: 'debuging' stamp: 'HernanMoralesDurand 12/16/2017 18:19'!
checkHabitusList: aHabitusMethodList existsIn: modelList dialogConfirmTypeName: typeName
	| undefined |
	undefined := Set new.
	(self perform: aHabitusMethodList) list
		do: [ :e | 
			((self perform: modelList) includes: e)
				ifFalse: [ undefined add: e ] ].
	undefined isEmpty
		ifFalse: [ (self
				confirm: (self confirmRemoveType: typeName undefined: undefined))
				ifTrue: [ (self perform: aHabitusMethodList) removeAll: undefined ] ]! !

!CMSpaceInterfaceConfig methodsFor: 'debuging' stamp: 'HernanMoralesDurand 12/16/2017 15:56'!
checkMethods: methodsList exists_dialogConfirmTypeName: methodsName
	| undefined |
	methodsList = #defaultPov
		ifTrue: [ self halt ].
	(self perform: methodsList)
		keysDo: [ :aClass | 
			undefined := Set new.
			((self perform: methodsList) at: aClass)
				do: [ :aM | 
					(aClass allInstanceSelectors includes: aM asSymbol)
						ifFalse: [ undefined add: aM ] ].
			undefined isEmpty
				ifFalse: [ (self
						confirm:
							(self
								confirmRemoveMethods: methodsName
								inClass: aClass
								undefined: undefined))
						ifTrue: [ ((self perform: methodsList) at: aClass) removeAll: undefined ] ] ]! !

!CMSpaceInterfaceConfig methodsFor: 'overwrite spaceInterface' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
classesForDelimitorMenuInheritingFrom: aClass
	
	^self observedEntitiesList list select: [:c | c inheritsFrom: aClass]! !

!CMSpaceInterfaceConfig methodsFor: 'overwrite spaceInterface' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
classesForInfoMenuInheritingFrom: aClass
	
	| list infolist |
	list := OrderedCollection new.
	(self observedEntitiesList list select: [:c | c inheritsFrom: aClass])
		do:
			[:c | 
			infolist := self infoMethodsFor: c.
			infolist isEmpty
				ifFalse:
					[(self isSingleDefaultInfoShown not
						and:
							[infolist size = 1 and: [(infolist at: 1) = (self defaultInfoFor: c)]])
						ifFalse: [list add: c]]].
	^list! !

!CMSpaceInterfaceConfig methodsFor: 'overwrite spaceInterface' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
classesForPovMenuInheritingFrom: aClass
	
	| list povlist |
	list := OrderedCollection new.
	(self observedEntitiesList list select: [:c | c inheritsFrom: aClass])
		do:
			[:c | 
			povlist := self povMethodsFor: c.
			povlist isEmpty
				ifFalse:
					[(self isSingleDefaultPovShown not
						and:
							[povlist size = 1 and: [(povlist at: 1) = (self defaultPovFor: c)]])
						ifFalse: [list add: c]]].
	^list! !

!CMSpaceInterfaceConfig methodsFor: 'overwrite spaceInterface' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
classesForTrackMenuInheritingFrom: aClass
	
	^self observedEntitiesList list select: [:c | c inheritsFrom: aClass]! !

!CMSpaceInterfaceConfig methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
configName
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^configName isNil
		ifTrue: [configName := String new asValue]
		ifFalse: [configName]! !

!CMSpaceInterfaceConfig methodsFor: 'debuging' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
confirmRemove: defValue list: aClass class: defaultListName
	^ 'The ' , defaultListName , ' ' , defValue , ' of class '
		, aClass name
		,
			' defined in the Habitus does not exist in the model.
Do you want to remove it (recommended)?

If you accept, even if the obsolete ' , defaultListName
		, ' is removed, you need to re-display the ' , defaultListName
		, ' list, to see the changes appear'! !

!CMSpaceInterfaceConfig methodsFor: 'debuging' stamp: 'HernanMoralesDurand 12/16/2017 15:56'!
confirmRemoveMethods: methodsName inClass: aClass undefined: undefined
	^ 'The ' , methodsName , ' ' , undefined printString , ' of class '
		, aClass name
		,
			' defined in the Habitus do not exist in the model.
Do you want to remove them (recommended)?

If you accept, even if the obsolete ' , methodsName
		, ' are removed, you need to re-display the ' , methodsName
		, ' list, to see the changes appear'! !

!CMSpaceInterfaceConfig methodsFor: 'debuging' stamp: 'HernanMoralesDurand 12/16/2017 18:19'!
confirmRemoveType: typeName undefined: undefined
	^ 'The ' , typeName , ' ' , undefined printString
		,
			' defined in the Habitus do not exist in the model.
Do you want to remove them (recommended)?

If you accept, even if the obsolete ' , typeName
		,
			' are removed, you need to reopen the Habitus interface to see the changes appear'! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
cormas
	
	^Cormas current! !

!CMSpaceInterfaceConfig methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
createEntitiesList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^createEntitiesList isNil
		ifTrue: [createEntitiesList := SelectionInList new]
		ifFalse: [createEntitiesList]! !

!CMSpaceInterfaceConfig methodsFor: 'debuging' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
debugPovNameDefault
	
	self povMethods values
		do:
			[:c | c do: [:v | ('* ->D' match: v ignoreCase: false) ifTrue: [self halt]]]! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
defaultInfo
	
	^defaultInfo ifNil: [defaultInfo := Dictionary new]! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
defaultInfo: anObject
	
	defaultInfo := anObject! !

!CMSpaceInterfaceConfig methodsFor: 'access methods' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
defaultInfoFor: aClass
	
	(self defaultInfo keys includes: aClass)
		ifFalse: [self defaultInfo at: aClass put: nil].
	^self defaultInfo at: aClass! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
defaultPov
	
	^defaultPov ifNil: [defaultPov := Dictionary new]! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
defaultPov: anObject
	
	defaultPov := anObject! !

!CMSpaceInterfaceConfig methodsFor: 'access methods' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
defaultPovFor: aClass
	
	(self defaultPov keys includes: aClass)
		ifFalse: [self defaultPov at: aClass put: nil].
	^self defaultPov at: aClass! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
defaultTool
	
	^defaultTool isNil
		ifTrue: [defaultTool := #toolInspect asValue]
		ifFalse: [defaultTool]! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
delimiterSize
	
	^delimiterSize isNil
		ifTrue:
			[delimiterSize := self spaceInterface
				ifNotNil: [:si | si delimiterSize]
				ifNil: [#pixel1 asValue]]
		ifFalse: [delimiterSize]! !

!CMSpaceInterfaceConfig methodsFor: 'refresh display methods' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
displayMethodsAndOptionsForManipEntity
	
	| anEntity |
	anEntity := self manipEntitiesList selection.
	anEntity
		ifNil:
			[self moveEntityCheckBox value: false.
			self manipWholePopCheckBox value: false.
			self canChangeValuesCheckBox value: false.
			^self manipMethodsList
				setList: List new
				selecting: Array new].
	self manipMethodsList
		setList: (self manipMethodsFor: anEntity)
		selecting: Array new.
	anEntity isSituatedClass
		ifTrue:
			[(self builder namedComponents at: #moveEntityCheckBox)
				enable;
				isVisible: true.
			self moveEntityCheckBox value: (self canBeMovedFor: anEntity)]
		ifFalse:
			[(self builder namedComponents at: #moveEntityCheckBox)
				disable;
				isVisible: false].
	self manipWholePopCheckBox value: (self manipWholePopFor: anEntity).
	self canChangeValuesCheckBox value: (self canChangeValuesFor: anEntity)! !

!CMSpaceInterfaceConfig methodsFor: 'refresh display methods' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
displayMethodsForObservedEntity
	
	| anEntity aPovList aInfoList |
	anEntity := self observedEntitiesList selection.
	anEntity
		ifNil:
			[self povMethodsList
				setList: List new
				selecting: Array new.
			self attributesList
				setList: List new
				selecting: Array new.
			self infoMethodsList
				setList: List new
				selecting: Array new.
			^self probeMethodsList
				setList: List new
				selecting: Array new].	"Prepare list for pov methods which will  include a specific sign for the default pov"
	aPovList := (self povMethodsFor: anEntity) copy.
	(self defaultPovFor: anEntity)
		ifNotNil:
			[aPovList remove: (self defaultPovFor: anEntity).
			aPovList add: (self defaultPov at: anEntity) , ' ->D'.
			aPovList sort: [:x :y | x < y]].	"Prepare list for info  methods which will  include a specific sign for the default info"
	aInfoList := (self infoMethodsFor: anEntity) copy.
	(self defaultInfoFor: anEntity)
		ifNotNil:
			[aInfoList remove: (self defaultInfoFor: anEntity).
			aInfoList add: (self defaultInfo at: anEntity) , ' ->D'.
			aInfoList sort: [:x :y | x < y]].
	self povMethodsList
		setList: aPovList
		selecting: Array new.
	self attributesList
		setList: (self attributesFor: anEntity)
		selecting: Array new.
	self infoMethodsList
		setList: aInfoList
		selecting: Array new.
	self probeMethodsList
		setList: (self probeMethodsFor: anEntity)
		selecting: Array new! !

!CMSpaceInterfaceConfig methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
displayOptionsValidation
	
	^true! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
entitiesList
	
	^entitiesList! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
entitiesList: anObject
	
	entitiesList := anObject! !

!CMSpaceInterfaceConfig methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/16/2017 14:59'!
entitiesToAddList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^entitiesToAddList isNil
		ifTrue: [entitiesToAddList := self multiSelectionList new]
		ifFalse: [entitiesToAddList]! !

!CMSpaceInterfaceConfig methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
entitySelected
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^entitySelected isNil
		ifTrue: [entitySelected := String new asValue]
		ifFalse: [entitySelected]! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 18:05'!
explainHabitus
	
	LongMessageDialogWindow new 
		entryText: self translator tHabitusText;
		title: self translator tHabitusTitle;
		open
! !

!CMSpaceInterfaceConfig methodsFor: 'overwrite spaceInterface' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
forceSItoApplyConfigTrackAgents
	
	(entitiesList
		sorted: [:a :b | a name asString first > b name asString first])
		do:
			[:agentClass | 
			(agentClass isSituatedClass and: [agentClass inheritsFrom: Agent])
				ifTrue: [self forceSItrackAgents: agentClass]]! !

!CMSpaceInterfaceConfig methodsFor: 'overwrite spaceInterface' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
forceSItrackAgents: aClass
	
	| menuSI agentFigures |
	menuSI := (self spaceInterface menuHolder value atNameKey: #trackAgents)
		submenu
		menuItemLabeled: aClass name asString
		ifNone: [nil].
	(((self trackedAgents includes: aClass name) and: [menuSI isOn not])
		or:
			[(self trackedAgents includes: aClass name) not
				and: [menuSI isNil not and: [menuSI isOn]]])
		ifTrue:
			[agentFigures := #().
			(self spaceInterface drawing entityFigures
				at: aClass
				ifAbsent: [nil])
				ifNotNil:
					[agentFigures := (self spaceInterface drawing entityFigures at: aClass)
						values].
			menuSI isOn
				ifTrue:
					[menuSI beOff.
					self spaceInterface trackedFigureTypes
						remove: aClass name
						ifAbsent: [nil].
					agentFigures do: [:af | af untrack]]
				ifFalse:
					[menuSI beOn.
					(self spaceInterface trackedFigureTypes includes: aClass name)
						ifFalse: [self spaceInterface trackedFigureTypes add: aClass name].
					agentFigures do: [:af | af track]]]! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
infoMethods
	
	^infoMethods ifNil: [infoMethods := Dictionary new]! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
infoMethods: anObject
	
	infoMethods := anObject! !

!CMSpaceInterfaceConfig methodsFor: 'access methods' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
infoMethodsFor: aClass
	
	| aSet |
	(self infoMethods keys includes: aClass)
		ifFalse:
			[aSet := aClass availableInfo.
			aSet remove: #nil.
			self infoMethods
				at: aClass
				put: aSet sorted].
	^self infoMethods at: aClass! !

!CMSpaceInterfaceConfig methodsFor: 'overwrite spaceInterface' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
infoMethodsForSIMenu: aClass
	
	| infoList |
	infoList := (self infoMethodsFor: aClass) copy.
	infoList addFirst: #nil.
	^infoList! !

!CMSpaceInterfaceConfig methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/16/2017 15:00'!
infoMethodsList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^infoMethodsList isNil
		ifTrue: [infoMethodsList := self multiSelectionList new]
		ifFalse: [infoMethodsList]! !

!CMSpaceInterfaceConfig methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/16/2017 15:00'!
infoMethodsList_WithoutDefaultSign
	
	| aList aDefInfoWithSign |
	aList := self infoMethodsList list copy.
	aDefInfoWithSign := aList
		detect: [:m | self isItDefault: m]
		ifNone: [^self infoMethodsList copy].
	aList remove: aDefInfoWithSign.
	aList add: (self defaultInfo at: self observedEntitiesList selection).
	aList sort: [:x :y | x < y].
	^ self multiSelectionList with: aList! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
initDisplayOptionsMenu
	
	| menuDyn agentClasses menuAgents |
	agentClasses := List new.
	agentClasses
		addAll:
			(entitiesList select: [:e | e isSituatedClass and: [e inheritsFrom: Agent]]).
	menuDyn := (builder menuAt: #displayOptionsMenu) value atNameKey:
			#trackAgents.
	menuAgents := Menu new.
	1
		to: agentClasses size
		do:
			[:i | 
			| aClass |
			aClass := agentClasses at: i.
			menuAgents
				addItemLabel: aClass name
				value: [self trackAgents: aClass]].
	menuDyn submenu: menuAgents! !

!CMSpaceInterfaceConfig methodsFor: 'testing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
isItDefault: aSymbolOrString
	
	^'* ->D' match: aSymbolOrString! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
isManipulateForTabletEnabled
	
	^isManipulateForTabletEnabled
		ifNil:
			[isManipulateForTabletEnabled := ((builder menuAt: #displayOptionsMenu)
				value atNameKey: #toggleTouchpadMode) isOn]! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
isManipulateForTabletEnabled: aBoolean
	
	| menuDyn |
	isManipulateForTabletEnabled := aBoolean.
	builder
		ifNotNil:
			[:b | 
			menuDyn := (b menuAt: #displayOptionsMenu) value atNameKey:
					#toggleTouchpadMode.
			aBoolean
				ifTrue: [menuDyn beOn]
				ifFalse: [menuDyn beOff]].
	self spaceInterface isManipulateForTabletEnabled = aBoolean
		ifFalse: [self spaceInterface isManipulateForTabletEnabled: aBoolean]! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
isSingleDefaultInfoShown
	
	^isSingleDefaultInfoShown
		ifNil:
			[isSingleDefaultInfoShown := builder
				ifNil: [true]
				ifNotNil:
					[:b | 
					((b menuAt: #displayOptionsMenu) value atNameKey:
							#toggleShowSingleDefaultInfo) isOn]]! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
isSingleDefaultInfoShown: aBoolean
	
	| menuDyn |
	isSingleDefaultInfoShown := aBoolean.
	builder
		ifNotNil:
			[:b | 
			menuDyn := (b menuAt: #displayOptionsMenu) value atNameKey:
					#toggleShowSingleDefaultInfo.
			aBoolean
				ifTrue: [menuDyn beOn]
				ifFalse: [menuDyn beOff]]! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
isSingleDefaultPovShown
	
	^isSingleDefaultPovShown
		ifNil:
			[isSingleDefaultPovShown := builder
				ifNil: [true]
				ifNotNil:
					[:b | 
					((b menuAt: #displayOptionsMenu) value atNameKey:
							#toggleShowSingleDefaultPov) isOn]]! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
isSingleDefaultPovShown: aBoolean
	
	| menuDyn |
	isSingleDefaultPovShown := aBoolean.
	builder
		ifNotNil:
			[:b | 
			menuDyn := (b menuAt: #displayOptionsMenu) value atNameKey:
					#toggleShowSingleDefaultPov.
			aBoolean
				ifTrue: [menuDyn beOn]
				ifFalse: [menuDyn beOff]]! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
isUndoRedoEnabled
	
	^isUndoRedoEnabled
		ifNil:
			[isUndoRedoEnabled := ((builder menuAt: #displayOptionsMenu) value
				atNameKey: #toggleUndoRedo) isOn]! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
isUndoRedoEnabled: aBoolean
	
	| menuDyn |
	isUndoRedoEnabled := aBoolean.
	builder
		ifNotNil:
			[:b | 
			menuDyn := (b menuAt: #displayOptionsMenu) value atNameKey: #toggleUndoRedo.
			aBoolean
				ifTrue: [menuDyn beOn]
				ifFalse: [menuDyn beOff]].
	self spaceInterface enableUndo = aBoolean
		ifFalse: [self spaceInterface enableUndoOption]! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 17:25'!
loadConfig
	
	| collec |
	collec := self spaceInterface cormasModel habitusNames.
	^ (self requestFrom: collec message: self translator tChooseConfig title: 'CORMAS')
		ifNotNil: [ : choice | self loadConfigName: choice ] 
		ifNil: [ nil ]
	! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
loadConfigName: aName
	
	self configName value: aName.
	self spaceInterface configName value: aName.
	self class
		loadSIconfig:
			(self spaceInterface cormasModelClass
				perform: ('SIconfig_' , aName) asSymbol)
		in: self
		ofModel: self spaceInterface cormasModel.
	self applyCurrentSettings.
	self setCheckMarksForDisplayOptionsMenu.
	self forceSItoApplyConfigTrackAgents! !

!CMSpaceInterfaceConfig methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
manipChekboxValidation
	
	^self manipEntitiesList selection isNil not! !

!CMSpaceInterfaceConfig methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
manipEntitiesList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^manipEntitiesList isNil
		ifTrue: [manipEntitiesList := SelectionInList new]
		ifFalse: [manipEntitiesList]! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
manipMethods
	
	^manipMethods ifNil: [manipMethods := Dictionary new]! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
manipMethods: anObject
	
	manipMethods := anObject! !

!CMSpaceInterfaceConfig methodsFor: 'access methods' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
manipMethodsFor: aClass
	
	(self manipMethods keys includes: aClass)
		ifFalse:
			[self manipMethods
				at: aClass
				put: aClass methodsForControl].
	^self manipMethods at: aClass! !

!CMSpaceInterfaceConfig methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/16/2017 15:02'!
manipMethodsList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^manipMethodsList isNil
		ifTrue: [manipMethodsList := self multiSelectionList new]
		ifFalse: [manipMethodsList]! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
manipWholePop
	
	^manipWholePop ifNil: [manipWholePop := Dictionary new]! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
manipWholePop: anObject
	
	manipWholePop := anObject! !

!CMSpaceInterfaceConfig methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
manipWholePopCheckBox
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^manipWholePopCheckBox isNil
		ifTrue: [manipWholePopCheckBox := false asValue]
		ifFalse: [manipWholePopCheckBox]! !

!CMSpaceInterfaceConfig methodsFor: 'access methods' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
manipWholePopFor: aClass
	
	(self manipWholePop keys includes: aClass)
		ifFalse: [self manipWholePop at: aClass put: true].
	^self manipWholePop at: aClass! !

!CMSpaceInterfaceConfig methodsFor: 'overwrite spaceInterface' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
manipulationMenuItemsForEntityType: aClass
	" Returns the set of methods defined in the habitus for manipulating the selected entity"
	
	(self manipEntitiesList list includes: aClass)
		ifTrue:
			[^(self manipMethodsFor: aClass)
				collect: [:aSymbol | aSymbol asString -> (aClass -> aSymbol)]]
		ifFalse: [^Array new]! !

!CMSpaceInterfaceConfig methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/16/2017 15:02'!
methodsToAddList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^methodsToAddList isNil
		ifTrue: [methodsToAddList := self multiSelectionList new]
		ifFalse: [methodsToAddList]! !

!CMSpaceInterfaceConfig methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
moveEntityCheckBox
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^moveEntityCheckBox isNil
		ifTrue: [moveEntityCheckBox := false asValue]
		ifFalse: [moveEntityCheckBox]! !

!CMSpaceInterfaceConfig methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
observedEntitiesList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^observedEntitiesList isNil
		ifTrue: [observedEntitiesList := SelectionInList new]
		ifFalse: [observedEntitiesList]! !

!CMSpaceInterfaceConfig methodsFor: 'interface opening' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
open
	
	self dependents isEmpty
		ifTrue:
			[builder := self allButOpenInterface: #windowSpec.
			builder window
				label:
					builder window label , self spaceInterface basicTitle printString.
			self initDisplayOptionsMenu.
			self setCheckMarksForDisplayOptionsMenu.
			^builder window open]
		ifFalse: [self mainWindow raise]! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
pixel0
	
	self delimiterSize value: #pixel0.
	self spaceInterface pixel0! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
pixel1
	
	self delimiterSize value: #pixel1.
	self spaceInterface pixel1! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
pixel2
	
	self delimiterSize value: #pixel2.
	self spaceInterface pixel2! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
pixel3
	
	self delimiterSize value: #pixel3.
	self spaceInterface pixel3! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
povMethods
	
	^povMethods ifNil: [povMethods := Dictionary new]! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
povMethods: anObject
	
	povMethods := anObject! !

!CMSpaceInterfaceConfig methodsFor: 'access methods' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
povMethodsFor: aClass
	
	| aSet |
	(self povMethods keys includes: aClass)
		ifFalse:
			[aSet := aClass availablePov.
			aSet remove: #nil.
			self povMethods
				at: aClass
				put: aSet sorted].
	^self povMethods at: aClass! !

!CMSpaceInterfaceConfig methodsFor: 'overwrite spaceInterface' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
povMethodsForSIMenu: aClass
	
	| povList |
	povList := (self povMethodsFor: aClass) copy.
	povList addFirst: #nil.
	^povList! !

!CMSpaceInterfaceConfig methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/16/2017 15:02'!
povMethodsList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^povMethodsList isNil
		ifTrue: [povMethodsList := self multiSelectionList new]
		ifFalse: [povMethodsList]! !

!CMSpaceInterfaceConfig methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/16/2017 15:02'!
povMethodsList_WithoutDefaultSign
	
	| aList aDefPovWithSign |
	aList := self povMethodsList list copy.
	aDefPovWithSign := aList
		detect: [:m | self isItDefault: m]
		ifNone: [^self povMethodsList copy].
	aList remove: aDefPovWithSign.
	aList add: (self defaultPov at: self observedEntitiesList selection).
	aList sort: [:x :y | x < y].
	^ self multiSelectionList with: aList! !

!CMSpaceInterfaceConfig methodsFor: 'initialize-release' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
prepareSettings
	
	self
		entitiesList:
			(self spaceInterface cormasModelClass visualizableClasses
				sort: [:x :y | x name < y name]) asList.
	self observedEntitiesList
		setList: self entitiesList copy
		selecting: nil.
	self manipEntitiesList
		setList: self entitiesList copy
		selecting: nil.
	self createEntitiesList
		setList: self entitiesList copy
		selecting: nil.
	self manipEntitiesList selectionHolder onChangeSend:
			#displayMethodsAndOptionsForManipEntity to: self.
	self observedEntitiesList selectionHolder onChangeSend:
			#displayMethodsForObservedEntity to: self! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
probeMethods
	
	^probeMethods ifNil: [probeMethods := Dictionary new]! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
probeMethods: anObject
	
	probeMethods := anObject! !

!CMSpaceInterfaceConfig methodsFor: 'access methods' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
probeMethodsFor: aClass
	
	| aSet |
	(self probeMethods keys includes: aClass)
		ifFalse:
			[aSet := aClass probes.
			self probeMethods at: aClass put: aSet].
	^self probeMethods at: aClass! !

!CMSpaceInterfaceConfig methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/16/2017 15:02'!
probeMethodsList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^probeMethodsList isNil
		ifTrue: [probeMethodsList := self multiSelectionList new]
		ifFalse: [probeMethodsList]! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 17:26'!
removeAttribute
	| aList |
	self attributesList selections isEmpty
		ifTrue: [ ^ self alertMessage: self translator tNoAttribSelector ].
	aList := self attributesList list copy.
	aList removeAll: self attributesList selections.
	self attributesList setList: aList selecting: Array new.
	self attributes
		at: self observedEntitiesList selection
		put: self attributesList list	"	self spaceInterface initMenuInfo."! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
removeCreateEntity
	
	self removeEntityListName: #createEntitiesList! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 17:27'!
removeEntityListName: aSymbol

	| x |
	(self perform: aSymbol) selection
		ifNil: [ ^ self alertMessage: self translator tNoEntitySelected  ].
	x := (self perform: aSymbol) selectionIndex.
	(self perform: aSymbol) list
		remove: (self perform: aSymbol) selection.
	(self perform: aSymbol)
		selectionIndex: (x min: (self perform: aSymbol) list size)! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 17:28'!
removeInfoMethod
	| aList |
	
	self infoMethodsList selections isEmpty
		ifTrue: [ ^ self alertMessage: self translator tNoMethodSelected ].
	self infoMethodsList selections do: [ :m | 
		(self isItDefault: m)
			ifTrue: [ self defaultInfo at: self observedEntitiesList selection put: nil ] ].
	aList := self infoMethodsList list copy.
	aList removeAll: self infoMethodsList selections.
	self infoMethodsList setList: aList selecting: Array new.
	self infoMethods
		at: self observedEntitiesList selection
		put: self infoMethodsList_WithoutDefaultSign list.
	self spaceInterface initMenuInfo! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
removeManipEntity
	
	| anEntity |
	anEntity := self manipEntitiesList selection.
	self removeEntityListName: #manipEntitiesList.
	(anEntity isNil not and: [self canBeMoved keys includes: anEntity])
		ifTrue: [self canBeMoved at: anEntity put: false].
	(anEntity isNil not and: [self manipWholePop keys includes: anEntity])
		ifTrue: [self manipWholePop at: anEntity put: false].
	(anEntity isNil not and: [self canChangeValues keys includes: anEntity])
		ifTrue: [self canChangeValues at: anEntity put: false]! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 17:28'!
removeManipMethod
	| aList |
	self manipMethodsList selections isEmpty
		ifTrue: [ ^ self alertMessage: self translator tNoMethodSelected ].
	aList := self manipMethodsList list copy.
	aList removeAll: self manipMethodsList selections.
	self manipMethodsList setList: aList selecting: Array new.
	self manipMethods
		at: self manipEntitiesList selection
		put: self manipMethodsList list! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
removeObservedEntity
	
	| old new test |
	old := self observedEntitiesList list copy.
	self removeEntityListName: #observedEntitiesList.
	new := self observedEntitiesList list.
	test := false.
	old
		do:
			[:aClass | 
			(new includes: aClass)
				ifFalse:
					[test := true.
					(self defaultPov keys includes: aClass)
						ifTrue: [self defaultPov removeKey: aClass]]].
	test
		ifTrue:
			[(self spaceInterface)
				initMenuPov;
				initMenuInfo;
				initMenuTrack]! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 17:29'!
removePovMethod
	| aList |
	self povMethodsList selections isEmpty
		ifTrue: [ ^ self alertMessage: self translator tNoMethodSelected ].
	self povMethodsList selections
		do: [ :m | 
			(self isItDefault: m)
				ifTrue:
					[ self defaultPov at: self observedEntitiesList selection put: nil ] ].
	aList := self povMethodsList list copy.
	aList removeAll: self povMethodsList selections.
	self povMethodsList setList: aList selecting: Array new.
	self povMethods
		at: self observedEntitiesList selection
		put: self povMethodsList_WithoutDefaultSign list.
	self spaceInterface initMenuPov! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 17:29'!
removeProbeMethod
	| aList |
	self probeMethodsList selections isEmpty
		ifTrue: [ ^ self alertMessage: self translator tNoMethodSelected ].
	aList := self probeMethodsList list copy.
	aList removeAll: self probeMethodsList selections.
	self probeMethodsList setList: aList selecting: Array new.
	self probeMethods
		at: self observedEntitiesList selection
		put: self probeMethodsList list! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
reopenSI
	
	| oldSI newSI |
	oldSI := self spaceInterface.
	newSI := self spaceInterface reopenWithSameHabitus.
	oldSI siConfig: nil.
	oldSI closeRequest.
	^newSI! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 15:27'!
saveConfig
	self configName value isEmpty
		ifTrue: [ ^ self alertMessage: self translator tConfigTitle ].
	(self configName value includes: $ )
		ifTrue: [ (self confirm: self translator tSpaceNotAllowed)
				ifTrue: [ self configName
						value: (self configName value replaceAll: $  with: $_) ]
				ifFalse: [ ^ nil ] ].
	self checkClassAndMethodsExist.
	self class
		saveSIconfig: self
		intoClass: self spaceInterface cormasModelClass
		name: self configName value.
	self spaceInterface configName value: self configName value! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
setChangeValues
	
	| anEntity |
	anEntity := self manipEntitiesList selection.
	anEntity ifNil: [^nil].
	self canChangeValues
		at: anEntity
		put: self canChangeValuesCheckBox value! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
setCheckMarksForDisplayOptionsMenu
	
	| menu menuDyn |
	entitiesList
		do:
			[:agentClass | 
			(agentClass isSituatedClass and: [agentClass inheritsFrom: Agent])
				ifTrue:
					[menu := ((builder menuAt: #displayOptionsMenu) value atNameKey:
							#trackAgents) submenu menuItemLabeled: agentClass name asString.
					(self trackedAgents includes: agentClass name)
						ifFalse: [menu beOff]
						ifTrue: [menu beOn]]].
	isManipulateForTabletEnabled
		ifNotNil:
			[menuDyn := (builder menuAt: #displayOptionsMenu) value atNameKey:
					#toggleTouchpadMode.
			isManipulateForTabletEnabled
				ifTrue: [menuDyn beOn]
				ifFalse: [menuDyn beOff]]
		ifNil:
			[self
				isManipulateForTabletEnabled:
					self spaceInterface isManipulateForTabletEnabled].
	isUndoRedoEnabled
		ifNotNil:
			[menuDyn := (builder menuAt: #displayOptionsMenu) value atNameKey:
					#toggleUndoRedo.
			isUndoRedoEnabled
				ifTrue: [menuDyn beOn]
				ifFalse: [menuDyn beOff]]
		ifNil: [self isUndoRedoEnabled: self spaceInterface enableUndo].
	isSingleDefaultPovShown
		ifNotNil:
			[menuDyn := (builder menuAt: #displayOptionsMenu) value atNameKey:
					#toggleShowSingleDefaultPov.
			isSingleDefaultPovShown
				ifTrue: [menuDyn beOn]
				ifFalse: [menuDyn beOff]].
	isSingleDefaultInfoShown
		ifNotNil:
			[menuDyn := (builder menuAt: #displayOptionsMenu) value atNameKey:
					#toggleShowSingleDefaultInfo.
			isSingleDefaultInfoShown
				ifTrue: [menuDyn beOn]
				ifFalse: [menuDyn beOff]]! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
setManipWholePop
	
	| anEntity |
	anEntity := self manipEntitiesList selection.
	anEntity ifNil: [^nil].
	self manipWholePop
		at: anEntity
		put: self manipWholePopCheckBox value! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
setMoveEntity
	
	| anEntity |
	anEntity := self manipEntitiesList selection.
	anEntity ifNil: [^nil].
	self canBeMoved
		at: anEntity
		put: self moveEntityCheckBox value! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 15:29'!
setSelectionAsDefaultInfo
	| aList anEntity |
	self infoMethodsList selections isEmpty
		ifTrue: [ ^ self alertMessage: self translator tNoInfoSelected ].
	anEntity := self observedEntitiesList selection.
	self infoMethodsList selections size > 1
		ifTrue: [ ^ self alertMessage: self translator tOneInfo ].
	(self isItDefault: self infoMethodsList selections first)
		ifTrue: [ ^ self alertMessage: self tInfoDefault ].
	aList := self infoMethodsList_WithoutDefaultSign list copy.
	self defaultInfo
		at: anEntity
		put: self infoMethodsList selections first.
	aList remove: (self defaultInfo at: anEntity).
	aList add: (self defaultInfo at: anEntity) , ' ->D'.
	aList sort: [ :x :y | x < y ].
	self infoMethodsList
		setList: aList
		selecting: (Array with: (self defaultInfo at: anEntity) , ' ->D')! !

!CMSpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 17:32'!
setSelectionAsDefaultPov
	| aList anEntity |
	self povMethodsList selections isEmpty
		ifTrue: [ ^ self alertMessage: self translator tNoPoVSelected ].
	anEntity := self observedEntitiesList selection.
	self povMethodsList selections size > 1
		ifTrue: [ ^ self alertMessage: self translator tOnePoV ].
	(self isItDefault: self povMethodsList selections first)
		ifTrue: [ ^ self alertMessage: self translator tPoVDefault ].
	aList := self povMethodsList_WithoutDefaultSign list copy.
	self defaultPov
		at: anEntity
		put: self povMethodsList selections first.
	aList remove: (self defaultPov at: anEntity).
	aList add: (self defaultPov at: anEntity) , ' ->D'.
	aList sort: [ :x :y | x < y ].
	self povMethodsList
		setList: aList
		selecting: (Array with: (self defaultPov at: anEntity) , ' ->D')! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
setTrackLength
	"set the maximum size of the figures' tracks"
	
	(self 
		requestFrom: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20)
		message: self translator tAgentTracksSize
		title: 'CORMAS')
			ifNil: [ ^ self ]
			ifNotNil: [ : selectedItem |
				self trackLengthValue: selectedItem.
				self applyTrackLengthValue: selectedItem ]! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
siMenuFormat
	
	^siMenuFormat isNil
		ifTrue: [siMenuFormat := #siMenuFull asValue]
		ifFalse: [siMenuFormat]! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
siMenuFull
	
	self siMenuFormat value: #siMenuFull! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
siMenuFull_apply
	
	self siMenuFull.
	self reopenSI openSIconfig! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
siMenuLimited
	
	self siMenuFormat value: #siMenuLimited! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
siMenuLimited2
	
	self siMenuFormat value: #siMenuLimited2! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
siMenuLimited2WithHabitus
	
	self siMenuFormat value: #siMenuLimited2WithHabitus! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
siMenuLimited2WithHabitus_apply
	
	self siMenuLimited2WithHabitus.
	self reopenSI openSIconfig! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
siMenuLimited2_apply
	
	self siMenuLimited2.
	self reopenSI openSIconfig! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
siMenuLimitedWithHabitus
	
	self siMenuFormat value: #siMenuLimitedWithHabitus! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
siMenuLimitedWithHabitus_apply
	
	self siMenuLimitedWithHabitus.
	self reopenSI openSIconfig! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
siMenuLimited_apply
	
	self siMenuLimited.
	self reopenSI openSIconfig! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
siMenuNone
	
	self siMenuFormat value: #siMenuNone! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
siMenuNone_apply
	
	self siMenuNone.
	self reopenSI openSIconfig! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
spaceInterface
	
	^spaceInterface! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
spaceInterface: anObject
	
	spaceInterface := anObject! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
toggleShowSingleDefaultInfo
	
	self isSingleDefaultInfoShown: self isSingleDefaultInfoShown not! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
toggleShowSingleDefaultPov
	
	self isSingleDefaultPovShown: self isSingleDefaultPovShown not! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
toggleTouchpadMode
	
	self isManipulateForTabletEnabled: self isManipulateForTabletEnabled not! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
toggleUndoRedo
	
	self isUndoRedoEnabled: self isUndoRedoEnabled not! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
toolCreate
	
	self defaultTool value: #toolCreate.
	self spaceInterface activateCreateEntityTool! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
toolInspect
	
	self defaultTool value: #toolInspect.
	self spaceInterface activateInspectTool! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
toolManipulate
	
	self defaultTool value: #toolManipulate.
	self spaceInterface activateManipulateTool! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
toolZoom
	
	self defaultTool value: #toolZoom.
	self spaceInterface activateZoomTool! !

!CMSpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
trackAgents: agentClass
	
	| menu menuSubclass builder |
	menu := ((builder menuAt: #displayOptionsMenu) value atNameKey:
			#trackAgents) submenu menuItemLabeled: agentClass name asString.
	menu isOn
		ifTrue:
			[menu beOff.
			(self trackedAgents includes: agentClass name)
				ifTrue: [self trackedAgents remove: agentClass name]]
		ifFalse:
			[(self observedEntitiesList list includes: agentClass)
				ifFalse:
					[^ self alertMessage: 'The entity ' , agentClass name , ' can not be observed in the current configuration'].
			menu beOn.
			(self trackedAgents includes: agentClass name)
				ifFalse: [self trackedAgents add: agentClass name]].
	self forceSItrackAgents: agentClass.
	agentClass subclasses
		do:
			[:aClass | 
			menuSubclass := ((builder menuAt: #displayOptionsMenu) value atNameKey:
					#trackAgents) submenu menuItemLabeled: aClass name asString.
			menu isOn
				ifTrue:
					[menuSubclass beOn.
					(self trackedAgents includes: aClass name)
						ifFalse: [self trackedAgents add: aClass name]]
				ifFalse:
					[menuSubclass beOff.
					(self trackedAgents includes: aClass name)
						ifTrue: [self trackedAgents remove: aClass name]].
			self forceSItrackAgents: aClass]! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
trackLengthValue
	
	^trackLengthValue! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
trackLengthValue: anObject
	
	trackLengthValue := anObject! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
trackedAgents
	
	^trackedAgents ifNil: [trackedAgents := Set new]! !

!CMSpaceInterfaceConfig methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/16/2017 14:55'!
trackedAgents: anObject
	
	trackedAgents := anObject! !

CMSpecObject subclass: #CMSpecAgentAddInterface
	instanceVariableNames: 'cbComm cbGroup cbLocation newClassName descriptionLabel toolbar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Core'!

!CMSpecAgentAddInterface commentStamp: 'HernanMoralesDurand 4/4/2018 18:13' prior: 0!
CMSpecAgentAddInterface example!

!CMSpecAgentAddInterface class methodsFor: 'specs' stamp: 'HernanMoralesDurand 9/25/2017 19:53'!
defaultSpec
	<spec>

	^ SpecLayout composed
		newRow: [ : col | 
			col
				newColumn: [ : row |
				row 
					add: #cbComm;
					add: #cbGroup;
					add: #cbLocation ];
			newColumn: [ : row | 
				row
					add: #newClassName;
					add: #descriptionLabel;
					add: #toolbar height: self toolbarHeight ] ]! !

!CMSpecAgentAddInterface methodsFor: 'actions' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
addNewSocialEntityGUI
	
	| newName superClass |
	(newName := self getNewClassNameFromGUI) isNil
		ifTrue: [ ^ self alertMessage: self translator tMissingClassName ].
	superClass := self getAgentSuperclassFromGUI.
	self projectManager 
		addNewClassType: 'Social' 
		inheritingFrom: superClass 
		name: newName 
		initProtocol: false 
		stepProtocol: false.
	self closeRequest! !

!CMSpecAgentAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/25/2017 19:54'!
cbComm
	^ cbComm! !

!CMSpecAgentAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/25/2017 19:54'!
cbComm: anObject
	cbComm := anObject! !

!CMSpecAgentAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/25/2017 19:54'!
cbGroup
	^ cbGroup! !

!CMSpecAgentAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/25/2017 19:54'!
cbGroup: anObject
	cbGroup := anObject! !

!CMSpecAgentAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/25/2017 19:54'!
cbLocation
	^ cbLocation! !

!CMSpecAgentAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/25/2017 19:54'!
cbLocation: anObject
	cbLocation := anObject! !

!CMSpecAgentAddInterface methodsFor: 'actions' stamp: 'HernanMoralesDurand 9/25/2017 19:51'!
defaultClassPrefix
	" Answer a <String> with a prefix for invalid class names entered by the user "
	
	^ 'X_'! !

!CMSpecAgentAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/21/2017 04:09'!
descriptionLabel
	" Answer the descriptionLabel of this CMSpecAgentAddInterface "

	^ descriptionLabel! !

!CMSpecAgentAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/21/2017 04:09'!
descriptionLabel: anObject
	" Sets the descriptionLabel of this CMSpecAgentAddInterface "

	descriptionLabel := anObject! !

!CMSpecAgentAddInterface methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/13/2017 00:51'!
getAgentSuperclassFromGUI
	
	self cbComm state not & self cbLocation state not & self cbGroup state not
		ifTrue: [ ^ CMAgent ].
	self cbComm state & self cbLocation state not & self cbGroup state not
		ifTrue: [ ^ CMAgentComm ].
	self cbComm state not & self cbLocation state & self cbGroup state not
		ifTrue: [ ^ CMAgentLocation ].
	self cbComm state & self cbLocation state & self cbGroup state not
		ifTrue: [ ^ CMAgentCommLocation ].
	self cbComm state not & self cbLocation state not & self cbGroup state
		ifTrue: [ ^ CMGroup ].
	self cbComm state & self cbLocation state not & self cbGroup state
		ifTrue: [ ^ CMGroupComm ].
	self cbComm state not & self cbLocation state & self cbGroup state
		ifTrue: [ ^ CMGroupLocation ].
	self cbComm state & self cbLocation state & self cbGroup state
		ifTrue: [ ^ CMGroupCommLocation ]! !

!CMSpecAgentAddInterface methodsFor: 'actions' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
getNewClassNameFromGUI
	" Answer a <String> with a valid Smalltalk class name "	

	| aName |
	self halt.
	(aName := self newClassName textValuePending) isEmpty
		ifFalse: [
			aName first isLetter ifFalse: [ aName := self defaultClassPrefix , aName ].
			(self projectManager verifyClassExist: aName)
				ifTrue: [ self cormas alertNameAlreadyExist. 	^nil ] ]
		ifTrue: [ ^ nil ].
	^ aName capitalized! !

!CMSpecAgentAddInterface methodsFor: 'initialization' stamp: 'HernanMoralesDurand 9/23/2017 19:39'!
initialExtent

	^ 500 @ 250! !

!CMSpecAgentAddInterface methodsFor: 'initialization' stamp: 'HernanMoralesDurand 9/25/2017 19:52'!
initializePresenter
	" Private - See superimplementor's comment "

	self toolbar firstButtonAction: [ self addNewSocialEntityGUI ].! !

!CMSpecAgentAddInterface methodsFor: 'initialization' stamp: 'HernanMoralesDurand 10/23/2017 01:22'!
initializeWidgets
	" Private - See superimplementor's comment "

	self instantiateModels: #(
		cbComm 					CheckBoxModel
		cbGroup 					CheckBoxModel
		cbLocation 				CheckBoxModel					 
		newClassName 			SpcLabeledTextField 
		descriptionLabel 		LabelModel 
		toolbar 					SpcOneButtonToolbar).

	self newClassName 
		beForText;
		label: 'Name:'.
	self cbComm label: self translator tCommunication.
	self cbGroup label: self translator tGroup.
	self cbLocation label: self translator tLocation.
	self toolbar firstButtonLabel: 'Ok'.
	self focusOrder
		add: self cbComm;
		add: self cbGroup;
		add: self cbLocation;
		add: self newClassName;
		add: self descriptionLabel;
		add: self toolbar! !

!CMSpecAgentAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/25/2017 19:54'!
newClassName
	^ newClassName! !

!CMSpecAgentAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/25/2017 19:54'!
newClassName: anObject
	newClassName := anObject! !

!CMSpecAgentAddInterface methodsFor: 'initialization' stamp: 'HernanMoralesDurand 10/22/2017 00:22'!
title
	" Private - See superimplementor's comment "

	^ self translator tCreateAgent! !

!CMSpecAgentAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/21/2017 04:09'!
toolbar
	" Answer the toolbar of this CMSpecAgentAddInterface "

	^ toolbar! !

!CMSpecAgentAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/21/2017 04:09'!
toolbar: anObject
	" Sets the toolbar of this CMSpecAgentAddInterface "

	toolbar := anObject! !

CMSpecObject subclass: #CMSpecAttributesToolbar
	instanceVariableNames: 'attributeLabel attributeAddButton attributeRemoveButton classVarLabel classVarAddButton classVarRemoveButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Core'!

!CMSpecAttributesToolbar commentStamp: 'HernanMoralesDurand 1/24/2018 18:37' prior: 0!
CMSpecAttributesToolbar example.

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.


    Implementation Points!

!CMSpecAttributesToolbar class methodsFor: 'specs' stamp: 'HernanMoralesDurand 11/20/2017 14:54'!
defaultSpec
	<spec>

	^ SpecLayout composed
		newRow: [ : r | 
			r
				add: #attributeLabel;
				add: #attributeAddButton;
				add: #attributeRemoveButton ;
				addSplitter;
				add: #classVarLabel;
				add: #classVarAddButton;
				add: #classVarRemoveButton  ]
			height: 25;			
			yourself			
! !

!CMSpecAttributesToolbar methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
addAttributeCallback
	" Callback for adding attribute in the target class "
	
	| userAnswer |
	userAnswer := self 
		requestText: self translator tEnterAttName
		title: self translator tAppTitle.
	(self validateAttributeName: userAnswer)
	 	ifTrue: [ CMSpecInitialValueChooser openFor: self projectManager ]
		ifFalse: [ 
			userAnswer 
				ifNotNil: [ self informMessage: userAnswer , self translator tInvalidName ] ]! !

!CMSpecAttributesToolbar methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/27/2018 09:52'!
attributeAddButton
	" Answer the attributeAddButton of this CMSpecAttributesToolbar "

	^ attributeAddButton
! !

!CMSpecAttributesToolbar methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/27/2018 09:51'!
attributeAddButton: anObject
	" Sets the attributeAddButton of this CMSpecAttributesToolbar "

	attributeAddButton := anObject
! !

!CMSpecAttributesToolbar methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/27/2018 09:52'!
attributeLabel
	" Answer the attributeLabel of this CMSpecAttributesToolbar "

	^ attributeLabel
! !

!CMSpecAttributesToolbar methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/27/2018 09:52'!
attributeLabel: anObject
	" Sets the attributeLabel of this CMSpecAttributesToolbar "

	attributeLabel := anObject
! !

!CMSpecAttributesToolbar methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/27/2018 09:52'!
attributeRemoveButton
	" Answer the attributeRemoveButton of this CMSpecAttributesToolbar "

	^ attributeRemoveButton
! !

!CMSpecAttributesToolbar methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/27/2018 09:51'!
attributeRemoveButton: anObject
	" Sets the attributeRemoveButton of this CMSpecAttributesToolbar "

	attributeRemoveButton := anObject
! !

!CMSpecAttributesToolbar methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/27/2018 09:52'!
classVarAddButton
	" Answer the classVarAddButton of this CMSpecAttributesToolbar "

	^ classVarAddButton
! !

!CMSpecAttributesToolbar methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/27/2018 09:52'!
classVarAddButton: anObject
	" Sets the classVarAddButton of this CMSpecAttributesToolbar "

	classVarAddButton := anObject
! !

!CMSpecAttributesToolbar methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/27/2018 09:52'!
classVarLabel
	" Answer the classVarLabel of this CMSpecAttributesToolbar "

	^ classVarLabel
! !

!CMSpecAttributesToolbar methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/27/2018 09:52'!
classVarLabel: anObject
	" Sets the classVarLabel of this CMSpecAttributesToolbar "

	classVarLabel := anObject
! !

!CMSpecAttributesToolbar methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/27/2018 09:52'!
classVarRemoveButton
	" Answer the classVarRemoveButton of this CMSpecAttributesToolbar "

	^ classVarRemoveButton
! !

!CMSpecAttributesToolbar methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/27/2018 09:52'!
classVarRemoveButton: anObject
	" Sets the classVarRemoveButton of this CMSpecAttributesToolbar "

	classVarRemoveButton := anObject
! !

!CMSpecAttributesToolbar methodsFor: 'initialization' stamp: 'HernanMoralesDurand 4/27/2018 09:53'!
initialExtent
	" Private - See superimplementor's comment "

	^ 600 @ 400! !

!CMSpecAttributesToolbar methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/20/2017 14:55'!
initializeFocus

	self focusOrder
		add: self attributeAddButton;
		add: self attributeRemoveButton;
		add: self classVarAddButton;
		add: self classVarRemoveButton
! !

!CMSpecAttributesToolbar methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/20/2017 16:05'!
initializeLabels
	" Private - See superimplementor's comment "

	self attributeLabel label: self translator tAttribute.
	self attributeAddButton 
		icon: (self iconNamed: #addIcon);
		help: self translator tHelpAddInstAtt.
	self attributeRemoveButton
		icon: (self iconNamed: #removeIcon);
		help: self translator tHelpRemoveInstAtt.

	self classVarLabel label: self translator tClassVariable.
	self classVarAddButton 
		icon: (self iconNamed: #addIcon);
		help: self translator tHelpAddClassAttr.
	self classVarRemoveButton
		icon: (self iconNamed: #removeIcon);
		help: self translator tHelpRemoveClassAtt.	! !

!CMSpecAttributesToolbar methodsFor: 'initialization' stamp: 'HernanMoralesDurand 4/7/2018 18:09'!
initializePresenter
	" Private - See superimplementor's comment "

	self attributeAddButton action: [ self addAttributeCallback ].
	self attributeRemoveButton action: [ self removeAtributeCallback ].

	self classVarAddButton action: [ self shouldBeImplemented ].
	self classVarRemoveButton action: [ self shouldBeImplemented ].! !

!CMSpecAttributesToolbar methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/20/2017 14:55'!
initializeWidgets
	" Private - See superimplementor's comment "

	self
		instantiateModels: #(
			attributeLabel 				LabelModel 
			attributeAddButton 		ButtonModel 
			attributeRemoveButton 	ButtonModel 
			classVarLabel 				LabelModel 
			classVarAddButton 			ButtonModel 
			classVarRemoveButton 		ButtonModel).
	
	self initializeLabels.
	self initializeFocus.
! !

!CMSpecAttributesToolbar methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 11/20/2017 16:58'!
openInitialValueChooser

	self shouldBeImplemented! !

!CMSpecAttributesToolbar methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 4/7/2018 18:09'!
removeAtributeCallback

	self owner superclassesAttributesTable hasSelectedItem
		ifTrue: [ self shouldBeImplemented  ]! !

!CMSpecAttributesToolbar methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 11/20/2017 16:32'!
removeAttributeCallback
	" Callback for adding attribute in the target class "
	
	| userAnswer |
	userAnswer := self 
		requestText: self translator tEnterAttName
		title: self translator tAppTitle.
	(self validateAttributeName: userAnswer)
	 	ifTrue: [ self openInitialValueChooser ]
		ifFalse: [ self informMessage: userAnswer , self translator tInvalidName ]! !

!CMSpecAttributesToolbar methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/20/2017 15:39'!
validateAttributeName: userAnswer
	" Answer <true> if provided userAnswer is valid as attribute name "

	^ userAnswer notNil and: [ userAnswer notEmpty and: 
		[ userAnswer isValidInstVarName ] ]! !

CMSpecObject subclass: #CMSpecConfirmBeforeLaunch
	instanceVariableNames: 'fixRandomSeedCheck fixRandomTextField finalStep initMethodList controlMethodList probesList stepBackCheck releaseRandomCheck toolbar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Core'!

!CMSpecConfirmBeforeLaunch commentStamp: 'HernanMoralesDurand 8/31/2017 22:02' prior: 0!
CMSpecConfirmBeforeLaunch new openWithSpec.

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	controlMethodList:		<Object>
	finalStep:		<Object>
	fixRandomSeedCheck:		<Object>
	fixRandomTextField:		<Object>
	initMethodList:		<Object>
	probesList:		<Object>
	releaseRandomCheck:		<Object>
	stepBackCheck:		<Object>
	toolbar:		<Object>


    Implementation Points!

!CMSpecConfirmBeforeLaunch class methodsFor: 'specs' stamp: 'HernanMoralesDurand 9/1/2017 01:26'!
defaultSpec
	<spec: #default>

	^ SpecLayout composed
		newColumn: [ : r | 
			r 
				newRow: [ : col | col 
					add: #fixRandomSeedCheck ;					
					add: #fixRandomTextField ] height: self toolbarHeight; 
				newRow: [ : col |
					col
						newColumn: [ : row |
							row
								add: #initMethodList;
								add: #controlMethodList;
								add: #finalStep height: self toolbarHeight ];
						newColumn: [ : row |
							row
								add: #probesList;
								add: #stepBackCheck height: self toolbarHeight ] ];
				add: #toolbar height: self toolbarHeight ];	
	yourself	! !

!CMSpecConfirmBeforeLaunch methodsFor: 'actions' stamp: 'NicolasBecu 5/1/2018 21:04'!
applyScenarioSettings
	self initMethodList selectedItem
		ifNotNil: [ :aInitMethod | self cormasModel activeInit: aInitMethod asSymbol ]
		ifNil: [ ^ self alertMessage: 'Choose a init method' ].
	self controlMethodList selectedItem
		ifNotNil: [ :aControlMethod | self cormasModel activeControl: aControlMethod asSymbol ]
		ifNil: [ ^ self alertMessage: 'Choose a control method' ].
	self cormasModel initSimulation.
	self delete! !

!CMSpecConfirmBeforeLaunch methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/31/2017 21:39'!
controlMethodList
	^ controlMethodList! !

!CMSpecConfirmBeforeLaunch methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/31/2017 21:39'!
controlMethodList: anObject
	controlMethodList := anObject! !

!CMSpecConfirmBeforeLaunch methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/31/2017 23:26'!
finalStep
	^ finalStep! !

!CMSpecConfirmBeforeLaunch methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/31/2017 23:26'!
finalStep: anObject
	finalStep := anObject! !

!CMSpecConfirmBeforeLaunch methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/31/2017 21:41'!
fixRandomSeedCheck
	^ fixRandomSeedCheck! !

!CMSpecConfirmBeforeLaunch methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/31/2017 21:41'!
fixRandomSeedCheck: anObject
	fixRandomSeedCheck := anObject! !

!CMSpecConfirmBeforeLaunch methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/31/2017 21:41'!
fixRandomTextField
	^ fixRandomTextField! !

!CMSpecConfirmBeforeLaunch methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/31/2017 21:41'!
fixRandomTextField: anObject
	fixRandomTextField := anObject! !

!CMSpecConfirmBeforeLaunch methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/31/2017 21:41'!
initMethodList
	^ initMethodList! !

!CMSpecConfirmBeforeLaunch methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/31/2017 21:41'!
initMethodList: anObject
	initMethodList := anObject! !

!CMSpecConfirmBeforeLaunch methodsFor: 'initialization' stamp: 'HernanMoralesDurand 12/9/2017 00:22'!
initialExtent
	"Answer the initial extent for the receiver."
	
	^ 700 @ 500! !

!CMSpecConfirmBeforeLaunch methodsFor: 'initialization' stamp: 'HernanMoralesDurand 12/9/2017 23:05'!
initializeActiveControl

	(self cormasModel activeControl
		ifNotNil: [ : m | self controlMethodList items includes: m ]
		ifNil: [ false ])
			ifTrue: [ self controlMethodList selectItem: self cormasModel activeControl ]
			ifFalse: 	 [ self controlMethodList notEmpty
				ifTrue: [ self controlMethodList selectItem: self controlMethodList items first ] ].! !

!CMSpecConfirmBeforeLaunch methodsFor: 'initialization' stamp: 'HernanMoralesDurand 1/24/2018 18:17'!
initializeActiveInit

	(self cormasModel activeInit
		ifNotNil: [ : m | self initMethodList items includes: m ]
		ifNil: [ false ])
			ifTrue: [ self initMethodList selectItem: self cormasModel activeInit ]
			ifFalse: 	 [ self initMethodList items notEmpty
				ifTrue: [ self initMethodList selectItem: self initMethodList first ] ].! !

!CMSpecConfirmBeforeLaunch methodsFor: 'initialization' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
initializePresenter
	" Private - See superimplementor's comment "
	" SimManager>>initScenarioWindow "
	
	self initMethodList items: self projectManager modelInitMethods.
	self controlMethodList items: self projectManager modelControlInitMethods.

	self initMethodList isEmpty 
		ifTrue: [ self alertMessage: self tMissingInitMethods ].
	self controlMethodList isEmpty 
		ifTrue: [ self alertMessage: self tMissingControlMethods ].
		
	self initializeActiveInit.
	self initializeActiveControl.! !

!CMSpecConfirmBeforeLaunch methodsFor: 'initialization' stamp: 'NicolasBecu 5/1/2018 12:37'!
initializeWidgets

	self instantiateModels: #(
		initMethodList			SpcLabeledList
		controlMethodList 	 	SpcLabeledList
		finalStep 				SpcLabeledTextField
		fixRandomSeedCheck 	CheckBoxModel
		fixRandomTextField 	TextInputFieldModel
		probesList 				SpcLabeledList
		releaseRandomCheck		CheckBoxModel
		stepBackCheck 			CheckBoxModel
		toolbar 					SpcTwoButtonToolbar	
	).
	
	self initMethodList label: 'Select a method of initialization'.
	self controlMethodList label: 'Select a method of control'.
	self probesList label: 'Select probes to record'.
	self fixRandomSeedCheck label: 'Fix the random seed to'.
	self finalStep label: 'Final step'.
	self stepBackCheck label: 'Enable stepping back'.
	self releaseRandomCheck label: 'Release random seed after initialization'.
	self toolbar
		secondButtonLabel: 'Apply';
		firstButtonLabel: 'Cancel';
		firstButtonAction: [ self delete ];
		secondButtonAction: [ self applyScenarioSettings ].
		! !

!CMSpecConfirmBeforeLaunch methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/31/2017 21:41'!
probesList
	^ probesList! !

!CMSpecConfirmBeforeLaunch methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/31/2017 21:41'!
probesList: anObject
	probesList := anObject! !

!CMSpecConfirmBeforeLaunch methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/31/2017 21:44'!
releaseRandomCheck
	^ releaseRandomCheck! !

!CMSpecConfirmBeforeLaunch methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/31/2017 21:44'!
releaseRandomCheck: anObject
	releaseRandomCheck := anObject! !

!CMSpecConfirmBeforeLaunch methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/31/2017 21:44'!
stepBackCheck
	^ stepBackCheck! !

!CMSpecConfirmBeforeLaunch methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/31/2017 21:44'!
stepBackCheck: anObject
	stepBackCheck := anObject! !

!CMSpecConfirmBeforeLaunch methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/1/2017 01:27'!
title

	^ 'Confirmation before launching'! !

!CMSpecConfirmBeforeLaunch methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/31/2017 21:44'!
toolbar
	^ toolbar! !

!CMSpecConfirmBeforeLaunch methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/31/2017 21:44'!
toolbar: anObject
	toolbar := anObject! !

CMSpecObject subclass: #CMSpecEditAttributes
	instanceVariableNames: 'superclassesAttributesTable sAttributesLabel targetAttributesTable tAttributesLabel toolbarAttributeActions toolbar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Core'!

!CMSpecEditAttributes commentStamp: 'HernanMoralesDurand 1/24/2018 18:43' prior: 0!
CMSpecEditAttributes example.

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.


    Implementation Points!

!CMSpecEditAttributes class methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/20/2017 13:28'!
defaultSpec
	<spec>
	^ SpecLayout composed
			newColumn: [ : r |
				r
					add: #sAttributesLabel height: self toolbarHeight;
					add: #superclassesAttributesTable;
					add: #tAttributesLabel height: self toolbarHeight;
					add: #targetAttributesTable;
					add: #toolbarAttributeActions height: self toolbarHeight;
					add: #toolbar height: self toolbarHeight ]
! !

!CMSpecEditAttributes methodsFor: 'private' stamp: 'HernanMoralesDurand 9/3/2017 14:26'!
attributesTableMenu
	" Private - Configure the contextual menu items for receiver's tables "

	| aMenu |
	aMenu := MenuModel new.
	"showEntryItemMenu ifTrue: [ self addMenuItemsForSelectedItemsIn:	aMenu ]."
	^ aMenu buildWithSpecAsPopup! !

!CMSpecEditAttributes methodsFor: 'initialization' stamp: ''!
initialExtent
	^ 600 @ 400! !

!CMSpecEditAttributes methodsFor: 'initialization' stamp: 'HernanMoralesDurand 9/3/2017 19:07'!
initializeAttributeTables

	{ 'Class' . 'Attribute' . 'Value' } do: [ : attName | 
		self superclassesAttributesTable addColumn: (FTColumn id: attName).
		self targetAttributesTable addColumn: (FTColumn id: attName) ].
	"numberOfColumns: 3 withWidths: #(250 250 50);"

	self superclassesAttributesTable
		display: [ : attItem | self wrapItem: attItem ];
		menu: [ self menuMorphForSelectedItems ].
	
	self targetAttributesTable
		display: [ : attItem | self morphForItemAt: attItem ];
		menu: [ self menuMorphForSelectedItems ].
! !

!CMSpecEditAttributes methodsFor: 'initialization' stamp: ''!
initializePresenter
	! !

!CMSpecEditAttributes methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/20/2017 13:31'!
initializeWidgets
	" Private - See superimplementor's comment "

	self
		instantiateModels: #(
			superclassesAttributesTable 	SpcFastTable 
			sAttributesLabel 					LabelModel 
			targetAttributesTable 			SpcFastTable 
			tAttributesLabel 					LabelModel
			toolbarAttributeActions 			CMSpecAttributesToolbar
			toolbar 								SpcTwoButtonToolbar).

	self initializeAttributeTables.
	self sAttributesLabel label: self translator tAttributesSuperLabel.
	self tAttributesLabel label: self translator tAttributesTargetLabel.
	self toolbar 
		firstButtonLabel: self translator tReset;
		secondButtonLabel: self translator tApply.
	self focusOrder
		add: superclassesAttributesTable;
		add: targetAttributesTable! !

!CMSpecEditAttributes methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/1/2017 19:58'!
sAttributesLabel
	" Answer the sAttributesLabel of this CMSpecEditAttributes "

	^ sAttributesLabel! !

!CMSpecEditAttributes methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/1/2017 19:58'!
sAttributesLabel: anObject
	" Sets the sAttributesLabel of this CMSpecEditAttributes "

	sAttributesLabel := anObject! !

!CMSpecEditAttributes methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/1/2017 19:58'!
superclassesAttributesTable
	" Answer the superclassesAttributesTable of this CMSpecEditAttributes "

	^ superclassesAttributesTable! !

!CMSpecEditAttributes methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/1/2017 19:58'!
superclassesAttributesTable: anObject
	" Sets the superclassesAttributesTable of this CMSpecEditAttributes "

	superclassesAttributesTable := anObject! !

!CMSpecEditAttributes methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/1/2017 19:58'!
tAttributesLabel
	" Answer the tAttributesLabel of this CMSpecEditAttributes "

	^ tAttributesLabel! !

!CMSpecEditAttributes methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/1/2017 19:58'!
tAttributesLabel: anObject
	" Sets the tAttributesLabel of this CMSpecEditAttributes "

	tAttributesLabel := anObject! !

!CMSpecEditAttributes methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/1/2017 19:58'!
targetAttributesTable
	" Answer the targetAttributesTable of this CMSpecEditAttributes "

	^ targetAttributesTable! !

!CMSpecEditAttributes methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/1/2017 19:58'!
targetAttributesTable: anObject
	" Sets the targetAttributesTable of this CMSpecEditAttributes "

	targetAttributesTable := anObject! !

!CMSpecEditAttributes methodsFor: 'initialization' stamp: ''!
title
	^ 'Attributes'! !

!CMSpecEditAttributes methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/20/2017 09:48'!
toolbar
	^ toolbar! !

!CMSpecEditAttributes methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/20/2017 09:48'!
toolbar: anObject
	toolbar := anObject! !

!CMSpecEditAttributes methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/2/2017 19:09'!
toolbarAttributeActions
	^ toolbarAttributeActions! !

!CMSpecEditAttributes methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/2/2017 19:09'!
toolbarAttributeActions: anObject
	toolbarAttributeActions := anObject! !

!CMSpecEditAttributes methodsFor: 'initialization' stamp: 'HernanMoralesDurand 9/3/2017 18:59'!
wrapItem: attItem

	^ { attItem . attItem . attItem }! !

CMSpecObject subclass: #CMSpecEntitiesBrowser
	instanceVariableNames: 'spatialList socialList passiveList defineEntitiesLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Core'!

!CMSpecEntitiesBrowser commentStamp: 'HernanMoralesDurand 1/24/2018 18:47' prior: 0!
CMSpecEntitiesBrowser example.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	defineEntitiesLabel:		<Object>
	passiveList:		<Object>
	socialList:		<Object>
	spatialList:		<Object>


    Implementation Points!

!CMSpecEntitiesBrowser class methodsFor: 'initialization' stamp: 'HernanMoralesDurand 9/15/2017 01:53'!
defaultSpec
	<spec>
	^ SpecLayout composed
		newColumn: [ : row | 
			row
				add: #defineEntitiesLabel height: self toolbarHeight ];
		newRow: [ : col |
			col
				add: #spatialList;
				add: #socialList;
				add: #passiveList ]
! !

!CMSpecEntitiesBrowser methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/15/2017 01:47'!
defineEntitiesLabel
	" Answer the defineEntitiesLabel of this CMSpecEntitiesBrowser "

	^ defineEntitiesLabel! !

!CMSpecEntitiesBrowser methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/15/2017 01:47'!
defineEntitiesLabel: anObject
	" Sets the defineEntitiesLabel of this CMSpecEntitiesBrowser "

	defineEntitiesLabel := anObject! !

!CMSpecEntitiesBrowser methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 10/31/2017 03:05'!
entityEditActivityDiagrams
	self shouldBeImplemented.! !

!CMSpecEntitiesBrowser methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 10/31/2017 03:05'!
entityEditMethods

	self shouldBeImplemented.! !

!CMSpecEntitiesBrowser methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 10/31/2017 03:06'!
entityEditPoVSetter
	self shouldBeImplemented.! !

!CMSpecEntitiesBrowser methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 10/31/2017 03:06'!
entityRemove
	self shouldBeImplemented.! !

!CMSpecEntitiesBrowser methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 10/31/2017 03:06'!
entityRename
	self shouldBeImplemented.! !

!CMSpecEntitiesBrowser methodsFor: 'initialization' stamp: ''!
initialExtent
	^ 600 @ 400! !

!CMSpecEntitiesBrowser methodsFor: 'initialization' stamp: 'HernanMoralesDurand 10/23/2017 01:48'!
initializeFocusOrder

	self focusOrder
		add: self spatialList;
		add: self socialList;
		add: self passiveList;
		add: self defineEntitiesLabel
! !

!CMSpecEntitiesBrowser methodsFor: 'initialization' stamp: 'HernanMoralesDurand 1/25/2018 01:13'!
initializeListsContents

	#('Spatial' 'Social' 'Passive')
		do: [ : aType | 
			| typeSelector |
			typeSelector := (aType asLowercase , 'List') asSymbol.
			"selectionInList := self perform: typeSelector."
			(self perform: typeSelector) items: (self initializeListsContents: aType) ]! !

!CMSpecEntitiesBrowser methodsFor: 'initialization' stamp: 'HernanMoralesDurand 1/24/2018 22:27'!
initializeListsContents: entityTypeString
	" Private - Populate the receiver's lists using the current loaded model "

	| aList highLevelClasses |
	aList := OrderedCollection new.
	highLevelClasses := (self cormasModelClass
		perform: (entityTypeString asLowercase , 'Classes') asSymbol)
			reject: [ : anEntity | anEntity cmEnvironment includes: anEntity superclass].
	(highLevelClasses asSortedCollection: [ : i : j | i name < j name]) 
		do: [ : anEntity | 
			(anEntity cmPrintHierarchy findTokens: Character cr)
				do: [ : s | aList add: s ] ].
	^ aList	! !

!CMSpecEntitiesBrowser methodsFor: 'initialization' stamp: 'HernanMoralesDurand 10/28/2017 04:07'!
initializeMenuItems
	" Private - Set the menu options for receiver's lists "

	self spatialList menu: [ self menuForSpatialList ].
	self socialList menu: [ self menuForSocialList ].
	self passiveList menu: [ self menuForPassiveList ].! !

!CMSpecEntitiesBrowser methodsFor: 'initialization' stamp: 'HernanMoralesDurand 4/5/2018 01:07'!
initializePresenter
	" Private - See superimplementor's comment "

	self spatialList addActionBlock: [ self openAddEntityInterface ].
	self socialList addActionBlock: [ self openAddAgentInterface ].
	self passiveList addActionBlock: [ self openAddPassiveInterface ].
! !

!CMSpecEntitiesBrowser methodsFor: 'initialization' stamp: 'HernanMoralesDurand 4/5/2018 01:17'!
initializeWidgets
	" Private - See superimplementor's comment "
	
	self
		instantiateModels: #(
			spatialList 				SpcActionList 
			socialList 				SpcActionList 
			passiveList 				SpcActionList 
			defineEntitiesLabel 	LabelModel).

	self defineEntitiesLabel label: self translator tDefineEntities.
	self spatialList label: self translator tSpatial.
	self socialList label: self translator tSocial.
	self passiveList label: self translator tPassive.

	self initializeMenuItems.
	self initializeFocusOrder.
	self initializeListsContents.

! !

!CMSpecEntitiesBrowser methodsFor: 'accessing-menu' stamp: 'HernanMoralesDurand 10/29/2017 00:24'!
menuForPassiveList

	| aMenu |
	aMenu := MenuModel new.
	aMenu
		addGroup: [ : aGroup |
			aGroup addItem: [ : anItem |
				anItem
					name: self translator tEdit;
					subMenu: self subMenuForEditEntity ] ];
		addGroup: [ : aGroup |
			aGroup 
				addItem: [ : anItem |
					anItem
						name: self translator tSpecialize;
						action: [ self entitySpecialize ] ];
				addItem: [ : anItem | 
					anItem
						name: self translator tAbstract;
						action: [ self entityAbstract ] ] ];
		addGroup: [ : aGroup |
			aGroup 
				addItem: [ : anItem | 
					anItem
						name: self translator tRemove;
						action: [ self entityRemove ] ] ].
	^ aMenu buildWithSpecAsPopup.! !

!CMSpecEntitiesBrowser methodsFor: 'accessing-menu' stamp: 'HernanMoralesDurand 10/28/2017 21:49'!
menuForSocialList

	| aMenu |
	aMenu := MenuModel new.
	aMenu
		addGroup: [ : aGroup |
			aGroup addItem: [ : anItem |
				anItem
					name: self translator tEdit;
					subMenu: self subMenuForEditEntity ] ];
		addGroup: [ : aGroup |
			aGroup 
				addItem: [ : anItem |
					anItem
						name: self translator tSpecialize;
						action: [ self entitySpecialize ] ];
				addItem: [ : anItem | 
					anItem
						name: self translator tRename;
						action: [ self entityRename ] ] ];
		addGroup: [ : aGroup |
			aGroup 
				addItem: [ : anItem | 
					anItem
						name: self translator tAbstract;
						action: [ self entityAbstract ] ] ].
	^ aMenu buildWithSpecAsPopup.
	
	
! !

!CMSpecEntitiesBrowser methodsFor: 'accessing-menu' stamp: 'HernanMoralesDurand 10/29/2017 00:34'!
menuForSpatialList

	| aMenu |
	aMenu := MenuModel new.
	aMenu
		addGroup: [ : aGroup | 			
			aGroup addItem: [ : anItem |
				anItem
					name: self translator tEdit;
					subMenu: self subMenuForEditEntity ] ];
		addGroup: [ : aGroup |
			aGroup 
				addItem: [ : anItem |
					anItem
						name: self translator tSpecialize;
						action: [ self entitySpecialize ];
						enabled: false ];
				addItem: [ : anItem | 
					anItem
						name: self translator tRename;
						action: [ self entityRename ] ] ];
		addGroup: [ : aGroup |
			aGroup 
				addItem: [ : anItem | 
					anItem
						name: self translator tRemove;
						action: [ self entityRemove ] ] ].
	^ aMenu buildWithSpecAsPopup.
	
	! !

!CMSpecEntitiesBrowser methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
openAddAgentInterface
	" Private - Callback for opening UI. The user clicked the add button to add a social entity "
	
	^ (CMSpecAgentAddInterface openFor: self projectManager)	
		owner: self socialList;
		yourself
! !

!CMSpecEntitiesBrowser methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
openAddEntityInterface
	" Private - Callback for opening UI. The user clicked the add button to add a spatial entity "

	^ (CMSpecEntityAddInterface openFor: self projectManager)	
		owner: self spatialList;
		yourself

! !

!CMSpecEntitiesBrowser methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
openAddPassiveInterface
	" Private - Callback for opening UI. The user clicked the add button to add a passive entity "
	
	^ (CMSpecPassiveAddInterface openFor: self projectManager)	
		owner: self passiveList;
		yourself
! !

!CMSpecEntitiesBrowser methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 4/7/2018 17:26'!
openEditAttributes
	" Open the edit attributes window "

	self projectManager openEditAttributes! !

!CMSpecEntitiesBrowser methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/15/2017 01:47'!
passiveList
	" Answer the passiveList of this CMSpecEntitiesBrowser "

	^ passiveList! !

!CMSpecEntitiesBrowser methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/15/2017 01:47'!
passiveList: anObject
	" Sets the passiveList of this CMSpecEntitiesBrowser "

	passiveList := anObject! !

!CMSpecEntitiesBrowser methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/15/2017 01:47'!
socialList
	" Answer the socialList of this CMSpecEntitiesBrowser "

	^ socialList! !

!CMSpecEntitiesBrowser methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/15/2017 01:47'!
socialList: anObject
	" Sets the socialList of this CMSpecEntitiesBrowser "

	socialList := anObject! !

!CMSpecEntitiesBrowser methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/15/2017 01:47'!
spatialList
	" Answer the spatialList of this CMSpecEntitiesBrowser "

	^ spatialList! !

!CMSpecEntitiesBrowser methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/15/2017 01:47'!
spatialList: anObject
	" Sets the spatialList of this CMSpecEntitiesBrowser "

	spatialList := anObject! !

!CMSpecEntitiesBrowser methodsFor: 'accessing-menu' stamp: 'HernanMoralesDurand 1/24/2018 18:46'!
subMenuForEditEntity

	^ MenuModel new
		addGroup: [ : group |
			group 
				addItem: [ : item | 				
					item
						name: self translator tAttributes;
						action: [ self openEditAttributes ] ];
				addItem: [ : item | 
					item 
						name: self translator tMethods;
						action: [ self entityEditMethods ] ];
				addItem: [ : item | 
					item 
						name: self translator tActivityDiagrams;
						action: [ self entityEditActivityDiagrams ] ];
				addItem: [ : item | 
					item 
						name: self translator tPoVSetter;
						action: [ self entityEditPoVSetter ] ] ]
! !

!CMSpecEntitiesBrowser methodsFor: 'initialization' stamp: ''!
title
	^ 'Entities'! !

CMSpecObject subclass: #CMSpecEntityAddInterface
	instanceVariableNames: 'entityName toolbar rbEntityElementType rbCellGroup rbConfigGroup entitySuperclass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Core'!

!CMSpecEntityAddInterface commentStamp: 'HernanMoralesDurand 8/12/2017 14:03' prior: 0!
CMSpecEntityAddInterface new openWithSpec.!

!CMSpecEntityAddInterface class methodsFor: 'specs' stamp: 'HernanMoralesDurand 9/16/2017 20:43'!
defaultSpec
	<spec: #default>

	^ SpecLayout composed
		newColumn: [ : r | 
			r 
				newRow: [ : col | col 
					add: #rbEntityElementType;
					add: #rbCellGroup ] height: 60;
				newRow: [ : col | col
					add: #rbConfigGroup ];
				add: #entityName height: self toolbarHeight + 5;
				add: #toolbar height: self toolbarHeight ];	


	yourself	! !

!CMSpecEntityAddInterface methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 9/30/2017 02:50'!
addActionBlock: aBlockClosure 
	" Private - Delegate the receiver's action block to its owner "

	self owner addActionBlock: aBlockClosure.! !

!CMSpecEntityAddInterface methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 9/30/2017 02:49'!
addEntity

	self validateEntity.
	self delete.
! !

!CMSpecEntityAddInterface methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 10/3/2017 19:27'!
addNewSpatialEntityGUI
	
	| superClass newName aClass |

	aClass := self spatialEntitySuperclass value = #CMSpatialEntityCell
		ifTrue: [self cellOrCA value]
		ifFalse: [self spatialEntitySuperclass value].
	superClass := aClass class.
	self cormas addNewClassType: 'Spatial' inheritingFrom: superClass name:
			newName initProtocol: false stepProtocol: false.
	self closeRequest! !

!CMSpecEntityAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/12/2017 13:20'!
entityName
	" Answer the entityName of this CMSpecEntityAddInterface "

	^ entityName! !

!CMSpecEntityAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/12/2017 13:20'!
entityName: anObject
	" Sets the entityName of this CMSpecEntityAddInterface "

	entityName := anObject! !

!CMSpecEntityAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/3/2017 19:32'!
entitySuperclass
	^ entitySuperclass! !

!CMSpecEntityAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/3/2017 19:32'!
entitySuperclass: anObject
	entitySuperclass := anObject! !

!CMSpecEntityAddInterface methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/24/2017 13:16'!
initialExtent

	^ 400 @ 300! !

!CMSpecEntityAddInterface methodsFor: 'initialization' stamp: 'HernanMoralesDurand 10/23/2017 01:29'!
initializeEntityOptions
	" EntityAdditionInterface>>postBuildWith: "

	self cormas spaceModel isNil "cellClass."
		ifTrue: [ 
			self entitySuperclass: CMSpatialEntityCell.
			"self cellOrCA value: #SpatialEntityElement."
			self rbEntityElementType enable.
			self rbSimpleCell enable.
			self rbCellularAutomaton enable.
			"(aBuilder componentAt: #LabelSpecialize) disable."
			self rbAggregate disable.
			self rbSetNoConnex disable ]! !

!CMSpecEntityAddInterface methodsFor: 'initialization' stamp: 'HernanMoralesDurand 10/3/2017 18:51'!
initializePresenter
	" Private - See superimplementor's comment "

	self setActionsForRb.
	self 
		bindKeyCombination: $o meta 
		toAction: [ self triggerOkAction ].
	self initializeEntityOptions.! !

!CMSpecEntityAddInterface methodsFor: 'initialization' stamp: 'HernanMoralesDurand 9/30/2017 15:12'!
initializeRbItems

	self rbEntityElementType
		label: self translator tElement;
		help: self translator tSpatialEntityCellHelp.
		
	self rbSimpleCell
		label: self translator tSimpleCell;
		help: self translator tSimpleCellHelp.
		
	self rbCellularAutomaton 
		label: self translator tCellularAutomaton;
		help: self translator tCellAutomatonHelp.
		
	self rbAggregate 
		label: self translator tAggregate;
		help: self translator tSpatialEntityHelp.
		
	self rbSetNoConnex 
		label: self translator tSetNotConnex;
		help: self translator tSetNotConnexHelp! !

!CMSpecEntityAddInterface methodsFor: 'initialization' stamp: 'HernanMoralesDurand 9/30/2017 15:13'!
initializeWidgets
	" Private - See superimplementor's comment "

	self instantiateModels: #(
		rbEntityElementType 	RadioButtonModel
		rbCellGroup 				SpcRadioButtonGroup
		rbConfigGroup 			SpcRadioButtonGroup
		entityName 				SpcLabeledTextField			
		toolbar 					SpcThreeButtonToolbar).

	self entityName label: self translator tName.
	self setFocus.
	self setToolbar.
	self initializeRbItems.! !

!CMSpecEntityAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/16/2017 21:53'!
rbAggregate

	^ self rbConfigGroup button1! !

!CMSpecEntityAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/16/2017 21:51'!
rbCellGroup
	^ rbCellGroup! !

!CMSpecEntityAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/16/2017 21:51'!
rbCellGroup: anObject
	rbCellGroup := anObject! !

!CMSpecEntityAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/16/2017 21:52'!
rbCellularAutomaton

	^ self rbCellGroup button2! !

!CMSpecEntityAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/16/2017 21:53'!
rbConfigGroup
	^ rbConfigGroup! !

!CMSpecEntityAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/16/2017 21:53'!
rbConfigGroup: anObject
	rbConfigGroup := anObject! !

!CMSpecEntityAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/12/2017 14:16'!
rbEntityElementType
	" Answer the entityElementType of this CMSpecEntityAddInterface "

	^ rbEntityElementType! !

!CMSpecEntityAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/12/2017 14:16'!
rbEntityElementType: anObject
	" Sets the entityElementType of this CMSpecEntityAddInterface "

	rbEntityElementType := anObject! !

!CMSpecEntityAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/16/2017 23:02'!
rbSetNoConnex

	^ self rbConfigGroup button2.! !

!CMSpecEntityAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/16/2017 21:51'!
rbSimpleCell

	^ self rbCellGroup button1! !

!CMSpecEntityAddInterface methodsFor: 'initialization' stamp: 'HernanMoralesDurand 8/12/2017 14:22'!
setActionsForRb

	self rbEntityElementType whenActivatedDo: [  ].
	self rbEntityElementType whenDeactivatedDo: [  ].
	
	self rbSimpleCell whenActivatedDo: [  ].
	self rbSimpleCell whenDeactivatedDo: [  ].

! !

!CMSpecEntityAddInterface methodsFor: 'initialization' stamp: 'HernanMoralesDurand 8/12/2017 14:12'!
setFocus

	self focusOrder
		add: self entityName;
		add: self toolbar! !

!CMSpecEntityAddInterface methodsFor: 'initialization' stamp: 'HernanMoralesDurand 9/30/2017 02:49'!
setToolbar
	self toolbar 
		firstButtonLabel: 'Help';
		firstButtonAction: [ self openHelp ];
		secondButtonLabel: 'Cancel';
		secondButtonAction: [ self delete ];
		thirdButtonLabel: 'Ok';
		thirdButtonAction: [ self addEntity. ]
! !

!CMSpecEntityAddInterface methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 12/13/2017 01:01'!
spatialEntitySuperclass

	^ Smalltalk at: #CMSpatialEntityAggregate! !

!CMSpecEntityAddInterface methodsFor: 'initialization' stamp: ''!
title
	^ 'Create a kind of Entity'! !

!CMSpecEntityAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/12/2017 13:20'!
toolbar
	" Answer the toolbar of this CMSpecEntityAddInterface "

	^ toolbar! !

!CMSpecEntityAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/12/2017 13:20'!
toolbar: anObject
	" Sets the toolbar of this CMSpecEntityAddInterface "

	toolbar := anObject! !

!CMSpecEntityAddInterface methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 9/30/2017 02:46'!
validateEntity

	| newClassName |
	
	(newClassName := self entityName textValuePending) isEmpty 
		ifTrue: [ ^ self informMessage: self translator tEnterClassName ].
	^ self owner addItem: newClassName trimBoth! !

CMSpecObject subclass: #CMSpecInitialValueChooser
	instanceVariableNames: 'setterAccessorCheckbox getterAccessorCheckbox notifyObsCheckbox toolbar initialRBGroup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Core'!

!CMSpecInitialValueChooser commentStamp: 'HernanMoralesDurand 11/20/2017 19:31' prior: 0!
CMSpecInitialValueChooser new openWithSpec.

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	arrayRadioButton:		<Object>
	booleanRadioButton:		<Object>
	collectionRadioButton:		<Object>
	getterAccessorCheckbox:		<Object>
	initialValueRadio:		<Object>
	newEntityRadioButton:		<Object>
	noValueRadioButton:		<Object>
	notifyObsCheckbox:		<Object>
	numberRadioButton:		<Object>
	randomRadioButton:		<Object>
	setterAccessorCheckbox:		<Object>
	stringRadioButton:		<Object>
	toolbar:		<Object>


    Implementation Points!

!CMSpecInitialValueChooser class methodsFor: 'specs' stamp: 'HernanMoralesDurand 11/24/2017 02:31'!
defaultSpec

    <spec>
    ^ SpecLayout composed
			newColumn: [ : c | 
				c 
					newRow: [ : r | r add: #setterAccessorCheckbox ] origin: 0 @ 0 corner: 0 @ 0.1;
					newRow: [ : r | r 
						add: #getterAccessorCheckbox;
						add: #notifyObsCheckbox ] origin: 0 @ 0.35 corner: 0 @ 0.5 ]
			origin: 0.05 @ 0.03 corner: 0.95 @ 0.4;
			newColumn: [ : c | c add: #initialRBGroup ]
			origin: 0.05 @ 0.15 corner: 0.95 @ 1;
			newRow: [ : r | r add: #toolbar ] origin: 0 @ 0.9 corner: 1 @ 1;
			yourself.! !

!CMSpecInitialValueChooser methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/20/2017 17:38'!
getterAccessorCheckbox
	" Answer the getterAccessorCheckbox of this CMSpecInitialValueChooser "

	^ getterAccessorCheckbox! !

!CMSpecInitialValueChooser methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/20/2017 17:38'!
getterAccessorCheckbox: anObject
	" Sets the getterAccessorCheckbox of this CMSpecInitialValueChooser "

	getterAccessorCheckbox := anObject! !

!CMSpecInitialValueChooser methodsFor: 'api' stamp: 'HernanMoralesDurand 11/24/2017 02:30'!
initialExtent

	^ 500 @ 450! !

!CMSpecInitialValueChooser methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/20/2017 19:44'!
initialRBGroup
	" Answer the initialValueRadio of this CMSpecInitialValueChooser "

	^ initialRBGroup! !

!CMSpecInitialValueChooser methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/20/2017 19:45'!
initialRBGroup: anObject
	" Sets the initialValueRadio of this CMSpecInitialValueChooser "

	initialRBGroup := anObject! !

!CMSpecInitialValueChooser methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/20/2017 19:44'!
initializeFocus

	self focusOrder
		add: self setterAccessorCheckbox;
		add: self getterAccessorCheckbox;
		add: self notifyObsCheckbox;
		add: self initialRBGroup;
		add: self toolbar! !

!CMSpecInitialValueChooser methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/23/2017 20:45'!
initializeLabels
	" Private - See superimplementor's comment "

	self setterAccessorCheckbox label: self translator tSetterAccessor.
	self getterAccessorCheckbox label: self translator tGetterAccessor.
	self notifyObsCheckbox label: self translator tNotifyObs.
	self toolbar
		firstButtonLabel: self translator tCancel;
		secondButtonLabel: self translator tOk.

! !

!CMSpecInitialValueChooser methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/24/2017 13:18'!
initializePresenter
	" Private - See superimplementor's comment "

	self setterAccessorCheckbox state: true.
	self getterAccessorCheckbox state: true.
! !

!CMSpecInitialValueChooser methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/23/2017 20:46'!
initializeWidgets
	" Private - See superimplementor's comment "

	self
		instantiateModels: #(
			setterAccessorCheckbox 	CheckBoxModel 
			getterAccessorCheckbox 	CheckBoxModel 
			notifyObsCheckbox 			CheckBoxModel 
			initialRBGroup 				CMSpecInitialValueSetter			
			toolbar 						SpcTwoButtonToolbar).
									
	self initializeLabels.
	self initializeFocus.! !

!CMSpecInitialValueChooser methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/20/2017 17:38'!
notifyObsCheckbox
	" Answer the notifyObsCheckbox of this CMSpecInitialValueChooser "

	^ notifyObsCheckbox! !

!CMSpecInitialValueChooser methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/20/2017 17:38'!
notifyObsCheckbox: anObject
	" Sets the notifyObsCheckbox of this CMSpecInitialValueChooser "

	notifyObsCheckbox := anObject! !

!CMSpecInitialValueChooser methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/20/2017 17:38'!
setterAccessorCheckbox
	" Answer the setterAccessorCheckbox of this CMSpecInitialValueChooser "

	^ setterAccessorCheckbox! !

!CMSpecInitialValueChooser methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/20/2017 17:38'!
setterAccessorCheckbox: anObject
	" Sets the setterAccessorCheckbox of this CMSpecInitialValueChooser "

	setterAccessorCheckbox := anObject! !

!CMSpecInitialValueChooser methodsFor: 'api' stamp: 'HernanMoralesDurand 11/21/2017 02:03'!
title

	^ self translator tInitialValueChooser! !

!CMSpecInitialValueChooser methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/20/2017 17:38'!
toolbar
	" Answer the toolbar of this CMSpecInitialValueChooser "

	^ toolbar! !

!CMSpecInitialValueChooser methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/20/2017 17:38'!
toolbar: anObject
	" Sets the toolbar of this CMSpecInitialValueChooser "

	toolbar := anObject! !

CMSpecObject subclass: #CMSpecInitialValueSetter
	instanceVariableNames: 'numberRadioButton randomRadioButton booleanRadioButton stringRadioButton collectionRadioButton arrayRadioButton newEntityRadioButton noValueRadioButton numberTextField randomTextField booleanList stringTextField collectionList arrayTextField newEntityTextField initialValueLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Core'!

!CMSpecInitialValueSetter commentStamp: 'HernanMoralesDurand 1/17/2018 17:54' prior: 0!
CMSpecInitialValueSetter example.

Internal Representation and Key Implementation Points.

    Instance Variables
	arrayRadioButton:		<Object>
	arrayTextField:		<Object>
	booleanList:		<Object>
	booleanRadioButton:		<Object>
	collectionList:		<Object>
	collectionRadioButton:		<Object>
	initialValueLabel:		<Object>
	newEntityRadioButton:		<Object>
	newEntityTextField:		<Object>
	noValueRadioButton:		<Object>
	numberRadioButton:		<Object>
	numberTextField:		<Object>
	randomRadioButton:		<Object>
	randomTextField:		<Object>
	stringRadioButton:		<Object>
	stringTextField:		<Object>


    Implementation Points!

!CMSpecInitialValueSetter class methodsFor: 'specs' stamp: 'HernanMoralesDurand 11/23/2017 20:40'!
defaultSpec
	<spec: #default>
	
	^ SpecLayout composed
		newColumn: [ : column |
			column 
				newRow: [ : r |	r add: #initialValueLabel ] height: self inputTextHeight + 4;
				newRow: [ : r |	r add: #numberRadioButton; add: #numberTextField ] height: self inputTextHeight + 4;
				newRow: [ : r |	r add: #randomRadioButton; add: #randomTextField ] height: self inputTextHeight + 4;
				newRow: [ : r |	r add: #booleanRadioButton; add: #booleanList ] height: self inputTextHeight + 4;
				newRow: [ : r |	r add: #stringRadioButton; add: #stringTextField ] height: self inputTextHeight;
				newRow: [ : r |	r add: #collectionRadioButton; add: #collectionList ] height: self inputTextHeight + 4;
				newRow: [ : r |	r add: #arrayRadioButton; add: #arrayTextField ] height: self inputTextHeight + 4;
				newRow: [ : r |	r add: #newEntityRadioButton; add: #newEntityTextField ] height: self inputTextHeight;
				newRow: [ : r |	r add: #noValueRadioButton ] height: self inputTextHeight + 4;
					
				newRow: [ : r |	 ] 	] 			
		yourself! !

!CMSpecInitialValueSetter class methodsFor: 'example' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
example

	^ self basicNew 
		projectManager: (CMProjectManager new projectWindow: self);
		translator: (CMTranslator newForLanguage: #EN);
		initialize;
		openWithSpec! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:26'!
arrayRadioButton
	^ arrayRadioButton! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:26'!
arrayRadioButton: anObject
	arrayRadioButton := anObject! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:34'!
arrayTextField
	^ arrayTextField! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:34'!
arrayTextField: anObject
	arrayTextField := anObject! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:34'!
booleanList
	^ booleanList! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:34'!
booleanList: anObject
	booleanList := anObject! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:23'!
booleanRadioButton
	^ booleanRadioButton! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:23'!
booleanRadioButton: anObject
	booleanRadioButton := anObject! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:34'!
collectionList
	^ collectionList! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:34'!
collectionList: anObject
	collectionList := anObject! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:26'!
collectionRadioButton
	^ collectionRadioButton! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:26'!
collectionRadioButton: anObject
	collectionRadioButton := anObject! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:39'!
initialValueLabel
	^ initialValueLabel! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:39'!
initialValueLabel: anObject
	initialValueLabel := anObject! !

!CMSpecInitialValueSetter methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/23/2017 23:05'!
initializeLabels

	self initialValueLabel label: self translator tInitialValueLabel.
	self numberRadioButton label: self translator tNumber.
	self randomRadioButton label: self translator tRandom.
	self booleanRadioButton label: self translator tBoolean.
	self stringRadioButton label: self translator tStringSymbol.
	self collectionRadioButton label: self translator tCollectionEmpty.
	self arrayRadioButton label: self translator tArray.
	self newEntityRadioButton label: self translator tNewEntity.
	self noValueRadioButton label: self translator tNoValue.! !

!CMSpecInitialValueSetter methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/24/2017 13:22'!
initializePresenter

	self booleanList 
		items: #(true false).
	self collectionList items: #(#OrderedCollection #Set #Dictionary).
	
! !

!CMSpecInitialValueSetter methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/24/2017 02:24'!
initializeWidgets

	self
		instantiateModels: #(
			initialValueLabel 			LabelModel		
			numberRadioButton 			SpcRadioButtonModel
			numberTextField 			TextInputFieldModel						
			randomRadioButton 			SpcRadioButtonModel
			randomTextField 			TextInputFieldModel
			booleanRadioButton 		SpcRadioButtonModel
			booleanList 					DropListModel					
			stringRadioButton 			SpcRadioButtonModel
			stringTextField 			TextInputFieldModel						
			collectionRadioButton 	SpcRadioButtonModel
			collectionList				DropListModel
			arrayRadioButton 			SpcRadioButtonModel
			arrayTextField 				TextInputFieldModel
			newEntityRadioButton 		SpcRadioButtonModel
			newEntityTextField 		TextInputFieldModel			
			noValueRadioButton			SpcRadioButtonModel).
						
	self initializeLabels.
	self setFocus.
	self setGroup! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:26'!
newEntityRadioButton
	^ newEntityRadioButton! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:26'!
newEntityRadioButton: anObject
	newEntityRadioButton := anObject! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:34'!
newEntityTextField
	^ newEntityTextField! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:34'!
newEntityTextField: anObject
	newEntityTextField := anObject! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:26'!
noValueRadioButton
	^ noValueRadioButton! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:26'!
noValueRadioButton: anObject
	noValueRadioButton := anObject! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:23'!
numberRadioButton
	^ numberRadioButton! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:23'!
numberRadioButton: anObject
	numberRadioButton := anObject! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:34'!
numberTextField
	^ numberTextField! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:34'!
numberTextField: anObject
	numberTextField := anObject! !

!CMSpecInitialValueSetter methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/24/2017 13:24'!
on: button show: aMorph

	button whenActivatedDo: [ self requestText: self translator tFillArray title: 'CORMAS' ].
! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:23'!
randomRadioButton
	^ randomRadioButton! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:23'!
randomRadioButton: anObject
	randomRadioButton := anObject! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:34'!
randomTextField
	^ randomTextField! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:34'!
randomTextField: anObject
	randomTextField := anObject! !

!CMSpecInitialValueSetter methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/23/2017 20:23'!
setFocus
	
"	self focusOrder
		add: button1;
		add: button2;
		add: button3.
	"! !

!CMSpecInitialValueSetter methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/23/2017 20:28'!
setGroup

	RadioButtonGroupModel new
		addRadioButton: numberRadioButton;
		addRadioButton: randomRadioButton;
		addRadioButton: booleanRadioButton;
		addRadioButton: stringRadioButton;
		addRadioButton: collectionRadioButton;
		addRadioButton: arrayRadioButton;
		addRadioButton: newEntityRadioButton;
		addRadioButton: noValueRadioButton;
		default: numberRadioButton.! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:26'!
stringRadioButton
	^ stringRadioButton! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:26'!
stringRadioButton: anObject
	stringRadioButton := anObject! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:34'!
stringTextField
	^ stringTextField! !

!CMSpecInitialValueSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/23/2017 20:34'!
stringTextField: anObject
	stringTextField := anObject! !

CMSpecObject subclass: #CMSpecModelComments
	instanceVariableNames: 'authorList modelText versionName toolbar creationDate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Core'!

!CMSpecModelComments commentStamp: 'HernanMoralesDurand 1/21/2018 01:51' prior: 0!
CMSpecModelComments example.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.


    Implementation Points!

!CMSpecModelComments class methodsFor: 'specs' stamp: 'HernanMoralesDurand 8/9/2017 02:52'!
defaultSpec

	^ SpecLayout composed
		newColumn: [ : c  |
				c newRow: [ : s |
					s
						add: #versionName;
						add: #creationDate ] height: self toolbarHeight;
				add: #authorList;
				add: #modelText;
				add: #toolbar height: self toolbarHeight ];
		yourself 
		
		
		! !

!CMSpecModelComments methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
addModelComments
	" Private - User has clicked Ok to add model comments "
	
	self projectManager 
		cormasModelCreationDate: self creationDate textValuePending;
		cormasModelVersion: self versionName textValuePending;
		cormasModelAuthors: self authorList authors;
		cormasModelEmails: self authorList emails;
		cormasModelText: self modelText textValuePending.
		
! !

!CMSpecModelComments methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/15/2017 17:35'!
authorList
	" Answer a <CMGrowableAuthorList> "

	^ authorList! !

!CMSpecModelComments methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/8/2017 04:46'!
authorList: anObject
	authorList := anObject! !

!CMSpecModelComments methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/9/2017 02:46'!
creationDate
	^ creationDate! !

!CMSpecModelComments methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/9/2017 02:46'!
creationDate: anObject
	creationDate := anObject! !

!CMSpecModelComments methodsFor: 'api' stamp: 'HernanMoralesDurand 8/8/2017 04:54'!
initialExtent
	"Answer the initial extent for the receiver."
	
	^ 600 @ 400! !

!CMSpecModelComments methodsFor: 'initialization' stamp: 'HernanMoralesDurand 10/15/2017 17:56'!
initializePresenter
	" Private - See superimplementor's comment "
	
	self versionName
		label: self translator tVersionName;
		ghostText: '1.0'.
	self creationDate 
		label: self translator tCreationDate;
		ghostText: Date today asString.
	self modelText
		label: self translator tModelComments.
	self toolbar 
"		firstButtonLabel: 'Cancel';
		firstButtonAction: [ self delete ];"
		firstButtonLabel: 'Ok';
		firstButtonAction: [ 
			self addModelComments.
			self delete ]! !

!CMSpecModelComments methodsFor: 'initialization' stamp: 'HernanMoralesDurand 10/10/2017 00:51'!
initializeWidgets
	" Private - See superimplementor's comment "
	
	self instantiateModels: #(
		versionName 			SpcLabeledTextField
		creationDate 		SpcLabeledTextField
		authorList 			CMGrowableAuthorList
		modelText 			SpcLabeledTextArea
		toolbar 				SpcOneButtonToolbar
		).
	self focusOrder 
		add: self authorList;
		add: self toolbar.! !

!CMSpecModelComments methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/8/2017 04:50'!
modelText
	^ modelText! !

!CMSpecModelComments methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/8/2017 04:50'!
modelText: anObject
	modelText := anObject! !

!CMSpecModelComments methodsFor: 'api' stamp: 'HernanMoralesDurand 10/16/2017 15:14'!
title
	" Private - See superimplementor's comment "

	^ 'Model Comments'! !

!CMSpecModelComments methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/8/2017 04:50'!
toolbar
	^ toolbar! !

!CMSpecModelComments methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/8/2017 04:50'!
toolbar: anObject
	toolbar := anObject! !

!CMSpecModelComments methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/15/2017 17:35'!
versionName
	" Answer a <SpcLabeledTextField> with version information "

	^ versionName! !

!CMSpecModelComments methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/9/2017 02:46'!
versionName: anObject
	versionName := anObject! !

!CMSpecObject class methodsFor: 'examples' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
example

	^ self basicNew 
		projectManager: (CMProjectManager new projectWindow: self);
		translator: (CMTranslator newForLanguage: #EN);
		initialize;
		openWithSpec! !

!CMSpecObject class methodsFor: 'instance creation' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
for: aCMProjectManager 
	" Answer a new instance of the receiver using aCMProjectManager as model "
	
	^ self basicNew 
		projectManager: aCMProjectManager;
		initialize;
		yourself! !

!CMSpecObject class methodsFor: 'instance creation' stamp: 'HernanMoralesDurand 4/7/2018 17:27'!
openFor: aCMProjectManager 
	" Create and open a new instance of the receiver, configuring its controller with aCMProjectManager"

	^ (self for: aCMProjectManager)
		openWithSpec;
		centered;
		yourself! !

!CMSpecObject class methodsFor: 'instance creation' stamp: 'HernanMoralesDurand 9/26/2017 18:32'!
openModalFor: aCMProjectManager 

	^ (self for: aCMProjectManager)
		initialize;
		openDialogWithSpec;
		centered;
		yourself! !

!CMSpecObject class methodsFor: 'instance creation' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
owner: owner
	" Answer a new instance of the receiver configuring project settings "
	
	^ self basicNew
		owner: owner;
		projectManager: owner projectManager;
		initialize;
		yourself.! !

!CMSpecObject methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/25/2017 19:46'!
alertNameAlreadyExist
	" Raise an alert modal message "

	^ self alertMessage: self translator tAlreadyUsed! !

!CMSpecObject methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
cormas
	" Answer a CMProjectModel "
	
	^ self projectManager cormasModel! !

!CMSpecObject methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
cormasModel
	" Answer a CMProjectModel "
	
	^ self projectManager cormasModel! !

!CMSpecObject methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
cormasModelClass
	" Answer a CMProjectModel class "
	
	^ self projectManager cormasModelClass! !

!CMSpecObject methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/26/2017 02:24'!
iconNamed: aSymbol
	" Answer a <> "

	^ CMIcons perform: aSymbol! !

!CMSpecObject methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 11/7/2017 20:40'!
openHelp
	self shouldBeImplemented.! !

!CMSpecObject methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/7/2018 17:19'!
projectManager
	^ projectManager! !

!CMSpecObject methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/7/2018 17:19'!
projectManager: aCMProjectManager
	" Set the receiver's project "

	projectManager := aCMProjectManager! !

!CMSpecObject methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
translator
	" Answer the project <PFTranslator> "

	^ self projectManager translator! !

!CMSpecObject methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
translator: aPFTranslator
	" Answer the project <PFTranslator> "

	^ self projectManager translator: aPFTranslator! !

CMSpecObject subclass: #CMSpecPassiveAddInterface
	instanceVariableNames: 'entityName toolbar rbTypeGroup entitySuperclass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Core'!

!CMSpecPassiveAddInterface class methodsFor: 'specs' stamp: 'HernanMoralesDurand 10/31/2017 03:03'!
defaultSpec
	<spec: #default>

	^ SpecLayout composed
		newColumn: [ : r | 
			r 
				newRow: [ : col | col 
					add: #rbTypeGroup ] height: 300;
				add: #entityName height: self toolbarHeight + 5;
				add: #toolbar height: self toolbarHeight ];	
	yourself	! !

!CMSpecPassiveAddInterface methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 10/29/2017 00:42'!
addActionBlock: aBlockClosure 
	" Private - Delegate the receiver's action block to its owner "

	self owner addActionBlock: aBlockClosure.! !

!CMSpecPassiveAddInterface methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 10/29/2017 00:42'!
addNewSpatialEntityGUI
	
	| superClass newName aClass |

	aClass := self spatialEntitySuperclass value = #CMSpatialEntityCell
		ifTrue: [self cellOrCA value]
		ifFalse: [self spatialEntitySuperclass value].
	superClass := aClass class.
	self cormas addNewClassType: 'Spatial' inheritingFrom: superClass name:
			newName initProtocol: false stepProtocol: false.
	self closeRequest! !

!CMSpecPassiveAddInterface methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 10/31/2017 03:04'!
addPassiveObject

	self shouldBeImplemented.! !

!CMSpecPassiveAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/29/2017 00:42'!
entityName
	" Answer the entityName of this CMSpecEntityAddInterface "

	^ entityName! !

!CMSpecPassiveAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/29/2017 00:42'!
entityName: anObject
	" Sets the entityName of this CMSpecEntityAddInterface "

	entityName := anObject! !

!CMSpecPassiveAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/29/2017 00:42'!
entitySuperclass
	^ entitySuperclass! !

!CMSpecPassiveAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/29/2017 00:42'!
entitySuperclass: anObject
	entitySuperclass := anObject! !

!CMSpecPassiveAddInterface methodsFor: 'initialization' stamp: 'HernanMoralesDurand 10/31/2017 03:03'!
initialExtent

	^ 300 @ 400! !

!CMSpecPassiveAddInterface methodsFor: 'initialization' stamp: 'HernanMoralesDurand 10/29/2017 20:18'!
initializeEntityOptions
	" EntityAdditionInterface>>postBuildWith: "

	self cormas spaceModel isNil "cellClass."
		ifTrue: [ 
			"self entitySuperclass: CMSpatialEntityCell."
			"self cellOrCA value: #SpatialEntityElement."
"			self rbEntityElementType enable.
			self rbSimpleCell enable.
			self rbCellularAutomaton enable."
			"(aBuilder componentAt: #LabelSpecialize) disable."
"			self rbAggregate disable.
			self rbSetNoConnex disable" ]! !

!CMSpecPassiveAddInterface methodsFor: 'initialization' stamp: 'HernanMoralesDurand 10/29/2017 00:42'!
initializePresenter
	" Private - See superimplementor's comment "

	self setActionsForRb.
	self 
		bindKeyCombination: $o meta 
		toAction: [ self triggerOkAction ].
	self initializeEntityOptions.! !

!CMSpecPassiveAddInterface methodsFor: 'initialization' stamp: 'HernanMoralesDurand 10/29/2017 19:59'!
initializeRbItems
	" Private - Initialize radio button items "

	self rbTypeGroup buttonObject
		label: self translator tObject;
		help: self translator tObjectHelp.
		
	self rbTypeGroup buttonLocatedObject
		label: self translator tLocatedObject;
		help: self translator tLocatedObjectHelp.
		
	self rbTypeGroup buttonNetworkNode
		label: self translator tNetworkNode;
		help: self translator tNetworkNodeHelp.
		
	self rbTypeGroup buttonNetworkArc
		label: self translator tNetworkArc;
		help: self translator tNetworkArcHelp.
		
	self rbTypeGroup buttonFullNetwork
		label: self translator tFullNetwork;
		help: self translator tFullNetworkHelp.
		
	self rbTypeGroup buttonMessage
		label: self translator tMessage;
		help: self translator tMessageHelp! !

!CMSpecPassiveAddInterface methodsFor: 'initialization' stamp: 'HernanMoralesDurand 10/29/2017 19:58'!
initializeWidgets
	" Private - See superimplementor's comment "

	self instantiateModels: #(
		rbTypeGroup 				CMSpecPassiveAddRBGroup
		entityName 				SpcLabeledTextField			
		toolbar 					SpcOneButtonToolbar).

	self entityName label: self translator tName.
	self setFocus.
	self setToolbar.
	self initializeRbItems.! !

!CMSpecPassiveAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/29/2017 00:44'!
rbTypeGroup
	^ rbTypeGroup! !

!CMSpecPassiveAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/29/2017 00:44'!
rbTypeGroup: anObject
	rbTypeGroup := anObject! !

!CMSpecPassiveAddInterface methodsFor: 'initialization' stamp: 'HernanMoralesDurand 10/29/2017 20:17'!
setActionsForRb
	"  buttonNetworkNode buttonNetworkArc buttonFullNetwork buttonMessage "
	self rbTypeGroup buttonObject whenActivatedDo: [  ].
	self rbTypeGroup buttonObject whenDeactivatedDo: [  ].
	
	self rbTypeGroup buttonLocatedObject whenActivatedDo: [  ].
	self rbTypeGroup buttonLocatedObject whenDeactivatedDo: [  ].

! !

!CMSpecPassiveAddInterface methodsFor: 'initialization' stamp: 'HernanMoralesDurand 10/29/2017 00:42'!
setFocus

	self focusOrder
		add: self entityName;
		add: self toolbar! !

!CMSpecPassiveAddInterface methodsFor: 'initialization' stamp: 'HernanMoralesDurand 10/29/2017 00:46'!
setToolbar

	self toolbar 
		firstButtonLabel: 'Ok';
		firstButtonAction: [ self addPassiveObject ]
! !

!CMSpecPassiveAddInterface methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 12/13/2017 01:01'!
spatialEntitySuperclass

	^ Smalltalk at: #CMSpatialEntityAggregate! !

!CMSpecPassiveAddInterface methodsFor: 'initialization' stamp: 'HernanMoralesDurand 10/29/2017 00:42'!
title
	^ 'Create a kind of Entity'! !

!CMSpecPassiveAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/29/2017 00:42'!
toolbar
	" Answer the toolbar of this CMSpecEntityAddInterface "

	^ toolbar! !

!CMSpecPassiveAddInterface methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/29/2017 00:42'!
toolbar: anObject
	" Sets the toolbar of this CMSpecEntityAddInterface "

	toolbar := anObject! !

!CMSpecPassiveAddInterface methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 10/29/2017 00:42'!
validateEntity

	| newClassName |
	
	(newClassName := self entityName textValuePending) isEmpty 
		ifTrue: [ ^ self informMessage: self translator tEnterClassName ].
	^ self owner addItem: newClassName trimBoth! !

CMSpecObject subclass: #CMSpecPovColor
	instanceVariableNames: 'colorChooser applyButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-PoV'!

!CMSpecPovColor commentStamp: 'HernanMoralesDurand 1/18/2018 02:54' prior: 0!
CMSpecPovColor example.

For the Responsibility part: Three sentences about my main responsibilities - what I do, what I know.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	applyButton:		<Object>
	colorChooser:		<Object>


    Implementation Points!

!CMSpecPovColor class methodsFor: 'specs' stamp: 'HernanMoralesDurand 1/18/2018 02:59'!
defaultSpec

    <spec>
    ^ SpecLayout composed
		newColumn: [ : c | 
			c
				add: #colorChooser;
				add: #applyButton height: self toolbarHeight ]! !

!CMSpecPovColor methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/17/2018 19:22'!
applyButton
	" Answer the applyButton of this CMSpecPovColor "

	^ applyButton! !

!CMSpecPovColor methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/17/2018 19:22'!
applyButton: anObject
	" Sets the applyButton of this CMSpecPovColor "

	applyButton := anObject! !

!CMSpecPovColor methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/17/2018 19:22'!
colorChooser
	" Answer the colorChooser of this CMSpecPovColor "

	^ colorChooser! !

!CMSpecPovColor methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/17/2018 19:22'!
colorChooser: anObject
	" Sets the colorChooser of this CMSpecPovColor "

	colorChooser := anObject! !

!CMSpecPovColor methodsFor: 'initialization' stamp: 'HernanMoralesDurand 1/21/2018 01:59'!
initialExtent
	"Answer the initial extent for the receiver."
	
	^ 600 @ 300
! !

!CMSpecPovColor methodsFor: 'initialization' stamp: 'HernanMoralesDurand 1/17/2018 19:22'!
initializeFocus
	" Private - See superimplementor's comment "

	self focusOrder
		add: self colorChooser;
	add: self applyButton. ! !

!CMSpecPovColor methodsFor: 'initialization' stamp: 'HernanMoralesDurand 1/17/2018 19:22'!
initializePresenter
	" Private - See superimplementor's comment "

	self colorChooser.
self applyButton.
.! !

!CMSpecPovColor methodsFor: 'initialization' stamp: 'HernanMoralesDurand 1/18/2018 02:54'!
initializeWidgets
	" Private - See superimplementor's comment "

	self instantiateModels: #(
		colorChooser		SpcColorChooserModel		
		applyButton		ButtonModel
	).
	self initializeFocus.! !

!CMSpecPovColor methodsFor: 'initialization' stamp: 'HernanMoralesDurand 1/17/2018 19:22'!
title
	" Private - See superimplementor's comment "

	^ 'PoV definition'! !

CMSpecObject subclass: #CMSpecPovDefinition
	instanceVariableNames: 'methodsList symbolsList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-PoV'!

!CMSpecPovDefinition commentStamp: 'HernanMoralesDurand 1/17/2018 17:57' prior: 0!
CMSpecPovDefinition example.

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	methodsList:		<Object>
	symbolsList:		<Object>
	toolbar:		<Object>


    Implementation Points!

!CMSpecPovDefinition class methodsFor: 'specs' stamp: 'HernanMoralesDurand 1/12/2018 20:03'!
defaultSpec

    <spec>
    ^ SpecLayout composed
		newRow: [ : r | 
			r
				add: #methodsList;
				add: #symbolsList ]! !

!CMSpecPovDefinition methodsFor: 'initialization' stamp: 'HernanMoralesDurand 12/20/2017 00:37'!
initialExtent
	"Answer the initial extent for the receiver."
	
	^ 600 @ 400
! !

!CMSpecPovDefinition methodsFor: 'initialization' stamp: 'HernanMoralesDurand 1/12/2018 20:03'!
initializeFocus
	" Private - See superimplementor's comment "

	self focusOrder
		add: self methodsList;
		add: self symbolsList! !

!CMSpecPovDefinition methodsFor: 'initialization' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
initializePresenter
	" Private - See superimplementor's comment "

	self methodsList
		editActionBlock: [ 
			Smalltalk tools browser 
				openOnClass: self projectManager cormasModelClass 
				selector: self methodsList selectedItem ].

	self symbolsList

	! !

!CMSpecPovDefinition methodsFor: 'initialization' stamp: 'HernanMoralesDurand 4/12/2018 02:48'!
initializeWidgets
	" Private - See superimplementor's comment "

	self instantiateModels: #(
		methodsList		SpcEditableList		
		symbolsList		SpcEditableList).
				
	self methodsList 
		label: self translator tPoVListMethods;
		layoutSpecSelector: #buttonsOnTopSpec.
	self symbolsList 
		label: self translator tPoVListSymbols;
		layoutSpecSelector: #buttonsOnTopSpec.
				
	self initializeFocus.! !

!CMSpecPovDefinition methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/20/2017 00:37'!
methodsList
	" Answer the methodsList of this CMSpecPovDefinition "

	^ methodsList! !

!CMSpecPovDefinition methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/20/2017 00:37'!
methodsList: anObject
	" Sets the methodsList of this CMSpecPovDefinition "

	methodsList := anObject! !

!CMSpecPovDefinition methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/20/2017 00:37'!
symbolsList
	" Answer the symbolsList of this CMSpecPovDefinition "

	^ symbolsList! !

!CMSpecPovDefinition methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/20/2017 00:37'!
symbolsList: anObject
	" Sets the symbolsList of this CMSpecPovDefinition "

	symbolsList := anObject! !

!CMSpecPovDefinition methodsFor: 'initialization' stamp: 'HernanMoralesDurand 1/15/2018 00:59'!
title
	" Private - See superimplementor's comment "

	^ self translator tPoVDefinition! !

CMSpecObject subclass: #CMSpecPovInfo
	instanceVariableNames: 'povInfoList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-PoV'!

!CMSpecPovInfo commentStamp: 'HernanMoralesDurand 1/17/2018 18:28' prior: 0!
CMSpecPovInfo example.

For the Responsibility part: Three sentences about my main responsibilities - what I do, what I know.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	povInfoList:		<Object>


    Implementation Points!

!CMSpecPovInfo class methodsFor: 'compiling' stamp: 'HernanMoralesDurand 1/17/2018 18:26'!
acceptsLoggingOfCompilation
	^ true! !

!CMSpecPovInfo class methodsFor: 'specs' stamp: 'HernanMoralesDurand 1/17/2018 18:26'!
defaultSpec

    <spec>
    ^ SpecLayout composed
		newColumn: [ : c | 
			c
				add: #povInfoList. ]! !

!CMSpecPovInfo methodsFor: 'initialization' stamp: 'HernanMoralesDurand 1/17/2018 18:26'!
initialExtent
	"Answer the initial extent for the receiver."
	
	^ 600 @ 400
! !

!CMSpecPovInfo methodsFor: 'initialization' stamp: 'HernanMoralesDurand 1/17/2018 18:26'!
initializeFocus
	" Private - See superimplementor's comment "

	self focusOrder
		add: self povInfoList. ! !

!CMSpecPovInfo methodsFor: 'initialization' stamp: 'HernanMoralesDurand 1/17/2018 18:26'!
initializePresenter
	" Private - See superimplementor's comment "

	self povInfoList.
.! !

!CMSpecPovInfo methodsFor: 'initialization' stamp: 'HernanMoralesDurand 1/17/2018 18:39'!
initializeWidgets
	" Private - See superimplementor's comment "

	self instantiateModels: #(povInfoList	SpcLabeledActionsList).
	self povInfoList 
		label: self translator tPoVListInfo;
		layoutSpecSelector: #buttonsOnTopSpec.
	self initializeFocus.! !

!CMSpecPovInfo methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/17/2018 18:26'!
povInfoList
	" Answer the povInfoList of this CMSpecPovInfo "

	^ povInfoList! !

!CMSpecPovInfo methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/17/2018 18:26'!
povInfoList: anObject
	" Sets the povInfoList of this CMSpecPovInfo "

	povInfoList := anObject! !

!CMSpecPovInfo methodsFor: 'initialization' stamp: 'HernanMoralesDurand 1/17/2018 18:28'!
title
	" Private - See superimplementor's comment "

	^ self translator tPoVInfoDisplayed! !

CMSpecObject subclass: #CMSpecPovSetter
	instanceVariableNames: 'povDefinition povInfo toolbar povColorButton setColorLabel applyButton selectedClass povDefinitionLabel povInfoLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-PoV'!

CMSpecPovSetter class
	instanceVariableNames: 'standardCellBounds'!

!CMSpecPovSetter commentStamp: 'HernanMoralesDurand 1/21/2018 01:38' prior: 0!
CMPovSetter example.

For the Responsibility part: Three sentences about my main responsibilities - what I do, what I know.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	povColor:		<Object>
	povDefinition:		<Object>
	povInfo:		<Object>


    Implementation Points!

CMSpecPovSetter class
	instanceVariableNames: 'standardCellBounds'!

!CMSpecPovSetter class methodsFor: 'colors' stamp: 'HernanMoralesDurand 1/17/2018 19:25'!
colorChooser
	"open a Color chooser.
	test it : CMPovSetter colorChooser  "

	^ (UITheme builder newColorChooserFor: World
		getColor: #color
		setColor: #color:
		help: self translator tChooseTokenColor) open.
! !

!CMSpecPovSetter class methodsFor: 'specs' stamp: 'HernanMoralesDurand 1/27/2018 01:45'!
defaultSpec

    <spec>
    ^ SpecLayout composed
		newColumn: [ : d |
			d newRow: [ : r |
					r 
						add: #povDefinitionLabel;
						add: #povInfoLabel
					 ] height: self toolbarHeight.
			d newColumn: [ : c |
				c newRow: [ : r | 
					r
						add: #povDefinition;
						add: #povInfo ] height: 230;
					newRow: [ : r |
					r
						add: #setColorLabel width: 70;
						add: #povColorButton ] height: self toolbarHeight;
					newRow: [ : r |
					r
						add: #applyButton width: 100 ] height: self toolbarHeight ] ]; 
		yourself! !

!CMSpecPovSetter class methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/14/2017 00:31'!
standardCellBounds
	
	^Rectangle
		origin: 0 @ 0
		extent: 51 @ 51! !

!CMSpecPovSetter methodsFor: 'action' stamp: 'HernanMoralesDurand 12/14/2017 07:12'!
addInfo
	"adding a new POV method"
	
	| aName |
	(aName := self
		requestText: self infoName
		initialAnswer: 'info_'
		title: 'CORMAS') 
			ifNil: [ ^ self ]
			ifNotNil: [ self modifyInfo: aName asSymbol ].
	self listInfo list
		addFirst: aName asString , ' (' , selectedClass name asString , ')'.
	self listInfo selectionIndex: 1! !

!CMSpecPovSetter methodsFor: 'action' stamp: 'HernanMoralesDurand 12/14/2017 07:13'!
addPov
	"adding a new POV method"
	
	| aName |
	
	(aName := self
		requestText: self povName
		title: 'CORMAS') 
			ifNil: [ ^ self ]
			ifNotNil: [ self modifyPov: aName asSymbol ].	
		self listMethods list
		addFirst: aName asString , ' (' , selectedClass name asString , ')'.
	self listMethods selectionIndex: 1! !

!CMSpecPovSetter methodsFor: 'action' stamp: 'HernanMoralesDurand 12/14/2017 07:25'!
addPovOnAttribute
	| list choice values valuesTextLine |
	list := DefaultAttributesSetter attributsFromClass: selectedClass.
	(choice := UITheme builder
		chooseDropList: self translator tCreatePoVAtt
		title: 'CORMAS'
		list: list) ifNil: [ ^ nil ].
	self createPovOnAttribute: choice.
	self cormas currentSimulation
		ifNotNil: [ values := (self cormas currentSimulation
				allTheEntities: selectedClass)
				collect: [ :entity | entity perform: choice asSymbol ] ].
	(values isNil or: [ values size = 1 and: [ values first isNil ] ])
		ifTrue: [ ^ self ].
	valuesTextLine := ''.
	values
		do: [ :v | valuesTextLine := valuesTextLine , v printString , ' ' ].
	(self confirmAttValues: choice for: valuesTextLine)
		ifTrue: [ values do: [ :v | 
					v isSymbol
						ifTrue: [ self addSymbolPov: v asString ]
						ifFalse: [ v isString
								ifTrue: [ self addSymbolPov: v ]
								ifFalse: [ v isLiteral
										ifTrue: [ self addSymbolPov: choice , v printString ] ] ] ] ]! !

!CMSpecPovSetter methodsFor: 'action' stamp: 'HernanMoralesDurand 12/14/2017 07:37'!
addSymbolPov
	
	| aString |
	selectedClass isNil ifTrue: [^nil].
	(aString := (self requestMessage: self translator tNewSymbol) asString)
		ifEmpty: [ ^ nil ].
	[ aString first = $# ]
		whileTrue: [
			(aString := aString allButFirst) 
			 	ifEmpty: [ ^ nil] ].
	^ self addSymbolPov: aString! !

!CMSpecPovSetter methodsFor: 'action' stamp: 'HernanMoralesDurand 12/19/2017 18:37'!
addSymbolPov: aString
	| aList |
	(self listSymbols list includes: aString)
		ifTrue: [ ^ self alertMessage: self translator tSymbolAlreadyExists ].
	aList := listSymbols list copy.
	aList add: aString.
	aList sort.
	self listSymbols setList: aList selecting: aString.
	selectedClass colorsDict
		at: aString asSymbol
		put: selectedClass defaultColor.
	^ aString! !

!CMSpecPovSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/24/2018 01:14'!
applyButton
	^ applyButton! !

!CMSpecPovSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/24/2018 01:14'!
applyButton: anObject
	applyButton := anObject! !

!CMSpecPovSetter methodsFor: 'util' stamp: 'HernanMoralesDurand 12/14/2017 00:31'!
blueSlider
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^blueSlider isNil
		ifTrue: [blueSlider := 0 asValue]
		ifFalse: [blueSlider]! !

!CMSpecPovSetter methodsFor: 'util' stamp: 'HernanMoralesDurand 12/14/2017 00:31'!
brightnessSlider
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^brightnessSlider isNil
		ifTrue: [brightnessSlider := 0 asValue]
		ifFalse: [brightnessSlider]! !

!CMSpecPovSetter methodsFor: 'action' stamp: 'HernanMoralesDurand 12/14/2017 00:31'!
close
	
	self closeRequest! !

!CMSpecPovSetter methodsFor: 'changed' stamp: 'HernanMoralesDurand 12/19/2017 18:38'!
colorChanged
	| color |
	self builder isNil
		ifTrue: [ ^ self ].
	listSymbols selection isNil
		ifTrue: [ ^ self alertMessage: self translator tSelectSymbol ].
	color := Color
		red: redHolder value
		green: greenHolder value
		blue: blueHolder value.
	color := Color
		hue: color hue
		saturation: color saturation
		brightness: brightnessHolder value.
	(self builder componentAt: #boutonAppliquer) enable.
	couleur := color.
	^ color! !

!CMSpecPovSetter methodsFor: 'action' stamp: 'HernanMoralesDurand 12/14/2017 07:24'!
confirmAttValues: choice for: valuesTextLine

	^ self confirm: (String streamContents: [ : stream |
			stream 
				nextPutAll: self translator tFoundValues;
				nextPutAll: choice;
				nextPutTerminator;
				nextPutAll: valuesTextLine;
				nextPutTerminator;
				nextPutAll: self translator tAddSymbols ])! !

!CMSpecPovSetter methodsFor: 'action' stamp: 'HernanMoralesDurand 1/25/2018 18:44'!
createPovOnAttribute: att
	
	" self codeGenerator createPovOnAttribute: att.  "

	selectedClass
		compile:
			('pov' , (Cormas upperCaseFirstChar: att) ,
					'\"return the value of the attribute\if the value is a string, converts it to a symbol\if the value is a number, converts it to a symbol, precede by the word '
				, att ,
					'"
	self ' , att , ' isString ifTrue:[^self ' , att ,
					' asSymbol].
	self ' , att , ' isLiteral ifTrue:[^ (''' , att , ''' , self ' , att ,
					' printString) asSymbol].
	^self ' , att , '') withCRs
		classified: 'star pov'
		notifying: nil! !

!CMSpecPovSetter methodsFor: 'colors' stamp: 'HernanMoralesDurand 12/19/2017 18:39'!
defaultColor
	
	^ Color blue! !

!CMSpecPovSetter methodsFor: 'action' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
editMethod: aSelector fromClass: aClass
	
	| browser |
	browser := Nautilus open.
	browser selectedClass: aClass.
	browser showHierarchy.
	browser selectedMethod: aSelector! !

!CMSpecPovSetter methodsFor: 'util' stamp: 'HernanMoralesDurand 1/25/2018 18:55'!
formatItemAt: i from: povItems

	^ String streamContents: [ : stream |
		stream 
			nextPutAll: (povItems at: i) asString;
			space;
			nextPut: $(;
			nextPutAll: selectedClass name asString;
			nextPut: $) ]! !

!CMSpecPovSetter methodsFor: 'util' stamp: 'HernanMoralesDurand 12/14/2017 00:31'!
greenSlider
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^greenSlider isNil
		ifTrue: [greenSlider := 0 asValue]
		ifFalse: [greenSlider]! !

!CMSpecPovSetter methodsFor: 'user messages' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
infoName
	
	^' info name : '! !

!CMSpecPovSetter methodsFor: 'util' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
inheritedMethodsFrom: aClass category: aCat
	"Retourne la liste des methodes des superclasses de aClass en s'arr√™tant √† Entity
	On rajoute povID et povClassName"
	
	| aList tmp classes |
	aList := OrderedCollection new.
	classes := aClass allSuperclasses copy.
	classes removeAll: CMEntity allSuperclasses.
	classes do: [ : uneClasse | 
		tmp := uneClasse organization listAtCategoryNamed: aCat.	"specific case of Entity and #pov"	"no need anymore since the generic category has been renamed '* pov'"	"(uneClasse = Entity and: [aCat = #pov]) 
				ifTrue:[tmp := (Entity organization listAtCategoryNamed: aCat) select: [:sel | sel = #povId | (sel = #povClassName)]]."
			1
				to: tmp size
				do:
					[:i | 
					tmp
						at: i
						put: (tmp at: i) asString , ' (' , uneClasse name asString , ')'].
			aList addAll: tmp].
	^aList! !

!CMSpecPovSetter methodsFor: 'initialization' stamp: 'HernanMoralesDurand 1/24/2018 01:20'!
initialExtent

	^ 850 @ 350! !

!CMSpecPovSetter methodsFor: 'initialization' stamp: 'HernanMoralesDurand 1/27/2018 00:05'!
initializePresenter
	" Private - See superimplementor's comment "

"	self povColorButton
		action: [ self openColorChooser ]"
	self listSymbols when: #changed send: #listSymbolsChanged to: self.
	self listMethods when: #changed send: #listMethodsChanged to: self.	! !

!CMSpecPovSetter methodsFor: 'initialization' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
initializeWidgets
	" Private - See superimplementor's comment "

	self povDefinition: (CMSpecPovDefinition for: self projectManager).
	self povInfo: (CMSpecPovInfo for: self projectManager).
	self instantiateModels: #(
		povDefinitionLabel	 	LabelModel
		povInfoLabel 			LabelModel
		setColorLabel 			LabelModel
		povColorButton 			SpcColorChooserModel
		applyButton				ButtonModel
"		toolbar 				SpcOneButtonToolbar").

	self povDefinitionLabel label: self translator tPoVDefinition.
	self povInfoLabel label: self translator tPoVInfoDisplayed.
	self setColorLabel label: self translator tPoVSetColor.
	self applyButton label: self translator tApply.
! !

!CMSpecPovSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/27/2018 00:09'!
listInfo
	
	^ self povInfo povInfoList! !

!CMSpecPovSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/25/2018 18:02'!
listMethods
	" Answer a <Collection> of receiver's PoV methods "
	
	^ self povDefinition methodsList! !

!CMSpecPovSetter methodsFor: 'changed' stamp: 'HernanMoralesDurand 1/27/2018 00:11'!
listMethodsChanged
	"propagate the change to cormas"
	
	self cormas listMethodsChanged	
	"cormas spaceInterfaces 
		do: [:sp | sp spaceModel ifNotNil: [sp initMenuPov]]"! !

!CMSpecPovSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/25/2018 18:02'!
listSymbols
	" Answer a <Collection> of receiver's PoV methods "
	
	^ self povDefinition symbolsList! !

!CMSpecPovSetter methodsFor: 'changed' stamp: 'HernanMoralesDurand 12/14/2017 00:31'!
listSymbolsChanged
	
	| aPov |
	self listSymbols selection ifNil: [^nil].
	aPov := self listSymbols selection asSymbol.
	(self selectedClass colorAtPov: aPov)
		ifNil:
			[self selectedClass colorsDict
				at: aPov
				put: selectedClass defaultColor].
	couleur := self selectedClass colorAtPov: aPov.
	self updateSlidersFromColor: couleur.
	^couleur! !

!CMSpecPovSetter methodsFor: 'action' stamp: 'HernanMoralesDurand 12/23/2017 12:54'!
modifyInfo
	| aSelector aClass |
	selectedClass isNil
		ifTrue: [ ^ nil ].
	(self listInfo selection isNil
		or: [ self listInfo selection = '----' ])
		ifTrue: [ ^ nil ].
	aSelector := (self removeBrackets: self listInfo selection) asSymbol.
	aClass := selectedClass whichClassIncludesSelector: aSelector.
	self editMethod: aSelector fromClass: aClass! !

!CMSpecPovSetter methodsFor: 'action' stamp: 'HernanMoralesDurand 12/14/2017 00:31'!
modifyInfo: infoName
	
	selectedClass
		compile:
			(infoName asString ,
					'\"return a String "\ ^self id printString\" ^ self class name asString "')
				withCRs
		classified: 'info'
		notifying: nil.
	self editMethod: infoName fromClass: selectedClass	"selectedClass infoDict at: infoName put: OrderedCollection new"! !

!CMSpecPovSetter methodsFor: 'action' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
modifyPov
	| aSelector aClass |
	selectedClass isNil
		ifTrue: [ ^ nil ].
	(self listMethods selection isNil
		or: [ self listMethods selection = '----' ])
		ifTrue: [ ^ nil ].
	aSelector := (self removeBrackets: self listMethods selection)
		asSymbol.
	aClass := selectedClass whichClassIncludesSelector: aSelector.
	self editMethod: aSelector fromClass: aClass! !

!CMSpecPovSetter methodsFor: 'action' stamp: 'HernanMoralesDurand 12/14/2017 00:31'!
modifyPov: povName
	
	selectedClass
		compile:
			(povName asString ,
					'\"return a symbol or a ColorValue"\^#aSymbol\"^ColorValue white"')
				withCRs
		classified: 'pov'
		notifying: nil.
	self editMethod: povName fromClass: selectedClass! !

!CMSpecPovSetter methodsFor: 'user messages' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
noSelectedEntity
	
	^'Select an entity first !!!!!! '! !

!CMSpecPovSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/24/2018 00:43'!
povColorButton
	^ povColorButton! !

!CMSpecPovSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/24/2018 00:43'!
povColorButton: anObject
	povColorButton := anObject! !

!CMSpecPovSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/17/2018 18:16'!
povDefinition
	^ povDefinition! !

!CMSpecPovSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/17/2018 18:16'!
povDefinition: anObject
	povDefinition := anObject! !

!CMSpecPovSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/27/2018 00:57'!
povDefinitionLabel
	^ povDefinitionLabel! !

!CMSpecPovSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/27/2018 00:57'!
povDefinitionLabel: anObject
	povDefinitionLabel := anObject! !

!CMSpecPovSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/17/2018 18:16'!
povInfo
	^ povInfo! !

!CMSpecPovSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/17/2018 18:16'!
povInfo: anObject
	povInfo := anObject! !

!CMSpecPovSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/27/2018 00:57'!
povInfoLabel
	^ povInfoLabel! !

!CMSpecPovSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/27/2018 00:57'!
povInfoLabel: anObject
	povInfoLabel := anObject! !

!CMSpecPovSetter methodsFor: 'user messages' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
povName
	
	^' pov name : '! !

!CMSpecPovSetter methodsFor: 'util' stamp: 'HernanMoralesDurand 12/14/2017 00:31'!
redSlider
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^redSlider isNil
		ifTrue: [redSlider := 0 asValue]
		ifFalse: [redSlider]! !

!CMSpecPovSetter methodsFor: 'util' stamp: 'HernanMoralesDurand 12/14/2017 00:31'!
removeBrackets: aNom
	
	| index unNom |
	aNom isNil ifTrue: [^nil].
	index := aNom findFirst: [:aChar | aChar = $(].
	index = 0 ifTrue: [^aNom].
	unNom := aNom
		changeFrom: index - 1
		to: aNom size
		with: ''.
	^unNom! !

!CMSpecPovSetter methodsFor: 'action' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
removeInfo
	
	| unSymb |
	self listInfo selection notNil
		ifTrue:
			[(self cormas
				confirm:
					'Delete the method '
						asString , ' ' , self listInfo selection , ' ?')
				ifTrue:
					[unSymb := (self removeBrackets: listInfo selection) asSymbol.
					selectedClass removeSelector: unSymb.
					self listInfo list remove: listInfo selection.
					self listInfo selectionIndex: 0]]! !

!CMSpecPovSetter methodsFor: 'util' stamp: 'HernanMoralesDurand 12/14/2017 00:31'!
removeParentheses: aNom
	
	| index unNom |
	aNom isNil ifTrue: [^nil].
	index := aNom findFirst: [:aChar | aChar = $(].
	index = 0 ifTrue: [^aNom].
	unNom := aNom
		changeFrom: index - 1
		to: aNom size
		with: ''.
	^unNom! !

!CMSpecPovSetter methodsFor: 'action' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
removePov
	
	| unSymb |
	self listMethods selection notNil
		ifTrue:
			[(self cormas
				confirm:
					'Delete the method '
						asString , self listMethods selection , ' ?')
				ifTrue:
					[unSymb := (self removeBrackets: listMethods selection) asSymbol.
					selectedClass removeSelector: unSymb.
					self listMethods list remove: listMethods selection.
					self listMethods selectionIndex: 0]]! !

!CMSpecPovSetter methodsFor: 'action' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
removeSymbolPov
	
	| selectedSymbol |
	self listSymbols selection isNil
		ifFalse:
			[(self cormas
				confirm:
					'Remove this symbol ?' asString)
				ifTrue:
					[selectedSymbol := self listSymbols selection.
					self removeClassMethodForSymbol: selectedSymbol.
					selectedClass colorsDict
						removeKey: selectedSymbol asSymbol
						ifAbsent: [nil].	"selectedClass povDict removeKey: selectedSymbol ifAbsent: [nil].  uniquement pour les agents"
					self removeSymbolPov: selectedSymbol.
					^selectedSymbol]]! !

!CMSpecPovSetter methodsFor: 'action' stamp: 'HernanMoralesDurand 12/14/2017 00:31'!
removeSymbolPov: aString
	
	| aList i |
	i := listSymbols list indexOf: aString.
	aList := listSymbols list copy.
	aList remove: aString.
	self listSymbols
		setList: aList
		selecting: (aList at: (i min: aList size))! !

!CMSpecPovSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/14/2017 00:31'!
selectedClass
	
	^selectedClass! !

!CMSpecPovSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/25/2018 17:52'!
selectedClass: anObject
	selectedClass := anObject! !

!CMSpecPovSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/14/2017 00:31'!
selectedMethod
	
	^self listMethods selection! !

!CMSpecPovSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/24/2018 01:10'!
setColorLabel
	^ setColorLabel! !

!CMSpecPovSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/24/2018 01:10'!
setColorLabel: anObject
	setColorLabel := anObject! !

!CMSpecPovSetter methodsFor: 'initialization' stamp: 'HernanMoralesDurand 1/25/2018 19:02'!
setListInfo

	| liste tmp |
	liste := OrderedCollection new.
	liste addAll: (self inheritedMethodsFrom: selectedClass category: #'star info').
	liste addFirst: '----'.
	tmp := (selectedClass organization listAtCategoryNamed: #'star info') asOrderedCollection.
	tmp addAll: (selectedClass organization listAtCategoryNamed: #info). 
	"to ensure compatibility for models implemented with previous Cormas versions" 
	1 to: tmp size do: [ : i | self formatItemAt: i from: tmp ].
	liste addAllFirst: tmp.
	self listInfo items: liste.
	liste isEmpty 
		ifFalse: [ self listInfo selectFirstItem ].! !

!CMSpecPovSetter methodsFor: 'initialization' stamp: 'HernanMoralesDurand 1/25/2018 18:58'!
setListMethods
	| liste tmp |
	liste := OrderedCollection new.
	liste addAll: (self inheritedMethodsFrom: selectedClass category: #'star pov').
	liste addFirst: '----'.
	tmp := (selectedClass organization listAtCategoryNamed: #'star pov') asOrderedCollection.
	tmp addAll: (selectedClass organization listAtCategoryNamed: #pov).
	"to ensure compatibility for models implemented with previous Cormas versions"
	1 to: tmp size do: [ :i | tmp at: i put: (self formatItemAt: i from: tmp) ].
	liste addAllFirst: tmp.
	self listMethods items: liste.
	liste isEmpty
		ifFalse: [ self listMethods selectFirstItem ]! !

!CMSpecPovSetter methodsFor: 'initialization' stamp: 'HernanMoralesDurand 1/25/2018 19:03'!
setListSymbols

	| liste |

	liste := OrderedCollection new.
	liste addAll: (selectedClass colorsDict keys collect: #asString).
	(liste includes: selectedClass name asString) 
		ifFalse: [ liste addFirst: selectedClass name asString ].
	self listSymbols list: liste sort.
	liste isEmpty 
		ifFalse: [ self listSymbols selectFirstItem ]! !

!CMSpecPovSetter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/25/2018 17:54'!
setModelClass: aClass
	
	selectedClass := aClass.
	self setListMethods.
	self setListSymbols.
	self setListInfo! !

!CMSpecPovSetter methodsFor: 'changed' stamp: 'HernanMoralesDurand 12/14/2017 00:31'!
updateSlidersFromColor: aCol
	
	aCol ifNil: [^nil].
	self blueSlider value: aCol blue.
	self greenSlider value: aCol green.
	self redSlider value: aCol red.
	self brightnessSlider value: aCol brightness! !

!CMSpecPovSetter methodsFor: 'action' stamp: 'HernanMoralesDurand 12/14/2017 00:31'!
validate
	
	self subclassResponsibility! !

CMSpecPovSetter subclass: #CMSpecPovSetter_Agent
	instanceVariableNames: 'tailleSlider tailleHolder colorChooser oldValue occupantPosition isDistortable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-PoV'!

!CMSpecPovSetter_Agent commentStamp: 'HernanMoralesDurand 1/17/2018 19:20' prior: 0!
CMPovSetter_Agent example.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	colorChooser:		<Object>
	isDistortable:		<Object>
	occupantPosition:		<Object>
	oldValue:		<Object>
	tailleHolder:		<Object>
	tailleSlider:		<Object>


    Implementation Points!

!CMSpecPovSetter_Agent class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
bitmapIcon
	
	^OpaqueImage
		figure: self bitmapImage
		shape: self bitmapMask! !

!CMSpecPovSetter_Agent class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
bitmapImage
	"Tools.UIMaskEditor new openOnClass: self andSelector: #bitmapImage"
	
	<resource: #image>
	^CachedImage
		on:
			(Image
				extent: 26 @ 20
				depth: 9
				bitsPerPixel: 16
				palette:
					(MappedPalette
						withColors:
							(#(#(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4850 4946 5010)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4818 4946 5043)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(160 738 1798)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5364 5396 5396)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5332 5396 5428)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1413 1606 1702)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1863 2087 2120)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2312 2505 2601)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6970 6938 6970)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2569 2730 2794)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2569 2762 2762)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3597 3597 3597)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3822 3822 3822)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4047 4047 4047)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4175 4304 4336)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4272 4272 4272)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4529 4497 4464)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4497 4497 4497)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4593 4786 4786)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5235 5428 5524)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5396 5396 5396)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6070 6070 6070)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6070 6103 6038)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6231 6327 6327)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1445 1606 1702)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6520 6520 6520)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1606 1895 1927)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1863 2087 2152)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2698 2376 1702)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6970 6970 6970)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2344 2537 2569)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7195 7195 7195)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7644 7644 7644)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2698 3019 3083)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8094 8094 8094)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3308 3404 3437)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3758 3854 3886)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4047 4047 4079)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4175 4304 4368)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4464 4529 4529)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4850 5010 5010)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5139 5203 5203)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5589 5653 5653)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6552 6520 6520)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1863 2087 2184)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2376 2537 2569)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2409 2537 2537)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7227 7195 7195)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4336 3212 1284)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3565 3276 2666)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3372 3372 3437)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3597 3629 3629)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3790 3854 3886)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4143 4079 3983)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4207 4336 4336)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4368 4593 4593)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4657 4753 4818)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4914 4978 5010)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5203 5203 5171)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(64 417 963)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5235 5235 5107)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(0 963 2505)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(160 1252 2730)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6552 6552 6520)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1702 1863 1927)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3854 3854 3854)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4079 4079 4079)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4207 4336 4368)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4304 4304 4304)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4464 4561 4561)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4497 4593 4497)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4978 4978 4978)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4882 5010 5043)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5203 5203 5203)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5428 5428 5428)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5878 5878 5878)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1316 1413 1445)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1477 1670 1702)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6552 6552 6552)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6103 6103 6103)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6777 6777 6777)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7002 7002 7002)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7227 7227 7227)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2890 2955 3051)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7452 7452 7452)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7677 7677 7677)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3180 3180 3212)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3308 3469 3469)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8126 8126 8126)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4207 4336 4400)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4721 4786 4786)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4625 4818 4850)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4978 4978 5010)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4850 5043 5075)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4689 4786 4818)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1316 1445 1445)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1477 1670 1734)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6584 6552 6552)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6103 6103 6135)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1830 2184 2216)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1959 2120 2152)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2248 2312 2344)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2473 2537 2569)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1638 1702 1541)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3629 3661 3661)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4079 4111 4111)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4015 4143 4143)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4304 4336 4336)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4047 4111 4143)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4978 5010 5010)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(64 64 64)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5396 5460 5492)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5653 5685 5685)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5878 5910 5910)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1477 1670 1766)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1477 1702 1734)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2633 2794 2858)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3372 3469 3469)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3661 3661 3661)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3886 3886 3886)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4240 4368 4400)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4336 4336 4336)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4272 4336 4400)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4561 4561 4561)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4721 4786 4850)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4786 4786 4786)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4753 4786 4818)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5010 5010 5010)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5043 5043 4946)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5396 5492 5492)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5685 5685 5685)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1284 1445 1541)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6135 6135 6135)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6584 6584 6584)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6360 6360 6360)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6809 6809 6809)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1959 2120 2216)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7034 7034 7034)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1477 1702 1766)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7484 7484 7484)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7709 7709 7709)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 8158 8158)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3404 3469 3469)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7934 7934 7934)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4304 4336 4400)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5621 5717 5749)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1477 1734 1766)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1670 1927 2055)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6649 6584 6552)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1959 2184 2184)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2152 2376 2473)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2344 2633 2698)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2633 2826 2890)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2601 2826 2923)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2216 2376 2409)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3372 3501 3501)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3629 3693 3726)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4015 4175 4207)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4464 4625 4657)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4561 4593 4593)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4497 4625 4625)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(64 160 738)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5010 5043 5043)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5235 5267 5267)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5171 5267 5332)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(321 674 1316)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5460 5492 5492)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1284 1477 1573)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1541 1702 1766)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1509 1734 1766)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6360 6392 6392)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6360 6360 6424)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3340 3501 3565)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4079 4175 4175)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6295 4432 1702)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4143 4143 4143)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4529 4625 4625)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(64 64 192)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5878 5974 5974)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1349 1477 1541)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6167 6167 6167)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5942 5942 5942)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6360 6392 6424)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6392 6392 6392)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6617 6617 6617)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7066 7066 7066)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2280 2376 2409)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2505 2601 2633)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2601 2858 2955)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7516 7516 7516)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2923 3083 3083)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7741 7741 7741)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6841 6841 6841)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3437 3469 3533)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 8191 8191)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3565 3758 3790)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4272 4432 4432)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4529 4625 4657)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4561 4625 4625)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4818 4818 4850)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4786 4850 4850)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(192 674 1509)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5749 5717 5717)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1349 1477 1573)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1573 1734 1766)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1477 1766 1830)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1509 1734 1830)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2505 2633 2633)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2280 2409 2409)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3693 3726 3726)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4368 4400 4400)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4786 4689 4368)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4721 4882 4914)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4850 4850 4818)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5043 5075 5075)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5492 5524 5524)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5428 5524 5589)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5685 5749 5781)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5717 5749 5749)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5878 5974 6038)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1316 1509 1606)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1606 1734 1766)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2601 2923 2955)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2698 2858 2923)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3276 3276 3276)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4561 4111 3180)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4175 4175 4175)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4400 4400 4400)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4368 4400 4432)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4529 4689 4657)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4304 4432 4464)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4850 4850 4850)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5267 5300 5332)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5300 5300 5300)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5460 5557 5557)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5396 5589 5589)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5974 5974 5974)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5749 5749 5749)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6199 6199 6199)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1573 1734 1830)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(192 1477 3469)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6424 6424 6424)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6649 6649 6649)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7098 7098 7098)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1991 2216 2280)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6874 6874 6874)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1509 1766 1863)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3147 3340 3372)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3693 3758 3758)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4079 4207 4272)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4497 4689 4721)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5974 5974 6006)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1349 1541 1606)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1573 1766 1830)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6424 6456 6424)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2087 2216 2216)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2601 2955 2987)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3051 3083 3083)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3115 3372 3404)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3212 3308 3372)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7998 7998 8030)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3950 3983 3983)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4304 4464 4497)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4625 4657 4657)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4561 4689 4689)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4850 4882 4882)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4657 4625 4657)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5043 5107 5139)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5557 5557 5524)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5524 5557 5557)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5781 5781 5749)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5974 6006 6006)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6199 6231 6231)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6231 6231 6199)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6424 6456 6456)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1573 1766 1863)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2537 2633 2730)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3083 3083 3083)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3790 3244 2216)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3404 3597 3597)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3758 3758 3758)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3918 4015 4015)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4015 3983 3950)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4432 4432 4432)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4657 4657 4657)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4561 4689 4721)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4882 4882 4882)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4818 4914 4914)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5107 5107 5107)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4978 5139 5203)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5332 5332 5332)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6006 6006 6006)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6456 6456 6456)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1991 2280 2312)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7130 7130 7130)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6906 6906 6906)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6906 6938 6874)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7580 7580 7580)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2666 2923 3019)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3983 4047 3950)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3983 4015 3983)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4336 4464 4529)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4593 4689 4721)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4368 4464 4497)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5010 5139 5203)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5043 5107 5203)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5267 5364 5396)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1798 2055 2087)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6938 6906 6906)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2762 2890 2987)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3533 3565 3565)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3950 4015 4047)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4207 4207 4272)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4625 4689 4721)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(192 192 192)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4850 4914 4946)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4786 4946 4978)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4818 4946 4946)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5974 6038 6070)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6199 6263 6295)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1413 1573 1638)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1381 1606 1638)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1798 2055 2120)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6488 6488 6456)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2120 2248 2280)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6906 6938 6938)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2826 2890 2955)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2698 2955 3019)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2794 2923 2955)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2858 2890 2923)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3565 3565 3565)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4175 4272 4272)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4240 4240 4240)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4464 4464 4464)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4400 4464 4529)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4978 5203 5235)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5364 5364 5364)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5589 5589 5589)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6038 6038 6038)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5814 5814 5814)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1477 1573 1606)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1349 1606 1702)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1606 1830 1895)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1798 2087 2120)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6488 6488 6488)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1991 2312 2376)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7163 7163 7163)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2698 2955 3051)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2762 2955 2987)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3340 3340 3372)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8062 8062 8062)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3469 3597 3661)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4207 4272 4272)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4657 4721 4721)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4625 4689 4786)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4914 4914 4946)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4850 4946 4978)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5492 5653 5653)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5557 5621 5621)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5685 5878 5910)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6713 6745 6713)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6970 6970 6906)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7195 7163 7163)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4464 4497 4497)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4689 4721 4721)))
								collect:
									[:each | 
									(each at: 1) value
										perform: (each at: 2)
										withArguments: (each at: 3)]))
				usingBits:
					(ByteArray fromPackedString:
							'@LH@0 CB@LH@0 CB@LH@0 CB@LH@0 CB@LH@0 CB@LH@0 CB@LH@0 CB@LH@0 CB@LH@0 CB@LH@0 D)@HT@60BD@TT@H@B=@K4@/PB=@K4@/PB=@K4@/PB=@K4@/PBK@ET@0 CB@LH@0 BO@KHAX0A]@C(AC@E%@MHAFPB^@E$@$@E!!@L\AN0AZ@I<@I0EN@V@@IPD7@JL@UPCB@LHAI D!!@L(@S E)@TT@%@@S@AL@WPA\@VTAC DI@MP@D @R@M,AQPD''@H\@O0CW@K\@0 CB@TT@: AY@F,@[PE+@O @^@AE@CP@+PCE@Q4@JPA0@M$@[0AH@Q4@N@D_@S0@ P@W@LH@0 EE@R8@/@C4@IT@3@CA@VP@J D>@P\@&0D0@A\@60@S@C$@_@DW@U\@F ET@S\@-0CB@LH@.PCT@P@AP BJ@GH@# D,@O$@>PD7@IDAA@C3@@L@VPA)@G8@@0@6@RTAL0DF@K\@0 CB@RX@@@E[@A,@;0A @H @YPED@BL@60B7@JL@>PB#@P4AM0D6@JHAD@AC@I\@D A!!@LH@0 EZ@S@AV0@[@N<@X@@E@UTAU CH@K$AY AZ@TT@H BO@R @5PD6@M\@JPDB@E,@.@CB@LHAV B$@T\@$0E@@HL@)0C\@A8@>0B6@ID@UPB=@V ADPC>@AXAJ0DE@R8@''P@A@OH@0 CB@B<@6@C9@@8@(@C%@Q$@BPAS@A\AYPB2@U(@ @@5@Q(AKPE%@MX@''@B0@G(@WPC2@LH@0 EZ@@P@I@A(@S\@5@E,@QTAR@@W@SH@E0@P@@H@O B%@KDAWPBQ@F(@(0EK@E8@.@CB@LHAI @(@I AL0A@@M4APPCK@FP@, @S@J(@U @=@O@@2PA.@FX@60C:@S,@U0D.@HT@0 CB@OLAOPD*@TH@*@@X@GH@" B3@LX@:0D?@CH@(P@;@KD@,PEF@QHAHPC$@@\AB@@+@LH@0 EE@VH@7 @,@N<@X@A2@H(@?@B:@RD@60CV@T$AEPB>@EXAL@EE@T<A@0EY@I8AP0CB@LHAQP@7@I$@A CL@D4@X@A @GL@W0B;@R4@X DO@VT@6 A1@OTAY0A5@A0AE AF@K\@0 CB@@ @1@B<@FLAD0BR@L4@?PC6@J$@S@CN@LL@:@@S@JX@JPC&@IX@Y0@0@J8@40B6@LH@0 D4@S$@+@D5@@(AE@A4@T AW@C_@L<@& CP@O\@>P@&@U<@KPC?@B8@LPC!!@C0@*0CB@LH@U@B#@E$@+PD8@O$@VPD-@P(AKPB-@CP@00CC@MD@L0AW@Q\AE0@4@F0AK0B#@OL@#PCB@E @H@EZ@TTAQPEE@TTAQPEE@L@@S BD@KH@, B2@KH@, B2@M,@-0C2@K$@/PBO@H4b'))! !

!CMSpecPovSetter_Agent class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
bitmapMask
	"Tools.UIMaskEditor new openOnClass: self andSelector: #bitmapMask"
	
	<resource: #image>
	^CachedImage
		on:
			(Image
				extent: 26 @ 20
				depth: 1
				bitsPerPixel: 1
				palette: CoveragePalette monoMaskPalette
				usingBits:
					#[255 255 255 192 255 255 255 192 255 255 255 192 255 255 255 192 255 255 255 192 255 255 255 192 255 255 255 192 255 255 255 192 255 255 255 192 255 255 255 192 255 255 255 192 255 255 255 192 255 255 255 192 255 255 255 192 255 255 255 192 255 255 255 192 255 255 255 192 255 255 255 192 255 255 255 192 255 255 255 192])! !

!CMSpecPovSetter_Agent class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
cachedImage
	"CormasNS.Kernel.ImageEditor new openOnClass: self andSelector: #cachedImage"
	
	<resource: #image>
	^CachedImage
		on:
			(Image
				extent: 126 @ 27
				depth: 8
				bitsPerPixel: 8
				palette:
					(MappedPalette
						withColors:
							(#(#(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 4368 3693)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7195 5139 7195)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6488 3244 6488)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6938 4625 6970)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 5267 4786)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 5267 4753)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7066 5075 7066)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 5717 5300)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 4207 3501)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6424 2955 6520)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 6649 6392)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 2087 1027)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7709 6777 7709)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 6038 5653)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 4529 3886)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 6488 6199)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 4978 4432)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6327 2601 6327)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 3918 3180)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6970 4625 6970)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 6360 6038)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 2826 1927)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 4818 4272)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 3758 3019)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 3758 2987)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 4240 3533)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 4207 3533)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7291 5653 7291)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7516 6199 7516)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 6649 6392)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 5139 4625)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7034 4882 7002)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 4079 3372)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 7580 7452)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 6038 5685)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6584 3437 6584)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6392 2826 6392)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 4978 4432)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4207 1541 4240)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6649 3983 6970)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 1959 867)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7644 6617 7644)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 3918 3180)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7837 7227 7837)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6970 4657 6970)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7355 5878 7355)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 6360 6038)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 3308 2473)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6906 4464 6906)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 3758 3019)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 6681 6424)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 8191 8191)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 3629 2858)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6874 4207 6874)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 7580 7484)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 6070 5685)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7227 5492 7227)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 4529 3918)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 5010 4464)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 6520 6231)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4207 1541 4272)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 6970 6777)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7002 4625 7002)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6617 3404 6617)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 3918 3212)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 5910 5524)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 4400 3758)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 6392 6070)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8062 7805 8062)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4111 1413 4175)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7163 5300 7163)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6970 4689 6970)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 3790 3051)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6263 2473 6263)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6906 4497 6906)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 6231 5878)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 6681 6424)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 3180 2312)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7420 4657 5910)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 5621 5171)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 6520 6263)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 1959 899)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6520 3308 6520)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 6392 6103)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6938 4464 6938)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 3790 3051)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 7291 7163)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6488 3051 6488)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7098 5139 7098)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 3661 2890)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 4111 3404)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7227 1316 3854)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8126 8062 8126)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7934 7452 7934)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 1991 931)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7002 4689 7002)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 3950 3244)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6970 4721 7002)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 6392 6103)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4625 1573 4561)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 3822 3083)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6263 2537 6263)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7098 5171 7098)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6938 4497 6938)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 6713 6456)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 3661 2890)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7741 6874 7741)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 6103 5749)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 4593 3983)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6809 4143 6777)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 3983 3276)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 5974 5589)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7195 5364 7163)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4143 1445 4207)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6263 2569 6263)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 3822 3083)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6938 4529 6938)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 4304 3629)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 4304 3597)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6681 3726 6681)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 3693 2923)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6231 2312 6231)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7741 6906 7741)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 7644 7548)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 4143 3437)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6906 1766 3790)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7966 7516 7901)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 6584 6295)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6809 4143 6809)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 7034 6841)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 5524 5075)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 2023 931)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7002 4753 7002)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 5974 5589)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7130 6456 7163)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 6424 6135)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 3372 2569)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 3854 3115)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6970 4497 6970)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7130 5171 7130)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6938 4561 6938)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 7805 7741)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 4304 3629)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 6745 6488)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6231 2344 6231)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 3693 2923)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7066 4978 7066)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6424 1445 4625)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 6584 6327)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6167 1830 5492)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6841 4111 6841)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 5524 5075)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7002 4786 7002)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 7966 7934)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 3404 2601)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6745 4015 6713)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6970 4529 6970)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 3854 3115)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7130 5203 7130)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 4336 3661)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 5846 5428)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 6295 5974)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6938 4593 6938)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4015 1445 4079)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 3726 2955)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 3115 2248)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 6617 6360)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6841 4175 6809)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 4015 3308)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 6006 5621)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 6456 6167)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7644 6520 7644)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 3886 3147)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 5396 4914)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6970 4561 6970)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 4336 3661)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 6327 6006)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 3726 2987)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 3726 2955)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 8158 8158)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 2666 1702)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 4657 4047)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 6167 5814)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 6617 6360)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 5107 4561)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 5557 5107)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 2537 1541)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 6038 5653)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6392 2794 6360)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 6938 6745)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 3437 2633)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6970 4593 6970)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 7387 7259)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 2376 1381)))
								collect:
									[:each | 
									(each at: 1) value
										perform: (each at: 2)
										withArguments: (each at: 3)]))
				usingBits:
					(ByteArray fromPackedString:
							'L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3@@@3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L86AN2JWG!!Z5C$H@'':=5]WV/+:>_''9>/#''XYBE).D(%3E;DX,)EYZU$4MCP4MCQ)VU&Q^KJ$,SEURFR]+B)@XJ @@CL3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3O@.Q(/)X X_F0PAHHG(DE/C[,7M06)*XVE!!Z$7Z;YK(R9"*#-P_9R7GP)LL&!!(ZF!!(L$0JB!!6&-9Q?_5@;C:*GT4LT,@@@L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3N7MAU$AX<!!L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3@@@3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3NYHLF8^3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L@@CL3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3U+RZM#L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L0@@L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L34KNSL3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3@@@3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3N= 3(3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L@@CL3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3 U8%L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L0@@L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L6!!QISL3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3@@@3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3N9JJ43L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L@@CL3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L;/+(OL3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L0@@!!#L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L44%L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3@@@&I"X&I"X&I"X&I"X&I"X&I"X&I"X&I"X&I"X&I"X<\TU1\WE1\WF#X9VSV75N_#L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L@@KL3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L2\I%#L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L0@@L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3NJ^SL3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3@@@3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3$I03L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L@@CL3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3YV43L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L0@@L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3DZ\3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3@@@3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3\(@3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L@@CL3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3/IY\L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L0@@L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3H2Q:L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3@@@3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L4$5Z#L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L@@CL3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3WS9WT)03L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L0@@L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L)@V4?@#L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3@@@3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3MDJ02+GB4[NGAF''&ZKVH.K''):^''):^V@ZRG9"DW1NL#GQ'']F]''UEQTUEQTUEQTUCA''LF]J]J:L(+<S@21GXXP@@CL3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L3L0@@'))! !

!CMSpecPovSetter_Agent class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
iconHexagon
	
	^SpaceInterface iconHexagon! !

!CMSpecPovSetter_Agent class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
libraryIcon
	
	^OpaqueImage
		figure: self libraryIconImage
		shape: self libraryIconMask! !

!CMSpecPovSetter_Agent class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
libraryIconImage
	
	<resource: #image>
	^Image
		extent: 25 @ 24
		depth: 1
		bitsPerPixel: 1
		palette: MonoMappedPalette whiteBlack
		usingBits:
			#[0 0 0 0 112 0 0 0 112 0 0 0 112 0 0 0 112 0 0 0 112 0 112 0 112 0 112 0 112 0 112 0 112 2 112 0 112 7 112 0 112 6 112 0 112 0 120 0 112 0 126 0 112 0 126 0 112 6 119 0 112 6 115 0 112 6 113 0 112 6 113 0 112 6 113 0 127 230 115 0 127 230 118 0 127 224 126 0 127 224 124 0 0 0 0 0]! !

!CMSpecPovSetter_Agent class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
libraryIconMask
	"Tools.UIMaskEditor new openOnClass: self andSelector: #libraryIconMask"
	
	<resource: #image>
	^Image
		extent: 25 @ 24
		depth: 1
		bitsPerPixel: 1
		palette: CoveragePalette monoMaskPalette
		usingBits:
			#[0 0 0 0 112 0 0 0 112 0 0 0 112 0 0 0 112 0 0 0 112 0 112 0 112 0 112 0 112 0 112 0 112 2 112 0 112 7 112 0 112 6 112 0 112 0 120 0 112 0 126 0 112 0 126 0 112 6 119 0 112 6 115 0 112 6 113 0 112 6 113 0 112 6 113 0 127 230 115 0 127 230 118 0 127 224 126 0 127 224 124 0 0 0 0 0]! !

!CMSpecPovSetter_Agent class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
menuSymbolePDV
	"Tools.MenuEditor new openOnClass: self andSelector: #menuSymbolePDV"
	
	<resource: #menu>
	^#(Menu #(#(MenuItem 
		#rawLabel: #(UserMessage 
			#key: #add 
			#defaultString: 'Add') 
		#value: #addSymbolPov) #(MenuItem 
		#rawLabel: 'Add - same shape as' 
		#nameKey: #addSymbolSameAs 
		#submenu: #(Menu #(#(MenuItem 
			#rawLabel: 'bidon' 
			#nameKey: #bidon)) #(1) nil)) #(MenuItem 
		#rawLabel: #(UserMessage 
			#key: #delete 
			#defaultString: 'Remove') 
		#value: #removeSymbolPov) #(MenuItem 
		#rawLabel: 'Set as default symbol shape' 
		#value: #setSymbolAsDefaultImage) #(MenuItem 
		#rawLabel: 'Set entity default color' 
		#nameKey: #setDefaultColor 
		#value: #setDefaultColor)) #(5) nil) decodeAsLiteralArray! !

!CMSpecPovSetter_Agent class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
vectorIcon
	
	^OpaqueImage
		figure: self vectorImage
		shape: self vectorMask! !

!CMSpecPovSetter_Agent class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
vectorImage
	"Tools.UIMaskEditor new openOnClass: self andSelector: #vectorImage"
	
	<resource: #image>
	^CachedImage
		on:
			(Image
				extent: 21 @ 20
				depth: 8
				bitsPerPixel: 8
				palette:
					(MappedPalette
						withColors:
							(#(#(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2537 3212 3854)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4240 4625 5043)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7420 7484 7612)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6295 6424 6488)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7837 7837 7837)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5846 5974 6070)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4432 4850 5300)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6231 6263 6392)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6584 6617 6681)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8062 8062 8062)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7259 7291 7323)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6070 6199 6295)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6038 6231 6295)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6103 6199 6263)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1638 4304 6006)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7934 7966 7966)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5300 5396 5557)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6327 6424 6488)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3244 3886 4497)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5171 5332 5428)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2184 4432 5685)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6552 6649 6713)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7291 7291 7323)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2730 3726 4529)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3051 4047 4882)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7098 7195 7291)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7163 7195 7227)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5685 6135 6456)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1316 2505 3533)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4850 4978 5139)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1252 3437 4657)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4368 4593 4689)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 8191 8191)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2409 3533 4400)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6231 6327 6392)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2055 3886 5075)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3180 5942 7195)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7130 7195 7291)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6231 6392 6681)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5267 5300 5428)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3886 4175 4625)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6649 6745 6906)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2473 4946 6263)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1702 4978 7002)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5878 6006 6103)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3372 3790 4207)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8094 8094 8094)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6970 6970 7034)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4625 4753 4978)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7291 7291 7387)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6103 6231 6327)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5010 5107 5235)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4786 5107 5460)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1381 2666 3693)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6135 6231 6295)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7966 7998 7998)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1284 3533 4914)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1060 5332 7644)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4400 5107 5524)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7452 7548 7644)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6360 6456 6520)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(931 3501 4978)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(995 2923 4175)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6584 6681 6745)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1895 4850 6649)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5428 5910 6360)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5878 5878 5942)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5942 6231 6520)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5781 5878 6038)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7612 7677 7709)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(224 1573 2666)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5107 5492 5781)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6520 6552 6617)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6874 6874 6938)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5942 6103 6327)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6392 6424 6552)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7098 7130 7130)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6295 6327 6424)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2987 3822 4625)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7773 7773 7805)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3308 4207 4914)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1124 2923 4079)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5300 5557 5878)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7644 7677 7709)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6488 6584 6649)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7677 7677 7677)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7998 7998 8030)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6360 6552 6809)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6006 6167 6231)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7484 7548 7677)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7901 7901 7901)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6263 6424 6713)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(481 1830 2858)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2633 3212 3629)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2794 3533 4143)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4400 5010 5364)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5910 5910 5942)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1381 3693 5075)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6135 6231 6392)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6552 6552 6649)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7677 7677 7709)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6841 6906 7002)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5524 5814 6103)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1156 3565 5107)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6006 6199 6231)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6392 6488 6552)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6520 6841 7066)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2473 3597 4432)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1027 2890 4272)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7805 7805 7805)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6424 6713 6970)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7773 7805 7837)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3950 4497 5043)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2826 3790 4561)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7644 7709 7741)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6520 6584 6681)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8030 8030 8030)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(770 2312 3469)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6135 6135 6199)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6424 6456 6584)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3115 4015 4721)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6520 6841 7098)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6745 6841 6874)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5814 5974 6038)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1959 3501 4753)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4561 4818 5139)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6167 6295 6360)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6199 6263 6360)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1766 4015 5428)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2184 3372 4336)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6070 6167 6263)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7901 7934 7966)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7934 7934 7934)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5589 5653 5942)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(642 2601 4015)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7452 7484 7548)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2152 2762 3340)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4079 4175 4304)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8158 8158 8158)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(4882 5300 5685)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(5846 5942 6070)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(2120 3597 4529)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1991 3629 4625)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7227 7420 7516)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3565 4111 4561)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(3308 4111 4818)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1991 4818 6424)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6906 6938 7002)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7259 7259 7323)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(7580 7612 7644)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(995 2666 3950)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(6424 6520 6584)))
								collect:
									[:each | 
									(each at: 1) value
										perform: (each at: 2)
										withArguments: (each at: 3)]))
				usingBits:
					(ByteArray fromPackedString:
							'HB@ HB@ HB@ HB@ HB@ HB@ HB@ @@@@HB@ HB@ HC(5GF8 HB@ HB@ HB@ @@@@HB@ HB@ HE@$ @YXSB@ HB@ I(UW@@@@HB@ HB@ HGA,]SPL^3L]Z@P/%)I\@@@@HB@ HB@ HAL''] P C0(ZDSBI!!#%F@@@@HB@ HB@ AT$7HB@ HB@ H@="WX -@@@@HB@ HB@,$5X HB@ HB@ H@,"!!E( @@@@HB@WZ0E:HB@ HB@ HB@OR78OHB@ @@@@HB@TJ$D HB@ HB@ HHP<  < HB@ @@@@HBAQ[A, HB@  5$BQSI7K"@ HB@ @@@@HB@PG2T HB@ Y"FA$FH HB@ HB@ @@@@HB@VSPH HB@ JD@+\YT HB@ HB@ @@@@HB@JA6P HB@ _S =D(\ HB@ HB@ @@@@HB@JA6P HB@ LVAB#F%$HB@ HB@ @@@@HB@JA6P HB@ HB@ H@M#S2@ HB@ @@@@HBBT_5L HB@ HB@ HH(MUD< HB@ @@@@HBACQ1$ HB@ HB@ HB@ M$)*^V< @@@@HC.M#X.WEQTUEQTUEQT?RE8#_E, @@@@HH<^XU=K\7M3\7M3\7M3B@@NY4P @@@@HGJQ$R$.HB@ HB@ HB@ HEHXS&T @@@@'))! !

!CMSpecPovSetter_Agent class methodsFor: 'resources' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
vectorMask
	"Tools.UIMaskEditor new openOnClass: self andSelector: #vectorMask"
	
	<resource: #image>
	^CachedImage
		on:
			(Image
				extent: 21 @ 20
				depth: 1
				bitsPerPixel: 1
				palette: CoveragePalette monoMaskPalette
				usingBits:
					#[0 0 0 0 1 224 0 0 1 248 56 0 1 255 248 0 1 255 248 0 3 248 248 0 7 232 240 0 60 99 224 0 56 127 128 0 56 127 0 0 56 124 0 0 56 125 0 0 56 124 0 0 56 126 0 0 56 7 0 0 56 7 240 0 56 1 240 0 127 255 240 0 127 255 240 0 127 255 240 0])! !

!CMSpecPovSetter_Agent class methodsFor: 'interface specs' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
windowSpec
	"Tools.UIPainter new openOnClass: self andSelector: #windowSpec"
	
	<resource: #canvas>
	^#(FullSpec 
		#window: #(WindowSpec 
			#label: #(UserMessage 
				#key: #observationOfEntity 
				#defaultString: 'Observation of Entity') 
			#min: #(Point 637 406) 
			#max: #(Point 414 423) 
			#bounds: #(Rectangle 746 158 1383 564) 
			#colors: #(LookPreferences 
				#setBackgroundColor: #(ColorValue 4096 6143 8191)) 
			#isEventDriven: true) 
		#component: #(SpecCollection 
			#collection: #(#(RegionSpec 
				#layout: #(Rectangle -3 -5 638 408) 
				#name: #fond 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue 4091 6142 8191) 
					#setBackgroundColor: #(ColorValue 3810 5717 7621)) 
				#lineWidth: 1) #(RegionSpec 
				#layout: #(Rectangle 7 176 275 371) 
				#name: #Region2 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#lineWidth: 1) #(RegionSpec 
				#layout: #(Rectangle 424 10 631 160) 
				#name: #Region6 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue 7700 7700 7700)) 
				#lineWidth: 1) #(RegionSpec 
				#layout: #(Rectangle 7 12 383 161) 
				#name: #Region5 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue 7700 7700 7700)) 
				#lineWidth: 1) #(GroupBoxSpec 
				#layout: #(Rectangle 5 3 385 163) 
				#name: #GroupBox3 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue 3072 3072 8191)) 
				#label: #(UserMessage 
					#key: #povDefinition 
					#defaultString: ' PoV definition ')) #(RegionSpec 
				#layout: #(Rectangle 422 172 630 370) 
				#name: #Region3 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue 7700 7700 7700)) 
				#lineWidth: 1) #(LabelSpec 
				#layout: #(Point 239 17) 
				#label: #(UserMessage 
					#key: #associatedSymbols 
					#defaultString: 'Associated Symbols') 
				#style: #pixelDefault) #(SequenceViewSpec 
				#layout: #(Rectangle 221 36 378 155) 
				#name: #pov 
				#model: #listSymbols 
				#menu: #menuSymbolePDV 
				#multipleSelections: false) #(SliderSpec 
				#layout: #(Rectangle 77 283 177 301) 
				#name: #greenSlider 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 6553 6553 6553) 
					#setSelectionBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#model: #greenSlider 
				#orientation: #horizontal 
				#start: 0 
				#stop: 1 
				#step: 0.01) #(SliderSpec 
				#layout: #(Rectangle 77 310 177 328) 
				#name: #blueSlider 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 6553 6553 6553) 
					#setSelectionBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#model: #blueSlider 
				#orientation: #horizontal 
				#start: 0 
				#stop: 1 
				#step: 0.01) #(LabelSpec 
				#layout: #(Point 13 255) 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #red) 
					#setBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#label: #(UserMessage 
					#key: #red 
					#defaultString: 'Red')) #(LabelSpec 
				#layout: #(Point 13 282) 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue 0 4986 0) 
					#setBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#label: #(UserMessage 
					#key: #green 
					#defaultString: 'Green')) #(LabelSpec 
				#layout: #(Point 13 308) 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue 0 0 4986) 
					#setBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#label: #(UserMessage 
					#key: #blue 
					#defaultString: 'Blue')) #(SliderSpec 
				#layout: #(Rectangle 77 344 177 360) 
				#name: #brightnessSlider 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 6553 6553 6553) 
					#setSelectionBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#model: #brightnessSlider 
				#orientation: #horizontal 
				#start: 0 
				#stop: 1 
				#step: 0.01) #(GroupBoxSpec 
				#layout: #(Rectangle 6 167 277 373) 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue 3072 3072 8191)) 
				#label: #(UserMessage 
					#key: #color 
					#defaultString: ' Set the Color ')) #(ActionButtonSpec 
				#layout: #(Rectangle 107 375 212 402) 
				#name: #boutonAppliquer 
				#flags: 40 
				#model: #validate 
				#label: #(UserMessage 
					#key: #apply 
					#defaultString: 'Apply') 
				#isDefault: false 
				#defaultable: true) #(SequenceViewSpec 
				#layout: #(Rectangle 10 36 205 154) 
				#name: #listMethods 
				#model: #listMethods 
				#callbacksSpec: #(UIEventCallbackSubSpec 
					#doubleClickSelector: #modifyPov) 
				#menu: #menuPDV 
				#multipleSelections: false) #(LabelSpec 
				#layout: #(Point 13 17) 
				#label: #(UserMessage 
					#key: #methodesreturningSymbol 
					#defaultString: 'Methodes returning a Symbol') 
				#style: #pixelDefault) #(InputFieldSpec 
				#layout: #(Rectangle 179 254 215 276) 
				#flags: 0 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#model: #redSlider 
				#tabable: true 
				#style: #pixelDefault 
				#type: #number 
				#formatString: '0.00') #(InputFieldSpec 
				#layout: #(Rectangle 178.5 281 217.0 303) 
				#flags: 0 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#model: #greenSlider 
				#style: #pixelDefault 
				#type: #number 
				#formatString: '0.00') #(InputFieldSpec 
				#layout: #(Rectangle 179 308 215 331) 
				#flags: 0 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#model: #blueSlider 
				#style: #pixelDefault 
				#type: #number 
				#formatString: '0.00') #(InputFieldSpec 
				#layout: #(Rectangle 179 341 217 361) 
				#flags: 0 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#model: #brightnessSlider 
				#style: #pixelDefault 
				#type: #number 
				#formatString: '0.00') #(LabelSpec 
				#layout: #(Point 13 340) 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#label: #(UserMessage 
					#key: #brightness 
					#defaultString: 'Brightness')) #(SequenceViewSpec 
				#layout: #(Rectangle 430 36 624 152) 
				#name: #List1 
				#model: #listInfo 
				#callbacksSpec: #(UIEventCallbackSubSpec 
					#doubleClickSelector: #modifyInfo) 
				#menu: #menuInfo 
				#useModifierKeys: true 
				#selectionType: #highlight) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 537 224 580 264) 
				#name: #openImageEditorButton 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue #white)) 
				#model: #openBitmapImageEditor 
				#helpText: #(UserMessage 
					#key: #OpenBitmapImageEditor 
					#defaultString: 'Open a Bitmap image editor') 
				#label: #bitmapIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(GroupBoxSpec 
				#layout: #(Rectangle 422 164 632 372) 
				#name: #GroupBox1 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue 3072 3072 8191)) 
				#label: #(UserMessage 
					#key: #createimage 
					#defaultString: ' Create the Image ')) #(LabelSpec 
				#layout: #(Point 460 282) 
				#name: #Label2 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 7700 7700 7700)) 
				#label: #(UserMessage 
					#key: #size1 
					#defaultString: 'Relative size')) #(LabelSpec 
				#layout: #(Point 462 301) 
				#name: #Label3 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 7700 7700 7700)) 
				#label: #(UserMessage 
					#key: #size2 
					#defaultString: 'of the entity:')) #(SliderSpec 
				#layout: #(Rectangle 443 274 461 365) 
				#name: #tailleSlider 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 7700 7700 7700)) 
				#model: #tailleSlider 
				#orientation: #vertical 
				#start: 0.1 
				#stop: 2 
				#step: 0.1) #(InputFieldSpec 
				#layout: #(Rectangle 478 325 505 340) 
				#name: #pourcentTailleIndicateur 
				#flags: 0 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 7700 7700 7700)) 
				#model: #tailleSlider 
				#style: #pixelDefault 
				#type: #number 
				#formatString: '0%') #(RegionSpec 
				#layout: #(Rectangle 308 296 391 379) 
				#name: #Region1 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue #white)) 
				#lineWidth: 1) #(GroupBoxSpec 
				#layout: #(Rectangle 422 3 632 162) 
				#name: #GroupBox2 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue 3072 3072 8191)) 
				#label: #(UserMessage 
					#key: #informationToBeDisplay 
					#defaultString: ' Information to be displayed ')) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 538 183 581 223) 
				#name: #openVectorEditorButton 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue #white)) 
				#model: #openVectorImageEditor 
				#helpText: #(UserMessage 
					#key: #OpenaVectorialimageeditor 
					#defaultString: 'Open a Vectorial image editor') 
				#label: #vectorIcon 
				#hasCharacterOrientedLabel: false 
				#isDefault: false 
				#defaultable: true) #(LabelSpec 
				#layout: #(Point 472 194) 
				#name: #Label5 
				#label: #(UserMessage 
					#key: #vectorial 
					#defaultString: 'Vectorial:')) #(LabelSpec 
				#layout: #(Point 481 229) 
				#name: #Label6 
				#label: 'Bitmap:') #(LabelSpec 
				#layout: #(Point 451 17) 
				#name: #Label1 
				#label: #(UserMessage 
					#key: #methodesreturningString 
					#defaultString: 'Methodes returning a String') 
				#style: #pixelDefault) #(RadioButtonSpec 
				#layout: #(Point 301 183) 
				#name: #RadioButton6 
				#model: #occupantPosition 
				#helpText: 'Put the entity image randomly on its cell' 
				#label: #(UserMessage 
					#key: #randomly 
					#defaultString: 'randomly') 
				#select: #random) #(DividerSpec 
				#layout: #(LayoutSizedOrigin 322 0 295 0 2 84) 
				#name: #Divider3 
				#orientation: #vertical) #(DividerSpec 
				#layout: #(LayoutSizedOrigin 375 0 295 0 2 84) 
				#name: #Divider4 
				#orientation: #vertical) #(DividerSpec 
				#layout: #(LayoutSizedOrigin 307 0 310 0 84 4) 
				#name: #Divider1) #(DividerSpec 
				#layout: #(LayoutSizedOrigin 307 0 364 0 85 4) 
				#name: #Divider2) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 580 224 623 264) 
				#name: #ActionButton1 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue #white)) 
				#model: #openBitmapLibrary 
				#label: #libraryIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(GroupBoxSpec 
				#layout: #(Rectangle 282 167 411 278) 
				#name: #GroupBox4 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue 3072 3072 8191)) 
				#label: #(UserMessage 
					#key: #createimage 
					#defaultString: ' Position on the cell ')) #(SubCanvasSpec 
				#layout: #(Rectangle 12 190 275 240) 
				#flags: 0 
				#majorKey: PovSetter 
				#minorKey: #palette) #(SliderSpec 
				#layout: #(Rectangle 77 255 177 273) 
				#name: #redSlider 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#model: #redSlider 
				#orientation: #horizontal 
				#start: 0 
				#stop: 1 
				#step: 0.01) #(RadioButtonSpec 
				#layout: #(Point 328 213) 
				#name: #RadioButton2 
				#model: #occupantPosition 
				#select: #topLeft) #(RadioButtonSpec 
				#layout: #(Point 328 229) 
				#name: #RadioButton7 
				#model: #occupantPosition 
				#select: #leftCenter) #(RadioButtonSpec 
				#layout: #(Point 328 245) 
				#name: #RadioButton4 
				#model: #occupantPosition 
				#select: #bottomLeft) #(RadioButtonSpec 
				#layout: #(Point 343 245) 
				#name: #RadioButton8 
				#model: #occupantPosition 
				#select: #bottomCenter) #(RadioButtonSpec 
				#layout: #(Point 343 229) 
				#name: #RadioButton1 
				#model: #occupantPosition 
				#select: #center) #(RadioButtonSpec 
				#layout: #(Point 343 213) 
				#name: #RadioButton10 
				#model: #occupantPosition 
				#select: #topCenter) #(RadioButtonSpec 
				#layout: #(Point 358 213) 
				#name: #RadioButton5 
				#model: #occupantPosition 
				#select: #topRight) #(RadioButtonSpec 
				#layout: #(Point 358 229) 
				#name: #RadioButton9 
				#model: #occupantPosition 
				#select: #rightCenter) #(RadioButtonSpec 
				#layout: #(Point 358 245) 
				#name: #RadioButton3 
				#model: #occupantPosition 
				#select: #bottomRight) #(RadioButtonSpec 
				#layout: #(Point 314 200) 
				#name: #RadioButton11 
				#model: #occupantPosition 
				#select: #border_topLeft) #(RadioButtonSpec 
				#layout: #(Point 314 229) 
				#name: #RadioButton12 
				#model: #occupantPosition 
				#select: #border_leftCenter) #(RadioButtonSpec 
				#layout: #(Point 314 258) 
				#name: #RadioButton13 
				#model: #occupantPosition 
				#select: #border_bottomLeft) #(RadioButtonSpec 
				#layout: #(Point 372 258) 
				#name: #RadioButton14 
				#model: #occupantPosition 
				#select: #border_bottomRight) #(RadioButtonSpec 
				#layout: #(Point 372 229) 
				#name: #RadioButton15 
				#model: #occupantPosition 
				#select: #border_rightCenter) #(RadioButtonSpec 
				#layout: #(Point 372 200) 
				#name: #RadioButton16 
				#model: #occupantPosition 
				#select: #border_topRight) #(RadioButtonSpec 
				#layout: #(Point 343 200) 
				#name: #RadioButton17 
				#model: #occupantPosition 
				#select: #border_topCenter) #(RadioButtonSpec 
				#layout: #(Point 343 258) 
				#name: #RadioButton18 
				#model: #occupantPosition 
				#select: #border_bottomCenter) #(CheckBoxSpec 
				#layout: #(Point 541 285) 
				#name: #isDistortable 
				#model: #isDistortable 
				#label: 'is distortable') #(LabelSpec 
				#layout: #(Point 540 304) 
				#name: #Label4 
				#label: '(adapt to cell shape)' 
				#style: #pixelSmall) #(RegionSpec 
				#layout: #(Rectangle 320 208 378 267) 
				#name: #virtualCell 
				#lineWidth: 1) #(ArbitraryComponentSpec 
				#layout: #(LayoutSizedOrigin 284 0 273 0 130 130) 
				#name: #ViewHolder2 
				#flags: 0 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue #white)) 
				#component: #imageOS) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication false) 
				#layout: #(Rectangle 579 183 622 223) 
				#name: #ActionButton2 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue #white)) 
				#model: #openVectorialLibrary 
				#label: 'Lib' 
				#style: #large 
				#defaultable: true) #(CompositeSpecCollection 
				#collection: #(#(RegionSpec 
					#layout: #(Rectangle 0 0 108 101) 
					#name: #Region4 
					#colors: #(LookPreferences 
						#setForegroundColor: #(ColorValue 4915 4915 4915) 
						#setBackgroundColor: #(ColorValue 7700 7700 7700))) #(CompositeSpecCollection 
					#collection: #(#(ActionButtonSpec 
						#layout: #(Rectangle 54 53 96 75) 
						#name: #ActionButton3 
						#model: #shrunkeBitmap 
						#label: '/ 2' 
						#defaultable: true) #(LabelSpec 
						#layout: #(Point 0 54) 
						#name: #Label9 
						#label: 'shrunke') #(ActionButtonSpec 
						#layout: #(Rectangle 54 27 96 49) 
						#name: #ActionButton5 
						#model: #resetBitmapSize 
						#label: '100%' 
						#defaultable: true) #(LabelSpec 
						#layout: #(Point 13 28) 
						#name: #Label10 
						#label: 'reset') #(ActionButtonSpec 
						#layout: #(Rectangle 54 0 96 22) 
						#name: #ActionButton4 
						#model: #magnifyBitmap 
						#label: 'x 2' 
						#defaultable: true) #(LabelSpec 
						#layout: #(Point 0 1) 
						#name: #Label8 
						#label: 'magnify')) 
					#compositeSpec: #(CompositeSpec 
						#layout: #(Rectangle 8 20 104 95) 
						#name: #Composite1))) 
				#compositeSpec: #(CompositeSpec 
					#layout: #(Rectangle 426 267 534 368) 
					#name: #CacheBitmap)))))! !

!CMSpecPovSetter_Agent methodsFor: 'adding' stamp: 'HernanMoralesDurand 12/19/2017 18:35'!
addSameSymbolAs: aSymbolString ofEntity: aClass
	
	| aString |
	(aString := self addSymbolPov) ifNotNil: [
		selectedClass povDict
			at: aString asSymbol
			put: (aClass povDict at: aSymbolString asSymbol) copy.
		self updateMenuAddSameAs.
		self listSymbolsChanged ]! !

!CMSpecPovSetter_Agent methodsFor: 'menu-symbol' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
addSubMenuSymbolSameAsTo: aMenuBuilder from: aListOfStrings for: aClass
	"a selection of an item calls the method addSameSymbolAs: aSymbol ofEntity: aClass"
	
	aMenuBuilder beginSubMenuLabeled: aClass name asString.
	aListOfStrings
		do:
			[:aSymbolString | 
			aMenuBuilder
				addLabel: aSymbolString
				value: [self addSameSymbolAs: aSymbolString ofEntity: aClass]].
	aMenuBuilder endSubMenu.
	aMenuBuilder line! !

!CMSpecPovSetter_Agent methodsFor: 'action' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
addSymbolPov: aString
	
	(super addSymbolPov: aString) ifNotNil: [self updateMenuAddSameAs].
	^aString! !

!CMSpecPovSetter_Agent methodsFor: 'changed' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
colorChanged
	
	| color |
	color := super colorChanged.
	self imageOS model color: color.
	imageOS figure fillColor: color.
	imageOS invalidate! !

!CMSpecPovSetter_Agent methodsFor: 'image' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
filledPolygon
	
	imageOS model isStroked: false.
	self updateMenuImage.
	(self builder componentAt: #boutonAppliquer) enable.
	imageOS invalidate! !

!CMSpecPovSetter_Agent methodsFor: 'menu-symbol' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
initMenuAddSameAs
	"a selection of one of this item create a new symbol which shape is a copy of the selected item"
	
	| aMenuBuilder ve listOfSymbolsString |
	aMenuBuilder := MenuBuilder new.
	self
		addSubMenuSymbolSameAsTo: aMenuBuilder
		from: self listSymbols list
		for: selectedClass.
	ve := self visualizedEntities.
	ve remove: selectedClass.
	ve
		do:
			[:aClass | 
			listOfSymbolsString := List new.
			aClass povDict keys do: [:aS | listOfSymbolsString add: aS asString].
			self addSubMenuSymbolSameAsTo: aMenuBuilder from: listOfSymbolsString
				for: aClass].
	self menuAddSameAs addPart: aMenuBuilder menu.
	self menuAddSameAs hideItem: (self menuAddSameAs menuItemLabeled: 'bidon')! !

!CMSpecPovSetter_Agent methodsFor: 'initialize-release' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
initialize
	
	super initialize.
	tailleHolder := 1 asValue.
	tailleHolder onChangeSend: #sizeSliderChanged to: self.
	tailleSlider := RangeAdaptor on: tailleHolder start: 0.1 stop: 1 grid: 0.1.
	self occupantPosition onChangeSend: #positionChanged to: self! !

!CMSpecPovSetter_Agent methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
isDistortable
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^isDistortable isNil
		ifTrue: [isDistortable := false asValue]
		ifFalse: [isDistortable]! !

!CMSpecPovSetter_Agent methodsFor: 'image' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
lineWidth
	
	| n |
	n := Cormas current
		request: 'Epaisseur du Trait : '
		initialAnswer: imageOS model lineWidth displayString.
	imageOS model lineWidth: n asNumber.
	(self builder componentAt: #boutonAppliquer) enable.
	imageOS invalidate! !

!CMSpecPovSetter_Agent methodsFor: 'changed' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
listSymbolsChanged
	
	| anImage aColor |
	self listSymbols selection ifNil: [^nil].
	anImage := selectedClass imageAtPov: listSymbols selection asSymbol.
	imageOS model: anImage copy.	"The model is the copy of the stored image and is be used to store the parameters of the bitmapPov"
	imageOS figure: imageOS model asFigure.	"imageOS figure is resized according to the sizeRatio of the image. It is used for the display on the povSetter view"
	self tailleSlider value: anImage sizeRatio.
	self isDistortable value: anImage isDistortable.
	anImage isBitmapPOV
		ifTrue: [(self builder componentAt: #CacheBitmap) beVisible]
		ifFalse:
			[aColor := anImage color.
			imageOS model color: aColor.
			self updateSlidersFromColor: aColor.
			(self builder componentAt: #CacheBitmap) beInvisible.
			(self builder componentAt: #tailleSlider) beVisible].
	self occupantPosition value: anImage position.
	imageOS invalidate! !

!CMSpecPovSetter_Agent methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
magnifyBitmap
	"imageOS figure cache magnifiedBy: 2 @ 2."
	
	(imageOS figure scaleByWithAnswer: 2) ifFalse: [^self].	"pour les bitmap, un petit changement ne produit pas de d√©formation du bitmap, et il n efaut donc pas changer le size Ratio"
	self positionChanged.	"ici on recacul la position en fonction de la position sp√©cifi√© sur l''interface"
	imageOS model sizeRatio: 2.
	self builder ifNil: [^self].
	(self builder componentAt: #boutonAppliquer) enable.
	imageOS invalidate.
	(self builder componentAt: #CacheBitmap) beVisible.
	(self builder componentAt: #tailleSlider) beInvisible! !

!CMSpecPovSetter_Agent methodsFor: 'menu-symbol' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
menuAddSameAs
	"return a Menu : #menuSymbolePDV menu"
	
	^((self builder menuAt: #menuSymbolePDV) value atNameKey: #addSymbolSameAs)
		submenu! !

!CMSpecPovSetter_Agent methodsFor: 'menu-symbol' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
menuDefaultColor
	"return a Menu : #menuSymbolePDV menu"
	
	^((self builder menuAt: #menuSymbolePDV) value atNameKey:
			#submenuSetDefaultColor) submenu! !

!CMSpecPovSetter_Agent methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
modifyPov: povName
	
	selectedClass
		compile:
			(povName asString ,
					'\"return a symbol that is associated to an image"\   ^#aSymbol\')
				withCRs
		classified: 'pov'
		notifying: nil.
	self editMethod: povName fromClass: selectedClass! !

!CMSpecPovSetter_Agent methodsFor: 'image' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
nbSegments
	
	| n |
	(n := Cormas current
		request: 'Nombre de Segments : '
		initialAnswer: imageOS model nbSegments displayString) isEmpty
		ifFalse:
			[imageOS model nbSegments: n asNumber.
			(self builder componentAt: #boutonAppliquer) enable.
			imageOS invalidate]! !

!CMSpecPovSetter_Agent methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
occupantPosition
	
	^occupantPosition isNil
		ifTrue: [occupantPosition := #center asValue]
		ifFalse: [occupantPosition]! !

!CMSpecPovSetter_Agent methodsFor: 'editor' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
openBitmapImageEditor
	
	| editor |
	editor := ImageEditor openOnClass: self class.
	editor observer: self.
	editor loadCurrentImage! !

!CMSpecPovSetter_Agent methodsFor: 'image library' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
openBitmapLibrary
	
	| lib |
	BitmapImageLibrary imLibPage: 1.
	lib := BitmapImageLibrary new.
	lib observer: self.
	lib open! !

!CMSpecPovSetter_Agent methodsFor: 'editor' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
openVectorImageEditor
	
	| editor |
	"editor := VectorialImageEditor example."
	editor := VectorialImageEditor open.
	editor observer: self.
	editor loadCurrentImage! !

!CMSpecPovSetter_Agent methodsFor: 'image library' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
openVectorialLibrary
	
	| lib |
	VectorialImageLibrary imLibPage: 1.
	lib := VectorialImageLibrary new.
	lib observer: self.
	lib open! !

!CMSpecPovSetter_Agent methodsFor: 'changed' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
positionChanged
	"Display the figure at the right position on the virtualCell"
	
	| figurePosition |
	imageOS model position: occupantPosition value.
	self builder ifNil: [^self].
	(self builder componentAt: #virtualCell) bounds.
	(self builder componentAt: #boutonAppliquer) enable.	"figurePosition := imageOS figure calculateNewPositionOnPatchBounds: ((self builder componentAt: #virtualCell) bounds moveTo: -17 @ -19)."
	occupantPosition value = #topLeft ifTrue: [figurePosition := -17 @ -17].
	occupantPosition value = #leftCenter ifTrue: [figurePosition := -17 @ 0].
	occupantPosition value = #bottomLeft ifTrue: [figurePosition := -17 @ 17].
	occupantPosition value = #topRight ifTrue: [figurePosition := 17 @ -17].
	occupantPosition value = #rightCenter ifTrue: [figurePosition := 17 @ 0].
	occupantPosition value = #bottomRight ifTrue: [figurePosition := 17 @ 17].
	occupantPosition value = #topCenter ifTrue: [figurePosition := 0 @ -17].
	occupantPosition value = #center ifTrue: [figurePosition := 0 @ 0].
	occupantPosition value = #bottomCenter ifTrue: [figurePosition := 0 @ 17].
	occupantPosition value = #random ifTrue: [figurePosition := 4 @ 6].
	occupantPosition value = #border_topLeft
		ifTrue: [figurePosition := -25 @ -25].
	occupantPosition value = #border_leftCenter
		ifTrue: [figurePosition := -25 @ 0].
	occupantPosition value = #border_bottomLeft
		ifTrue: [figurePosition := -25 @ 25].
	occupantPosition value = #border_topRight
		ifTrue: [figurePosition := 25 @ -25].
	occupantPosition value = #border_rightCenter
		ifTrue: [figurePosition := 25 @ 0].
	occupantPosition value = #border_bottomRight
		ifTrue: [figurePosition := 25 @ 25].
	occupantPosition value = #border_topCenter
		ifTrue: [figurePosition := 0 @ -25].
	occupantPosition value = #border_bottomCenter
		ifTrue: [figurePosition := 0 @ 25].
	imageOS figure isBitmapFigure
		ifTrue: [imageOS figure translateTo: figurePosition]
		ifFalse:
			["it is a vectorialFigure"
			imageOS figure
				translateTo: figurePosition - (imageOS figure bounds extent / 2)].
	imageOS invalidate! !

!CMSpecPovSetter_Agent methodsFor: 'saving&removing pov symbols' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
removeClassMethodForSymbol: aSymbol
	
	imageOS model copy isBitmapPOV
		ifTrue:
			[selectedClass class removeSelector: ('BitmapPOV_' , aSymbol) asSymbol.
			selectedClass class removeSelector: (aSymbol , 'BitmapImage') asSymbol]
		ifFalse:
			[selectedClass class removeSelector: ('VectorialPOV_' , aSymbol) asSymbol]! !

!CMSpecPovSetter_Agent methodsFor: 'action' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
removeSymbolPov
	
	| aString |
	aString := super removeSymbolPov.
	aString
		ifNotNil:
			[selectedClass povDict
				removeKey: aString asSymbol
				ifAbsent: [nil].
			self updateMenuAddSameAs]! !

!CMSpecPovSetter_Agent methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
resetBitmapSize
	
	self listSymbolsChanged! !

!CMSpecPovSetter_Agent methodsFor: 'menu-symbol' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
saveBitmapImage: aPOV in: aClass
	"Dans le cas d'image Bitmap, l'image est sauvegard√©e au niveau de la classe de l'entit√© /// protocol 'images - bitmap'
(dans le cas d'un VectorialPOV, la sauveagrde se fait au niveau du fichier ev, dans le cas on inscrit l'ensemble des attributs de l'image).
Par contre l'attribut position du POV, m√™me pour un POV d type Bitmap image,est sauvegard√© adans le fichier ev "
	
	| image s class imageName |
	aPOV isBitmapPOV
		ifTrue:
			[image := aPOV bitmap.
			class := aClass class.
			imageName := self listSymbols selection , 'BitmapImage'.
			s := WriteStream on: (String new: image bits size // 8).
			s
				nextPutAll: imageName;
				cr.
			s
				tab;
				crtab;
				nextPutAll: '<resource: #image>';
				crtab;
				nextPut: $^.
			s nextPutAll: image minimalStorageString.
			class
				compile: s contents
				classified: #'images - bitmap']! !

!CMSpecPovSetter_Agent methodsFor: 'saving&removing pov symbols' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
saveBitmapImage: aPOV intoClass: aClass symbol: aSymbol
	"Dans le cas d'image Bitmap, l'image est sauvegard√©e au niveau de la classe de l'entit√© /// protocol 'images - bitmap'
(dans le cas d'un VectorialPOV, la sauveagrde se fait au niveau du fichier ev, dans le cas on inscrit l'ensemble des attributs de l'image).
Par contre l'attribut position du POV, m√™me pour un POV d type Bitmap image,est sauvegard√© adans le fichier ev "
	
	| image s class imageName |
	aPOV isBitmapPOV
		ifTrue:
			[image := aPOV bitmap figure image.
			class := aClass class.
			imageName := aSymbol , 'BitmapImage'.
			s := WriteStream on: (String new: image bits size // 8).
			s
				nextPutAll: imageName;
				cr.
			s
				tab;
				crtab;
				nextPutAll: '<resource: #image>';
				crtab;
				nextPut: $^.
			s nextPutAll: image minimalStorageString.
			class
				compile: s contents
				classified: 'pov symbols']! !

!CMSpecPovSetter_Agent methodsFor: 'saving&removing pov symbols' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
saveBitmapPOV: aPOV intoClass: aClass symbol: aSymbol
	
	| selector |
	selector := 'BitmapPOV_' , aSymbol.
	aClass class
		compile:
			(selector ,
					'\"Returns an array containing the settings of a Situated entity bitmap pov symbol in the following order:\(position)\The bitmap itself corresponding to the symbol is in the selector '
				, aSymbol printString , 'BitmapImage"\^Array with: '
				, aPOV position printString) withCRs
		classified: 'pov symbols'
		notifying: nil.
	self saveBitmapImage: aPOV intoClass: aClass symbol: aSymbol! !

!CMSpecPovSetter_Agent methodsFor: 'saving&removing pov symbols' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
savePOVsymbol: aSymbol
	
	| aPOV |
	aPOV := imageOS model copy.
	aPOV isBitmapPOV
		ifTrue:
			[self
				saveBitmapPOV: imageOS model copy
				intoClass: selectedClass
				symbol: aSymbol.
			selectedClass class removeSelector: ('VectorialPOV_' , aSymbol) asSymbol]
		ifFalse:
			[self
				saveVectorialPOV: imageOS model copy
				intoClass: selectedClass
				symbol: aSymbol.
			selectedClass class removeSelector: ('BitmapPOV_' , aSymbol) asSymbol.
			selectedClass class removeSelector: (aSymbol , 'BitmapImage') asSymbol]! !

!CMSpecPovSetter_Agent methodsFor: 'saving&removing pov symbols' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
saveVectorialPOV: aPOV intoClass: aClass symbol: aSymbol
	
	| selector |
	selector := 'VectorialPOV_' , aSymbol.
	aClass class
		compile:
			(selector ,
					'\"Returns an array containing the settings of a Situated entity vectorial pov symbol in the following order:\(color red) (color green) (color blue) (lineColor red) (lineColor green) (lineColor blue) lineWidth sizeratio position (array of outline vertices) isDistortable." \^#('
				, aPOV color red printString , ' ' , aPOV color green printString , ' '
				, aPOV color blue printString , ' ' , aPOV lineColor red printString ,
					' ' , aPOV lineColor green printString , ' '
				, aPOV lineColor blue printString , ' ' , aPOV lineWidth printString ,
					' ' , aPOV sizeRatio printString , ' ' , aPOV position printString ,
					' ' , aPOV outline vertices printString , ' '
				, aPOV isDistortable printString , ')') withCRs
		classified: 'pov symbols'
		notifying: nil! !

!CMSpecPovSetter_Agent methodsFor: 'menu-symbol' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
setDefaultColor
	
	| aCV green red blue |
	aCV := PovSetter colorChooser.
	aCV ifNil: [^nil].
	green := aCV green.
	red := aCV red.
	blue := aCV blue.
	selectedClass class
		compile:
			('defaultColor 
				\^ColorValue red: ' , red printString , ' green: ' , green printString
				, ' blue: ' , blue printString) withCRs
		classified: 'pov symbols'
		notifying: nil! !

!CMSpecPovSetter_Agent methodsFor: 'initialize-release' stamp: 'HernanMoralesDurand 12/19/2017 18:30'!
setListSymbols
	
	| liste |
	listSymbols selectionIndexHolder onChangeSend: #listSymbolsChanged to:
			self.
	liste := OrderedCollection new.
	liste addAll: (selectedClass povDict keys collect: [:pov | pov asString]).
	(liste includes: selectedClass name asString)
		ifFalse: [liste addFirst: selectedClass name asString].
	self listSymbols list: liste sort.
	liste isEmpty ifFalse: [listSymbols selection: listSymbols list first]! !

!CMSpecPovSetter_Agent methodsFor: 'menu-symbol' stamp: 'HernanMoralesDurand 12/19/2017 18:31'!
setModelClass: aClass
	
	super setModelClass: aClass.	"set the background color adapted to class"
	(aClass inheritsFrom: CMAgent)
		ifFalse:
			[(self builder componentAt: #fond) component component
				insideColor: (Color red: 1.0 green: 0.624954 blue: 0.250031)].
	self initMenuAddSameAs! !

!CMSpecPovSetter_Agent methodsFor: 'editor' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
setNewBitMapImage
	
	self setNewBitmapImage: self class cachedImage asImage! !

!CMSpecPovSetter_Agent methodsFor: 'editor' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
setNewBitmapImage: anImage
	
	| im |
	"on adapte le slider avant de coller l'image dans imageOS"
	"tailleHolder value: ((im preferredBounds extent x / self imageOS bounds extent x 
				max: im preferredBounds extent y / self imageOS bounds extent y) min: 2)."
	tailleHolder value: 1.
	im := anImage.	"si image trop grande, on la r√©tr√©cit"
	[im preferredBounds extent > (self imageOS bounds extent * 1.5)]
		whileTrue:
			[im := im shrunkenBy: 2 @ 2.
			tailleHolder value: tailleHolder value / 2].
	imageOS model: (BitmapPOV newFrom: im).
	imageOS figure: imageOS model asFigure.
	(self builder componentAt: #boutonAppliquer) enable.
	(self builder componentAt: #isDistortable) disable.
	(self builder componentAt: #CacheBitmap) beVisible.
	imageOS invalidate! !

!CMSpecPovSetter_Agent methodsFor: 'editor' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
setNewVectorialImage: aPOV
	
	(aPOV isKindOf: VectorialPOV) ifFalse: [^nil].
	aPOV
		scaledBy:
			PovSetter standardCellBounds extent
				/ (aPOV bounds extent x max: aPOV bounds extent y).
	imageOS model: aPOV.
	imageOS figure: imageOS model asFigure.
	self tailleSlider value: aPOV sizeRatio.	"on met le tailleSlider √† 100% sans alerter les listeners"
	couleur := imageOS model color.
	self updateSlidersFromColor: couleur.
	(self builder componentAt: #boutonAppliquer) enable.
	(self builder componentAt: #isDistortable) enable.
	(self builder componentAt: #CacheBitmap) beInvisible.
	(self builder componentAt: #tailleSlider) beVisible.
	imageOS invalidate! !

!CMSpecPovSetter_Agent methodsFor: 'menu-symbol' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
setSymbolAsDefaultImage
	"selectedClass povDict at: listSymbols selection asSymbol"
	
	(self cormas confirm:
			'The selected image will be the shape for the next symbols of the class')
		ifFalse: [^nil].
	listSymbols selection isNil
		ifTrue: [^self cormas warn: 'Please, select a symbol'].
	((selectedClass povDict at: listSymbols selection asSymbol) isKindOf:
			BitmapPOV)
		ifTrue: [^self cormas warn: 'Cannot define a shape from a bitmap'].
	selectedClass class
		compile:
			('defaultImage' ,
					'\"returns a copy of the POV image stored in the povDict of the class at a specifed symbol key"\^((self povDict at: #'
				, listSymbols selection , ' ifAbsent:[super defaultImage]) copy')
				withCRs
		classified: 'pov symbols'
		notifying: nil! !

!CMSpecPovSetter_Agent methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
shrunkeBitmap
	
	(imageOS figure scaleByWithAnswer: 0.5) ifFalse: [^self].	"pour les bitmap, un petit changement ne produit pas de d√©formation du bitmap, et il n efaut donc pas changer le size Ratio"
	self positionChanged.	"ici on recacul la position en fonction de la position sp√©cifi√© sur l''interface"
	imageOS model sizeRatio: 0.5.
	self builder ifNil: [^self].
	(self builder componentAt: #boutonAppliquer) enable.
	imageOS invalidate.
	(self builder componentAt: #CacheBitmap) beVisible.
	(self builder componentAt: #tailleSlider) beInvisible! !

!CMSpecPovSetter_Agent methodsFor: 'changed' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
sizeSliderChanged
	
	tailleHolder value = imageOS model sizeRatio ifTrue: [^self].	"on est oblig√© de repartir de la figure de d√©part pour pas perdre la r√©solution du bitmap de d√©part
Lorsqu''on part de la figure de d√©part la position est au milieu sur la vue du povSetter. Il faut donc appeler un positionChanged ; mais on fait cela apr√®s avoir ajuster la taille au sizeRatio demand√©"
	imageOS figure: imageOS model asFigure.	"newScale = newValue / oldValue"
	(imageOS figure
		scaleByWithAnswer: tailleHolder value / imageOS model sizeRatio)
		ifFalse: [^self].	"pour les bitmap, un petit changement ne produit pas de d√©formation du bitmap, et il n efaut donc pas changer le size Ratio"
	self positionChanged.	"ici on recacul la position en fonction de la position sp√©cifi√© sur l''interface"
	imageOS model sizeRatio: tailleHolder value.
	self builder ifNil: [^self].
	(self builder componentAt: #boutonAppliquer) enable.
	imageOS invalidate! !

!CMSpecPovSetter_Agent methodsFor: 'image' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
strokedPolygon
	
	self imageOS model isStroked: true.
	self updateMenuImage.
	(self builder componentAt: #boutonAppliquer) enable.
	imageOS invalidate! !

!CMSpecPovSetter_Agent methodsFor: 'aspects' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
tailleSlider
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^tailleSlider isNil
		ifTrue: [tailleSlider := 0 asValue]
		ifFalse: [tailleSlider]! !

!CMSpecPovSetter_Agent methodsFor: 'menu-symbol' stamp: 'HernanMoralesDurand 12/19/2017 12:35'!
updateMenuAddSameAs
	"a selection of one of this item create a new symbol which shape is a copy of the selected item"
	
	self visualizedEntities
		do:
			[:aClass | 
			self menuAddSameAs
				removeItem: (self menuAddSameAs menuItemLabeled: aClass name asString)].
	self initMenuAddSameAs! !

!CMSpecPovSetter_Agent methodsFor: 'image' stamp: 'HernanMoralesDurand 12/19/2017 12:36'!
updateMenuImage
	
	| menu |
	menu := (self builder componentAt: #imageOS) widget controller menu.
	imageOS model isStroked
		ifTrue:
			[(menu menuItemAt: 1)
				beOn;
				enable.
			(menu menuItemAt: 2)
				beOff;
				enable]
		ifFalse:
			[(menu menuItemAt: 1)
				beOff;
				enable.
			(menu menuItemAt: 2)
				beOn;
				enable].
	(menu menuItemAt: 3) enable.
	(menu menuItemAt: 4) enable.
	(self builder componentAt: #tailleSlider) enable! !

!CMSpecPovSetter_Agent methodsFor: 'action' stamp: 'HernanMoralesDurand 12/19/2017 18:34'!
validate
	
	| selectedSymbol aPOV |
	listSymbols selection
		ifNil: [ ^ self alertMessage: self translator tSelectPoVSymbol ]
		ifNotNil: [:aSelec | selectedSymbol := aSelec asSymbol].
	aPOV := imageOS model.	"copy"
	(aPOV isKindOf: BitmapPOV)
		ifFalse: [
			aPOV scaledBy: imageOS model sizeRatio.
			aPOV sizeRatio: nil.
			aPOV isDistortable: self isDistortable value ]
		ifTrue: [ aPOV bitmap: imageOS figure bitmap copy ].
	selectedClass povDict at: selectedSymbol put: aPOV.	"on met √† jour le dico povDict"
	self savePOVsymbol: selectedSymbol.	"on sauvegarde au niveau de la classe de l''entit√©"	""	"on demande aux agents de rafraichir leur afficage pour ce povResult"
	self cormas currentSimulation
		ifNotNil: [ : sim | 
			(sim allTheEntities: selectedClass) do: [ : entity | 
				sim
					registerEntityChange: #povSymbolChanged
					with: selectedSymbol
					from: (EntityReference on: entity) ] ].	"ne fonctionne pas lorsque le povResult est un povId ou un povEnergy ; c''est √† dire un pov dont la couleur est calcul√©, car ds ce cas le povResult est une couleur au 	niveau de la figure alors que c''est le povName sumbol (povId) pour l''entityPov"
	self tailleSlider value: 1! !

!CMSpecPovSetter_Agent methodsFor: 'menu-symbol' stamp: 'HernanMoralesDurand 1/17/2018 14:22'!
visualizedEntities
	
	| ve |
	ve := self cormas currentModel visualizableClasses.
	ve removeAll: self cormas currentModel spatialClasses.
	ve removeAllSuchThat: [:c | c inheritsFrom: CMArcEntity].
	^ve! !

CMSpecPovSetter subclass: #CMSpecPovSetter_Arc
	instanceVariableNames: 'startAnnotation widthChoices stopAnnotation lineWidth stopPosition startPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-PoV'!

!CMSpecPovSetter_Arc class methodsFor: 'interface specs' stamp: 'HernanMoralesDurand 1/26/2018 23:58'!
windowSpec
	"Tools.UIPainter new openOnClass: self andSelector: #windowSpec"
	
	<resource: #canvas>
	^#(FullSpec 
		#window: #(WindowSpec 
			#label: #(UserMessage 
				#key: #observationOfEntity 
				#defaultString: 'Observation of ArcEntity') 
			#min: #(Point 672 423) 
			#max: #(Point 414 423) 
			#bounds: #(Rectangle 720 450 1357 856) 
			#colors: #(LookPreferences 
				#setBackgroundColor: #(ColorValue 8191 5119 2048)) 
			#isEventDriven: true) 
		#component: #(SpecCollection 
			#collection: #(#(RegionSpec 
				#layout: #(Rectangle 375 285 458 368) 
				#name: #Region1 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue #white)) 
				#lineWidth: 1) #(ArbitraryComponentSpec 
				#layout: #(LayoutSizedOrigin 373 0 283 0 87 87) 
				#name: #imageOS 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue #white)) 
				#component: #imageOS) #(RegionSpec 
				#layout: #(Rectangle 5 175 274 370) 
				#name: #Region3 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue #white)) 
				#lineWidth: 1) #(RegionSpec 
				#layout: #(Rectangle 7 176 275 371) 
				#name: #Region4 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#lineWidth: 1) #(RegionSpec 
				#layout: #(Rectangle 424 11 631 161) 
				#name: #Region6 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue 7700 7700 7700)) 
				#lineWidth: 1) #(RegionSpec 
				#layout: #(Rectangle 7 12 383 161) 
				#name: #Region2 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 7700 7700 7700)) 
				#lineWidth: 1) #(GroupBoxSpec 
				#layout: #(Rectangle 5 3 385 163) 
				#name: #GroupBox3 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue 7700 7700 7700) 
					#setBackgroundColor: #(ColorValue 6054 3027 0)) 
				#label: #(UserMessage 
					#key: #povDefinition 
					#defaultString: ' PoV definition ')) #(LabelSpec 
				#layout: #(Point 247 17) 
				#label: #(UserMessage 
					#key: #associatedSymbols 
					#defaultString: 'Associated Symbols') 
				#style: #pixelDefault) #(SequenceViewSpec 
				#layout: #(Rectangle 221 36 378 155) 
				#name: #pov 
				#model: #listSymbols 
				#menu: #menuSymbolePDV 
				#multipleSelections: false) #(ActionButtonSpec 
				#layout: #(Rectangle 117 376 222 403) 
				#name: #boutonAppliquer 
				#flags: 40 
				#model: #validate 
				#label: #(UserMessage 
					#key: #apply 
					#defaultString: 'Apply') 
				#isDefault: false 
				#defaultable: true) #(SequenceViewSpec 
				#layout: #(Rectangle 10 36 205 154) 
				#name: #listMethods 
				#model: #listMethods 
				#callbacksSpec: #(UIEventCallbackSubSpec 
					#doubleClickSelector: #modifyPov) 
				#menu: #menuPDV 
				#multipleSelections: false) #(LabelSpec 
				#layout: #(Point 11 17) 
				#label: #(UserMessage 
					#key: #methodesreturningPoV 
					#defaultString: 'Methodes returning a Color or a Symbol') 
				#style: #pixelDefault) #(SequenceViewSpec 
				#layout: #(Rectangle 431 36 625 152) 
				#name: #List1 
				#model: #listInfo 
				#callbacksSpec: #(UIEventCallbackSubSpec 
					#doubleClickSelector: #modifyInfo) 
				#menu: #menuInfo 
				#useModifierKeys: true 
				#selectionType: #highlight) #(GroupBoxSpec 
				#layout: #(Rectangle 423 3 633 162) 
				#name: #GroupBox2 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue 6054 3027 0)) 
				#label: #(UserMessage 
					#key: #informationToBeDisplay 
					#defaultString: ' Information to be displayed ')) #(LabelSpec 
				#layout: #(Point 449 17) 
				#name: #Label1 
				#label: #(UserMessage 
					#key: #methodesreturningString 
					#defaultString: 'Methodes returning a String') 
				#style: #pixelDefault) #(CheckBoxSpec 
				#layout: #(Point 488 324) 
				#name: #startAnnotation 
				#model: #startAnnotation 
				#label: 'start annotation') #(CheckBoxSpec 
				#layout: #(Point 488 349) 
				#name: #stopAnnotation 
				#model: #stopAnnotation 
				#label: 'stop annotation') #(LabelSpec 
				#layout: #(Point 488 291) 
				#name: #Label2 
				#label: 'Line width:') #(ComboBoxSpec 
				#layout: #(Rectangle 552 291 595 312) 
				#name: #ComboBox1 
				#model: #lineWidth 
				#type: #number 
				#formatString: '0' 
				#comboList: #widthChoices) #(LabelSpec 
				#layout: #(Point 601 291) 
				#name: #Label3 
				#label: 'pixels') #(LabelSpec 
				#layout: #(Point 13 255) 
				#name: #Label4 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #red) 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#label: #(UserMessage 
					#key: #red 
					#defaultString: 'Red')) #(LabelSpec 
				#layout: #(Point 13 282) 
				#name: #Label5 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#label: #(UserMessage 
					#key: #green 
					#defaultString: 'Green')) #(LabelSpec 
				#layout: #(Point 13 308) 
				#name: #Label6 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#label: #(UserMessage 
					#key: #blue 
					#defaultString: 'Blue')) #(GroupBoxSpec 
				#layout: #(Rectangle 6 167 277 373) 
				#name: #GroupBox1 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue 6054 3027 0)) 
				#label: #(UserMessage 
					#key: #color 
					#defaultString: ' Set the Color ')) #(SubCanvasSpec 
				#layout: #(Rectangle 9 188 272 238) 
				#name: #Subcanvas1 
				#flags: 0 
				#majorKey: PovSetter 
				#minorKey: #palette) #(InputFieldSpec 
				#layout: #(Rectangle 179 254 219 273) 
				#name: #InputField1 
				#flags: 0 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#model: #redSlider 
				#tabable: true 
				#style: #pixelDefault 
				#type: #number 
				#formatString: '0.00') #(InputFieldSpec 
				#layout: #(Rectangle 179.0 281 217.0 301) 
				#name: #InputField2 
				#flags: 0 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#model: #greenSlider 
				#style: #pixelDefault 
				#type: #number 
				#formatString: '0.00') #(InputFieldSpec 
				#layout: #(Rectangle 179 307 215 329) 
				#name: #InputField3 
				#flags: 0 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#model: #blueSlider 
				#style: #pixelDefault 
				#type: #number 
				#formatString: '0.00') #(InputFieldSpec 
				#layout: #(Rectangle 179 339 214 360) 
				#name: #InputField4 
				#flags: 0 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#model: #brightnessSlider 
				#style: #pixelDefault 
				#type: #number 
				#formatString: '0.00') #(LabelSpec 
				#layout: #(Point 13 340) 
				#name: #Label7 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#label: #(UserMessage 
					#key: #brightness 
					#defaultString: 'Brightness')) #(SliderSpec 
				#layout: #(Rectangle 77 342 177 358) 
				#name: #Slider4 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#model: #brightnessSlider 
				#orientation: #horizontal 
				#start: 0 
				#stop: 1 
				#step: 0.01) #(SliderSpec 
				#layout: #(Rectangle 77 310 177 328) 
				#name: #Slider3 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#model: #blueSlider 
				#orientation: #horizontal 
				#start: 0 
				#stop: 1 
				#step: 0.01) #(SliderSpec 
				#layout: #(Rectangle 77 283 177 301) 
				#name: #Slider1 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#model: #greenSlider 
				#orientation: #horizontal 
				#start: 0 
				#stop: 1 
				#step: 0.01) #(SliderSpec 
				#layout: #(Rectangle 77 255 177 273) 
				#name: #Slider2 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#model: #redSlider 
				#orientation: #horizontal 
				#start: 0 
				#stop: 1 
				#step: 0.01) #(RadioButtonSpec 
				#layout: #(Point 301 183) 
				#name: #RadioButton1 
				#model: #startPosition 
				#helpText: 'Put the entity image randomly on its cell' 
				#label: #(UserMessage 
					#key: #randomly 
					#defaultString: 'randomly') 
				#select: #random) #(GroupBoxSpec 
				#layout: #(Rectangle 282 167 411 278) 
				#name: #GroupBox5 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue 3072 3072 8191)) 
				#label: #(UserMessage 
					#key: #createimage 
					#defaultString: 'Start position on the cell ')) #(RadioButtonSpec 
				#layout: #(Point 328 213) 
				#name: #RadioButton6 
				#model: #startPosition 
				#select: #topLeft) #(RadioButtonSpec 
				#layout: #(Point 328 229) 
				#name: #RadioButton2 
				#model: #startPosition 
				#select: #leftCenter) #(RadioButtonSpec 
				#layout: #(Point 328 245) 
				#name: #RadioButton7 
				#model: #startPosition 
				#select: #bottomLeft) #(RadioButtonSpec 
				#layout: #(Point 343 245) 
				#name: #RadioButton4 
				#model: #startPosition 
				#select: #bottomCenter) #(RadioButtonSpec 
				#layout: #(Point 343 229) 
				#name: #RadioButton8 
				#model: #startPosition 
				#select: #center) #(RadioButtonSpec 
				#layout: #(Point 343 213) 
				#name: #RadioButton19 
				#model: #startPosition 
				#select: #topCenter) #(RadioButtonSpec 
				#layout: #(Point 358 213) 
				#name: #RadioButton10 
				#model: #startPosition 
				#select: #topRight) #(RadioButtonSpec 
				#layout: #(Point 358 229) 
				#name: #RadioButton5 
				#model: #startPosition 
				#select: #rightCenter) #(RadioButtonSpec 
				#layout: #(Point 358 245) 
				#name: #RadioButton9 
				#model: #startPosition 
				#select: #bottomRight) #(RadioButtonSpec 
				#layout: #(Point 314 200) 
				#name: #RadioButton3 
				#model: #startPosition 
				#select: #border_topLeft) #(RadioButtonSpec 
				#layout: #(Point 314 229) 
				#name: #RadioButton11 
				#model: #startPosition 
				#select: #border_leftCenter) #(RadioButtonSpec 
				#layout: #(Point 314 258) 
				#name: #RadioButton12 
				#model: #startPosition 
				#select: #border_bottomLeft) #(RadioButtonSpec 
				#layout: #(Point 372 258) 
				#name: #RadioButton13 
				#model: #startPosition 
				#select: #border_bottomRight) #(RadioButtonSpec 
				#layout: #(Point 372 229) 
				#name: #RadioButton14 
				#model: #startPosition 
				#select: #border_rightCenter) #(RadioButtonSpec 
				#layout: #(Point 372 200) 
				#name: #RadioButton15 
				#model: #startPosition 
				#select: #border_topRight) #(RadioButtonSpec 
				#layout: #(Point 343 200) 
				#name: #RadioButton16 
				#model: #startPosition 
				#select: #border_topCenter) #(RadioButtonSpec 
				#layout: #(Point 343 258) 
				#name: #RadioButton17 
				#model: #startPosition 
				#select: #border_bottomCenter) #(RegionSpec 
				#layout: #(Rectangle 320 208 378 267) 
				#name: #Region5 
				#lineWidth: 1) #(RadioButtonSpec 
				#layout: #(Point 438 183) 
				#name: #RadioButton18 
				#model: #stopPosition 
				#helpText: 'Put the entity image randomly on its cell' 
				#label: #(UserMessage 
					#key: #randomly 
					#defaultString: 'randomly') 
				#select: #random) #(RadioButtonSpec 
				#layout: #(Point 465 213) 
				#name: #RadioButton20 
				#model: #stopPosition 
				#select: #topLeft) #(RadioButtonSpec 
				#layout: #(Point 465 229) 
				#name: #RadioButton21 
				#model: #stopPosition 
				#select: #leftCenter) #(RadioButtonSpec 
				#layout: #(Point 465 245) 
				#name: #RadioButton22 
				#model: #stopPosition 
				#select: #bottomLeft) #(RadioButtonSpec 
				#layout: #(Point 480 245) 
				#name: #RadioButton23 
				#model: #stopPosition 
				#select: #bottomCenter) #(RadioButtonSpec 
				#layout: #(Point 480 229) 
				#name: #RadioButton24 
				#model: #stopPosition 
				#select: #center) #(RadioButtonSpec 
				#layout: #(Point 480 213) 
				#name: #RadioButton25 
				#model: #stopPosition 
				#select: #topCenter) #(RadioButtonSpec 
				#layout: #(Point 495 213) 
				#name: #RadioButton26 
				#model: #stopPosition 
				#select: #topRight) #(RadioButtonSpec 
				#layout: #(Point 495 229) 
				#name: #RadioButton27 
				#model: #stopPosition 
				#select: #rightCenter) #(RadioButtonSpec 
				#layout: #(Point 495 245) 
				#name: #RadioButton28 
				#model: #stopPosition 
				#select: #bottomRight) #(RadioButtonSpec 
				#layout: #(Point 451 200) 
				#name: #RadioButton29 
				#model: #stopPosition 
				#select: #border_topLeft) #(RadioButtonSpec 
				#layout: #(Point 451 229) 
				#name: #RadioButton30 
				#model: #stopPosition 
				#select: #border_leftCenter) #(RadioButtonSpec 
				#layout: #(Point 451 258) 
				#name: #RadioButton31 
				#model: #stopPosition 
				#select: #border_bottomLeft) #(RadioButtonSpec 
				#layout: #(Point 509 258) 
				#name: #RadioButton32 
				#model: #stopPosition 
				#select: #border_bottomRight) #(RadioButtonSpec 
				#layout: #(Point 509 229) 
				#name: #RadioButton33 
				#model: #stopPosition 
				#select: #border_rightCenter) #(RadioButtonSpec 
				#layout: #(Point 509 200) 
				#name: #RadioButton34 
				#model: #stopPosition 
				#select: #border_topRight) #(RadioButtonSpec 
				#layout: #(Point 480 200) 
				#name: #RadioButton35 
				#model: #stopPosition 
				#select: #border_topCenter) #(RadioButtonSpec 
				#layout: #(Point 480 258) 
				#name: #RadioButton36 
				#model: #stopPosition 
				#select: #border_bottomCenter) #(RegionSpec 
				#layout: #(Rectangle 457 208 515 267) 
				#name: #Region7 
				#lineWidth: 1) #(GroupBoxSpec 
				#layout: #(Rectangle 419 167 548 278) 
				#name: #GroupBox6 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue 3072 3072 8191)) 
				#label: #(UserMessage 
					#key: #createimage 
					#defaultString: 'Stop position on the cell ')))))! !

!CMSpecPovSetter_Arc methodsFor: 'changed' stamp: 'HernanMoralesDurand 1/26/2018 23:58'!
colorChanged
	
	| color |
	color := super colorChanged.
	self imageOS model lineColor: color.
	imageOS figure lineColor: color.
	imageOS invalidate! !

!CMSpecPovSetter_Arc methodsFor: 'initialize-release' stamp: 'HernanMoralesDurand 1/26/2018 23:58'!
initialize
	
	super initialize.
	self lineWidth onChangeSend: #setLineWidth to: self.
	self startAnnotation onChangeSend: #setStartAnnotation to: self.
	self stopAnnotation onChangeSend: #setStopAnnotation to: self.
	self startPosition onChangeSend: #startPositionChanged to: self.
	self stopPosition onChangeSend: #stopPositionChanged to: self! !

!CMSpecPovSetter_Arc methodsFor: 'aspects' stamp: 'HernanMoralesDurand 1/26/2018 23:58'!
lineWidth
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^lineWidth isNil
		ifTrue: [lineWidth := 1 asValue]
		ifFalse: [lineWidth]! !

!CMSpecPovSetter_Arc methodsFor: 'changed' stamp: 'HernanMoralesDurand 1/26/2018 23:58'!
listSymbolsChanged
	
	| anImage |
	self listSymbols selection ifNil: [^nil].
	anImage := selectedClass imageAtPov: listSymbols selection asSymbol.
	imageOS model: anImage copy.
	imageOS figure: imageOS model asFigure.
	couleur := super listSymbolsChanged.
	imageOS model color: couleur.
	self startAnnotation value: anImage startAnnotation.
	self stopAnnotation value: anImage stopAnnotation.
	self lineWidth value: anImage lineWidth.
	imageOS invalidate! !

!CMSpecPovSetter_Arc methodsFor: 'saving&removing pov symbols' stamp: 'HernanMoralesDurand 1/26/2018 23:58'!
removeClassMethodForSymbol: aSymbol
	
	selectedClass class removeSelector: ('ArcPOV_' , aSymbol) asSymbol! !

!CMSpecPovSetter_Arc methodsFor: 'saving&removing pov symbols' stamp: 'HernanMoralesDurand 1/26/2018 23:58'!
saveArcPOV: aPOV intoClass: aClass symbol: aSymbol
	
	| selector |
	selector := 'ArcPOV_' , aSymbol.
	aClass class
		compile:
			(selector ,
					'\"Returns an array containing the settings of a Arc entity pov symbol in the following order:\(lineColor red) (lineColor green) (lineColor blue) lineWidth startAnnotation stopAnnotation startPosition stopPosition"\^#('
				, aPOV lineColor red printString , ' '
				, aPOV lineColor green printString , ' '
				, aPOV lineColor blue printString , ' ' , aPOV lineWidth printString ,
					' ' , aPOV startAnnotation printString , ' '
				, aPOV stopAnnotation printString , aPOV startPosition printString ,
					' ' , aPOV stopPosition printString , ' ' , ')') withCRs
		classified: 'pov symbols'
		notifying: nil! !

!CMSpecPovSetter_Arc methodsFor: 'saving&removing pov symbols' stamp: 'HernanMoralesDurand 1/26/2018 23:58'!
savePOVsymbol: aSymbol
	
	self
		saveArcPOV: imageOS model copy
		intoClass: selectedClass
		symbol: aSymbol! !

!CMSpecPovSetter_Arc methodsFor: 'changed' stamp: 'HernanMoralesDurand 1/26/2018 23:58'!
setLineWidth
	
	self imageOS model lineWidth: self lineWidth value.
	imageOS figure lineWidth: self lineWidth value.
	imageOS invalidate.
	(self builder componentAt: #boutonAppliquer) enable! !

!CMSpecPovSetter_Arc methodsFor: 'changed' stamp: 'HernanMoralesDurand 1/26/2018 23:58'!
setStartAnnotation
	
	self startAnnotation value
		ifTrue: [imageOS figure addCircleStart]
		ifFalse: [imageOS figure removeCircle].
	imageOS invalidate.
	self imageOS model startAnnotation: self startAnnotation value.
	(self builder componentAt: #boutonAppliquer) enable! !

!CMSpecPovSetter_Arc methodsFor: 'changed' stamp: 'HernanMoralesDurand 1/26/2018 23:58'!
setStopAnnotation
	
	self stopAnnotation value
		ifTrue: [imageOS figure addStopArrow]
		ifFalse: [imageOS figure removeArrow].
	imageOS invalidate.
	self imageOS model stopAnnotation: self stopAnnotation value.
	(self builder componentAt: #boutonAppliquer) enable! !

!CMSpecPovSetter_Arc methodsFor: 'aspects' stamp: 'HernanMoralesDurand 1/26/2018 23:58'!
startAnnotation
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^startAnnotation isNil
		ifTrue: [startAnnotation := false asValue]
		ifFalse: [startAnnotation]! !

!CMSpecPovSetter_Arc methodsFor: 'aspects' stamp: 'HernanMoralesDurand 1/26/2018 23:58'!
startPosition
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^startPosition isNil
		ifTrue: [startPosition := #center asValue]
		ifFalse: [startPosition]! !

!CMSpecPovSetter_Arc methodsFor: 'changed' stamp: 'HernanMoralesDurand 1/26/2018 23:58'!
startPositionChanged
	"Display the figure at the right position on the virtualCell"
	
	imageOS model startPosition: startPosition value	"	self builder ifNil: [^self].
	(self builder componentAt: #virtualCell) bounds.
	(self builder componentAt: #boutonAppliquer) enable."	"figurePosition := imageOS figure calculateNewPositionOnPatchBounds: ((self builder componentAt: #virtualCell) bounds moveTo: -17 @ -19)."	"startPosition value = #topLeft ifTrue: [figurePosition := -17 @ -17].
	startPosition value = #leftCenter ifTrue: [figurePosition := -17 @ 0].
	startPosition value = #bottomLeft ifTrue: [figurePosition := -17 @ 17].
	startPosition value = #topRight ifTrue: [figurePosition := 17 @ -17].
	startPosition value = #rightCenter ifTrue: [figurePosition := 17 @ 0].
	startPosition value = #bottomRight ifTrue: [figurePosition := 17 @ 17].
	startPosition value = #topCenter ifTrue: [figurePosition := 0 @ -17].
	startPosition value = #center ifTrue: [figurePosition := 0 @ 0].
	startPosition value = #bottomCenter ifTrue: [figurePosition := 0 @ 17].
	startPosition value = #random ifTrue: [figurePosition := 4 @ 6].

	startPosition value = #border_topLeft ifTrue: [figurePosition := -25 @ -25].
	startPosition value = #border_leftCenter ifTrue: [figurePosition := -25 @ 0].
	startPosition value = #border_bottomLeft ifTrue: [figurePosition := -25 @ 25].
	startPosition value = #border_topRight ifTrue: [figurePosition := 25 @ -25].
	startPosition value = #border_rightCenter ifTrue: [figurePosition := 25 @ 0].
	startPosition value = #border_bottomRight ifTrue: [figurePosition := 25 @ 25].
	startPosition value = #border_topCenter ifTrue: [figurePosition := 0 @ -25].
	startPosition value = #border_bottomCenter ifTrue: [figurePosition := 0 @ 25].

	imageOS figure translateTo: figurePosition - (imageOS figure bounds extent / 2).
	imageOS invalidate"! !

!CMSpecPovSetter_Arc methodsFor: 'aspects' stamp: 'HernanMoralesDurand 1/26/2018 23:58'!
stopAnnotation
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^stopAnnotation isNil
		ifTrue: [stopAnnotation := true asValue]
		ifFalse: [stopAnnotation]! !

!CMSpecPovSetter_Arc methodsFor: 'aspects' stamp: 'HernanMoralesDurand 1/26/2018 23:58'!
stopPosition
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^stopPosition isNil
		ifTrue: [stopPosition := #center asValue]
		ifFalse: [stopPosition]! !

!CMSpecPovSetter_Arc methodsFor: 'changed' stamp: 'HernanMoralesDurand 1/26/2018 23:58'!
stopPositionChanged
	"Display the figure at the right position on the virtualCell"
	
	imageOS model stopPosition: stopPosition value	"	self builder ifNil: [^self].
	(self builder componentAt: #virtualCell) bounds.
	(self builder componentAt: #boutonAppliquer) enable."	"figurePosition := imageOS figure calculateNewPositionOnPatchBounds: ((self builder componentAt: #virtualCell) bounds moveTo: -17 @ -19)."	"startPosition value = #topLeft ifTrue: [figurePosition := -17 @ -17].
	startPosition value = #leftCenter ifTrue: [figurePosition := -17 @ 0].
	startPosition value = #bottomLeft ifTrue: [figurePosition := -17 @ 17].
	startPosition value = #topRight ifTrue: [figurePosition := 17 @ -17].
	startPosition value = #rightCenter ifTrue: [figurePosition := 17 @ 0].
	startPosition value = #bottomRight ifTrue: [figurePosition := 17 @ 17].
	startPosition value = #topCenter ifTrue: [figurePosition := 0 @ -17].
	startPosition value = #center ifTrue: [figurePosition := 0 @ 0].
	startPosition value = #bottomCenter ifTrue: [figurePosition := 0 @ 17].
	startPosition value = #random ifTrue: [figurePosition := 4 @ 6].

	startPosition value = #border_topLeft ifTrue: [figurePosition := -25 @ -25].
	startPosition value = #border_leftCenter ifTrue: [figurePosition := -25 @ 0].
	startPosition value = #border_bottomLeft ifTrue: [figurePosition := -25 @ 25].
	startPosition value = #border_topRight ifTrue: [figurePosition := 25 @ -25].
	startPosition value = #border_rightCenter ifTrue: [figurePosition := 25 @ 0].
	startPosition value = #border_bottomRight ifTrue: [figurePosition := 25 @ 25].
	startPosition value = #border_topCenter ifTrue: [figurePosition := 0 @ -25].
	startPosition value = #border_bottomCenter ifTrue: [figurePosition := 0 @ 25].

	imageOS figure translateTo: figurePosition - (imageOS figure bounds extent / 2).
	imageOS invalidate"! !

!CMSpecPovSetter_Arc methodsFor: 'action' stamp: 'HernanMoralesDurand 1/26/2018 23:58'!
validate
	
	| selectedSymbol aPOV |
	listSymbols selection
		ifNil:
			[^Dialog
				warn:
					(UserMessage defaultString: 'Select a pov symbol' key: #selectPovMethod)
						asString]
		ifNotNil: [:aSelec | selectedSymbol := aSelec asSymbol].
	aPOV := imageOS model copy.
	selectedClass povDict at: selectedSymbol put: aPOV.	"on met √† jour le dico povDict"
	self savePOVsymbol: selectedSymbol.	"on sauvegarde au niveau de la classe de l''entit√©"	""	"on fait oublier aux agents leur visualState pour ce pov"
	self cormas currentSimulation
		ifNotNil:
			[:sim | 
			(sim allTheEntities: selectedClass)
				do:
					[:entity | 
					sim
						registerEntityChange: #povSymbolChanged
						with: selectedSymbol
						from: (EntityReference on: entity)]	"entity replacePovAtSymbol: selectedSymbol]"]! !

!CMSpecPovSetter_Arc methodsFor: 'aspects' stamp: 'HernanMoralesDurand 1/26/2018 23:58'!
widthChoices
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^widthChoices isNil
		ifTrue: [widthChoices := (List withAll: #(1 2 3 4 5)) asValue]
		ifFalse: [widthChoices]! !

CMSpecPovSetter subclass: #CMSpecPovSetter_SpatialEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-PoV'!

!CMSpecPovSetter_SpatialEntity class methodsFor: 'interface specs' stamp: ' 31/3/15 09:47'!
windowSpec
	"Tools.UIPainter new openOnClass: self andSelector: #windowSpec"
	
	<resource: #canvas>
	^#(FullSpec 
		#window: #(WindowSpec 
			#label: #(UserMessage 
				#key: #observationOfEntity 
				#defaultString: 'Observation of Entity') 
			#min: #(Point 672 423) 
			#max: #(Point 414 423) 
			#bounds: #(Rectangle 720 450 1357 855) 
			#colors: #(LookPreferences 
				#setBackgroundColor: #(ColorValue 4053 6482 4053)) 
			#isEventDriven: true) 
		#component: #(SpecCollection 
			#collection: #(#(RegionSpec 
				#layout: #(Rectangle -1 0 637 407) 
				#name: #fond 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 4357 6339 2374)) 
				#lineWidth: 1) #(RegionSpec 
				#layout: #(Rectangle 7 180 276 371) 
				#name: #Region3 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#lineWidth: 1) #(RegionSpec 
				#layout: #(Rectangle 6 13 383 161) 
				#name: #Region4 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 7700 7700 7700)) 
				#lineWidth: 1) #(RegionSpec 
				#layout: #(Rectangle 426 13 632 162) 
				#name: #Region5 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 7700 7700 7700)) 
				#lineWidth: 1) #(GroupBoxSpec 
				#layout: #(Rectangle 5 5 385 165) 
				#name: #GroupBox3 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue 0 4274 0)) 
				#label: #(UserMessage 
					#key: #povDefinition 
					#defaultString: ' PoV definition ')) #(LabelSpec 
				#layout: #(Point 241 19) 
				#label: #(UserMessage 
					#key: #associatedSymbols 
					#defaultString: 'Associated Symbols') 
				#style: #pixelDefault) #(SequenceViewSpec 
				#layout: #(Rectangle 221 38 378 157) 
				#name: #pov 
				#model: #listSymbols 
				#menu: #menuSymbolePDV 
				#multipleSelections: false) #(ActionButtonSpec 
				#layout: #(Rectangle 300 346 405 373) 
				#name: #boutonAppliquer 
				#flags: 40 
				#model: #validate 
				#label: #(UserMessage 
					#key: #apply 
					#defaultString: 'Apply') 
				#isDefault: false 
				#defaultable: true) #(SequenceViewSpec 
				#layout: #(Rectangle 10 38 205 156) 
				#name: #listMethods 
				#model: #listMethods 
				#callbacksSpec: #(UIEventCallbackSubSpec 
					#doubleClickSelector: #modifyPov) 
				#menu: #menuPDV 
				#multipleSelections: false) #(LabelSpec 
				#layout: #(Point 9 19) 
				#label: #(UserMessage 
					#key: #methodesreturningPoV 
					#defaultString: 'Methodes returning a Color or a Symbol') 
				#style: #pixelDefault) #(SequenceViewSpec 
				#layout: #(Rectangle 432 38 626 154) 
				#name: #List1 
				#model: #listInfo 
				#callbacksSpec: #(UIEventCallbackSubSpec 
					#doubleClickSelector: #modifyInfo) 
				#menu: #menuInfo 
				#useModifierKeys: true 
				#selectionType: #highlight) #(RegionSpec 
				#layout: #(Rectangle 312 226 395 309) 
				#name: #Region1 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue #white)) 
				#lineWidth: 1) #(ArbitraryComponentSpec 
				#layout: #(LayoutSizedOrigin 310 0 223 0 87 87) 
				#name: #imageOS 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue 5734 5734 5734) 
					#setBackgroundColor: #(ColorValue #white)) 
				#component: #imageOS) #(GroupBoxSpec 
				#layout: #(Rectangle 424 5 634 164) 
				#name: #GroupBox2 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue 0 4274 0)) 
				#label: #(UserMessage 
					#key: #informationToBeDisplay 
					#defaultString: ' Information to be displayed ')) #(LabelSpec 
				#layout: #(Point 445 19) 
				#name: #Label1 
				#label: #(UserMessage 
					#key: #methodesreturningString 
					#defaultString: 'Methodes returning a String') 
				#style: #pixelDefault) #(SliderSpec 
				#layout: #(Rectangle 77 286 177 304) 
				#name: #Slider1 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#model: #greenSlider 
				#orientation: #horizontal 
				#start: 0 
				#stop: 1 
				#step: 0.01) #(SliderSpec 
				#layout: #(Rectangle 77 259 177 277) 
				#name: #Slider2 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#model: #redSlider 
				#orientation: #horizontal 
				#start: 0 
				#stop: 1 
				#step: 0.01) #(SliderSpec 
				#layout: #(Rectangle 77 313 177 331) 
				#name: #Slider3 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 6553 6553 6553) 
					#setSelectionBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#model: #blueSlider 
				#orientation: #horizontal 
				#start: 0 
				#stop: 1 
				#step: 0.01) #(LabelSpec 
				#layout: #(Point 13 259) 
				#name: #Label2 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #red) 
					#setBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#label: #(UserMessage 
					#key: #red 
					#defaultString: 'Red')) #(LabelSpec 
				#layout: #(Point 13 286) 
				#name: #Label3 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue 0 4986 0) 
					#setBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#label: #(UserMessage 
					#key: #green 
					#defaultString: 'Green')) #(LabelSpec 
				#layout: #(Point 13 312) 
				#name: #Label4 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue 0 0 4986) 
					#setBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#label: #(UserMessage 
					#key: #blue 
					#defaultString: 'Blue')) #(SliderSpec 
				#layout: #(Rectangle 77 348 177 364) 
				#name: #Slider4 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 6553 6553 6553) 
					#setSelectionBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#model: #brightnessSlider 
				#orientation: #horizontal 
				#start: 0 
				#stop: 1 
				#step: 0.01) #(GroupBoxSpec 
				#layout: #(Rectangle 6 171 277 373) 
				#name: #GroupBox1 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue 0 4274 0)) 
				#label: #(UserMessage 
					#key: #color 
					#defaultString: ' Set the Color ')) #(SubCanvasSpec 
				#layout: #(Rectangle 9 192 272 242) 
				#name: #Subcanvas1 
				#flags: 0 
				#majorKey: PovSetter 
				#minorKey: #palette) #(InputFieldSpec 
				#layout: #(Rectangle 181 257 215 280) 
				#name: #InputField1 
				#flags: 0 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#model: #redSlider 
				#tabable: true 
				#style: #pixelDefault 
				#type: #number 
				#formatString: '0.00') #(InputFieldSpec 
				#layout: #(Rectangle 180.5 283 219.0 307) 
				#name: #InputField2 
				#flags: 0 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#model: #greenSlider 
				#style: #pixelDefault 
				#type: #number 
				#formatString: '0.00') #(InputFieldSpec 
				#layout: #(Rectangle 181 310 217 334) 
				#name: #InputField3 
				#flags: 0 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#model: #blueSlider 
				#style: #pixelDefault 
				#type: #number 
				#formatString: '0.00') #(InputFieldSpec 
				#layout: #(Rectangle 181 344 223 364) 
				#name: #InputField4 
				#flags: 0 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#model: #brightnessSlider 
				#style: #pixelDefault 
				#type: #number 
				#formatString: '0.00') #(LabelSpec 
				#layout: #(Point 13 344) 
				#name: #Label5 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#label: #(UserMessage 
					#key: #brightness 
					#defaultString: 'Brightness')))))! !

!CMSpecPovSetter_SpatialEntity methodsFor: 'changed' stamp: ' 31/3/15 09:47'!
colorChanged
	
	| color w |
	color := super colorChanged.
	w := (self builder componentAt: #imageOS) widget.
	w bounds asFiller displayOn: (w graphicsContext paint: color)! !

!CMSpecPovSetter_SpatialEntity methodsFor: 'changed' stamp: ' 31/3/15 09:47'!
listSymbolsChanged
	
	couleur := super listSymbolsChanged.
	couleur ifNil: [^self]	"	w := (self builder componentAt: #imageOS) widget.
	(imageOS model)
		wp: w bounds asFiller;
		color: couleur.
	imageOS displayOn: w graphicsContext"! !

!CMSpecPovSetter_SpatialEntity methodsFor: 'saving&removing pov symbols' stamp: ' 31/3/15 09:47'!
removeClassMethodForSymbol: aSymbol
	
	selectedClass class
		removeSelector: ('SpatialEntityPOV_' , aSymbol) asSymbol! !

!CMSpecPovSetter_SpatialEntity methodsFor: 'saving&removing pov symbols' stamp: ' 31/3/15 09:47'!
savePOVsymbol: aSymbol
	
	self saveSpatialEntityPOVcolor: couleur intoClass: selectedClass symbol:
			aSymbol! !

!CMSpecPovSetter_SpatialEntity methodsFor: 'saving&removing pov symbols' stamp: ' 31/3/15 09:47'!
saveSpatialEntityPOVcolor: color intoClass: aClass symbol: aSymbol
	
	| selector |
	selector := 'SpatialEntityPOV_' , aSymbol.
	aClass class
		compile:
			(selector ,
					'\"Returns an array containing the settings of a Spatial entity pov symbol in the following order:\(color red) (color green) (color blue)"\^Array with: '
				, color red printString , ' with: ' , color green printString ,
					' with: ' , color blue printString) withCRs
		classified: 'pov symbols'
		notifying: nil! !

!CMSpecPovSetter_SpatialEntity methodsFor: 'action' stamp: ' 31/3/15 09:47'!
validate
	
	| selectedSymbol |
	listSymbols selection
		ifNil:
			[^Dialog
				warn:
					(UserMessage defaultString: 'Select a pov symbol' key: #selectPovMethod)
						asString]
		ifNotNil: [:aSelec | selectedSymbol := aSelec asSymbol].
	selectedClass colorsDict at: selectedSymbol put: couleur.	"on met √† jour le dico 'colorsDict' de la classe de l'entite"
	self savePOVsymbol: selectedSymbol.	"on sauvegarde au niveau de la casse de l''entit√©"	""	"ask the currently dispayed figures that correspond this povResult to update color"
	self cormas currentSimulation
		ifNotNil:
			[:sim | 
			(sim allTheEntities: selectedClass)
				do:
					[:entity | 
					sim
						registerEntityChange: #povSymbolChanged
						with: selectedSymbol
						from: (EntityReference on: entity)]].
	(self builder componentAt: #boutonAppliquer) disable! !

CMSpecObject subclass: #CMSpecPovSetterNotebook
	instanceVariableNames: 'tabManager cormasModel cormas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-PoV'!

!CMSpecPovSetterNotebook commentStamp: 'HernanMoralesDurand 1/17/2018 19:19' prior: 0!
Container for PoV Setter palettes.

CMPovSetterNotebook example.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	cormas:		<Object>
	cormasModel:		<Object>
	majorKeys:		<Object>


    Implementation Points!

!CMSpecPovSetterNotebook class methodsFor: 'specs' stamp: 'HernanMoralesDurand 12/26/2017 18:12'!
defaultSpec
	<spec>

	^ SpecLayout composed
		newRow: [ : col | 
			col
				add: #tabManager ]! !

!CMSpecPovSetterNotebook methodsFor: 'change messages' stamp: 'HernanMoralesDurand 1/25/2018 18:57'!
changedExample
	
	| sel modelClass povSetter |
	
	self halt.
	(sel := self tabManager selectedTab) isNil 
		ifTrue: [ ^ self ].
	((modelClass := ('CM' , sel label) asClass) inheritsFrom: CMArcEntity)
		ifTrue: [povSetter := PovSetter_Arc new]
		ifFalse: [ 
			modelClass isSpatialClass
				ifTrue: [ povSetter := CMSpecPovSetter_SpatialEntity new ]
				ifFalse: [ povSetter := CMSpecPovSetter_Agent new ] ].
	povSetter cormas: cormas.
	(self builder componentAt: #pageHolder) widget client: povSetter spec:
			#windowSpec.
	povSetter setModelClass: modelClass! !

!CMSpecPovSetterNotebook methodsFor: 'initialization' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
findPovSetterTabFor: anEntity

	| modelClass |
	
	modelClass := (anEntity inheritsFrom: CMArcEntity)
		ifTrue: [ CMSpecPovSetter_Agent  ]
		ifFalse: [ 
			anEntity isSpatialClass 
				ifTrue: [ CMSpecPovSetter_SpatialEntity ]
				ifFalse: [ CMSpecPovSetter_Agent ] ].
	^ (modelClass for: self projectManager) setModelClass: anEntity! !

!CMSpecPovSetterNotebook methodsFor: 'initialization' stamp: 'HernanMoralesDurand 1/17/2018 14:12'!
initializePresenter
	" Private - See superimplementor's comment "

	self populateManager.
	self tabManager whenTabSelected: [ 
		self changedExample ].! !

!CMSpecPovSetterNotebook methodsFor: 'initialization' stamp: 'HernanMoralesDurand 1/17/2018 02:11'!
initializeWidgets
	" Private - See superimplementor's comment "

	tabManager := self newTabManager.
	tabManager owner: self.
	self prepareClasses.! !

!CMSpecPovSetterNotebook methodsFor: 'initialization' stamp: 'HernanMoralesDurand 1/27/2018 00:14'!
newTabFor: anEntity
	| tab modelClass |
	
	modelClass := self findPovSetterTabFor: anEntity.
	(tab := self newTab)
		label: anEntity labelName; " Cell, Node, Arc, etc "
		model: modelClass;
		owner: self.			
	^ tab! !

!CMSpecPovSetterNotebook methodsFor: 'initialization' stamp: 'HernanMoralesDurand 1/27/2018 00:16'!
populateManager
	" Add dynamic tabs "

	self prepareClasses do: [ : entity |
		| tab |
		tab := (self newTabFor: entity)
				closeable: false;
				yourself.
		self tabManager addTab: tab ]! !

!CMSpecPovSetterNotebook methodsFor: 'private' stamp: 'HernanMoralesDurand 12/28/2017 01:57'!
prepareClasses
	
	| modelClasses |
	modelClasses := OrderedCollection new.
	^ modelClasses 
		add: self cormasModelClass cellClass;
		addAll: self cormasModelClass compoundSpatialClasses;
		addAll: (self cormasModelClass socialClasses select: #isSituatedClass);
		addAll: (self cormasModelClass passiveObjectClasses select: #isSituatedClass);
		yourself
! !

!CMSpecPovSetterNotebook methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/26/2017 18:00'!
tabManager
	^ tabManager! !

!CMSpecPovSetterNotebook methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/26/2017 18:00'!
tabManager: anObject
	tabManager := anObject! !

!CMSpecPovSetterNotebook methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/27/2018 00:19'!
title

	^ self translator tPoVSetter! !

CMSpecObject subclass: #CMSpecPovTab
	instanceVariableNames: 'tabManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-PoV'!

!CMSpecPovTab commentStamp: 'HernanMoralesDurand 12/23/2017 14:56' prior: 0!
Container for PoV Setter palettes.

CMPovTab new open.

Internal Representation and Key Implementation Points.

    Instance Variables
	tabManager:		<Object>


    Implementation Points!

CMSpecObject subclass: #CMSpecSimulationContainer
	instanceVariableNames: 'simWindow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Core'!

!CMSpecSimulationContainer class methodsFor: 'specs' stamp: 'HernanMoralesDurand 12/30/2017 14:02'!
defaultSpec
    <spec>
    ^ SpecLayout composed newColumn: [ : c | 
			c add: #simWindow ]! !

!CMSpecSimulationContainer methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/30/2017 16:32'!
hideSimInterface

	self simulationWidget hide.! !

!CMSpecSimulationContainer methodsFor: 'initialization' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
initializeWidgets
	" Private - See superimplementor's comment "
	
	self simWindow: (CMSpecSimulationWindow for: self projectManager).

! !

!CMSpecSimulationContainer methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/30/2017 16:32'!
showSimInterface

	self simulationWidget show.! !

!CMSpecSimulationContainer methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/30/2017 19:16'!
simInterfaceIsDisplayed

	^ self simulationWidget visible ! !

!CMSpecSimulationContainer methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/30/2017 14:02'!
simWindow
	^ simWindow! !

!CMSpecSimulationContainer methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/30/2017 14:02'!
simWindow: anObject
	simWindow := anObject! !

!CMSpecSimulationContainer methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/30/2017 16:32'!
simulationWidget

	^ spec instance widget! !

!CMSpecSimulationContainer methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/30/2017 19:08'!
toggleSimInterface

	self simInterfaceIsDisplayed
		ifTrue: [ self hideSimInterface ]
		ifFalse: [ self showSimInterface ]! !

CMSpecObject subclass: #CMSpecSimulationWindow
	instanceVariableNames: 'simulateLabel replayLabel initializeLabel backwardLabel currentStepLabel forwardLabel closeButton changeButton simulateButton replayButton backwardAllButton backwardStepButton currentStepInputText forwardStepButton forwardAllButton replayStepButton replayAllButton finalStepInputText finalStepLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Core'!

!CMSpecSimulationWindow commentStamp: 'HernanMoralesDurand 12/30/2017 14:03' prior: 0!
Simulation interface

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	backwardAllButton:		<Object>
	backwardLabel:		<Object>
	backwardStepButton:		<Object>
	changeButton:		<Object>
	closeButton:		<Object>
	currentStepInputText:		<Object>
	currentStepLabel:		<Object>
	finalStepInputText:		<Object>
	finalStepLabel:		<Object>
	forwardAllButton:		<Object>
	forwardLabel:		<Object>
	forwardStepButton:		<Object>
	initializeLabel:		<Object>
	replayAllButton:		<Object>
	replayButton:		<Object>
	replayLabel:		<Object>
	replayStepButton:		<Object>
	simulateButton:		<Object>
	simulateLabel:		<Object>


    Implementation Points!

!CMSpecSimulationWindow class methodsFor: 'specs' stamp: 'NicolasBecu 5/1/2018 11:50'!
defaultSpec
    <spec>
    ^ SpecLayout composed newColumn: [ : c | 
			c
				newRow: [ : r |
					r
						newColumn: [ : ec | ] width: 80;					
						add: #initializeLabel width: 80;
						add: #backwardLabel width: 100;
						newColumn: [ : ec | ] width: 100;	
						add: #forwardLabel width: 70;
						add: #closeButton width: 30 ]
				height: self toolbarHeight - 5;
				newRow: [ : r | 
					r
						newColumn: [ : col | 
							col 
								add: #simulateLabel;
								add: #replayLabel ] width: 70;
						newColumn: [ : col |
							col
								add: #simulateButton;
								add: #replayButton ]  width: 70;
						newColumn: [ : col | 
							col 
								newRow: [ : er |
									er 
										add: #backwardAllButton;
										add: #backwardStepButton  ]
							] width: 100;
						newColumn: [ : ec | ] width: 10;
						newColumn: [ : col | 
							col 
								add: #currentStepLabel;
								add: #currentStepInputText height: self inputTextHeight;
								newRow: [ : ec | ] ] width: 70;
						newColumn: [ : ec | ] width: 10;							
						newColumn: [ : col | 
							col 
								newRow: [ : er |
									er 
										add: #forwardStepButton;
										add: #forwardAllButton ];
								newRow: [ : er |
									er 
										add: #replayStepButton;
										add: #replayAllButton ]									
							] width: 100;
						newColumn: [ : ec | ] width: 10;
						newColumn: [ : col | 
							col 
								add: #finalStepLabel;
								newRow: [ : er | ] height: self inputTextHeight;								
								add: #finalStepInputText height: self inputTextHeight;
								newRow: [ : er | ] height: self inputTextHeight - 4;
								add: #changeButton height: self inputTextHeight - 4 ] width: 70 ]
		]  ! !

!CMSpecSimulationWindow class methodsFor: 'example' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
example

	^ self basicNew 
		projectManager: (CMProjectManager new projectWindow: self);
		translator: (CMTranslator newForLanguage: #EN);
		initialize;
		openWithSpec! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
backwardAllButton
	" Answer the backwardAllButton of this CMSpecSimulationWindow "

	^ backwardAllButton! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
backwardAllButton: anObject
	" Sets the backwardAllButton of this CMSpecSimulationWindow "

	backwardAllButton := anObject! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
backwardLabel
	" Answer the backwardLabel of this CMSpecSimulationWindow "

	^ backwardLabel! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
backwardLabel: anObject
	" Sets the backwardLabel of this CMSpecSimulationWindow "

	backwardLabel := anObject! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
backwardStepButton
	" Answer the backwardStepButton of this CMSpecSimulationWindow "

	^ backwardStepButton! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
backwardStepButton: anObject
	" Sets the backwardStepButton of this CMSpecSimulationWindow "

	backwardStepButton := anObject! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
changeButton
	" Answer the changeButton of this CMSpecSimulationWindow "

	^ changeButton! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
changeButton: anObject
	" Sets the changeButton of this CMSpecSimulationWindow "

	changeButton := anObject! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/26/2017 02:53'!
closeButon
	" Answer the closeButton of this CMSpecSimulationWindow "

	^ closeButton! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
closeButton
	" Answer the closeButton of this CMSpecSimulationWindow "

	^ closeButton! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
closeButton: anObject
	" Sets the closeButton of this CMSpecSimulationWindow "

	closeButton := anObject! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
currentStepInputText
	" Answer the currentStepInputText of this CMSpecSimulationWindow "

	^ currentStepInputText! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
currentStepInputText: anObject
	" Sets the currentStepInputText of this CMSpecSimulationWindow "

	currentStepInputText := anObject! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
currentStepLabel
	" Answer the currentStepLabel of this CMSpecSimulationWindow "

	^ currentStepLabel! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
currentStepLabel: anObject
	" Sets the currentStepLabel of this CMSpecSimulationWindow "

	currentStepLabel := anObject! !

!CMSpecSimulationWindow methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
defineScenarioAction

	CMSpecConfirmBeforeLaunch openFor: self projectManager! !

!CMSpecSimulationWindow methodsFor: 'morphic' stamp: 'HernanMoralesDurand 11/26/2017 14:54'!
defineScenarioButtonMorph

	^ IconicButton new
		target: self;
		actionSelector: #defineScenarioAction;
		labelGraphic: (self iconNamed: #defineScenarioIcon);
		color: Color transparent;
		borderColor: Color red;
		borderWidth: 1;
		helpText: 'Define the scenario';
		yourself.! !

!CMSpecSimulationWindow methodsFor: 'callbacks' stamp: 'NicolasBecu 5/1/2018 21:05'!
exec1StepAction
	(CMPharoGridSimulation new
		on: self cormasModel
		withCells: self cormasModel spaceModelEntities
		withSituatedEntities: self cormasModel allTheSituatedEntities) runAndVisualize

	"(CMPharoGridSimulation new on: self cormasModel) 
			runAndVisualize."! !

!CMSpecSimulationWindow methodsFor: 'morphic' stamp: 'HernanMoralesDurand 11/26/2017 15:42'!
exec1StepButtonMorph

	^ IconicButton new
		target: self;
		actionSelector: #exec1StepAction;
		labelGraphic: (self iconNamed: #exec1StepIcon);
		color: Color transparent;
		borderColor: Color red;
		borderWidth: 1;
		helpText: 'Execute 1 step';
		yourself.! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
finalStepInputText
	" Answer the finalStepInputText of this CMSpecSimulationWindow "

	^ finalStepInputText! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
finalStepInputText: anObject
	" Sets the finalStepInputText of this CMSpecSimulationWindow "

	finalStepInputText := anObject! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/26/2017 15:28'!
finalStepLabel
	^ finalStepLabel! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/26/2017 15:28'!
finalStepLabel: anObject
	finalStepLabel := anObject! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
forwardAllButton
	" Answer the forwardAllButton of this CMSpecSimulationWindow "

	^ forwardAllButton! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
forwardAllButton: anObject
	" Sets the forwardAllButton of this CMSpecSimulationWindow "

	forwardAllButton := anObject! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
forwardLabel
	" Answer the forwardLabel of this CMSpecSimulationWindow "

	^ forwardLabel! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
forwardLabel: anObject
	" Sets the forwardLabel of this CMSpecSimulationWindow "

	forwardLabel := anObject! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
forwardStepButton
	" Answer the forwardStepButton of this CMSpecSimulationWindow "

	^ forwardStepButton! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
forwardStepButton: anObject
	" Sets the forwardStepButton of this CMSpecSimulationWindow "

	forwardStepButton := anObject! !

!CMSpecSimulationWindow methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/26/2017 03:29'!
initialExtent
	"Answer the initial extent for the receiver."
	
	^ 700 @ 200
! !

!CMSpecSimulationWindow methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/26/2017 02:34'!
initialize

	self initializeMorphs.
	super initialize.! !

!CMSpecSimulationWindow methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
initializeFocus
	" Private - See superimplementor's comment "

	self focusOrder
		add: self closeButton;
	add: self changeButton;
	add: self simulateButton;
	add: self replayButton;
	add: self backwardAllButton;
	add: self backwardStepButton;
	add: self currentStepInputText;
	add: self forwardStepButton;
	add: self forwardAllButton;
	add: self replayStepButton;
	add: self replayAllButton;
	add: self finalStepInputText.. ! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
initializeLabel
	" Answer the initializeLabel of this CMSpecSimulationWindow "

	^ initializeLabel! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
initializeLabel: anObject
	" Sets the initializeLabel of this CMSpecSimulationWindow "

	initializeLabel := anObject! !

!CMSpecSimulationWindow methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/26/2017 15:30'!
initializeLabels

	self simulateLabel 
		label: self translator tSimulate;
		color: Color red.
	self replayLabel 
		label: self translator tReplay;
		color: Color purple.

	self finalStepLabel label: self translator tFinalStep.
	self currentStepLabel label: self translator tCurrentStep.
	self initializeLabel label: self translator tInitialize.
	self backwardLabel label:  self translator tBackwardLabel.
	self forwardLabel label: self translator tForwardLabel.! !

!CMSpecSimulationWindow methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/26/2017 15:44'!
initializeMorphs

	self simulateButton: self defineScenarioButtonMorph asSpecAdapter.	
	self replayButton: self replayAStoredSimButtonMorph asSpecAdapter.
	self backwardAllButton: self replaySimBackwardButtonMorph asSpecAdapter.
	self backwardStepButton: self run1StepBackwardButtonMorph asSpecAdapter.
	self forwardStepButton: self exec1StepButtonMorph asSpecAdapter.
	self forwardAllButton: self runAllSimButtonMorph asSpecAdapter.
	self replayStepButton: self replay1StoredStepButtonMorph asSpecAdapter.
	self replayAllButton: self replayStoredSimButtonMorph asSpecAdapter.
! !

!CMSpecSimulationWindow methodsFor: 'initialization' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
initializePresenter
	" Private - See superimplementor's comment "

	self changeButton action: [ CMSpecStepMethodChoice openFor: self projectManager ].
! !

!CMSpecSimulationWindow methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/26/2017 15:32'!
initializeWidgets
	" Private - See superimplementor's comment "

	self instantiateModels: #(
		simulateLabel			LabelModel		
		replayLabel				LabelModel		
		initializeLabel			LabelModel		
		backwardLabel			LabelModel		
		currentStepLabel		LabelModel		
		finalStepLabel 			LabelModel
		forwardLabel				LabelModel
		currentStepInputText	TextInputFieldModel					
		finalStepInputText		TextInputFieldModel
		changeButton				ButtonModel
		closeButton 				ButtonModel).
	self initializeFocus.
	self initializeLabels.

	self changeButton label: self translator tChange.

	self closeButton
		icon: #smallCancelIcon asIcon;
		action: [ self delete ];
		help: self translator tSimCloseHelp.

	self currentStepInputText
		text: 0;
		help: self translator tSimStepHelp.

	self finalStepInputText
		text: 0;
		help: self translator tSimFinalStepHelp

! !

!CMSpecSimulationWindow methodsFor: 'morphic' stamp: 'HernanMoralesDurand 11/26/2017 15:41'!
replay1StoredStepButtonMorph

	^ IconicButton new
		target: self;
		actionSelector: #replay1StoredStepAction;
		labelGraphic: (self iconNamed: #replay1StoredStepIcon);
		color: Color transparent;
		borderColor: Color purple;
		borderWidth: 1;
		helpText: 'Replay 1 stored step';
		yourself.! !

!CMSpecSimulationWindow methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 12/10/2017 17:05'!
replayAStoredSimAction
	" #openReplayWin "

	self halt.
	self application hasStoredSimulations
		ifFalse: [ self alertMessage: self translator tNoStoredSim ]
		ifTrue: [ self requestStoredSims: self application storedSimulations ]
! !

!CMSpecSimulationWindow methodsFor: 'morphic' stamp: 'HernanMoralesDurand 11/26/2017 14:55'!
replayAStoredSimButtonMorph

	^ IconicButton new
		target: self;
		actionSelector: #replayAStoredSimAction;
		labelGraphic: (self iconNamed: #replayAStoredSimIcon);
		color: Color transparent;
		borderColor: Color purple;
		borderWidth: 1;
		helpText: 'Replay a stored simulation';
		yourself.! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
replayAllButton
	" Answer the replayAllButton of this CMSpecSimulationWindow "

	^ replayAllButton! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
replayAllButton: anObject
	" Sets the replayAllButton of this CMSpecSimulationWindow "

	replayAllButton := anObject! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
replayButton
	" Answer the replayButton of this CMSpecSimulationWindow "

	^ replayButton! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
replayButton: anObject
	" Sets the replayButton of this CMSpecSimulationWindow "

	replayButton := anObject! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
replayLabel
	" Answer the replayLabel of this CMSpecSimulationWindow "

	^ replayLabel! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
replayLabel: anObject
	" Sets the replayLabel of this CMSpecSimulationWindow "

	replayLabel := anObject! !

!CMSpecSimulationWindow methodsFor: 'morphic' stamp: 'HernanMoralesDurand 11/26/2017 14:55'!
replaySimBackwardButtonMorph

	^ IconicButton new
		target: self;
		actionSelector: #replaySimBackwardAction;
		labelGraphic: (self iconNamed: #replaySimBackwardIcon);
		color: Color transparent;
		borderColor: Color purple;
		borderWidth: 1;
		helpText: 'Replay simulation backward';
		yourself.! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
replayStepButton
	" Answer the replayStepButton of this CMSpecSimulationWindow "

	^ replayStepButton! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
replayStepButton: anObject
	" Sets the replayStepButton of this CMSpecSimulationWindow "

	replayStepButton := anObject! !

!CMSpecSimulationWindow methodsFor: 'morphic' stamp: 'HernanMoralesDurand 11/26/2017 15:41'!
replayStoredSimButtonMorph

	^ IconicButton new
		target: self;
		actionSelector: #replayStoredSimAction;
		labelGraphic: (self iconNamed: #replayStoredSimIcon);
		color: Color transparent;
		borderColor: Color purple;
		borderWidth: 1;
		helpText: 'Replay stored simulation';
		yourself.! !

!CMSpecSimulationWindow methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 12/10/2017 17:32'!
requestStepSim: simName directory: dumpDir 

	| directoryContent firstStep |
	self simFolder: simName.
	self simNumero: self simNumero + 1.
	self enableBackward: true.

	directoryContent := simName asFileReference entries.
	(directoryContent removeAllSuchThat: [ : txt | (txt beginsWith: self stepNameStart) not]) isEmpty
		ifTrue: [ ^ self alertMessage: simName , self translator tNoStoredSimFolder ].

	self traceSize: directoryContent size - 1.
	self traceSize > 1
		ifTrue: [ 
			self simButtonAt: #replayRunForward displayActivated: true.
			self simButtonAt: #replayStepForward displayActivated: true ].

	(firstStep := self getStepNumberOfBosFilename: directoryContent first) > 0
		ifTrue: [ self alertMessage: self translator tReplayStartStep , firstStep printString ].
	self currentTime: firstStep.
	self cormas cycle value: self traceSize + firstStep.
	self cormasModel spaceModel ifNil: [ self cormasModel initializeSpaceModel ].
	self replayStepForward: firstStep! !

!CMSpecSimulationWindow methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 12/10/2017 17:08'!
requestStoredSims: directoryContent

	| cmSimName dumpDir |
	cmSimName := directoryContent
		detect: [ : txt | txt = self simName ]
		ifNone: [ directoryContent first ].
	self simName: cmSimName.
	(dumpDir := self 
		requestDirectoryName: self translator tChooseDumpDir
		from: ((self application dumpPath: self cormasModel class name) / cmSimName)) isEmpty
			ifFalse: [ self requestStepSim: dumpDir ].! !

!CMSpecSimulationWindow methodsFor: 'morphic' stamp: 'HernanMoralesDurand 11/26/2017 14:55'!
run1StepBackwardButtonMorph

	^ IconicButton new
		target: self;
		actionSelector: #run1StepBackwardAction;
		labelGraphic: (self iconNamed: #run1StepBackwardIcon);
		color: Color transparent;
		borderColor: Color purple;
		borderWidth: 1;
		helpText: 'Return 1 step backward';
		yourself.! !

!CMSpecSimulationWindow methodsFor: 'morphic' stamp: 'HernanMoralesDurand 11/26/2017 15:42'!
runAllSimButtonMorph

	^ IconicButton new
		target: self;
		actionSelector: #runAllSimAction;
		labelGraphic: (self iconNamed: #runAllSimIcon);
		color: Color transparent;
		borderColor: Color red;
		borderWidth: 1;
		helpText: 'Run simulation until final step';
		yourself.! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
simulateButton
	" Answer the simulateButton of this CMSpecSimulationWindow "

	^ simulateButton! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
simulateButton: anObject
	" Sets the simulateButton of this CMSpecSimulationWindow "

	simulateButton := anObject! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
simulateLabel
	" Answer the simulateLabel of this CMSpecSimulationWindow "

	^ simulateLabel! !

!CMSpecSimulationWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
simulateLabel: anObject
	" Sets the simulateLabel of this CMSpecSimulationWindow "

	simulateLabel := anObject! !

!CMSpecSimulationWindow methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/25/2017 18:18'!
title
	" Private - See superimplementor's comment "

	^ ''! !

CMSpecObject subclass: #CMSpecStepMethodChoice
	instanceVariableNames: 'selectMethodLabel methodsLabeledList finalStepLabeledTextInput randomnessCheckbox toolbar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Core'!

!CMSpecStepMethodChoice class methodsFor: 'specs' stamp: 'HernanMoralesDurand 11/26/2017 22:27'!
defaultSpec

    <spec>
    ^ SpecLayout composed
		newColumn: [ : c | 
			c
				add: #methodsLabeledList;
				newRow: [ : r | r add: #finalStepLabeledTextInput left: 350 ] height: self toolbarHeight;
				add: #randomnessCheckbox height: self toolbarHeight;
				add: #toolbar height: self toolbarHeight ]! !

!CMSpecStepMethodChoice class methodsFor: 'example' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
example

	^ self basicNew 
		projectManager: (CMProjectManager new projectWindow: self);
		translator: (CMTranslator newForLanguage: #EN);
		initialize;
		openWithSpec! !

!CMSpecStepMethodChoice methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/26/2017 21:40'!
finalStepLabeledTextInput
	" Answer the finalStepLabeledTextInput of this CMSpecStepMethodChoice "

	^ finalStepLabeledTextInput! !

!CMSpecStepMethodChoice methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/26/2017 21:40'!
finalStepLabeledTextInput: anObject
	" Sets the finalStepLabeledTextInput of this CMSpecStepMethodChoice "

	finalStepLabeledTextInput := anObject! !

!CMSpecStepMethodChoice methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/26/2017 21:40'!
initialExtent
	"Answer the initial extent for the receiver."
	
	^ 600 @ 400
! !

!CMSpecStepMethodChoice methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/26/2017 21:40'!
initializeFocus
	" Private - See superimplementor's comment "

	self focusOrder
		add: self methodsLabeledList;
	add: self finalStepLabeledTextInput;
	add: self randomnessCheckbox;
	add: self toolbar. ! !

!CMSpecStepMethodChoice methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/26/2017 21:47'!
initializePresenter
	" Private - See superimplementor's comment "

	self toolbar 
		firstButtonLabel: self translator tCancel;
		firstButtonAction: [ self delete ];
		secondButtonLabel: self translator tApply;
		secondButtonAction: [ self halt ]! !

!CMSpecStepMethodChoice methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/26/2017 22:19'!
initializeWidgets
	" Private - See superimplementor's comment "

	self instantiateModels: #(
		methodsLabeledList				SpcLabeledList		
		finalStepLabeledTextInput	SpcLabeledTextField
		randomnessCheckbox				CheckBoxModel
		toolbar 							SpcTwoButtonToolbar).
	self initializeFocus.
	
	self methodsLabeledList
		label: self translator tSelectMethod.
	self finalStepLabeledTextInput
		label: self translator tFinalStepChoice;
		text: '0'.
	self randomnessCheckbox 
		label: self translator tInitializeRandomness.! !

!CMSpecStepMethodChoice methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/26/2017 21:40'!
methodsLabeledList
	" Answer the methodsLabeledList of this CMSpecStepMethodChoice "

	^ methodsLabeledList! !

!CMSpecStepMethodChoice methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/26/2017 21:40'!
methodsLabeledList: anObject
	" Sets the methodsLabeledList of this CMSpecStepMethodChoice "

	methodsLabeledList := anObject! !

!CMSpecStepMethodChoice methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/26/2017 21:40'!
randomnessCheckbox
	" Answer the randomnessCheckbox of this CMSpecStepMethodChoice "

	^ randomnessCheckbox! !

!CMSpecStepMethodChoice methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/26/2017 21:40'!
randomnessCheckbox: anObject
	" Sets the randomnessCheckbox of this CMSpecStepMethodChoice "

	randomnessCheckbox := anObject! !

!CMSpecStepMethodChoice methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/26/2017 21:40'!
selectMethodLabel
	" Answer the selectMethodLabel of this CMSpecStepMethodChoice "

	^ selectMethodLabel! !

!CMSpecStepMethodChoice methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/26/2017 21:40'!
selectMethodLabel: anObject
	" Sets the selectMethodLabel of this CMSpecStepMethodChoice "

	selectMethodLabel := anObject! !

!CMSpecStepMethodChoice methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/26/2017 21:40'!
title
	" Private - See superimplementor's comment "

	^ ''! !

!CMSpecStepMethodChoice methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/26/2017 21:40'!
toolbar
	" Answer the toolbar of this CMSpecStepMethodChoice "

	^ toolbar! !

!CMSpecStepMethodChoice methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/26/2017 21:40'!
toolbar: anObject
	" Sets the toolbar of this CMSpecStepMethodChoice "

	toolbar := anObject! !

ComposableModel subclass: #CMSpecPassiveAddRBGroup
	instanceVariableNames: 'buttonObject buttonLocatedObject buttonNetworkNode buttonNetworkArc buttonFullNetwork buttonMessage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Core'!

!CMSpecPassiveAddRBGroup commentStamp: 'HernanMoralesDurand 10/29/2017 20:10' prior: 0!
CMSpecPassiveAddRBGroup new openWithSpec.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	buttonFullNetwork:		<Object>
	buttonLocatedObject:		<Object>
	buttonMessage:		<Object>
	buttonNetworkArc:		<Object>
	buttonNetworkNode:		<Object>
	buttonObject:		<Object>


    Implementation Points!

!CMSpecPassiveAddRBGroup class methodsFor: 'specs' stamp: 'HernanMoralesDurand 10/29/2017 20:10'!
defaultSpec
	<spec: #default>
	
	^ SpecLayout composed
		newColumn: [ :row |
			row 
				add: #buttonObject;
				add: #buttonLocatedObject;
				add: #buttonNetworkNode;
				add: #buttonNetworkArc;
				add: #buttonFullNetwork;
				add: #buttonMessage ];
		yourself! !

!CMSpecPassiveAddRBGroup methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/29/2017 19:58'!
buttonFullNetwork
	^ buttonFullNetwork! !

!CMSpecPassiveAddRBGroup methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/29/2017 19:58'!
buttonFullNetwork: anObject
	buttonFullNetwork := anObject! !

!CMSpecPassiveAddRBGroup methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/29/2017 19:58'!
buttonLocatedObject
	^ buttonLocatedObject! !

!CMSpecPassiveAddRBGroup methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/29/2017 19:58'!
buttonLocatedObject: anObject
	buttonLocatedObject := anObject! !

!CMSpecPassiveAddRBGroup methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/29/2017 19:58'!
buttonMessage
	^ buttonMessage! !

!CMSpecPassiveAddRBGroup methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/29/2017 19:58'!
buttonMessage: anObject
	buttonMessage := anObject! !

!CMSpecPassiveAddRBGroup methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/29/2017 19:58'!
buttonNetworkArc
	^ buttonNetworkArc! !

!CMSpecPassiveAddRBGroup methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/29/2017 19:58'!
buttonNetworkArc: anObject
	buttonNetworkArc := anObject! !

!CMSpecPassiveAddRBGroup methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/29/2017 19:58'!
buttonNetworkNode
	^ buttonNetworkNode! !

!CMSpecPassiveAddRBGroup methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/29/2017 19:58'!
buttonNetworkNode: anObject
	buttonNetworkNode := anObject! !

!CMSpecPassiveAddRBGroup methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/29/2017 19:58'!
buttonObject
	^ buttonObject! !

!CMSpecPassiveAddRBGroup methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/29/2017 19:58'!
buttonObject: anObject
	buttonObject := anObject! !

!CMSpecPassiveAddRBGroup methodsFor: 'initialization' stamp: 'HernanMoralesDurand 10/29/2017 20:14'!
initializeWidgets
	" Private - See superimplementor's comment "

	self instantiateModels: #(
		buttonObject  				RadioButtonModel
		buttonLocatedObject 		RadioButtonModel
		buttonNetworkNode 			RadioButtonModel
		buttonNetworkArc 			RadioButtonModel
		buttonFullNetwork 			RadioButtonModel
		buttonMessage 				RadioButtonModel).
	self setFocus.
	self setGroup.! !

!CMSpecPassiveAddRBGroup methodsFor: 'initialization' stamp: 'HernanMoralesDurand 10/29/2017 20:14'!
setFocus
	
	self focusOrder
		add: buttonObject;
		add: buttonLocatedObject;
		add: buttonNetworkNode;
		add: buttonNetworkArc;
		add: buttonFullNetwork;
		add: buttonMessage
! !

!CMSpecPassiveAddRBGroup methodsFor: 'initialization' stamp: 'HernanMoralesDurand 10/29/2017 20:15'!
setGroup
	" Group receiver's radio buttons "

	RadioButtonGroupModel new
		addRadioButton: buttonObject;
		addRadioButton: buttonLocatedObject;
		addRadioButton: buttonNetworkNode;
		addRadioButton: buttonNetworkArc;
		addRadioButton: buttonFullNetwork;
		addRadioButton: buttonMessage;
		default: buttonObject.

! !

SpcGrowableSearchList subclass: #CMGrowableAuthorList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Core'!

!CMGrowableAuthorList commentStamp: 'HernanMoralesDurand 8/8/2017 03:03' prior: 0!
Please comment me using the following template inspired by Class Responsibility Collaborator (CRC) design:

CMGrowableAuthorList new openWithSpec.

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.


    Implementation Points!

!CMGrowableAuthorList methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/15/2017 15:06'!
authors
	" Answer a <Collection> of <String> with author names "

	| authWidgets authCollection |
	authWidgets := self widgets collect: #authorName.
	authCollection := (authWidgets collect: #pendingText) values.
	^ (authCollection joinUsing: Character cr) asString.! !

!CMGrowableAuthorList methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/15/2017 17:49'!
emails
	" Answer a <Collection> of <String> with author's emails "

	| authWidgets authCollection |

	authWidgets := self widgets collect: #authorEmail.
	authCollection := (authWidgets collect: #pendingText) values.
	^ (authCollection joinUsing: Character cr) asString.! !

!CMGrowableAuthorList methodsFor: 'initialization' stamp: 'HernanMoralesDurand 8/8/2017 03:05'!
initializeWidgets

	self instantiateModels: #(firstItem CMSpecCommentInterfaceAuthor).
	self collection add: #firstItem! !

!CMGrowableAuthorList methodsFor: 'private' stamp: 'HernanMoralesDurand 8/8/2017 02:57'!
listBoxClass
	" Private -  See comment in #add "

	^ #CMSpecCommentInterfaceRemovableAuthor! !

!SubscriptionRegistry methodsFor: '*Cormas-UI' stamp: 'HernanMoralesDurand 4/11/2018 10:54'!
glmSubscriptions

	^ self subscriptions! !

SpcDynamicGrowableBox subclass: #CMSpecCommentInterfaceAuthor
	instanceVariableNames: 'validated conditionValue authorName authorEmail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Core'!

!CMSpecCommentInterfaceAuthor commentStamp: 'HernanMoralesDurand 10/15/2017 03:08' prior: 0!
Represents each "row" with author information in Model Comments window.

| m |
m := DynamicComposableModel new.
m instantiateModels: #(item CMSpecCommentInterfaceAuth  ok OkToolbar).
m ok okAction: [ m window delete ].
m openWithSpecLayout: (SpecLayout composed
	newColumn: [: c | 
		c add: #item ;
			add: #ok height: 26 ];
	yourself).
	
CMSpecCommentInterfaceAuthor new openWithSpec.!

!CMSpecCommentInterfaceAuthor class methodsFor: 'specs' stamp: 'HernanMoralesDurand 8/8/2017 02:08'!
spec
	<spec>
	
	^ SpecLayout composed newRow: [: r |
			r
				add: #authorName;
				add: #authorEmail;
				add: #ok width: 35 ]
			height: 25;
		yourself! !

!CMSpecCommentInterfaceAuthor methodsFor: 'initialization' stamp: 'HernanMoralesDurand 8/8/2017 02:25'!
initializeAuthorEmail

	self authorEmail
		ghostText: 'e-mail';
		entryCompletion: nil;
		autoAccept: true;
		acceptBlock: validateBlock;
		whenTextChanged: [ : t | 
			t isEmpty 
				ifTrue: [ self beInvalid ]
				ifFalse: [ self beValid ] ].! !

!CMSpecCommentInterfaceAuthor methodsFor: 'initialization' stamp: 'HernanMoralesDurand 8/8/2017 02:25'!
initializeAuthorName

	self authorName
		ghostText: 'Name';
		entryCompletion: nil;
		autoAccept: true;
		acceptBlock: validateBlock;
		whenTextChanged: [ : t | 
			t isEmpty 
				ifTrue: [ self beInvalid ]
				ifFalse: [ self beValid ] ].! !

!CMSpecCommentInterfaceAuthor methodsFor: 'initialization' stamp: 'HernanMoralesDurand 8/8/2017 02:10'!
initializeBoxModels

	self instantiateModels: #(
		authorName 			#TextInputFieldModel 
		authorEmail 			#TextInputFieldModel 
		ok 						#ButtonModel).! !

!CMSpecCommentInterfaceAuthor methodsFor: 'initialization' stamp: 'HernanMoralesDurand 9/15/2017 01:25'!
initializeWidgets
	" Private - See superimplementor's comment "

	self initializeBoxModels.
	validateBlock := [ :t | self ok enabled: t isEmpty not ].
	self initializeAuthorName.
	self initializeAuthorEmail.	
	self initializeAddButton.
	self focusOrder
		add: self authorName;
		add: self authorEmail;
		add: self ok! !

CMSpecCommentInterfaceAuthor subclass: #CMSpecCommentInterfaceRemovableAuthor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Core'!

!CMSpecCommentInterfaceRemovableAuthor commentStamp: 'HernanMoralesDurand 8/8/2017 03:17' prior: 0!
CMSpecCommentInterfaceRemovableAuthor new openWithSpec.

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.


    Implementation Points!

!CMSpecCommentInterfaceRemovableAuthor class methodsFor: 'specs' stamp: 'HernanMoralesDurand 8/8/2017 03:18'!
defaultSpec
	<spec>
	
	^ SpecLayout composed newRow: [ : r |
			r
				add: #authorName;
				add: #authorEmail;
				add: #ok width: 35;
				add: #removeButton width: 35 ]				
			height: 25;
		yourself! !

!CMSpecCommentInterfaceRemovableAuthor methodsFor: 'initialization' stamp: 'HernanMoralesDurand 8/8/2017 03:18'!
initializeBoxModels
	" Private - See superimplementor's comment "

	self instantiateModels: #(
		authorName 			#TextInputFieldModel 
		authorEmail 			#TextInputFieldModel 
		ok 						#ButtonModel		
		removeButton 		#ButtonModel).! !

!CMSpecCommentInterfaceRemovableAuthor methodsFor: 'initialization' stamp: 'HernanMoralesDurand 8/8/2017 02:50'!
initializeRemoveButton
	" Private - Set a remove button to remove the receiver from its owner "

	self removeButton
		label: '-';
		state: false;
		enabled: true;
		action: [ (self confirm: 'Are you sure you want to delete the selected author?')
				ifTrue: [ self owner remove: self ] ]! !

!CMSpecCommentInterfaceRemovableAuthor methodsFor: 'initialization' stamp: 'HernanMoralesDurand 8/8/2017 03:18'!
initializeWidgets
	" Private - See superimplementor's comment "

	super initializeWidgets.
	self initializeRemoveButton.
	self focusOrder
		add: self authorName;
		add: self authorEmail;
		add: self ok;
		add: self removeButton! !

PFProjectManager subclass: #CMProjectManager
	instanceVariableNames: 'openStatus currentModelPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Project'!

!CMProjectManager commentStamp: 'HernanMoralesDurand 10/1/2017 16:50' prior: 0!
Controller between the UI classes and CMProjectModel.

Example expressions:

CMProjectManager new openProject.

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

openStatus 		<Boolean> 	<true> if receiver's model file was opened successfully, <false> otherwise!

!CMProjectManager methodsFor: 'code-generation' stamp: 'HernanMoralesDurand 10/22/2017 19:12'!
addNewClassType: aString inheritingFrom: aClass name: nameString initProtocol: initBoolean stepProtocol: stepBoolean

	self codeGenerator 
		addNewClassType: aString 
		inheritingFrom: aClass 
		name: nameString 
		initProtocol: initBoolean 
		stepProtocol: stepBoolean 
! !

!CMProjectManager methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/27/2017 23:22'!
applicationExtension
	" See comment in #applicationExtension "

	^ self applicationClass applicationExtension  ! !

!CMProjectManager methodsFor: 'code-generation' stamp: 'HernanMoralesDurand 10/22/2017 19:11'!
codeGenerator
	" Answer the receiver's Code Generator "
	
	^ self currentProject codeGenerator! !

!CMProjectManager methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/9/2017 23:01'!
cormasModel
	" Answer a <CMProjectModel> which is a Cormas model instance "

	^ self currentProject cormasModel! !

!CMProjectManager methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/15/2017 15:52'!
cormasModelAuthors: aString
	" Set aString with author names (one by line) to the receiver's model "

	self currentProject cormasModelAuthors: aString! !

!CMProjectManager methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/2/2017 00:29'!
cormasModelClass

	^ self currentProject cormasModelClass! !

!CMProjectManager methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/10/2017 01:51'!
cormasModelCreationDate: aString

	self currentProject cormasModelCreationDate: aString
! !

!CMProjectManager methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/15/2017 17:44'!
cormasModelEmails: aString
	" Set aString with emails (one by line) to the receiver's model "

	self currentProject cormasModelEmails: aString! !

!CMProjectManager methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/30/2017 12:22'!
cormasModelName
	" Answer a <String> which is a Cormas model name "

	^ self currentProject cormasModelName! !

!CMProjectManager methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/15/2017 17:36'!
cormasModelText: aString
	" Set the receiver's model comments to aString "

	self currentProject cormasModelText: aString
! !

!CMProjectManager methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/15/2017 15:54'!
cormasModelVersion: aString
	" Set the receiver's model version number to aString.
	ToDo: Currently the version number format is not normalized/validated "

	self currentProject cormasModelVersion: aString
! !

!CMProjectManager methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 1/8/2018 23:06'!
cormasModels
	" Answer a <Collection> of <String> with receiver's available models "
	
	^ Cormas modelsPath entries collect: #basename! !

!CMProjectManager methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 4/27/2018 10:24'!
cormasOpenLocations
	" Answer a Collection of valid locations for opening a Cormas model "
	
	^ self cormasOpenLocationsMap keys
! !

!CMProjectManager methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 4/27/2018 13:55'!
cormasOpenLocationsMap
	" Answer a Collection of valid locations for opening a Cormas model "

	^ Dictionary new
		at: 'Local Disk' 		put: #requestModelOpenFromLocalDisk;
		at: 'URL' 				put: #requestModelOpenFromURL;
		at: 'Local image' 		put: #requestModelOpenFromLocalImage;
		at: 'Remote image'		put: #requestModelOpenFromRemoteImage;
		yourself ! !

!CMProjectManager methodsFor: 'accessing' stamp: 'HernanMoralesDurand 10/2/2017 00:28'!
createClassModelNamed: modelName
 	" Private - See delegated method implementor. Answer a new <Class> "
	
	^ self currentProject createClassModelNamed: modelName! !

!CMProjectManager methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 9/26/2017 17:12'!
createNewProject
	" Private - See superimplementor's comment "
	
	| answer |

	(answer := self requestMessage: self translator tNewProjectName) isEmptyOrNil 
		ifFalse: [ 
			self createAppProject: answer.
			self fsm handleEvent: #actionNew.
			(CMSpecModelComments for: self) openWithSpec ]
		ifTrue: [ self informMessage: self translator tNewProjectEmptyName ].

! !

!CMProjectManager methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 9/26/2017 17:12'!
doPostOpenActions
	" Private - See superimplentor's comment "

	self updateNewProject: self cormasModelName.
	self fsm handleEvent: #actionOpened.! !

!CMProjectManager methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 9/15/2017 01:42'!
exploreProject

	self flag: #toBeReviewed.
	self currentProject explore.! !

!CMProjectManager methodsFor: 'private' stamp: 'HernanMoralesDurand 1/9/2018 02:27'!
findModelClass: aFilename
	" Answer a <String> with the model class name found in aFilename"
 
	| ckDecl |
	self flag: #toReview.
	ckDecl := ((ChunkFileFormatParser for: aFilename asFileReference readStream) parseChunks
		select: [ : c | c isDoItDeclaration and: [ c contents beginsWith: 'CormasModel subclass:' ] ]) anyOne.
	^ ckDecl contents substrings third
		! !

!CMProjectManager methodsFor: 'initialization' stamp: 'HernanMoralesDurand 1/1/2018 18:29'!
initialize
	" Set the receiver's inital state "

	super initialize.
	self applicationClass: CMApplicationProject.
	openStatus := false.
! !

!CMProjectManager methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/9/2017 23:02'!
modelControlInitMethods
	" Answer a <Collection> of <String> with CORMAS model control selectors "
	
	^ (self cormasModelClass organization listAtCategoryNamed: #control) collect: #asString! !

!CMProjectManager methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/9/2017 23:02'!
modelInitMethods
	" Answer a <Collection> of <String> with CORMAS model initialization selectors "
	
	^ (self cormasModelClass organization listAtCategoryNamed: #init) collect: #asString! !

!CMProjectManager methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 4/7/2018 17:27'!
openEditAttributes

	self projectWindow openEditAttributes.! !

!CMProjectManager methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 4/27/2018 15:02'!
openImageProject: modelName
	" Open the project named projectApp "

	self currentProject: (CMProjectModel basicNew
		initializeForModel: (Smalltalk at: modelName asSymbol) named: modelName;
		yourself).

! !

!CMProjectManager methodsFor: 'callbacks' stamp: 'NicolasBecu 4/30/2018 10:36'!
openModelNamed: aString
	" Request a file to be opened as CORMAS project "

	(FDOpenFileDialog new
		title: ('Choose st file');
		extensionFilters: 	{ 'st files' -> #(st) };
		defaultFolder:  FileLocator imageDirectory / 'Models'/ aString ;
		openModal)	
			
		ifNotNil: [ : fileRef | 
			[ fileRef readStream fileInDisplayingProgress ]
			on: Exception
			do: [ : ex | 
				self alertMessage: ex messageText. 
				openStatus := false ].
			openStatus := true.
			^ fileRef fullName ]
		ifNil: [ openStatus := false ]! !

!CMProjectManager methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 4/27/2018 10:38'!
openProject

	| locationName |
	locationName := self requestModelNameLocation
		ifNotNil: [ : locName | self perform: (self cormasOpenLocationsMap at: locName) ].
! !

!CMProjectManager methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 1/9/2018 02:35'!
openProject: modelName fileName: fileName
	" Open the project named projectApp "

	| modelClass |
	modelClass := (self findModelClass: fileName) allButFirst asClass.
	self currentProject: (CMProjectModel basicNew
		fileName: fileName;
		initializeForModel: modelClass new named: modelName;
		yourself).

! !

!CMProjectManager methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 4/27/2018 13:54'!
requestModelNameLocation
	" Open request dialog to select a load nodel location "
	
	| widget |
	widget := SpcListModel new.
	widget
		title: self translator tWhichOpeningLocation;
		items: self cormasOpenLocations.
	widget openDialogWithSpec modalRelativeTo: self currentWorld.
	^ widget selectedItem		
		! !

!CMProjectManager methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 4/27/2018 10:42'!
requestModelOpenDialogFromLocalImage
	" Open a Cormas model. Answer project creation status, <true> if project was opened successfully "
	
	| widget |
	widget := SpcListModel new.
	widget
		title: self translator tWhichModel;
		items: self cormasModels.
	widget openDialogWithSpec modalRelativeTo: self currentWorld.
	^ widget selectedItem! !

!CMProjectManager methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 4/27/2018 13:56'!
requestModelOpenFromLocalDisk
	" Open a Cormas model. Answer project creation status, <true> if project was opened successfully "

	| mName fileName |		
	(mName := self requestModelOpenDialogFromLocalImage)
		ifNotNil: [ : modelName | fileName := self openModelNamed: modelName ].
	openStatus
		ifTrue: [ 
			self openProject: mName fileName: fileName.
			self doPostOpenActions ]
		ifFalse: [ self informMessage: self translator tProjectOpenFailed ].
	^ openStatus
		! !

!CMProjectManager methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 4/27/2018 14:02'!
requestModelOpenFromLocalImage
	" Open a Cormas model. Answer project creation status, <true> if project was opened successfully "

	| mName fileName |		
	(mName := self requestModelOpenDialogFromLocalImage)
		ifNotNil: [ : modelName | openStatus := true ].
	openStatus
		ifTrue: [ 
			self openImageProject: mName.
			self doPostOpenActions ]
		ifFalse: [ self informMessage: self translator tProjectOpenFailed ].
	^ openStatus
		! !

!CMProjectManager methodsFor: 'callbacks' stamp: 'NicolasBecu 5/1/2018 22:38'!
updateNewProject: modelName
	" See superimplementor's comment "

	self currentProject hasCormasModelClass
		ifFalse: [ self currentProject cormasModelClass: (self createClassModelNamed: modelName).
			self currentProject cormasModel: self cormasModelClass new ].
	self cormasModelClass initialize.
	self cormasModel projectManager: self.
	super updateNewProject: modelName! !

!CMProjectManager methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 4/8/2018 23:52'!
updateStateInit
	" Private - Handle the open application event "

	super updateStateInit.
	self projectWindow
		menuDisableProgrammingGroup;
		menuDisableVisualizationGroup;
		menuDisableSimulationGroup;
		menuDisableToolsGroup;
		menuDisableHelpGroup.! !

!CMProjectManager methodsFor: 'utilities' stamp: 'HernanMoralesDurand 9/26/2017 14:44'!
verifyClassExist: aClassName
	
	^ Smalltalk hasClassNamed: self cormasModelClass! !

RTView subclass: #CMPharoGridSimulation
	instanceVariableNames: 'anim cellSize model situatedEntitiesViews origin speed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Core'!

!CMPharoGridSimulation methodsFor: 'model scheduling' stamp: 'NicolasBecu 5/1/2018 16:38'!
addNewSituatedEntities
	
	| newSituatedEntities newSituatedEntitiesViews |
	newSituatedEntities := model allTheSituatedEntities select: [ :a | ((situatedEntitiesViews collect: [ :e | e model ]) includes: a) not ].
	newSituatedEntitiesViews := (RTEllipse new
		color: [ :fe | fe getColorForPov: #pov ];
		size: 20) elementsOn: newSituatedEntities.
	situatedEntitiesViews addAll: newSituatedEntitiesViews.
	self addAll: newSituatedEntitiesViews.
	! !

!CMPharoGridSimulation methodsFor: 'instance creation' stamp: 'NicolasBecu 5/1/2018 21:18'!
addViewForAgents: situatedEntities
	"Organize coordinate system"
	| windowSize |
	origin := (self elements collect: [ :e | e position x ]) min
		@ (self elements collect: [ :e | e position y ]) min.
	windowSize := (self elements collect: [ :e | e position x ]) max
		@ (self elements collect: [ :e | e position y ]) max.
	"9@6 / (3@2)"
	cellSize := (windowSize - origin) / (model spaceModel column @ model spaceModel line).
	situatedEntitiesViews := ((RTEllipse new
				color: [ :fe | fe getColorForPov: #pov ];
				size: 20) elementsOn: situatedEntities).
	
	self addAll: situatedEntitiesViews.! !

!CMPharoGridSimulation methodsFor: 'instance creation' stamp: 'NicolasBecu 5/1/2018 21:19'!
addViewForCells: cells
self
		addAll:
			((RTBox new
				color: [ :e | 
					e getColorForPov: #pov ];
				size: 25) elementsOn: cells).
	RTGridLayout new
		gapSize: 0;
		lineItemsCount: model spaceModel column;
		on: self elements.! !

!CMPharoGridSimulation methodsFor: 'opening and menus' stamp: 'NicolasBecu 5/1/2018 21:22'!
buildMenu
	| menuBuilder |
	menuBuilder := RTMenuBuilder new view: self.
	speed := 2.0.
	menuBuilder
		menu: 'speedOfNextSim'
		submenu: 'fast'
		background: (Color red alpha: 0.4)
		callback: [ speed := 0.0 ].
	menuBuilder
		menu: 'speedOfNextSim'
		submenu: 'medium'
		background: (Color blue alpha: 0.4)
		callback: [ speed := 500.0 ].
	menuBuilder
		menu: 'speedOfNextSim'
		submenu: 'slow'
		background: (Color green alpha: 0.4)
		callback: [ speed := 1000.0 ].
	menuBuilder
		menu: 'reset'
		background: (Color lightBlue alpha: 0.4)
		callback: [ self removeAllElements.
			model initSimulation.
			self
				on: model
				withCells: model spaceModelEntities
				withSituatedEntities: model allTheSituatedEntities ]! !

!CMPharoGridSimulation methodsFor: 'accessing' stamp: 'NickPapoulias 4/26/2018 16:01'!
cellSize
	^ cellSize ! !

!CMPharoGridSimulation methodsFor: 'accessing' stamp: 'BrunoBonte 4/25/2018 12:11'!
cellSize: anObject
	cellSize := anObject! !

!CMPharoGridSimulation methodsFor: 'instance creation' stamp: 'HernanMoralesDurand 4/26/2018 18:55'!
on: aModel

	^ self on: aModel with: aModel spaceModelEntities! !

!CMPharoGridSimulation methodsFor: 'instance creation' stamp: 'BrunoBonte 4/25/2018 11:47'!
on: aModel with: cells


	self addAll: ((RTBox new color: [ :e | 
		e getColorForPov: #pov]; 
		size: 25) 
		elementsOn: cells).

	RTGridLayout new
		gapSize: 0;
		lineItemsCount: aModel spaceModel column;
		on: self elements.

	self canvas camera focusOnCenterScaled.
	
	anim := RTActiveAnimation new.
	anim intervalInMilliseconds: 0.
	anim
		blockToExecute: [ aModel runStep.
			self elements do: #updateShape ].
	
	anim inView: self.! !

!CMPharoGridSimulation methodsFor: 'instance creation' stamp: 'BrunoBonte 4/26/2018 20:05'!
on: aModel with: cells and: situatedEntities
	| windowSize |
	"self halt."
	"Create grid"
	model := aModel. 
	self
		addAll:
			((RTBox new
				color: [ :e | 
					(e theOccupants values isEmpty or: [ e theOccupants values first isEmpty ])
						ifFalse: [ e getColorForPov: #pov ]
						ifTrue: [ e getColorForPov: #pov ] ];
				size: 25) elementsOn: cells).
	RTGridLayout new
		gapSize: 0;
		lineItemsCount: aModel spaceModel column;
		on: self elements.
	"Organize coordinate system"
	origin := (self elements collect: [ :e | e position x ]) min
		@ (self elements collect: [ :e | e position y ]) min.
	windowSize := (self elements collect: [ :e | e position x ]) max
		@ (self elements collect: [ :e | e position y ]) max.
	"9@6 / (3@2)"
	cellSize := (windowSize - origin) / (aModel spaceModel column @ aModel spaceModel line).
	situatedEntitiesViews := ((RTEllipse new
				color: [ :fe | fe getColorForPov: #pov ];
				size: 20) elementsOn: situatedEntities).
	
	self addAll: situatedEntitiesViews.
	
	self canvas camera focusOnCenterScaled.
	anim := RTActiveAnimation new.
	anim intervalInMilliseconds: (speed ifNil:[2]).
	anim
		blockToExecute: [ self runModelStep].
	anim inView: self.
	! !

!CMPharoGridSimulation methodsFor: 'instance creation' stamp: 'NicolasBecu 5/1/2018 23:41'!
on: aModel withCells: cells withSituatedEntities: situatedEntities
	"This method is called by the CMSpecSimulationWindow. It launches the RTActiveAnimation (replacement of spaceInterface)"

	model := aModel.
	self addViewForCells: cells.
	self addViewForAgents: situatedEntities.
	self canvas camera focusOnCenterScaled.
	anim := RTActiveAnimation new.
	anim intervalInMilliseconds: (speed ifNil: [ 0 ]).
	anim
		blockToExecute: [ self runModelStep
			"model timeStep = 100
				ifTrue: [ self halt ]" ].
	anim inView: self! !

!CMPharoGridSimulation methodsFor: 'accessing' stamp: 'BrunoBonte 4/26/2018 19:42'!
origin
	^ origin! !

!CMPharoGridSimulation methodsFor: 'accessing' stamp: 'BrunoBonte 4/26/2018 19:42'!
origin: anObject
	origin := anObject! !

!CMPharoGridSimulation methodsFor: 'model scheduling' stamp: 'NicolasBecu 5/1/2018 16:38'!
removeObsoleteSituatedEntities
	| obsoleteSituatedEntities |
	obsoleteSituatedEntities  := situatedEntitiesViews select: [ :e | e model isSituated not ].
	obsoleteSituatedEntities do:[:e| e remove].
	situatedEntitiesViews removeAll: obsoleteSituatedEntities.! !

!CMPharoGridSimulation methodsFor: 'opening and menus' stamp: 'NicolasBecu 5/1/2018 21:23'!
runAndVisualize

	self buildMenu.
	
	self openWithToolbar.
	! !

!CMPharoGridSimulation methodsFor: 'model scheduling' stamp: 'NicolasBecu 5/1/2018 16:40'!
runModelStep
	model runStep.
	self removeObsoleteSituatedEntities.
	self addNewSituatedEntities.
	situatedEntitiesViews do: [ :e | e translateTo: e model patch x @ e model patch y * cellSize ].
	self elements do: #updateShape! !

!CMPharoGridSimulation methodsFor: 'accessing' stamp: 'BrunoBonte 4/25/2018 12:14'!
situatedEntitiesViews
	^ situatedEntitiesViews! !

!CMPharoGridSimulation methodsFor: 'accessing' stamp: 'BrunoBonte 4/25/2018 12:14'!
situatedEntitiesViews: anObject
	situatedEntitiesViews := anObject! !

PFTranslator subclass: #CMTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Project'!

!CMTranslator commentStamp: 'HernanMoralesDurand 9/10/2017 17:19' prior: 0!
Contains CORMAS translations for user messages.

See superclass for usage and description.
!

!CMTranslator methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/11/2018 10:08'!
addTranslationsForEN
	" Private - See superimplementor's comment "

	super addTranslationsForEN.
	self addTranslationsForENPart1.
	self addTranslationsForENPart2.
	self addTranslationsForENPart3.
! !

!CMTranslator methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/8/2018 23:44'!
addTranslationsForENPart1
	" Private - See superimplementor's comment "

	^ (self translatorClass forLanguage: #EN) translationMap 
		at: #tVersionName 						put: 'Version name';
		at: #tCreationDate 					put: 'Creation date';
		at: #tModelComments 					put: 'Model Comments';
		at: #tModelRename 						put: 'The model has been renamed as {1}.
A new class category has been created and all the classes of the previous model have ben copied

We recommend you:
- To save and reload this model, then
- To copy the required directories (Maps, Data, ...) from {2} to {1}
';
		at: #tCreateNewModel 					put: 'Create a new model!!!!';
		at: #tCreateEntityKind 				put: 'Create a kind of Entity';
		at: #tCreateAgent 						put: 'Create a kind of Agent';
		at: #tCommunication 					put: 'Communication';
		at: #tGroup 								put: 'Group';
		at: #tLocation 							put: 'Location';								
		at: #tElement 							put: 'Element';
		at: #tSimpleCell 						put: 'Simple Cell';
		at: #tCellularAutomaton 				put: 'Cellular Automaton';
		at: #tAggregate 						put: 'Aggregate';
		at: #tSetNotConnex 					put: 'Set no connex';
		at: #tName 								put: 'Name';
		at: #tDefineEntities 					put: 'Define the entities';
		at: #tAbstract 							put: 'Abstract / No abstract';
		at: #tSpatial 							put: 'Spatial';
		at: #tSocial 							put: 'Social';
		at: #tPassive 							put: 'Passive';
		at: #tProgrammingEntityClass		put: 'the class for each Entity...';
		at: #tSimOrganization 				put: 'the simulation Organization...';
		at: #tObserver 							put: 'the Observer...';
		at: #tMessages 							put: 'Messages';
		at: #tProbes 							put: 'Probes';
		at: #tInitInstantiation 				put: 'the initial instantiation';
		at: #tScheduler 						put: 'the scheduler';
		at: #tSpaceEntities 					put: 'Space and Entities';
		at: #tEdit 								put: 'Edit';
		at: #tSpecialize						put: 'Specialize';
		at: #tRemove 							put: 'Remove';
		at: #tAttributes 						put: 'Attributes';
		at: #tMethods 							put: 'Methods';
		at: #tActivityDiagrams 				put: 'Activity diagrams';
		at: #tPoVSetter 						put: 'PoV Setter';
		at: #tObject  							put: 'Object';
		at: #tObjectHelp 						put: 'A simple passive entity';
		at: #tLocatedObject 					put: 'Located Object';
		at: #tLocatedObjectHelp 				put: 'A passive entity located on a cell';
		at: #tNetworkNode 						put: 'Network Node';
		at: #tNetworkNodeHelp 				put: 'A Node of a Network located on a Cell';
		at: #tNetworkArc 						put: 'Network Arc';
		at: #tNetworkArcHelp 					put: 'An Arc of a Network located on 2 Cells';
		at: #tFullNetwork 						put: 'Full Network';
		at: #tFullNetworkHelp 				put: 'An oriented Network composed of a Set of Arc and Nodes';
		at: #tMessage 							put: 'Message';
		at: #tMessageHelp 						put: 'Message for AgentCommunication (with mailbox)';
		at: #tEditActivityDiagrams 			put: 'edit activity diagrams';
		at: #tEditAttributes 					put: 'edit attributes';
		at: #tEditInit 							put: 'edit initialization';
		at: #tEditSteps 						put: 'edit steps';
		at: #tMissingClassName 				put: 'Please enter a name for the new class!!!!';
		at: #tAlreadyUsed 						put: 'Already used!!!!';
		at: #tWhichModel 						put: 'Which Model?';
		at: #tVisualization 					put: 'Visualization';
		at: #tProgramming 						put: 'Programming';
		at: #tSimulation 						put: 'Simulation';
		at: #tEnterClassName 					put: 'Please enter a name for the new class!!';
		at: #tSpatialEntityCellHelp 		put: 'SpatialEntityCell: the cell is the basic entity of the space (as Cellular Automata)';
		at: #tSimpleCellHelp 					put: 'SpatialEntityElement is the basic Cell entity';
		at: #tSpatialEntityHelp 				put: 'SpatialEntityAggregate is composed of connected cells';
		at: #tSetNotConnexHelp 				put: 'SpatialEntityNotConnex is composed of unconnected cells or aggregates';
		at: #tCellAutomatonHelp 				put: 'CA is usefull for dynamics between cells';
		at: #tOATPredefValues 				put: 'Predefined by list of values';						
		at: #tOATSeqValues 					put: 'Sequential values';
		at: #tCrossedSeqValues 				put: 'Sequential values';
		at: #tCrossedPredefValues 			put: 'Predefined by list of values';						
		at: #tCrossSensAnalysis 				put: 'Crossed Sensitivity Analysis';
		at: #tDisplayParams 					put: 'Display Parameters';
		at: #tOATSensAnalysis 				put: 'OAT Sensitivity Analysis';
		at: #tSimpleStochAnalysis 			put: 'Simple Stochastic Analysis';
		at: #tMonteCarlo 						put: 'Monte Carlo';
		at: #tClassifyByParams 				put: 'Classify by parameters';
		at: #tSimInformation 					put: 'Simulation Information';
		at: #tSimInterface 					put: 'Simulation Interface';
		at: #tStartRWebService 				put: 'Start Web Service for R';
		at: #tStopRWebService 				put: 'Stop Web Service for R';
		at: #tAnalysis 							put: 'Analysis';
		at: #tCreateInstances 				put: 'Create Instances';
		at: #tOpenPharoMenu 					put: 'Open Pharo Menu';
		at: #tManipulateInstances 			put: 'Manipulate Instances';
		at: #tModelGlossary 					put: 'Model Glossary';
		at: #tModelListing 					put: 'Model listing as text file';
		at: #tPackageClient 					put: 'Package client';
		at: #tSpace 								put: 'Space';
		at: #tDisplayModelVersions 			put: 'Display model versions';
		at: #tSnapshot 							put: 'Snapshot current state';
		at: #tModifiedModelName 				put: 'The name has been renamed as ';
		at: #tDisplayLegends 					put: 'Display Legends';
		at: #tPhoto 								put: 'Photo';
		at: #tVideo 								put: 'Video';
		at: #tClickTo 							put: 'Click to...';
		at: #tHabitus 							put: 'Habitus';
		at: #tUnmoveableZoom 					put: 'Unmoveable zoom';
		at: #tMoveableZoom						put: 'Moveable zoom';
		at: #tSetTrackLength					put: 'Set track length';
		at: #tEnableUndoRedo					put: 'Enable Undo/Redo...';
		at: #tTouchpad 							put: 'Touchpad manipulate mode';
		at: #tEnvironment 						put: 'Environment';
		at: #tGridSize 							put: 'Grid size';
		at: #tLoad 								put: 'Load';
		at: #tModify 							put: 'Modify';
		at: #tReOpen 							put: 'Re-Open';
		at: #tPoV 								put: 'PoV';
		at: #tAttribute 						put: 'Attribute';
		at: #tClassVariable 					put: 'Class variable';
		at: #tAttributesSuperLabel 			put: 'Attributes and class Variables of the super classes';
		at: #tAttributesTargetLabel 		put: 'Attributes and class Variables of the target class';
		at: #tReset 								put: 'Reset';
		at: #tApply 								put: 'Apply';
		at: #tEnterAttName 					put: 'Enter an attribute name (without white spaces, numbers or symbols)';
		at: #tAppTitle 							put: 'CORMAS';
		at: #tInvalidName 						put: ' is not a valid name. Please, enter a valid name';
		at: #tHelpAddInstAtt 					put: 'Add a new attribute to the target class';
		at: #tHelpRemoveInstAtt 				put: 'Remove an attribute from the target class';
		at: #tHelpAddClassAttr				put: 'Add a new class attribute to the target class';
		at: #tHelpRemoveClassAtt 			put: 'Remove an attribute from the target class';
		at: #tClassEditor 						put: 'UML - Class Editor';
		yourself! !

!CMTranslator methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/12/2018 20:12'!
addTranslationsForENPart2
	" Private - See superimplementor's comment "

	^ (self translatorClass forLanguage: #EN) translationMap 
		at: #tInitialValueChooser 			put: 'Initial value chooser';
		at: #tSetterAccessor 					put: 'Setter accessor';
		at: #tGetterAccessor 					put: 'Getter accessor';
		at: #tNotifyObs 						put: 'Notify observers when changed';
		at: #tInitialValueLabel				put: 'Enter an initial value for this attribute';
		at: #tNumber 							put: 'Number';
		at: #tRandom 							put: 'Random';
		at: #tBoolean 							put: 'Boolean';
		at: #tStringSymbol 					put: 'String / Symbol';
		at: #tArray 								put: 'Array';
		at: #tNewEntity 						put: 'New Entity';
		at: #tCollectionEmpty 				put: 'Collection (empty)';
		at: #tNoValue 							put: 'No value or another instance (to be sent in #init)';
		at: #tFillArray							put: 'Fill the Array with values';
		at: #tSimulate 							put: 'simulate';
		at: #tReplay 							put: 'replay';
		at: #tCurrentStep 						put: 'current step';
		at: #tInitialize 						put: 'Initialize';
		at: #tBackwardLabel 					put: 'Backward';
		at: #tForwardLabel 					put: 'Forward';
		at: #tFinalStep 						put: 'final step';
		at: #tChange 							put: 'Change';
		at: #tSimCloseHelp 					put: 'Close the simulation interface';
		at: #tSimStepHelp 						put: 'Current time';	
		at: #tSimFinalStepHelp 				put: 'Enter the final step';
		at: #tSelectMethod 					put: 'Select a method of ';
		at: #tFinalStepChoice 				put: 'Final step:';
		at: #tInitializeRandomness 			put: 'Initialize randomness';
		at: #tMissingInitMethods 			put: 'The model does not define any method for initialization !!';
		at: #tMissingControlMethods 		put: 'The model does not define any method for control !!';
		at: #tNoStoredSim 						put: 'The "Dump" directory does not contain stored simulations';
		at: #tNoStoredSimFolder				put: ' directory does not contain stored simulations';
		at: #tReplayStartStep 				put: 'The replay will starts at step ';
		at: #tChooseDumpDir					put: 'Choose a ''Dump'' Directory:';
		at: #tCreatePoVAtt 					put: 'Create PoV on which attribute?';
		at: #tFoundPoVValues 					put: 'Cormas found the following values for the attribute ';
		at: #tAddSymbols 						put: 'Do you want to create the symbols associated to these values?';
		at: #tEnterNewSymbol 					put: 'Enter a new symbol';
		at: #tSelectEntity 					put: 'An entity must be selected';
		at: #tNoMoreMethods 					put: 'No more methods can be added to this list';
		at: #tNoMorePoVMethods				put: 'No more pov can be added to this list';
		at: #tNoMoreEntities 					put: 'No more entities can be added to this list';
		at: #tNoMoreInfo 						put: 'No more info can be added to this list';
		at: #tPoVMethods 						put: 'POV Methods';
		at: #tAgentTracksSize 				put: 'Choose the size of the agents tracks';
		at: #tSpaceNotAllowed 				put: 'Space characters are not allowed for Habitus names. Do you want to replace by ''_'' character ?';
		at: #tConfigTitle 						put: 'Please enter a title for that configuration';
		at: #tOneInfo 							put: 'Only one info can be set as default';
		at: #tInfoDefault 						put: 'This info is already set as default';
		at: #tPoVDefault 						put: 'This pov is already set as default';
		at: #tMustSelectEntity 				put: 'An entity must be selected';
		at: #tEntitiesToCreate 				put: 'Entities to be Created';
		at: #tManipulationEntities			put: 'Manipulation Entities';
		at: #tObservedEntities 				put: 'Observed Entities';
		at: #tChooseConfig 					put: 'Choose a configuration';
		at: #tNoInfoSelected 					put: 'No info selected';							
		at: #tNoAttribSelected 				put: 'No attribute selected';
		at: #tNoEntitySelected 				put: 'No entity selected';
		at: #tNoMethodSelected 				put: 'No method selected';
		at: #tNoPoVSelected 					put: 'No pov selected';
		at: #tOnePoV 							put: 'Only one pov can be set as default';
		at: #tHabitusTitle 					put: 'Habitus from Bourdieu';
		at: #tHabitusText 						put: 'L''habitus est un système de disposition acquises par l''apprentissage implicite ou explicite qui fonctionne comme un système de schèmes générateurs. L''habitus est générateur de stratégies qui peuvent être objectivement conformes aux intérêts objectifs de leurs auteurs sans en avoir été expressément conçues à cette fin. (Bourdieu 1972)
Autre définition : L''habitus est un ensemble de manière d''être, d''agir et de penser propre à un individu, fruit d''un apprentissage particulier lié à son groupe d''appartenance, qui diffère selon sa classe sociale, sa disposition en capital, et sa place occupée dans l''espace social. L''habitus structure les comportements et les actions de l''individu, et à la fois, structure les positions dans l''espace social.';
		at: #tSelectPoVSymbol 				put: 'Please, select a pov symbol';
		at: #tSymbolAlreadyExists 			put: 'This symbol already exists !!!!!!';
		at: #tSelectSymbol 					put: 'Select a symbol !!!!!!';
		at: #tChooseTokenColor 				put: 'Choose token color';
		at: #tNoModel 							put: 'Select or create a model';
		at: #tWhichAttribute					put: 'Which attribute !!!!';
		at: #tPoVDefinition 					put: 'PoV definition';
		at: #tPoVListMethods 					put: 'Methods returning a Color or Symbol';
		at: #tPoVListSymbols 					put: 'Associated Symbols';
		at: #tPoVInfoDisplayed				put: 'Information to be displayed';
		at: #tPoVListInfo 						put: 'Methods returning a String';
		at: #tPoVSetColor 						put: 'Set the Color';
		yourself! !

!CMTranslator methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/27/2018 13:54'!
addTranslationsForENPart3
	" Private - See superimplementor's comment "

	^ (self translatorClass forLanguage: #EN) translationMap 
		at: #tDistributeAsServer 			put: 'Distribute (act as a server)';
		at: #tDistributeAsClient  			put: 'Distribute (act as a client)';
		at: #tAboutModel 						put: 'About this model';
		at: #tHowToRunModel 					put: 'How to run this model';
		at: #tChangeModelComments 			put: 'Change model Comments';
		at: #tWhichOpeningLocation 			put: 'Select open location';
		yourself! !

!CMTranslator methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/11/2018 10:08'!
addTranslationsForES
	" See superimplementor's comment "

	super addTranslationsForES.
	self addTranslationsForESPart1.
	self addTranslationsForESPart2.
	self addTranslationsForESPart3.! !

!CMTranslator methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/8/2018 23:45'!
addTranslationsForESPart1
	" See superimplementor's comment "

	^ (self translatorClass forLanguage: #ES) translationMap 
		at: #tVersionName 						put: 'Versión';
		at: #tCreationDate 					put: 'Fecha de creación';
		at: #tModelComments 					put: 'Comentarios';	
		at: #tModelRename 						put: 'El modelo fue renombrado como {1}.
Una nueva categoría de clase fue creada y todas las clases del modelo anterior fueron copiadas.

Le recomendamos que:
- Guarde y recargue este modelo, y luego
- Copie los directorios requeridos (Mapas, Datos, ...) de {2} a {1}
';								
		at: #tCreateNewModel 					put: 'Cree un nuevo modelo!!!!';
		at: #tCreateEntityKind 				put: 'Crear un nuevo tipo de Entidad';
		at: #tCreateAgent 						put: 'Crear un tipo de Agente';
		at: #tCommunication 					put: 'Comunicación';
		at: #tGroup 								put: 'Grupo';
		at: #tLocation 							put: 'Ubicación';												
		at: #tElement 							put: 'Elemento';
		at: #tSimpleCell 						put: 'Célula Simple';
		at: #tCellularAutomaton 				put: 'Autómata Celular';
		at: #tAggregate 						put: 'Agrupado';
		at: #tSetNotConnex 					put: 'No connex';
		at: #tName 								put: 'Nombre';
		at: #tDefineEntities 					put: 'Definir las entidades';
		at: #tAbstract 							put: 'Abstracta / No abstracta';
		at: #tSpatial 							put: 'Espacial';
		at: #tSocial 							put: 'Social';
		at: #tPassive 							put: 'Pasiva';
		at: #tProgrammingEntityClass		put: 'la clase de cada Entidad...';
		at: #tSimOrganization 				put: 'la Organización de la simulación...';	
		at: #tObserver 							put: 'el Observador...';
		at: #tMessages 							put: 'Mensajes';
		at: #tProbes 							put: 'Probes';
		at: #tInitInstantiation 				put: 'la instanciación inicial';
		at: #tScheduler 						put: 'el planificador';
		at: #tSpaceEntities 					put: 'Espacio y Entidades';
		at: #tEdit 								put: 'Editar';
		at: #tSpecialize						put: 'Especializar';
		at: #tAttributes 						put: 'Atributos';
		at: #tMethods 							put: 'Métodos';
		at: #tActivityDiagrams 				put: 'Diagramas de actividad';
		at: #tPoVSetter 						put: 'Configuración PoV';
		at: #tObject  							put: 'Object';
		at: #tObjectHelp 						put: 'Una entidad pasiva';									
		at: #tLocatedObject 					put: 'Objeto Situado';
		at: #tLocatedObjectHelp 				put: 'Una entidad pasiva situada en una celda/célula';							
		at: #tNetworkNode 						put: 'Nodo de Red';
		at: #tNetworkNodeHelp 				put: 'Un Nodo de una Red situado en una Célula';								
		at: #tNetworkArc 						put: 'Arco de Red';
		at: #tNetworkArcHelp 					put: 'Un Arco de una Red situado en 2 Células';
		at: #tFullNetwork 						put: 'Red Completa';
		at: #tFullNetworkHelp 				put: 'Una Red compuesta de un Conjunto de Arcos y Nodos';
		at: #tMessage 							put: 'Mensaje';
		at: #tMessageHelp 						put: 'Mensaje para un AgentCommunication (con mailbox)';
		at: #tRemove 							put: 'Eliminar';	
		at: #tEditActivityDiagrams 			put: 'editar diagramas de actividad';
		at: #tEditAttributes 					put: 'editar atributos';
		at: #tEditInit 							put: 'editar inicialización';
		at: #tEditSteps 						put: 'editar pasos';
		at: #tMissingClassName 				put: 'Por favor ingrese un nombre para la nueva clase!!!!';
		at: #tAlreadyUsed 						put: 'Ya está en uso!!!!';
		at: #tWhichModel 						put: '¿Qué Modelo?';
		at: #tVisualization 					put: 'Visualización';
		at: #tProgramming 						put: 'Programación';
		at: #tSimulation 						put: 'Simulación';
		at: #tEnterClassName 					put: 'Por favor ingrese un nombres para la nueva clase!!';
		at: #tSpatialEntityCellHelp 		put: 'SpatialEntityCell: la célula es la entidad básica del espacio (como Autómata Celular)';
		at: #tSimpleCellHelp 					put: 'SpatialEntityElement es la entidad Célula básica';
		at: #tSpatialEntityHelp 				put: 'SpatialEntityAggregate está compuesto de células conectadas';
		at: #tSetNotConnexHelp 				put: 'SpatialEntityNotConnex está compuesto de agreggates o células desconectadas';
		at: #tCellAutomatonHelp 				put: 'El autómata celular es útil para dinámicas entre células';
		at: #tOATPredefValues 				put: 'Predefinido por lista de valores';
		at: #tOATSeqValues 					put: 'Valores secuenciales';						
		at: #tCrossedPredefValues 			put: 'Predefinido por lista de valores';						
		at: #tCrossSeqValues 					put: 'Valores secuenciales';
		at: #tCrossSensAnalysis 				put: 'Análisis de Sensitividad Cruzado';
		at: #tDisplayParams 					put: 'Visualizar parámetros';
		at: #tOATSensAnalysis 				put: 'Análisis de Sensitividad OAT';
		at: #tSimpleStochAnalysis 			put: 'Análisis Estocástico Simple';
		at: #tMonteCarlo 						put: 'Monte Carlo';
		at: #tClassifyByParams 				put: 'Classify by parameters';
		at: #tSimInformation 					put: 'Información de Simulación';
		at: #tSimInterface 					put: 'Interface de Simulación';
		at: #tStartRWebService 				put: 'Arrancar Servicio Web para R';
		at: #tStopRWebService 				put: 'Detener Servicio Web para R';
		at: #tAnalysis 							put: 'Análisis';
		at: #tCreateInstances 				put: 'Crear Instancias';
		at: #tOpenPharoMenu 					put: 'Abrir Menú de Pharo';
		at: #tManipulateInstances 			put: 'Manipular Instancias';
		at: #tModelGlossary 					put: 'Glosario de Modelo';
		at: #tModelListing 					put: 'Listado de Modelo como archivo de texto';
		at: #tPackageClient 					put: 'Empaquetar cliente';
		at: #tSpace 								put: 'Espacio';
		at: #tDisplayModelVersions 			put: 'Visualizar versiones de modelo';
		at: #tSnapshot 							put: 'Guardar estado actual';
		at: #tModifiedModelName 				put: 'El nombre ha sido renombrado como ';
		at: #tDisplayLegends 					put: 'Mostrar Leyendas';
		at: #tPhoto 								put: 'Foto';
		at: #tVideo 								put: 'Video';
		at: #tClickTo 							put: 'Clickear...';
		at: #tHabitus 							put: 'Habitus';
		at: #tUnmoveableZoom 					put: 'Zoom no movible';
		at: #tMoveableZoom						put: 'Zoom movible';
		at: #tSetTrackLength					put: 'Configurar pista';
		at: #tEnableUndoRedo					put: 'Habilitar hacer/deshacer...';
		at: #tTouchpad 							put: 'Modo de manipulación touchpad';
		at: #tEnvironment 						put: 'Ambiente';
		at: #tGridSize 							put: 'Tamaño de grilla';
		at: #tLoad 								put: 'Cargar';
		at: #tModify 							put: 'Modificar';
		at: #tReOpen 							put: 'Recargar';
		at: #tPoV 								put: 'PoV';
		at: #tAttribute 						put: 'Atributo';
		at: #tClassVariable 					put: 'Variable de clase';
		at: #tAttributesSuperLabel 			put: 'Atributos y Variables de clase de las superclases';
		at: #tAttributesTargetLabel 		put: 'Atributos y Variables de clase de la clase destino';
		at: #tReset 								put: 'Resetear';
		at: #tApply 								put: 'Aplicar';	
		at: #tEnterAttName 					put: 'Ingrese el nombre del atributo (sin espacios, números o símbolos)';
		at: #tAppTitle 							put: 'CORMAS';
		at: #tInvalidName 						put: ' no es un nombre válido. Por favor, ingrese un nombre válido';
		at: #tHelpAddInstAtt 					put: 'Agregar un nuevo atributo a la clase destino';
		at: #tHelpRemoveInstAtt 				put: 'Eliminar un atributo de la clase destino';
		at: #tHelpAddClassAttr				put: 'Agregar un nuevo atributo de clase a la clase destino';
		at: #tHelpRemoveClassAtt 			put: 'Eliminar un atributo de clase de la clase destino';
		at: #tClassEditor 						put: 'UML - Editor de Clases';																																				
		yourself! !

!CMTranslator methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/12/2018 20:14'!
addTranslationsForESPart2
	" See superimplementor's comment "

	^ (self translatorClass forLanguage: #ES) translationMap 
		at: #tInitialValueChooser 			put: 'Selector de valor inicial';
		at: #tSetterAccessor 					put: 'Accesor de escritura';
		at: #tGetterAccessor 					put: 'Accesor de lectura';
		at: #tNotifyObs 						put: 'Notificar observadores cuando haya cambios';
		at: #tInitialValueLabel				put: 'Ingrese un valor inicial para el atributo';
		at: #tNumber 							put: 'Number';
		at: #tRandom 							put: 'Random';
		at: #tBoolean 							put: 'Boolean';
		at: #tStringSymbol 					put: 'String / Symbol';
		at: #tArray 								put: 'Array';
		at: #tNewEntity 						put: 'Nueva Entidad';							
		at: #tCollectionEmpty 				put: 'Collection (vacía)';
		at: #tNoValue 							put: 'Sin valor u otra instancia (a ser configurada en #init)';
		at: #tFillArray							put: 'Complete el Array con valores';
		at: #tSimulate 							put: 'simular';
		at: #tReplay 							put: 'reiniciar';
		at: #tCurrentStep 						put: 'paso actual';
		at: #tInitialize 						put: 'Inicializar';
		at: #tBackwardLabel 					put: 'Reversa';
		at: #tForwardLabel 					put: 'Adelantar';
		at: #tFinalStep 	 					put: 'paso final';
		at: #tChange 							put: 'Cambiar';
		at: #tSimCloseHelp 					put: 'Cerrar la interface de simulación';
		at: #tSimStepHelp 						put: 'Tiempo actual';	
		at: #tSimFinalStepHelp 				put: 'Ingrese el paso final';
		at: #tSelectMethod 					put: 'Seleccione un método de ';
		at: #tFinalStepChoice 				put: 'Paso final:';
		at: #tInitializeRandomness 			put: 'Inicializar aleatoriedad';
		at: #tMissingInitMethods 			put: 'El modelo no define ningún método de inicialización !!';
		at: #tMissingControlMethods 		put: 'El modelo no define ningún método de control !!';
		at: #tNoStoredSim 						put: 'El directorio "Dump" no contiene ninguna simulación';
		at: #tNoStoredSimFolder				put: ' el directorio no contiene ninguna simulación';
		at: #tReplayStartStep 				put: 'La repetición comenzará en el paso ';								
		at: #tChooseDumpDir					put: 'Seleccione un directorio de ''Volcado''';
		at: #tCreatePoVAtt 					put: '¿Crear PoV en qué atributo?';
		at: #tFoundPoVValues 					put: 'CORMAS encontró los siguientes valores para el atributo ';
		at: #tAddSymbols 						put: '¿Desea crear los símbolos asociados a estos valores?';	
		at: #tEnterNewSymbol 					put: 'Ingrese un nuevo símbolo';
		at: #tSelectEntity 					put: 'Debe seleccionar una entidad';
		at: #tNoMoreMethods 					put: 'No se pueden agregar más métodos a esta lista';
		at: #tNoMorePoVMethods				put: 'No se pueden agregar más pov a esta lista';
		at: #tNoMoreEntities 					put: 'No se pueden agregar más entidades a esta lista';
		at: #tNoMoreInfo 						put: 'No se pueden agregar más info a esta lista';
		at: #tPoVMethods 						put: 'Métodos POV';
		at: #tAgentTracksSize 				put: 'Choose the size of the agents tracks';
		at: #tSpaceNotAllowed 				put: 'Los espacios no están permitidos para nombres de Habitus. ¿Quiere reemplazarlos con el caracter ''_''?';
		at: #tConfigTitle 						put: 'Por favor, ingrese el título para la configuración';
		at: #tOneInfo 							put: 'Only one info can be set as default';
		at: #tInfoDefault 						put: 'This info is already set as default';
		at: #tPoVDefault 						put: 'This pov is already set as default';
		at: #tMustSelectEntity 				put: 'Se debe seleccionar una entidad';
		at: #tEntitiesToCreate 				put: 'Entidades a ser creadas';
		at: #tManipulationEntities			put: 'Manipulation Entities';
		at: #tObservedEntities 				put: 'Entidades Observadas';
		at: #tChooseConfig 					put: 'Seleccione una configuración';
		at: #tNoInfoSelected 					put: 'No se seleccionó ningún info';
		at: #tNoAttribSelected 				put: 'No se seleccionó ningún atributo';
		at: #tNoEntitySelected 				put: 'No se seleccionó ninguna entidad';
		at: #tNoMethodSelected 				put: 'No se seleccionó ningún método';
		at: #tNoPoVSelected 					put: 'No se seleccionó ningún POV';
		at: #tOnePoV 							put: 'Solo un POV puede ser seleccionado por omisión';
		at: #tHabitusTitle 					put: 'Habitus de Bourdieu';
		at: #tHabitusText 						put: 'L''habitus est un système de disposition acquises par l''apprentissage implicite ou explicite qui fonctionne comme un système de schèmes générateurs. L''habitus est générateur de stratégies qui peuvent être objectivement conformes aux intérêts objectifs de leurs auteurs sans en avoir été expressément conçues à cette fin. (Bourdieu 1972)
Autre définition : L''habitus est un ensemble de manière d''être, d''agir et de penser propre à un individu, fruit d''un apprentissage particulier lié à son groupe d''appartenance, qui diffère selon sa classe sociale, sa disposition en capital, et sa place occupée dans l''espace social. L''habitus structure les comportements et les actions de l''individu, et à la fois, structure les positions dans l''espace social.';
		at: #tSelectPoVSymbol 				put: 'Por favor, seleccione un Symbol de PoV';
		at: #tSymbolAlreadyExists 			put: 'El Symbol ya existe !!!!!!';
		at: #tSelectSymbol 					put: 'Seleccione un símbolo !!!!!!';
		at: #tPoVDefinition 					put: 'Definición del PoV';
		at: #tPoVListMethods 					put: 'Métodos que responden un Color ó Symbol';
		at: #tPoVListSymbols 					put: 'Símbolos Asociados';
		at: #tPoVInfoDisplayed				put: 'Información a visualizar';
		at: #tPoVListInfo 						put: 'Métodos que responden un String';
		at: #tPoVSetColor 						put: 'Configurar el Color';
		yourself! !

!CMTranslator methodsFor: 'accessing' stamp: 'HernanMoralesDurand 4/27/2018 13:54'!
addTranslationsForESPart3
	" Private - See superimplementor's comment "

	^ (self translatorClass forLanguage: #ES) translationMap 
		at: #tDistributeAsServer 			put: 'Distribuir (actar como servidor)';
		at: #tDistributeAsClient  			put: 'Distribuir (actuar como cliente)';
		at: #tAboutModel 						put: 'Sobre este modelo';
		at: #tHowToRunModel 					put: 'Como ejecutar este modelo';
		at: #tChangeModelComments 			put: 'Modificar comentarios del modelo';
		at: #tWhichOpeningLocation 			put: 'Seleccione la ubicacion del elemento';
		yourself
! !

PackageManifest subclass: #ManifestCormasUI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Core'!

!ManifestCormasUI commentStamp: '<historical>' prior: 0!
I store metadata for this package. These meta data are used by other tools such as the SmalllintManifestChecker and the critics Browser!

!ManifestCormasUI class methodsFor: 'code-critics' stamp: 'HernanMoralesDurand 9/22/2017 14:27'!
ruleRBSentNotImplementedRuleV1FalsePositive
	^ #(#(#(#RGPackage #(#'Cormas-UI')) #'2017-09-22T14:27:39.111431-03:00') )! !

PFProjectApplication subclass: #CMApplicationProject
	instanceVariableNames: 'processReplayForward processReplayBackward processRun'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Project'!

!CMApplicationProject commentStamp: 'HernanMoralesDurand 1/1/2018 18:25' prior: 0!
Accessing application:

CMSpecApplicationProject uniqueInstance.

Release and re-initialize application:

CMApplicationProject release.
CMApplicationProject currentProjectName.
!

!CMApplicationProject class methodsFor: 'accessing' stamp: 'HernanMoralesDurand 12/27/2017 23:22'!
applicationExtension
	" See comment in #applicationExtension "

	^ 'prj'! !

!CMApplicationProject class methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/4/2017 15:08'!
applicationName
	" Answer a <String> with receiver's name "
	
	^ 'CORMAS Application'! !

!CMApplicationProject methodsFor: 'accessing-path' stamp: 'HernanMoralesDurand 12/10/2017 14:20'!
addOnsPath
	" Answer a <FileReference> corresponding to the path of 'Add-ons' directory "
	
	^ (self cormasPath / 'Add-ons') ensureCreateDirectory.

! !

!CMApplicationProject methodsFor: 'accessing-path' stamp: 'HernanMoralesDurand 12/10/2017 14:07'!
cormasPath
	" Answer a <FileReference> corresponding to the path of Cormas directory. "

	^ FileSystem disk workingDirectory
		! !

!CMApplicationProject methodsFor: 'accessing' stamp: 'HernanMoralesDurand 9/18/2017 21:53'!
defaultProjectClass
	" Private - See superimplementor's comment "

	^ CMProjectModel! !

!CMApplicationProject methodsFor: 'defaults' stamp: 'HernanMoralesDurand 4/7/2018 13:16'!
defaultTranslatorClass
	" Answer the default translation class for the receiver "

	^ CMTranslator! !

!CMApplicationProject methodsFor: 'accessing-path' stamp: 'HernanMoralesDurand 12/10/2017 14:23'!
dumpPath: aModelClassName
	" Answer a <FileReference> corresponding to the path of the current model 'dump' directory.
	aModelClassName = <String>"
	
	^ ((self modelPath: aModelClassName) asFileReference / 'dump') ensureCreateDirectory.
! !

!CMApplicationProject methodsFor: 'accessing-simulations' stamp: 'HernanMoralesDurand 12/10/2017 17:13'!
findSimulationNamed: aName
	" Answer <true> if the dump folder has stored simulations "

	^ (Cormas dumpPath: self cormasModel class name)
		removeAllSuchThat: [ : txt | (txt beginsWith: self simNameStart) not ].
! !

!CMApplicationProject methodsFor: 'testing' stamp: 'HernanMoralesDurand 12/10/2017 13:10'!
hasStoredSimulations
	" Answer <true> if the dump folder has stored simulations "

	| directoryContent |
	self terminateAllProcesses.
	(directoryContent := Cormas dumpPath: self cormasModel class name)
		removeAllSuchThat: [ : txt | (txt beginsWith: self simNameStart) not ].
	^ directoryContent isEmpty! !

!CMApplicationProject methodsFor: 'accessing-path' stamp: 'HernanMoralesDurand 12/10/2017 14:20'!
modelPath: aModelClassName
	"Purpose: Returns a Filename corresponding to the path of the current model directory.
	Argument: aModelClassName = <String>
	Example: 
	(Cormas modelPath: #FireModel) construct: 'test.csv' 
	"
	
	^ (self modelsPath / aModelClassName asString) ensureCreateDirectory.
! !

!CMApplicationProject methodsFor: 'accessing-path' stamp: 'HernanMoralesDurand 12/10/2017 14:06'!
modelsPath
	" Answer a <FileReference> corresponding to the path of 'Models' directory "
	
	^ (self cormasPath / 'Models') ensureCreateDirectory.
! !

!CMApplicationProject methodsFor: 'accessing-simulations' stamp: 'HernanMoralesDurand 12/10/2017 16:31'!
storedSimulations
	" Answer <true> if the dump folder has stored simulations "

	^ (Cormas dumpPath: self cormasModel class name)
		removeAllSuchThat: [ : txt | (txt beginsWith: self simNameStart) not ].
! !

!CMApplicationProject methodsFor: 'convenience' stamp: 'HernanMoralesDurand 12/10/2017 13:11'!
terminateAllProcesses
	"Terminate all the processes"
	
	processReplayForward isNil
		ifFalse:
			[processReplayForward terminate.
			processReplayForward := nil].
	processReplayBackward isNil
		ifFalse:
			[processReplayBackward terminate.
			processReplayBackward := nil].
	processRun isNil
		ifFalse:
			[processRun terminate.
			processRun := nil]! !

!CMApplicationProject methodsFor: 'accessing-path' stamp: 'HernanMoralesDurand 12/10/2017 14:24'!
videoPath: aModelClassName
	" Answer a <FileReference> corresponding to the path of the current model 'dump' directory.
	aModelClassName = <String>"
	
	^ ((self modelPath: aModelClassName) asFileReference / 'video') ensureCreateDirectory.
! !

!CMApplicationProject methodsFor: 'accessing-path' stamp: 'HernanMoralesDurand 12/10/2017 14:24'!
xmlPath: aModelClassName
	" Answer a <FileReference> corresponding to the path of the current model 'dump' directory.
	aModelClassName = <String>"
	
	^ ((self modelPath: aModelClassName) asFileReference / 'xml') ensureCreateDirectory.
! !

PFStandardProjectWindow subclass: #CMSpecProjectWindow
	instanceVariableNames: 'simWindow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Project'!

!CMSpecProjectWindow class methodsFor: 'specs' stamp: 'HernanMoralesDurand 12/9/2017 00:07'!
defaultSpec
	<spec: #default>
	
	^ SpecLayout composed
		newColumn: [ :c | 
			c 
				add: #menuToolbar height: self toolbarHeight;
				add: #simWindow ];
		yourself! !

!CMSpecProjectWindow class methodsFor: 'world menu' stamp: 'HernanMoralesDurand 9/15/2017 00:45'!
menuCommandOn: aBuilder
	<worldMenu>
	
	(aBuilder item: #'CORMAS')
		action: [ self open ]; 
		icon: CMIcons smallCormasLogoIcon;
		order: 5.
		
	aBuilder withSeparatorAfter! !

!CMSpecProjectWindow class methodsFor: 'opening' stamp: 'HernanMoralesDurand 4/11/2018 10:07'!
open
 	" Open the receiver's window " 

	| win |
	
	CMApplicationProject release.
	PFProjectSettings currentApplicationClass: CMApplicationProject.
	" Rebuild translator table "
	CMApplicationProject uniqueInstance translator: nil.		
	win := self new 
		openWithSpec;
		centered;
		startFSM;
		yourself.
	win simWindow hideSimInterface! !

!CMSpecProjectWindow methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 9/15/2017 01:31'!
applicationProperties
	" Private - Open a window to set receiver's properties "

	(CMSpecModelComments for: self projectManager) openWithSpec! !

!CMSpecProjectWindow methodsFor: 'private' stamp: ''!
closeAfterCreateProject
	^ true! !

!CMSpecProjectWindow methodsFor: 'private' stamp: 'HernanMoralesDurand 10/10/2017 00:02'!
cormasModelClass
	" Private - See comment in #cormasModelClass "

	^ self projectManager cormasModelClass ! !

!CMSpecProjectWindow methodsFor: 'defaults' stamp: 'HernanMoralesDurand 1/1/2018 18:31'!
defaultProjectManagerClass
	" Private - See superimplementor's comment "

	^ CMProjectManager! !

!CMSpecProjectWindow methodsFor: 'defaults' stamp: 'HernanMoralesDurand 9/4/2017 15:52'!
defaultWindowTitle
	" Private - See superimplementor's comment "

	^ 'Cormas'! !

!CMSpecProjectWindow methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/28/2017 16:55'!
initialExtent
	"Answer the initial extent for the receiver."
	
	^ 600 @ 300! !

!CMSpecProjectWindow methodsFor: 'initialization' stamp: 'HernanMoralesDurand 12/30/2017 23:53'!
initializeApplication
	" Private - Configure the receiver's application class "

	ShortcutReminder enabled: false.
! !

!CMSpecProjectWindow methodsFor: 'initialization' stamp: 'HernanMoralesDurand 12/9/2017 00:06'!
initializeButtonToolbar
	" Private - Set up the main window toolbar "
! !

!CMSpecProjectWindow methodsFor: 'initialization' stamp: 'HernanMoralesDurand 10/10/2017 00:05'!
initializeMenuToolbar
	" Private - See superimplementor's commen "

	menuToolbar := MenuModel new
		addGroup: [ : group | 
			self initializeFileSubMenu: group.
			self initializeProgrammingSubMenu: group.
			self initializeVisualizationSubMenu: group.
			self initializeSimulationSubMenu: group.
			self intializeToolsSubMenu: group.
			self initializeHelpMenu: group ];
		addGroup: [ : group |
			"self initializeFileToolbarButtons: group.			"
			self initializeActionsButtons: group ].
	menuToolbar applyTo: self.! !

!CMSpecProjectWindow methodsFor: 'initialization' stamp: 'HernanMoralesDurand 10/1/2017 21:08'!
initializeProgrammingSubMenu: group

	group
		addItem: [ : item | 
			item
				name: self translator tProgramming;
				subMenu: self subMenuForProgramming ]! !

!CMSpecProjectWindow methodsFor: 'initialization' stamp: 'HernanMoralesDurand 10/1/2017 21:08'!
initializeSimulationSubMenu: group

	group
		addItem: [ : item | 
			item
				name: self translator tSimulation;
				subMenu: self subMenuForSimulation ]! !

!CMSpecProjectWindow methodsFor: 'initialization' stamp: 'HernanMoralesDurand 10/1/2017 21:08'!
initializeVisualizationSubMenu: group

	group
		addItem: [ : item | 
			item
				name: self translator tVisualization;
				subMenu: self subMenuForVisualization ]! !

!CMSpecProjectWindow methodsFor: 'initialization' stamp: 'HernanMoralesDurand 12/30/2017 14:05'!
initializeWidgets
	" Private - See superimplementor's comment "

	self initializeApplication.
	super initializeWidgets.
	self simWindow: ((CMSpecSimulationContainer for: self projectManager)
		owner: self;
		yourself)
! !

!CMSpecProjectWindow methodsFor: 'initialization' stamp: 'HernanMoralesDurand 10/1/2017 21:09'!
intializeToolsSubMenu: group

	group
		addItem: [ : item | 
			item
				name: self translator tTools;
				subMenu: self subMenuForTools ]! !

!CMSpecProjectWindow methodsFor: 'menu' stamp: 'HernanMoralesDurand 4/8/2018 23:37'!
menuDisableClassForEachEntity

	(self selectMenuItemNamed: self translator tProgrammingEntityClass) enabled: true.
! !

!CMSpecProjectWindow methodsFor: 'menu' stamp: 'HernanMoralesDurand 4/12/2018 02:42'!
menuDisableFileGroup
	" Private - Disable all menu items within the File group "

	{ 
		#tClose .
		#tSave .
		#tSaveAs .
		#tExplore .
		#tRemove .
"		#tRename .
		#tRenameAs ."
		#tProperties
	} do: [ : itemSel | self menuDisableItem: itemSel ]! !

!CMSpecProjectWindow methodsFor: 'menu' stamp: 'HernanMoralesDurand 4/11/2018 10:38'!
menuDisableHelpGroup
	" Private - Disable all menu items within the Help group "

	{ 
		#tAboutModel .
		#tHowToRunModel .
		#tChangeModelComments
	} do: [ : itemSel | self menuDisableItem: itemSel ]! !

!CMSpecProjectWindow methodsFor: 'menu' stamp: 'HernanMoralesDurand 4/8/2018 23:37'!
menuDisableItem: aSelector

	(self selectMenuItemNamed: (self translator perform: aSelector)) enabled: false.
! !

!CMSpecProjectWindow methodsFor: 'menu' stamp: 'HernanMoralesDurand 4/8/2018 23:53'!
menuDisableProgrammingGroup
	" Private - Disable all menu items within the Programming group "

	{ 
		#tProgrammingEntityClass .
		#tEditInit .
		#tEditAttributes .
		#tEditSteps .
		#tEditActivityDiagrams .
		#tProbes .
		#tMessages .
		#tSpaceEntities
	} do: [ : itemSel | self menuDisableItem: itemSel ]! !

!CMSpecProjectWindow methodsFor: 'menu' stamp: 'HernanMoralesDurand 4/8/2018 23:50'!
menuDisableSimulationGroup
	" Private - Disable all menu items within the Simulation group "

	{ 
		#tDisplayParams .
		#tSimInformation .
		#tSimpleStochAnalysis .
		#tOATSeqValues .
		#tOATPredefValues .
		#tMonteCarlo .
		#tClassifyByParams .
		#tCrossedSeqValues .
		#tCrossedPredefValues .
		#tStopRWebService 
	} do: [ : itemSel | self menuDisableItem: itemSel ]! !

!CMSpecProjectWindow methodsFor: 'menu' stamp: 'HernanMoralesDurand 4/8/2018 23:51'!
menuDisableToolsGroup
	" Private - Disable all menu items within the Tools group "

	{ 
		#tManipulateInstances .
		#tCreateInstances .
		#tSnapshot .
		#tModelListing .
		#tModelGlossary .
		#tDisplayModelVersions .
		#tDistributeAsServer .
		#tDistributeAsClient .
		#tPackageClient
	} do: [ : itemSel | self menuDisableItem: itemSel ]! !

!CMSpecProjectWindow methodsFor: 'menu' stamp: 'HernanMoralesDurand 4/11/2018 09:56'!
menuDisableVisualizationGroup
	" Private - Disable all menu items within the Visualization group "

	{ 
		#tProbes .
		#tMessages .
		#tSpaceEntities
	} do: [ : itemSel | self menuDisableItem: itemSel ]
! !

!CMSpecProjectWindow methodsFor: 'menu' stamp: 'HernanMoralesDurand 4/12/2018 02:41'!
menuEnableFileGroup
	" Private - Enable all menu items within the File group "

	{ 
		#tClose .
		#tSave .
		#tSaveAs .
		#tExplore .
		#tRemove .
"		#tRename .
		#tRenameAs ."
		#tProperties
	} do: [ : itemSel | self menuEnableItem: itemSel ]! !

!CMSpecProjectWindow methodsFor: 'menu' stamp: 'HernanMoralesDurand 4/11/2018 10:41'!
menuEnableHelpGroup
	" Private - Enable all menu items within the Tools group "

	{ 
		#tAboutModel .
		#tHowToRunModel .
		#tChangeModelComments	
	} do: [ : itemSel | self menuEnableItem: itemSel ]! !

!CMSpecProjectWindow methodsFor: 'menu' stamp: 'HernanMoralesDurand 4/8/2018 23:37'!
menuEnableItem: aSelector

	(self selectMenuItemNamed: (self translator perform: aSelector)) enabled: true.
! !

!CMSpecProjectWindow methodsFor: 'menu' stamp: 'HernanMoralesDurand 4/12/2018 02:45'!
menuEnableProgrammingGroup
	" Private - Enable all menu items within the Programming group "

	{ 
		#tProgrammingEntityClass .
		#tEditInit .
		#tEditAttributes .
		#tEditSteps .
		#tEditActivityDiagrams .
		#tProbes .
		#tMessages .
		#tSpaceEntities
	} do: [ : itemSel | self menuEnableItem: itemSel ]! !

!CMSpecProjectWindow methodsFor: 'menu' stamp: 'HernanMoralesDurand 4/8/2018 23:50'!
menuEnableSimulationGroup
	" Private - Enable all menu items within the Simulation group "

	{ 
		#tDisplayParams .
		#tSimInformation .
		#tSimpleStochAnalysis .
		#tOATSeqValues .
		#tOATPredefValues .
		#tMonteCarlo .
		#tClassifyByParams .
		#tCrossedSeqValues .
		#tCrossedPredefValues .
		#tStopRWebService 
	} do: [ : itemSel | self menuEnableItem: itemSel ]
! !

!CMSpecProjectWindow methodsFor: 'menu' stamp: 'HernanMoralesDurand 4/8/2018 23:51'!
menuEnableToolsGroup
	" Private - Enable all menu items within the Tools group "

	{ 
		#tManipulateInstances .
		#tCreateInstances .
		#tSnapshot .
		#tModelListing .
		#tModelGlossary .
		#tDisplayModelVersions .
		#tDistributeAsServer .
		#tDistributeAsClient .
		#tPackageClient
	} do: [ : itemSel | self menuEnableItem: itemSel ]! !

!CMSpecProjectWindow methodsFor: 'menu' stamp: 'HernanMoralesDurand 4/8/2018 23:37'!
menuEnableVisualizationGroup
	" Private - Disable all menu items within the Visualization group "

	{ 
		#tProgrammingEntityClass .
		#tEditInit .
		#tEditAttributes .
		#tEditSteps .
		#tEditActivityDiagrams .
		#tProbes .
		#tMessages .
		#tSpaceEntities
	} do: [ : itemSel | self menuEnableItem: itemSel ]! !

!CMSpecProjectWindow methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 4/7/2018 17:18'!
openEditAttributes
	" Open the edit attributes window "

	CMSpecEditAttributes openFor: self projectManager.! !

!CMSpecProjectWindow methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 1/24/2018 18:34'!
openEditInitialization
	" Open a browser tool to edit the receiver's model initialization "

	Smalltalk tools browser 
		openOnCategory: #init
		ofClass:self cormasModelClass
! !

!CMSpecProjectWindow methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 1/24/2018 18:34'!
openEditSteps
	" Open a browser tool to edit the model steps "

	Smalltalk tools browser 
		openOnCategory: #control
		ofClass: self cormasModelClass 
		! !

!CMSpecProjectWindow methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 1/25/2018 19:05'!
openPovSetterGUI

	| setter |
	
	self cormasModelClass isNil ifTrue: [ ^ self alertMessage: self translator tNoModel ].
	self cormasModelClass cellClass isNil ifTrue: [ ^ self alertMessage: self translator tWhichAttribute ].
	setter := CMSpecPovSetterNotebook openFor: self projectManager.
! !

!CMSpecProjectWindow methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 9/16/2017 22:58'!
openProgrammingEntityClass
	" Private - Open an entities browser "

	CMSpecEntitiesBrowser openFor: self projectManager
! !

!CMSpecProjectWindow methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 11/7/2017 19:00'!
openVizMessages

	CMSpecVizSpaceWindow new 
		owner: self;
		openWithSpec.! !

!CMSpecProjectWindow methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 11/7/2017 19:04'!
openVizSpace

	CMSpecVizSpaceWindow new 
		owner: self;
		openWithSpec.! !

!CMSpecProjectWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/28/2017 16:46'!
simWindow
	^ simWindow! !

!CMSpecProjectWindow methodsFor: 'accessing' stamp: 'HernanMoralesDurand 11/28/2017 16:46'!
simWindow: anObject
	simWindow := anObject! !

!CMSpecProjectWindow methodsFor: 'submenu-help' stamp: 'HernanMoralesDurand 4/11/2018 10:45'!
subMenuAboutThisModel: anItem

	anItem
		name: self translator tAboutModel;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $I command;
		action: [ self openHelpAboutThisModel ]! !

!CMSpecProjectWindow methodsFor: 'submenu-help' stamp: 'HernanMoralesDurand 4/11/2018 10:45'!
subMenuChangeModelComments: anItem

	anItem
		name: self translator tChangeModelComments;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $R command;
		action: [ self openHelpChangeModelComments ]! !

!CMSpecProjectWindow methodsFor: 'submenu-simulation' stamp: 'HernanMoralesDurand 8/21/2017 00:31'!
subMenuCormasR

	^ MenuModel new
		addGroup: [ : group |
			group 
				addItem: [ : item | self subMenuStartWSR: item ];
				addItem: [ : item | self subMenuStopWSR: item ] ]! !

!CMSpecProjectWindow methodsFor: 'submenu-help' stamp: 'HernanMoralesDurand 4/11/2018 10:43'!
subMenuForHelp 

	^ MenuModel new
		addGroup: [ : group |
			group 
				addItem: [ : item | self subMenuAboutThisModel: item ];
				addItem: [ : item | self subMenuHowToRunThisModel: item ];
				addItem: [ : item | self subMenuChangeModelComments: item ];
				addItem: [ : item | self subMenuAbout: item ] ]! !

!CMSpecProjectWindow methodsFor: 'submenu-programming' stamp: 'HernanMoralesDurand 12/30/2017 12:24'!
subMenuForProgramming

	^ MenuModel new
		addGroup: [ : group |
			group addItem: [ : item | self subMenuProgrammingEntityClass: item ] ];
		addGroup: [ : group | 
			group addItem: [ : item | self subMenuProgrammingSimulationOrganisation: item ] ];
		addGroup: [ : group | 
			group addItem: [ : item | self subMenuProgrammingObserver: item ] ];
		addGroup: [ : group |
			group addItem: [ : item | self subMenuProgrammingUML: item ] ]! !

!CMSpecProjectWindow methodsFor: 'submenu-simulation' stamp: 'HernanMoralesDurand 8/21/2017 00:07'!
subMenuForSimCrossedSensitivityAnalysis

	^ MenuModel new
		addGroup: [ : group |
			group 	
				addItem: [ : item | self subMenuSimCrossedSensSequentialValues: item ];
				addItem: [ : item | self subMenuSimCrossedSensPredefinedValues: item ] ]! !

!CMSpecProjectWindow methodsFor: 'submenu-programming' stamp: 'HernanMoralesDurand 9/5/2017 01:24'!
subMenuForSimInitInstantiation

	^ MenuModel new
		addGroup: [ : group |
			group 
				addItem: [ : anItem | self subMenuSimEditInitialization: anItem ];
				addItem: [ : anItem | self subMenuSimEditAttributes: anItem ] ]
		

! !

!CMSpecProjectWindow methodsFor: 'submenu-simulation' stamp: 'HernanMoralesDurand 8/21/2017 00:17'!
subMenuForSimOATSensitivityAnalysis

	^ MenuModel new
		addGroup: [ : group |
			group 	
				addItem: [ : item | self subMenuSimOATSensSequentialValues: item ];
				addItem: [ : item | self subMenuSimOATSensPredefinedValues: item ];
				addItem: [ : item | self subMenuSimOATSensMC: item ] ];
		addGroup: [ : group | 
			group
				addItem: [ : item | self subMenuSimOATSensByParams: item ] ]			! !

!CMSpecProjectWindow methodsFor: 'submenu-programming' stamp: 'HernanMoralesDurand 9/5/2017 01:26'!
subMenuForSimScheduler

	^ MenuModel new
		addGroup: [ : group |
			group 
				addItem: [ : anItem | self subMenuSimEditSteps: anItem ];
				addItem: [ : anItem | self subMenuSimEditActivityDiagrams: anItem ] ]
		

! !

!CMSpecProjectWindow methodsFor: 'submenu-simulation' stamp: 'HernanMoralesDurand 8/19/2017 01:26'!
subMenuForSimulation

	^ MenuModel new
		addGroup: [ : group |
			group 
				addItem: [ : item | self subMenuSimInterface: item ];
				addItem: [ : item | self subMenuSimDisplayParams: item ];
				addItem: [ : item | self subMenuSimInformation: item ] ];
		addGroup: [ : group | 
			group
				addItem: [ : item | self subMenuSimAnalysis: item ] ]! !

!CMSpecProjectWindow methodsFor: 'submenu-tools' stamp: 'HernanMoralesDurand 4/11/2018 10:19'!
subMenuForTools

	^ MenuModel new
		addGroup: [ : group |
			group 
				addItem: [ : item | self subMenuToolsManipulateInstances: item ];
				addItem: [ : item | self subMenuToolsCreateInstances: item ];
				addItem: [ : item | self subMenuToolsSnapshot: item ];
				addItem: [ : item | self subMenuToolsMain: item ] ];
		addGroup: [ : group | 
			group
				addItem: [ : item | self subMenuToolsAddOns: item ];
				addItem: [ : item | self subMenuToolsModelListing: item ];
				addItem: [ : item | self subMenuToolsModelGlossary: item ];
				addItem: [ : item | self subMenuToolsVersions: item ] ];
		addGroup: [ : group | 
			group
				addItem: [ : item | self subMenuToolsDistributeAsClient: item ];
				addItem: [ : item | self subMenuToolsDistributeAsServer: item ];
				addItem: [ : item | self subMenuToolsPackageClient: item ] ]! !

!CMSpecProjectWindow methodsFor: 'submenu-visualization' stamp: 'HernanMoralesDurand 8/19/2017 01:22'!
subMenuForVisualization

	^ MenuModel new
		addGroup: [ : group |
			group 
				addItem: [ : item | self subMenuVizProbes: item ] ];
		addGroup: [ : group | 
			group
				addItem: [ : item | self subMenuVizMessages: item ] ];
		addGroup: [ : group | 
			group
				addItem: [ : item | self subMenuVizSpace: item ] ]! !

!CMSpecProjectWindow methodsFor: 'submenu-help' stamp: 'HernanMoralesDurand 4/11/2018 10:46'!
subMenuHowToRunThisModel: anItem

	anItem
		name: self translator tHowToRunModel;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $R command;
		action: [ self openHelpHowToRunModel ]! !

!CMSpecProjectWindow methodsFor: 'submenu-programming' stamp: 'HernanMoralesDurand 12/30/2017 12:26'!
subMenuOpenClassEditor: item

	item
		name: 'Class Editor...';
		icon: #openIcon asIcon;
		shortcut: $c command;
		action: [ OPUmlProject openOnModel: (OPUMLModel new name: self projectManager cormasModelName)
 ]
		
! !

!CMSpecProjectWindow methodsFor: 'submenu-programming' stamp: 'HernanMoralesDurand 12/30/2017 12:25'!
subMenuProgrammingClassEditor

	^ MenuModel new
		addGroup: [ : group |
			group addItem: [ : item | self subMenuOpenClassEditor: item ] ]
		
! !

!CMSpecProjectWindow methodsFor: 'submenu-programming' stamp: 'HernanMoralesDurand 9/22/2017 00:28'!
subMenuProgrammingEntityClass: item

	item
		name: self translator tProgrammingEntityClass;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $C command;
		action: [ self openProgrammingEntityClass ]! !

!CMSpecProjectWindow methodsFor: 'submenu-programming' stamp: 'HernanMoralesDurand 8/19/2017 03:25'!
subMenuProgrammingMessages

	^ MenuModel new
		addGroup: [ : group |
			group 
				addItem: [ : item | self subMenuProgrammingProbes: item ] ];
		addGroup: [ : group | 
			group
				addItem: [ : item | self subMenuProgrammingMessages: item ] ];
		addGroup: [ : group | 
			group
				addItem: [ : item | self subMenuProgrammingSpaceAndEntities: item ] ]! !

!CMSpecProjectWindow methodsFor: 'submenu-programming' stamp: 'HernanMoralesDurand 9/22/2017 00:29'!
subMenuProgrammingMessages: item

	item
		name: self translator tMessages;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $M command;
		action: [ self openProgrammingMessages ]! !

!CMSpecProjectWindow methodsFor: 'submenu-programming' stamp: 'HernanMoralesDurand 8/19/2017 03:24'!
subMenuProgrammingObserver

	^ MenuModel new
		addGroup: [ : group |
			group 
				addItem: [ : item | self subMenuProgrammingProbes: item ] ];
		addGroup: [ : group | 
			group
				addItem: [ : item | self subMenuProgrammingMessages: item ] ];
		addGroup: [ : group | 
			group
				addItem: [ : item | self subMenuProgrammingSpaceAndEntities: item ] ]! !

!CMSpecProjectWindow methodsFor: 'submenu-programming' stamp: 'HernanMoralesDurand 12/30/2017 12:07'!
subMenuProgrammingObserver: item

	item
		name: self translator tObserver;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $O command;
		subMenu: self subMenuProgrammingObserver! !

!CMSpecProjectWindow methodsFor: 'submenu-programming' stamp: 'HernanMoralesDurand 9/22/2017 00:30'!
subMenuProgrammingProbes: item

	item
		name: self translator tProbes;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $P command;
		action: [ self openProgrammingProbes ]! !

!CMSpecProjectWindow methodsFor: 'submenu-programming' stamp: 'HernanMoralesDurand 9/22/2017 00:31'!
subMenuProgrammingSimInitialInstantiation: item

	item
		name: self translator tInitInstantiation;
"		icon: Smalltalk ui icons openIcon;"
		subMenu: self subMenuForSimInitInstantiation
		

! !

!CMSpecProjectWindow methodsFor: 'submenu-programming' stamp: 'HernanMoralesDurand 9/22/2017 00:32'!
subMenuProgrammingSimScheduler: item

	item
		name: self translator tScheduler;
"		icon: Smalltalk ui icons openIcon;"
		subMenu: self subMenuForSimScheduler! !

!CMSpecProjectWindow methodsFor: 'submenu-programming' stamp: 'HernanMoralesDurand 8/19/2017 03:31'!
subMenuProgrammingSimulationOrganisation

	^ MenuModel new
		addGroup: [ : group |
			group 
				addItem: [ : item | self subMenuProgrammingSimInitialInstantiation: item ] ];
		addGroup: [ : group | 
			group
				addItem: [ : item | self subMenuProgrammingSimScheduler: item ] ]! !

!CMSpecProjectWindow methodsFor: 'submenu-programming' stamp: 'HernanMoralesDurand 9/22/2017 00:27'!
subMenuProgrammingSimulationOrganisation: item

	item
		name: self translator tSimOrganization;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $S command;
		subMenu: self subMenuProgrammingSimulationOrganisation! !

!CMSpecProjectWindow methodsFor: 'submenu-programming' stamp: 'HernanMoralesDurand 1/25/2018 17:43'!
subMenuProgrammingSpaceAndEntities: item

	item
		name: self translator tSpaceEntities;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $S command;
		action: [ self openPovSetterGUI ]! !

!CMSpecProjectWindow methodsFor: 'submenu-programming' stamp: 'HernanMoralesDurand 12/30/2017 12:12'!
subMenuProgrammingUML: item

	item
		name: self translator tClassEditor;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $U command;
		subMenu: self subMenuProgrammingClassEditor! !

!CMSpecProjectWindow methodsFor: 'submenu-simulation' stamp: 'HernanMoralesDurand 8/20/2017 23:39'!
subMenuSimAnalysis

	^ MenuModel new
		addGroup: [ : group |
			group 
				addItem: [ : item | self subMenuSimStochasticAnalysis: item ];
				addItem: [ : item | self subMenuSimOATSensitivityAnalysis: item ];
				addItem: [ : item | self subMenuSimCrossedSensitivityAnalysis: item ] ];
		addGroup: [ : group | 
			group
				addItem: [ : item | self subMenuSimCormasR: item ] ]! !

!CMSpecProjectWindow methodsFor: 'submenu-simulation' stamp: 'HernanMoralesDurand 10/1/2017 21:18'!
subMenuSimAnalysis: item

	item
		name: self translator tAnalysis;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $A command;
		subMenu: self subMenuSimAnalysis! !

!CMSpecProjectWindow methodsFor: 'submenu-simulation' stamp: 'HernanMoralesDurand 8/21/2017 00:30'!
subMenuSimCormasR: item

	item
		name: 'Cormas <-> R';
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $R command;
		subMenu: self subMenuCormasR! !

!CMSpecProjectWindow methodsFor: 'submenu-simulation' stamp: 'HernanMoralesDurand 4/8/2018 23:37'!
subMenuSimCrossedSensPredefinedValues: item

	item
		name: self translator tOATPredefValues;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $P command;
		action: [ self openSimCrossedSensPredefinedValues ]! !

!CMSpecProjectWindow methodsFor: 'submenu-simulation' stamp: 'HernanMoralesDurand 4/8/2018 23:44'!
subMenuSimCrossedSensSequentialValues: item

	item
		name: self translator tCrossedSeqValues;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $V command;
		action: [ self openSimCrossedSensSequentialValues ]! !

!CMSpecProjectWindow methodsFor: 'submenu-simulation' stamp: 'HernanMoralesDurand 10/1/2017 21:12'!
subMenuSimCrossedSensitivityAnalysis: item

	item
		name: self translator tCrossSensAnalysis;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $C command;
		subMenu: self subMenuForSimCrossedSensitivityAnalysis
! !

!CMSpecProjectWindow methodsFor: 'submenu-simulation' stamp: 'HernanMoralesDurand 10/1/2017 21:12'!
subMenuSimDisplayParams: item

	item
		name: self translator tDisplayParams;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $D command;
		action: [ self openSimDisplayParams ]! !

!CMSpecProjectWindow methodsFor: 'submenu-programming' stamp: 'HernanMoralesDurand 9/22/2017 00:46'!
subMenuSimEditActivityDiagrams: anItem

	anItem
		name: self translator tEditActivityDiagrams;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $S command;
		action: [ self openActivityDiagrams ]		
		

! !

!CMSpecProjectWindow methodsFor: 'submenu-programming' stamp: 'HernanMoralesDurand 9/22/2017 00:47'!
subMenuSimEditAttributes: anItem

	anItem
		name: self translator tEditAttributes;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $A command;
		action: [ self openEditAttributes ]
! !

!CMSpecProjectWindow methodsFor: 'submenu-programming' stamp: 'HernanMoralesDurand 10/10/2017 00:04'!
subMenuSimEditInitialization: anItem

	anItem
		name: self translator tEditInit;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $I command;
		action: [ self openEditInitialization ]! !

!CMSpecProjectWindow methodsFor: 'submenu-programming' stamp: 'HernanMoralesDurand 9/22/2017 00:50'!
subMenuSimEditSteps: anItem

	anItem
		name: self translator tEditSteps;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $S command;
		action: [ self openEditSteps ]		

! !

!CMSpecProjectWindow methodsFor: 'submenu-simulation' stamp: 'HernanMoralesDurand 10/1/2017 21:16'!
subMenuSimInformation: item

	item
		name: self translator tSimInformation;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $F command;
		action: [ self openSimInformation ]! !

!CMSpecProjectWindow methodsFor: 'submenu-simulation' stamp: 'HernanMoralesDurand 12/30/2017 19:07'!
subMenuSimInterface: item

	item
		name: self translator tSimInterface;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $I command;
		action: [ self simWindow toggleSimInterface ]! !

!CMSpecProjectWindow methodsFor: 'submenu-simulation' stamp: 'HernanMoralesDurand 10/1/2017 21:15'!
subMenuSimOATSensByParams: item

	item
		name: self translator tClassifyByParams;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $P command;
		action: [ self openSimOATSensClassifyByParams ]! !

!CMSpecProjectWindow methodsFor: 'submenu-simulation' stamp: 'HernanMoralesDurand 10/1/2017 21:14'!
subMenuSimOATSensMC: item

	item
		name: self translator tMonteCarlo;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $V command;
		action: [ self openSimOATSensMC ]! !

!CMSpecProjectWindow methodsFor: 'submenu-simulation' stamp: 'HernanMoralesDurand 4/8/2018 23:37'!
subMenuSimOATSensPredefinedValues: item

	item
		name: self translator tCrossedPredefValues;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $P command;
		action: [ self openSimOATSensPredefinedValues ]! !

!CMSpecProjectWindow methodsFor: 'submenu-simulation' stamp: 'HernanMoralesDurand 4/8/2018 23:40'!
subMenuSimOATSensSequentialValues: item

	item
		name: self translator tOATSeqValues;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $V command;
		action: [ self openSimOATSensSequentialValues ]! !

!CMSpecProjectWindow methodsFor: 'submenu-simulation' stamp: 'HernanMoralesDurand 10/1/2017 21:13'!
subMenuSimOATSensitivityAnalysis: item

	item
		name: self translator tOATSensAnalysis;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $O command;
		subMenu: self subMenuForSimOATSensitivityAnalysis! !

!CMSpecProjectWindow methodsFor: 'submenu-simulation' stamp: 'HernanMoralesDurand 10/1/2017 21:14'!
subMenuSimStochasticAnalysis: item

	item
		name: self translator tSimpleStochAnalysis;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $S command;
		action: [ self openSimStochasticAnalysis ]! !

!CMSpecProjectWindow methodsFor: 'submenu-simulation' stamp: 'HernanMoralesDurand 10/1/2017 21:16'!
subMenuStartWSR: item

	item
		name: self translator tStartRWebService;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $S command;
		action: [ self openStartWSForR ]! !

!CMSpecProjectWindow methodsFor: 'submenu-simulation' stamp: 'HernanMoralesDurand 10/1/2017 21:17'!
subMenuStopWSR: item

	item
		name: self translator tStopRWebService;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $P command;
		action: [ self openStopWSForR ]! !

!CMSpecProjectWindow methodsFor: 'submenu-tools' stamp: 'HernanMoralesDurand 8/20/2017 19:55'!
subMenuToolsAddOns: item
! !

!CMSpecProjectWindow methodsFor: 'submenu-tools' stamp: 'HernanMoralesDurand 10/1/2017 21:19'!
subMenuToolsCreateInstances: item

	item
		name: self translator tCreateInstances;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $C command;
		action: [ self openToolsCreateInstances ]! !

!CMSpecProjectWindow methodsFor: 'submenu-tools' stamp: 'HernanMoralesDurand 4/11/2018 10:20'!
subMenuToolsDistributeAsClient: item

	item
		name: self translator tDistributeAsClient;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $C command;
		action: [ self openToolsDistribteAsClient ]! !

!CMSpecProjectWindow methodsFor: 'submenu-tools' stamp: 'HernanMoralesDurand 4/11/2018 10:21'!
subMenuToolsDistributeAsServer: item

	item
		name: self translator tDistributeAsServer;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $S command;
		action: [ self openToolsDistribteAsServer ]! !

!CMSpecProjectWindow methodsFor: 'submenu-tools' stamp: 'HernanMoralesDurand 4/12/2018 01:19'!
subMenuToolsMain: item

	item
		name: self translator tOpenPharoMenu;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $P command;
		action: [ World worldMenu openCenteredInWorld ]! !

!CMSpecProjectWindow methodsFor: 'submenu-tools' stamp: 'HernanMoralesDurand 10/1/2017 21:19'!
subMenuToolsManipulateInstances: item

	item
		name: self translator tManipulateInstances;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $I command;
		action: [ self openToolsManipulateInstances ]! !

!CMSpecProjectWindow methodsFor: 'submenu-tools' stamp: 'HernanMoralesDurand 10/1/2017 21:20'!
subMenuToolsModelGlossary: item

	item
		name: self translator tModelGlossary;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $G command;
		action: [ self openToolsModelGlossary ]! !

!CMSpecProjectWindow methodsFor: 'submenu-tools' stamp: 'HernanMoralesDurand 10/1/2017 21:20'!
subMenuToolsModelListing: item

	item
		name: self translator tModelListing;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $L command;
		action: [ self openToolsModelListing ]! !

!CMSpecProjectWindow methodsFor: 'submenu-tools' stamp: 'HernanMoralesDurand 10/1/2017 21:21'!
subMenuToolsPackageClient: item

	item
		name: self translator tPackageClient;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $K command;
		action: [ self openToolsPackageClient ]! !

!CMSpecProjectWindow methodsFor: 'submenu-tools' stamp: 'HernanMoralesDurand 10/1/2017 21:23'!
subMenuToolsSnapshot: item

	item
		name: self translator tSnapshot;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $S command;
		action: [ self openToolsSnapshotState ]! !

!CMSpecProjectWindow methodsFor: 'submenu-tools' stamp: 'HernanMoralesDurand 10/1/2017 21:22'!
subMenuToolsVersions: item

	item
		name: self translator tDisplayModelVersions;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $V command;
		action: [ self openToolsModelVersions ]! !

!CMSpecProjectWindow methodsFor: 'submenu-visualization' stamp: 'HernanMoralesDurand 10/1/2017 21:21'!
subMenuVizMessages: item

	item
		name: self translator tMessages;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $M command;
		action: [ self openVizMessages ]! !

!CMSpecProjectWindow methodsFor: 'submenu-visualization' stamp: 'HernanMoralesDurand 10/1/2017 21:21'!
subMenuVizProbes: item

	item
		name: self translator tProbes;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $P command;
		action: [ self openVizProbes ]! !

!CMSpecProjectWindow methodsFor: 'submenu-visualization' stamp: 'HernanMoralesDurand 10/1/2017 21:22'!
subMenuVizSpace: item

	item
		name: self translator tSpace;
"		icon: Smalltalk ui icons openIcon;"
		shortcut: $S command;
		action: [ self openVizSpace ]! !

!CMSpecProjectWindow methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 4/12/2018 02:42'!
updateCloseProject
	" Private - See superimplementor's comment "

	super updateCloseProject.
	self 
		menuDisableFileGroup;	
		menuDisableProgrammingGroup;
		menuDisableSimulationGroup;
		menuDisableToolsGroup;
		menuDisableVisualizationGroup;	
		menuDisableHelpGroup;
		updateSimulationWindow.! !

!CMSpecProjectWindow methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 12/30/2017 19:29'!
updateSimulationWindow
	" Open or update the receiver's simulation interface "
	
	self simWindow toggleSimInterface! !

!CMSpecProjectWindow methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 4/8/2018 23:37'!
updateStateOpened
	" Private - See superimplementor's comment "

	super updateStateOpened.
	self 
		menuEnableProgrammingGroup;
		menuEnableSimulationGroup;
		menuEnableToolsGroup;
		menuEnableVisualizationGroup;
		menuEnableHelpGroup;
		updateSimulationWindow! !

!CMSpecProjectWindow methodsFor: 'callbacks' stamp: 'HernanMoralesDurand 4/8/2018 23:37'!
updateStateWaitNewOrOpen
	" Private - See superimplementor's comment "

	self flag: #toBeReviewed. "Apparently menugroupmorph does not disable correctly "
	super updateStateWaitNewOrOpen.
	self 
		menuDisableProgrammingGroup;
		menuDisableSimulationGroup;
		menuDisableToolsGroup;
		menuDisableVisualizationGroup;
		menuDisableHelpGroup
! !

PFStandardProjectWindow subclass: #CMSpecVizSpaceWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-UI-Core'!

!CMSpecVizSpaceWindow commentStamp: 'HernanMoralesDurand 11/8/2017 11:25' prior: 0!
CMSpecVizSpaceWindow new openWithSpec.

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.


    Implementation Points

| menuModel |
	
menuModel := CGStSpcMenuBuilder new 
	generateGroupSubMenuItems: 
		#(
		#(#Info #Track) 
		#(#SpatialDelimitor #Time #Background)
		#(#CellVsAggregates)
		).
Smalltalk tools workspace 
	openContents: menuModel 
	label: 'MenuModel Generator'.
!

!CMSpecVizSpaceWindow methodsFor: 'private' stamp: ''!
closeAfterCreateProject
	^ true! !

!CMSpecVizSpaceWindow methodsFor: 'initialization' stamp: 'HernanMoralesDurand 12/10/2017 13:53'!
initializeApplication

	self applicationClass: CMApplicationProject! !

!CMSpecVizSpaceWindow methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/8/2017 10:36'!
initializeDisplaysMenuToolbar
	" Private - See superimplementor's commen "

	^ MenuModel new
		addGroup: [ : group | 
			group
				addItem: [ : item | 
					item 
						name: self translator tInfo;
						subMenu: self subMenuForInfo ] ];
		addGroup: [ : group | 
			group
				addItem: [ : item | 
					item 
						name: self translator tSpatialDelimitor;
						subMenu: self subMenuForSpatialDelimitor ];
			addItem: [ : item | 
					item 
						name: self translator tTime;
						subMenu: self subMenuForTime ] ];
		addGroup: [ : group | 
			group
				addItem: [ : item | 
					item 
						name: self translator tCellVsAggregates;
						subMenu: self subMenuForCellVsAggregates ] ]! !

!CMSpecVizSpaceWindow methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/9/2017 01:13'!
initializeEnvironmentMenuToolbar
	" Private - See superimplementor's commen "

	^ MenuModel new
		addGroup: [ : group | 
			group
				addItem: [ : item | 
					item 
						name: self translator tNew;
						subMenu: self subMenuForNew ];
				addItem: [ : item | 
					item 
						name: self translator tLoad;
						subMenu: self subMenuForLoad ] ];
		addGroup: [ : group | 
			group
				addItem: [ : item | 
					item 
						name: self translator tModify;
						subMenu: self subMenuForModify ];
				addItem: [ : item | 
					item 
						name: self translator tReOpen;
						action: [ self reOpen ] ] ];
		addGroup: [ : group | 
			group
				addItem: [ : item | 
					item 
						name: self translator tClose;
						action: [ self close ] ] ]! !

!CMSpecVizSpaceWindow methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/8/2017 23:56'!
initializeMenuToolbar
	" Private - See superimplementor's commen "

	menuToolbar := MenuModel new
		addGroup: [ : group | 
			group
				addItem: [ : item | 
					item 
						name: self translator tEnvironment;
						subMenu: self initializeEnvironmentMenuToolbar ];					
				addItem: [ : item | 
					item 
						name: self translator tPoV;
						subMenu: self initializeToolsMenuToolbar ];			
				addItem: [ : item |
					item 
						name: self translator tDisplayLegends;
						subMenu: self initializeOptionMenuToolbar ];
				addItem: [ : item | 
					item 
						name: self translator tTools;
						subMenu: self initializeToolsMenuToolbar ]
					 ].
	menuToolbar applyTo: self.
! !

!CMSpecVizSpaceWindow methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/7/2017 18:55'!
initializeOptionMenuToolbar
	" Private - See superimplementor's commen "

	^ MenuModel new
		addGroup: [ : group | 
			group
				addItem: [ : item | 
					item 
						name: self translator tUnmoveableZoom;
						action: [  ] ];
				addItem: [ : item | 
					item 
						name: self translator tMoveableZoom;
						action: [  ] ] ];
		addGroup: [ : group |
			group
				addItem: [ : item | 
					item 
						name: self translator tSetTrackLength;
						action: [  ] ];
				addItem: [ : item | 
					item 
						name: self translator tEnableUndoRedo;
						action: [  ] ] ];
		addGroup: [ : group | 
			group
				addItem: [ : item | 
					item 
						name: self translator tTouchpad;
						action: [  ] ] ];
		yourself
! !

!CMSpecVizSpaceWindow methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/7/2017 18:53'!
initializeToolsMenuToolbar
	" Private - See superimplementor's commen "

	^ MenuModel new
		addGroup: [ : group | 
			group
				addItem: [ : item | 
					item 
						name: self translator tDisplayLegends;
						action: [  ] ];
				addItem: [ : item | 
					item 
						name: self translator tPhoto;
						action: [  ] ];
				addItem: [ : item | 
					item 
						name: self translator tVideo;
						action: [  ] ];
				addItem: [ : item | 
					item 
						name: self translator tManipulateInstances;
						action: [  ] ];
				addItem: [ : item | 
					item 
						name: self translator tCreateInstances;
						action: [  ] ];
				addItem: [ : item | 
					item 
						name: self translator tClickTo;
						action: [  ] ];
				addItem: [ : item | 
					item 
						name: self translator tHabitus;
						action: [  ] ] ];
			yourself! !

!CMSpecVizSpaceWindow methodsFor: 'initialization' stamp: 'HernanMoralesDurand 11/7/2017 18:42'!
initializeWidgets
	" Private - See superimplementor's comment "

	self initializeApplication.
	super initializeWidgets.
	self initializeMenuToolbar.
	self setFocusOrder.! !

!CMSpecVizSpaceWindow methodsFor: 'private' stamp: ''!
projectClass
	^ CMProjectManager! !

!CMSpecVizSpaceWindow methodsFor: 'private' stamp: 'HernanMoralesDurand 11/9/2017 01:12'!
subMenuForLoad
	
	^ MenuModel new! !

!CMSpecVizSpaceWindow methodsFor: 'private' stamp: 'HernanMoralesDurand 11/9/2017 01:12'!
subMenuForModify

	^ MenuModel new! !

!CMSpecVizSpaceWindow methodsFor: 'private' stamp: 'HernanMoralesDurand 11/9/2017 00:16'!
subMenuForNew

	^ MenuModel new
		addGroup: [ : group |
			group 
				addItem: [ : item | 				
					item
						name: self translator tGridSize;
						action: [ self openDimensionChooser ] ] ]! !

!CMSpecVizSpaceWindow methodsFor: 'initialization' stamp: ''!
title
	^ 'CORMAS - Visualization Space'! !
